/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(ie){for(var t=[],k=0,P=ie.length;k<P;k++)t[k]=be[ie[k]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:jt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Tt,construct:Ct}=typeof Reflect<"u"&&Reflect;Tt||(Tt=function(t,k,P){return t.apply(k,P)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,k){return new t(...k)});const oi=ut(Array.prototype.forEach),Ht=ut(Array.prototype.pop),wt=ut(Array.prototype.push),Et=ut(String.prototype.toLowerCase),Pt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),vt=ui(TypeError);function ut(ie){return function(t){for(var k=arguments.length,P=new Array(k>1?k-1:0),n=1;n<k;n++)P[n-1]=arguments[n];return Tt(ie,t,P)}}function ui(ie){return function(){for(var t=arguments.length,k=new Array(t),P=0;P<t;P++)k[P]=arguments[P];return Ct(ie,k)}}function Ue(ie,t,k){var P;k=(P=k)!==null&&P!==void 0?P:Et,jt&&jt(ie,null);let n=t.length;for(;n--;){let j=t[n];if(typeof j=="string"){const A=k(j);A!==j&&(ii(t)||(t[n]=A),j=A)}ie[j]=!0}return ie}function bt(ie){const t=ri(null);for(const[k,P]of zt(ie))t[k]=P;return t}function At(ie,t){for(;ie!==null;){const P=si(ie,t);if(P){if(P.get)return ut(P.get);if(typeof P.value=="function")return ut(P.value)}ie=ni(ie)}function k(P){return console.warn("fallback value for",P),null}return k}const Ut=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),_t=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,k){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let P=null;const n="data-tt-policy-suffix";k&&k.hasAttribute(n)&&(P=k.getAttribute(n));const j="dompurify"+(P?"#"+P:"");try{return t.createPolicy(j,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+j+" could not be created."),null}};function xt(){let ie=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!ie||!ie.document||ie.document.nodeType!==9)return t.isSupported=!1,t;const k=ie.document,P=k.currentScript;let{document:n}=ie;const{DocumentFragment:j,HTMLTemplateElement:A,Node:S,Element:b,NodeFilter:w,NamedNodeMap:y=ie.NamedNodeMap||ie.MozNamedAttrMap,HTMLFormElement:M,DOMParser:r,trustedTypes:u}=ie,e=b.prototype,s=At(e,"cloneNode"),m=At(e,"nextSibling"),d=At(e,"childNodes"),o=At(e,"parentNode");if(typeof A=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let $,c="";const{implementation:f,createNodeIterator:h,createDocumentFragment:F,getElementsByTagName:O}=n,{importNode:R}=k;let B={};t.isSupported=typeof zt=="function"&&typeof o=="function"&&f&&f.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:v,ERB_EXPR:C,TMPLIT_EXPR:V,DATA_ATTR:U,ARIA_ATTR:T,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:z}=Kt;let{IS_ALLOWED_URI:X}=Kt,Y=null;const fe=Ue({},[...Ut,...Rt,...Lt,...It,...Wt]);let le=null;const ee=Ue({},[...Vt,...Mt,...qt,...kt]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Le=null,Ne=null,Be=!0,ne=!0,J=!1,se=!0,oe=!1,W=!1,G=!1,ue=!1,me=!1,Se=!1,ke=!1,Ce=!0,K=!1;const g="user-content-";let D=!0,p=!1,l={},i=null;const a=Ue({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let E=null;const I=Ue({},["audio","video","img","source","image","track"]);let N=null;const H=Ue({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),_="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",he="http://www.w3.org/1999/xhtml";let pe=he,ye=!1,we=null;const Ee=Ue({},[_,Z,he],Pt);let ve;const Pe=["application/xhtml+xml","text/html"],Ie="text/html";let Me,Ye=null;const et=n.createElement("form"),Qe=function(ae){return ae instanceof RegExp||ae instanceof Function},x=function(ae){if(!(Ye&&Ye===ae)){if((!ae||typeof ae!="object")&&(ae={}),ae=bt(ae),ve=Pe.indexOf(ae.PARSER_MEDIA_TYPE)===-1?ve=Ie:ve=ae.PARSER_MEDIA_TYPE,Me=ve==="application/xhtml+xml"?Pt:Et,Y="ALLOWED_TAGS"in ae?Ue({},ae.ALLOWED_TAGS,Me):fe,le="ALLOWED_ATTR"in ae?Ue({},ae.ALLOWED_ATTR,Me):ee,we="ALLOWED_NAMESPACES"in ae?Ue({},ae.ALLOWED_NAMESPACES,Pt):Ee,N="ADD_URI_SAFE_ATTR"in ae?Ue(bt(H),ae.ADD_URI_SAFE_ATTR,Me):H,E="ADD_DATA_URI_TAGS"in ae?Ue(bt(I),ae.ADD_DATA_URI_TAGS,Me):I,i="FORBID_CONTENTS"in ae?Ue({},ae.FORBID_CONTENTS,Me):a,Le="FORBID_TAGS"in ae?Ue({},ae.FORBID_TAGS,Me):{},Ne="FORBID_ATTR"in ae?Ue({},ae.FORBID_ATTR,Me):{},l="USE_PROFILES"in ae?ae.USE_PROFILES:!1,Be=ae.ALLOW_ARIA_ATTR!==!1,ne=ae.ALLOW_DATA_ATTR!==!1,J=ae.ALLOW_UNKNOWN_PROTOCOLS||!1,se=ae.ALLOW_SELF_CLOSE_IN_ATTR!==!1,oe=ae.SAFE_FOR_TEMPLATES||!1,W=ae.WHOLE_DOCUMENT||!1,me=ae.RETURN_DOM||!1,Se=ae.RETURN_DOM_FRAGMENT||!1,ke=ae.RETURN_TRUSTED_TYPE||!1,ue=ae.FORCE_BODY||!1,Ce=ae.SANITIZE_DOM!==!1,K=ae.SANITIZE_NAMED_PROPS||!1,D=ae.KEEP_CONTENT!==!1,p=ae.IN_PLACE||!1,X=ae.ALLOWED_URI_REGEXP||_t,pe=ae.NAMESPACE||he,ge=ae.CUSTOM_ELEMENT_HANDLING||{},ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ae.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&Qe(ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ae.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ae.CUSTOM_ELEMENT_HANDLING&&typeof ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ae.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),oe&&(ne=!1),Se&&(me=!0),l&&(Y=Ue({},[...Wt]),le=[],l.html===!0&&(Ue(Y,Ut),Ue(le,Vt)),l.svg===!0&&(Ue(Y,Rt),Ue(le,Mt),Ue(le,kt)),l.svgFilters===!0&&(Ue(Y,Lt),Ue(le,Mt),Ue(le,kt)),l.mathMl===!0&&(Ue(Y,It),Ue(le,qt),Ue(le,kt))),ae.ADD_TAGS&&(Y===fe&&(Y=bt(Y)),Ue(Y,ae.ADD_TAGS,Me)),ae.ADD_ATTR&&(le===ee&&(le=bt(le)),Ue(le,ae.ADD_ATTR,Me)),ae.ADD_URI_SAFE_ATTR&&Ue(N,ae.ADD_URI_SAFE_ATTR,Me),ae.FORBID_CONTENTS&&(i===a&&(i=bt(i)),Ue(i,ae.FORBID_CONTENTS,Me)),D&&(Y["#text"]=!0),W&&Ue(Y,["html","head","body"]),Y.table&&(Ue(Y,["tbody"]),delete Le.tbody),ae.TRUSTED_TYPES_POLICY){if(typeof ae.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ae.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=ae.TRUSTED_TYPES_POLICY,c=$.createHTML("")}else $===void 0&&($=Di(u,P)),$!==null&&typeof c=="string"&&(c=$.createHTML(""));ot&&ot(ae),Ye=ae}},re=Ue({},["mi","mo","mn","ms","mtext"]),de=Ue({},["foreignobject","desc","title","annotation-xml"]),Ae=Ue({},["title","style","font","a","script"]),Te=Ue({},Rt);Ue(Te,Lt),Ue(Te,ci);const je=Ue({},It);Ue(je,fi);const Ve=function(ae){let Fe=o(ae);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:pe,tagName:"template"});const Re=Et(ae.tagName),We=Et(Fe.tagName);return we[ae.namespaceURI]?ae.namespaceURI===Z?Fe.namespaceURI===he?Re==="svg":Fe.namespaceURI===_?Re==="svg"&&(We==="annotation-xml"||re[We]):!!Te[Re]:ae.namespaceURI===_?Fe.namespaceURI===he?Re==="math":Fe.namespaceURI===Z?Re==="math"&&de[We]:!!je[Re]:ae.namespaceURI===he?Fe.namespaceURI===Z&&!de[We]||Fe.namespaceURI===_&&!re[We]?!1:!je[Re]&&(Ae[Re]||!Te[Re]):!!(ve==="application/xhtml+xml"&&we[ae.namespaceURI]):!1},_e=function(ae){wt(t.removed,{element:ae});try{ae.parentNode.removeChild(ae)}catch{ae.remove()}},Je=function(ae,Fe){try{wt(t.removed,{attribute:Fe.getAttributeNode(ae),from:Fe})}catch{wt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(ae),ae==="is"&&!le[ae])if(me||Se)try{_e(Fe)}catch{}else try{Fe.setAttribute(ae,"")}catch{}},tt=function(ae){let Fe,Re;if(ue)ae="<remove></remove>"+ae;else{const lt=li(ae,/^[\r\n\t ]+/);Re=lt&&lt[0]}ve==="application/xhtml+xml"&&pe===he&&(ae='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ae+"</body></html>");const We=$?$.createHTML(ae):ae;if(pe===he)try{Fe=new r().parseFromString(We,ve)}catch{}if(!Fe||!Fe.documentElement){Fe=f.createDocument(pe,"template",null);try{Fe.documentElement.innerHTML=ye?c:We}catch{}}const it=Fe.body||Fe.documentElement;return ae&&Re&&it.insertBefore(n.createTextNode(Re),it.childNodes[0]||null),pe===he?O.call(Fe,W?"html":"body")[0]:W?Fe.documentElement:it},Ze=function(ae){return h.call(ae.ownerDocument||ae,ae,w.SHOW_ELEMENT|w.SHOW_COMMENT|w.SHOW_TEXT,null,!1)},nt=function(ae){return ae instanceof M&&(typeof ae.nodeName!="string"||typeof ae.textContent!="string"||typeof ae.removeChild!="function"||!(ae.attributes instanceof y)||typeof ae.removeAttribute!="function"||typeof ae.setAttribute!="function"||typeof ae.namespaceURI!="string"||typeof ae.insertBefore!="function"||typeof ae.hasChildNodes!="function")},st=function(ae){return typeof S=="object"?ae instanceof S:ae&&typeof ae=="object"&&typeof ae.nodeType=="number"&&typeof ae.nodeName=="string"},rt=function(ae,Fe,Re){B[ae]&&oi(B[ae],We=>{We.call(t,Fe,Re,Ye)})},gt=function(ae){let Fe;if(rt("beforeSanitizeElements",ae,null),nt(ae))return _e(ae),!0;const Re=Me(ae.nodeName);if(rt("uponSanitizeElement",ae,{tagName:Re,allowedTags:Y}),ae.hasChildNodes()&&!st(ae.firstElementChild)&&(!st(ae.content)||!st(ae.content.firstElementChild))&&ht(/<[/\w]/g,ae.innerHTML)&&ht(/<[/\w]/g,ae.textContent))return _e(ae),!0;if(!Y[Re]||Le[Re]){if(!Le[Re]&&mt(Re)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Re)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Re)))return!1;if(D&&!i[Re]){const We=o(ae)||ae.parentNode,it=d(ae)||ae.childNodes;if(it&&We){const lt=it.length;for(let Ke=lt-1;Ke>=0;--Ke)We.insertBefore(s(it[Ke],!0),m(ae))}}return _e(ae),!0}return ae instanceof b&&!Ve(ae)||(Re==="noscript"||Re==="noembed"||Re==="noframes")&&ht(/<\/no(script|embed|frames)/i,ae.innerHTML)?(_e(ae),!0):(oe&&ae.nodeType===3&&(Fe=ae.textContent,Fe=dt(Fe,v," "),Fe=dt(Fe,C," "),Fe=dt(Fe,V," "),ae.textContent!==Fe&&(wt(t.removed,{element:ae.cloneNode()}),ae.textContent=Fe)),rt("afterSanitizeElements",ae,null),!1)},St=function(ae,Fe,Re){if(Ce&&(Fe==="id"||Fe==="name")&&(Re in n||Re in et))return!1;if(!(ne&&!Ne[Fe]&&ht(U,Fe))){if(!(Be&&ht(T,Fe))){if(!le[Fe]||Ne[Fe]){if(!(mt(ae)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,ae)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ae))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Fe)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Fe))||Fe==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Re)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Re))))return!1}else if(!N[Fe]){if(!ht(X,dt(Re,z,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&ae!=="script"&&ai(Re,"data:")===0&&E[ae])){if(!(J&&!ht(L,dt(Re,z,"")))){if(Re)return!1}}}}}}return!0},mt=function(ae){return ae.indexOf("-")>0},Ft=function(ae){let Fe,Re,We,it;rt("beforeSanitizeAttributes",ae,null);const{attributes:lt}=ae;if(!lt)return;const Ke={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(it=lt.length;it--;){Fe=lt[it];const{name:ct,namespaceURI:$t}=Fe;if(Re=ct==="value"?Fe.value:hi(Fe.value),We=Me(ct),Ke.attrName=We,Ke.attrValue=Re,Ke.keepAttr=!0,Ke.forceKeepAttr=void 0,rt("uponSanitizeAttribute",ae,Ke),Re=Ke.attrValue,Ke.forceKeepAttr||(Je(ct,ae),!Ke.keepAttr))continue;if(!se&&ht(/\/>/i,Re)){Je(ct,ae);continue}oe&&(Re=dt(Re,v," "),Re=dt(Re,C," "),Re=dt(Re,V," "));const Dt=Me(ae.nodeName);if(St(Dt,We,Re)){if(K&&(We==="id"||We==="name")&&(Je(ct,ae),Re=g+Re),$&&typeof u=="object"&&typeof u.getAttributeType=="function"&&!$t)switch(u.getAttributeType(Dt,We)){case"TrustedHTML":{Re=$.createHTML(Re);break}case"TrustedScriptURL":{Re=$.createScriptURL(Re);break}}try{$t?ae.setAttributeNS($t,ct,Re):ae.setAttribute(ct,Re),Ht(t.removed)}catch{}}}rt("afterSanitizeAttributes",ae,null)},Ot=function ze(ae){let Fe;const Re=Ze(ae);for(rt("beforeSanitizeShadowDOM",ae,null);Fe=Re.nextNode();)rt("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof j&&ze(Fe.content),Ft(Fe));rt("afterSanitizeShadowDOM",ae,null)};return t.sanitize=function(ze){let ae=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Re,We,it;if(ye=!ze,ye&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return ze;if(G||x(ae),t.removed=[],typeof ze=="string"&&(p=!1),p){if(ze.nodeName){const ct=Me(ze.nodeName);if(!Y[ct]||Le[ct])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof S)Fe=tt("<!---->"),Re=Fe.ownerDocument.importNode(ze,!0),Re.nodeType===1&&Re.nodeName==="BODY"||Re.nodeName==="HTML"?Fe=Re:Fe.appendChild(Re);else{if(!me&&!oe&&!W&&ze.indexOf("<")===-1)return $&&ke?$.createHTML(ze):ze;if(Fe=tt(ze),!Fe)return me?null:ke?c:""}Fe&&ue&&_e(Fe.firstChild);const lt=Ze(p?ze:Fe);for(;We=lt.nextNode();)gt(We)||(We.content instanceof j&&Ot(We.content),Ft(We));if(p)return ze;if(me){if(Se)for(it=F.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(le.shadowroot||le.shadowrootmode)&&(it=R.call(k,it,!0)),it}let Ke=W?Fe.outerHTML:Fe.innerHTML;return W&&Y["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Qt,Fe.ownerDocument.doctype.name)&&(Ke="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Ke),oe&&(Ke=dt(Ke,v," "),Ke=dt(Ke,C," "),Ke=dt(Ke,V," ")),$&&ke?$.createHTML(Ke):Ke},t.setConfig=function(ze){x(ze),G=!0},t.clearConfig=function(){Ye=null,G=!1},t.isValidAttribute=function(ze,ae,Fe){Ye||x({});const Re=Me(ze),We=Me(ae);return St(Re,We,Fe)},t.addHook=function(ze,ae){typeof ae=="function"&&(B[ze]=B[ze]||[],wt(B[ze],ae))},t.removeHook=function(ze){if(B[ze])return Ht(B[ze])},t.removeHooks=function(ze){B[ze]&&(B[ze]=[])},t.removeAllHooks=function(){B={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[41],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lR=t.$kR=void 0;class k{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const S=P(A);this.a!==S&&(this.a=S,this.domNode.style.maxWidth=this.a)}setWidth(A){const S=P(A);this.b!==S&&(this.b=S,this.domNode.style.width=this.b)}setHeight(A){const S=P(A);this.c!==S&&(this.c=S,this.domNode.style.height=this.c)}setTop(A){const S=P(A);this.d!==S&&(this.d=S,this.domNode.style.top=this.d)}setLeft(A){const S=P(A);this.e!==S&&(this.e=S,this.domNode.style.left=this.e)}setBottom(A){const S=P(A);this.f!==S&&(this.f=S,this.domNode.style.bottom=this.f)}setRight(A){const S=P(A);this.g!==S&&(this.g=S,this.domNode.style.right=this.g)}setPaddingTop(A){const S=P(A);this.h!==S&&(this.h=S,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const S=P(A);this.i!==S&&(this.i=S,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const S=P(A);this.j!==S&&(this.j=S,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const S=P(A);this.k!==S&&(this.k=S,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const S=P(A);this.n!==S&&(this.n=S,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const S=P(A);this.s!==S&&(this.s=S,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const S=P(A);this.t!==S&&(this.t=S,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,S){this.domNode.classList.toggle(A,S),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,S){this.domNode.setAttribute(A,S)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$kR=k;function P(j){return typeof j=="number"?`${j}px`:j}function n(j){return new k(j)}t.$lR=n}),define(be[69],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CP=t.$BP=void 0;const k=new WeakMap;function P(S){if(!S.parent||S.parent===S)return null;try{const b=S.location,w=S.parent.location;if(b.origin!=="null"&&w.origin!=="null"&&b.origin!==w.origin)return null}catch{return null}return S.parent}class n{static a(b){let w=k.get(b);if(!w){w=[],k.set(b,w);let y=b,M;do M=P(y),M?w.push({window:new WeakRef(y),iframeElement:y.frameElement||null}):w.push({window:new WeakRef(y),iframeElement:null}),y=M;while(y)}return w.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(b,w){if(!w||b===w)return{top:0,left:0};let y=0,M=0;const r=this.a(b);for(const u of r){const e=u.window.deref();if(y+=e?.scrollY??0,M+=e?.scrollX??0,e===w||!u.iframeElement)break;const s=u.iframeElement.getBoundingClientRect();y+=s.top,M+=s.left}return{top:y,left:M}}}t.$BP=n;async function j(S,b){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const w=JSON.stringify({parentOrigin:S,salt:b}),M=new TextEncoder().encode(w),r=await crypto.subtle.digest("sha-256",M);return A(r)}t.$CP=j;function A(S){const w=Array.from(new Uint8Array(S)).map(y=>y.toString(16).padStart(2,"0")).join("");return BigInt(`0x${w}`).toString(32).padStart(52,"0")}}),define(be[70],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4R=t.$3R=t.$2R=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var k;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(k||(t.ListDragOverEffectType=k={}));var P;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(P||(t.ListDragOverEffectPosition=P={})),t.$2R={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(S,b){super(`ListError [${S}] ${b}`)}}t.$3R=n;class j{constructor(){this.c=new WeakMap}getHeight(S){return this.c.get(S)??this.d(S)}setDynamicHeight(S,b){b>0&&this.c.set(S,b)}}t.$4R=j}),define(be[71],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RR=void 0;class k{constructor(n){this.a=n}splice(n,j,A){this.a.forEach(S=>S.splice(n,j,A))}}t.$RR=k}),define(be[42],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qR=void 0;const k=20;class P{constructor(j,A,S,b,w,y){this.a=Math.round(A),this.b=Math.round(S),this.c=Math.round(j),this.d=b,this.e=w,this.f=y,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new P(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(j){const A=Math.round(j);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(j){const A=Math.round(j);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(j){const A=Math.round(j);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(j){this.a=Math.round(j)}setOppositeScrollbarSize(j){this.b=Math.round(j)}static l(j,A,S,b,w){const y=Math.max(0,S-j),M=Math.max(0,y-2*A),r=b>0&&b>S;if(!r)return{computedAvailableSize:Math.round(y),computedIsNeeded:r,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const u=Math.round(Math.max(k,Math.floor(S*M/b))),e=(M-u)/(b-S),s=w*e;return{computedAvailableSize:Math.round(y),computedIsNeeded:r,computedSliderSize:Math.round(u),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const j=P.l(this.b,this.c,this.d,this.e,this.f);this.g=j.computedAvailableSize,this.h=j.computedIsNeeded,this.i=j.computedSliderSize,this.j=j.computedSliderRatio,this.k=j.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(j){if(!this.h)return 0;const A=j-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(j){if(!this.h)return 0;const A=j-this.c;let S=this.f;return A<this.k?S-=this.d:S+=this.d,S}getDesiredScrollPositionFromDelta(j){if(!this.h)return 0;const A=this.k+j;return Math.round(A/this.j)}}t.$qR=P}),define(be[26],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=t.$TT=t.$ST=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var k;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(k||(t.TreeVisibility=k={}));var P;(function(b){b[b.Expanded=0]="Expanded",b[b.Collapsed=1]="Collapsed",b[b.PreserveOrExpanded=2]="PreserveOrExpanded",b[b.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(P||(t.ObjectTreeElementCollapseState=P={}));var n;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var j;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(j||(t.TreeDragOverBubble=j={})),t.$ST={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:b}}};class A extends Error{constructor(w,y){super(`TreeError [${w}] ${y}`)}}t.$TT=A;class S{constructor(w){this.a=w,this.b=new WeakMap}map(w){let y=this.b.get(w);return y||(y=this.a(w),this.b.set(w,y)),y}}t.$UT=S}),define(be[21],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fP=t.$window=t.$dP=t.$cP=void 0;function k(n,j){const A=n;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>j})}t.$cP=k,t.$dP=window,t.$window=t.$dP;function P(n){return n===t.$dP?!1:typeof n?.vscodeWindowId=="number"}t.$fP=P}),define(be[72],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function k(s,m,d){const o=P(s,m);if(o!==-1)return s[o]}t.$fb=k;function P(s,m,d=s.length-1){for(let o=d;o>=0;o--){const $=s[o];if(m($))return o}return-1}t.$gb=P;function n(s,m){const d=j(s,m);return d===-1?void 0:s[d]}t.$hb=n;function j(s,m,d=0,o=s.length){let $=d,c=o;for(;$<c;){const f=Math.floor(($+c)/2);m(s[f])?$=f+1:c=f}return $-1}t.$ib=j;function A(s,m){const d=S(s,m);return d===s.length?void 0:s[d]}t.$jb=A;function S(s,m,d=0,o=s.length){let $=d,c=o;for(;$<c;){const f=Math.floor(($+c)/2);m(s[f])?c=f:$=f+1}return $}t.$kb=S;function b(s,m,d=0,o=s.length){const $=S(s,m,d,o);return $===s.length?-1:$}t.$lb=b;class w{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(w.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!m(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const d=j(this.e,m,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}t.$mb=w;function y(s,m){if(s.length===0)return;let d=s[0];for(let o=1;o<s.length;o++){const $=s[o];m($,d)>0&&(d=$)}return d}t.$nb=y;function M(s,m){if(s.length===0)return;let d=s[0];for(let o=1;o<s.length;o++){const $=s[o];m($,d)>=0&&(d=$)}return d}t.$ob=M;function r(s,m){return y(s,(d,o)=>-m(d,o))}t.$pb=r;function u(s,m){if(s.length===0)return-1;let d=0;for(let o=1;o<s.length;o++){const $=s[o];m($,s[d])>0&&(d=o)}return d}t.$qb=u;function e(s,m){for(const d of s){const o=m(d);if(o!==void 0)return o}}t.$rb=e}),define(be[73],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function k(A,S){const b=Object.create(null);for(const w of A){const y=S(w);let M=b[y];M||(M=b[y]=[]),M.push(w)}return b}t.$K=k;function P(A,S){const b=[],w=[];for(const y of A)S.has(y)||b.push(y);for(const y of S)A.has(y)||w.push(y);return{removed:b,added:w}}t.$L=P;function n(A,S){const b=[],w=[];for(const[y,M]of A)S.has(y)||b.push(M);for(const[y,M]of S)A.has(y)||w.push(M);return{removed:b,added:w}}t.$M=n;function j(A,S){const b=new Set;for(const w of S)A.has(w)&&b.add(w);return b}t.$N=j}),define(be[74],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mt=t.$lt=t.$kt=t.$jt=void 0;function k(S,b){const w=Math.pow(10,b);return Math.round(S*w)/w}class P{constructor(b,w,y,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,b))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=k(Math.max(Math.min(1,M),0),3)}static equals(b,w){return b.r===w.r&&b.g===w.g&&b.b===w.b&&b.a===w.a}}t.$jt=P;class n{constructor(b,w,y,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.l=k(Math.max(Math.min(1,y),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.l===w.l&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,M=b.b/255,r=b.a,u=Math.max(w,y,M),e=Math.min(w,y,M);let s=0,m=0;const d=(e+u)/2,o=u-e;if(o>0){switch(m=Math.min(d<=.5?o/(2*d):o/(2-2*d),1),u){case w:s=(y-M)/o+(y<M?6:0);break;case y:s=(M-w)/o+2;break;case M:s=(w-y)/o+4;break}s*=60,s=Math.round(s)}return new n(s,m,d,r)}static i(b,w,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?b+(w-b)*6*y:y<1/2?w:y<2/3?b+(w-b)*(2/3-y)*6:b}static toRGBA(b){const w=b.h/360,{s:y,l:M,a:r}=b;let u,e,s;if(y===0)u=e=s=M;else{const m=M<.5?M*(1+y):M+y-M*y,d=2*M-m;u=n.i(d,m,w+1/3),e=n.i(d,m,w),s=n.i(d,m,w-1/3)}return new P(Math.round(u*255),Math.round(e*255),Math.round(s*255),r)}}t.$kt=n;class j{constructor(b,w,y,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,b),0)|0,this.s=k(Math.max(Math.min(1,w),0),3),this.v=k(Math.max(Math.min(1,y),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(b,w){return b.h===w.h&&b.s===w.s&&b.v===w.v&&b.a===w.a}static fromRGBA(b){const w=b.r/255,y=b.g/255,M=b.b/255,r=Math.max(w,y,M),u=Math.min(w,y,M),e=r-u,s=r===0?0:e/r;let m;return e===0?m=0:r===w?m=((y-M)/e%6+6)%6:r===y?m=(M-w)/e+2:m=(w-y)/e+4,new j(Math.round(m*60),s,r,b.a)}static toRGBA(b){const{h:w,s:y,v:M,a:r}=b,u=M*y,e=u*(1-Math.abs(w/60%2-1)),s=M-u;let[m,d,o]=[0,0,0];return w<60?(m=u,d=e):w<120?(m=e,d=u):w<180?(d=u,o=e):w<240?(d=e,o=u):w<300?(m=e,o=u):w<=360&&(m=u,o=e),m=Math.round((m+s)*255),d=Math.round((d+s)*255),o=Math.round((o+s)*255),new P(m,d,o,r)}}t.$lt=j;class A{static fromHex(b){return A.Format.CSS.parseHex(b)||A.red}static equals(b,w){return!b&&!w?!0:!b||!w?!1:b.equals(w)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(b){if(b)if(b instanceof P)this.rgba=b;else if(b instanceof n)this.i=b,this.rgba=n.toRGBA(b);else if(b instanceof j)this.j=b,this.rgba=j.toRGBA(b);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(b){return!!b&&P.equals(this.rgba,b.rgba)&&n.equals(this.hsla,b.hsla)&&j.equals(this.hsva,b.hsva)}getRelativeLuminance(){const b=A.k(this.rgba.r),w=A.k(this.rgba.g),y=A.k(this.rgba.b),M=.2126*b+.7152*w+.0722*y;return k(M,4)}static k(b){const w=b/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y?(w+.05)/(y+.05):(y+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w>y}isDarkerThan(b){const w=this.getRelativeLuminance(),y=b.getRelativeLuminance();return w<y}lighten(b){return new A(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*b,this.hsla.a))}darken(b){return new A(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*b,this.hsla.a))}transparent(b){const{r:w,g:y,b:M,a:r}=this.rgba;return new A(new P(w,y,M,r*b))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new P(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(b){const w=b.rgba,y=this.rgba.a,M=w.a,r=y+M*(1-y);if(r<1e-6)return A.transparent;const u=this.rgba.r*y/r+w.r*M*(1-y)/r,e=this.rgba.g*y/r+w.g*M*(1-y)/r,s=this.rgba.b*y/r+w.b*M*(1-y)/r;return new A(new P(u,e,s,r))}makeOpaque(b){if(this.isOpaque()||b.rgba.a!==1)return this;const{r:w,g:y,b:M,a:r}=this.rgba;return new A(new P(b.rgba.r-r*(b.rgba.r-w),b.rgba.g-r*(b.rgba.g-y),b.rgba.b-r*(b.rgba.b-M),1))}flatten(...b){const w=b.reduceRight((y,M)=>A.o(M,y));return A.o(this,w)}static o(b,w){const y=1-b.rgba.a;return new A(new P(y*w.rgba.r+b.rgba.a*b.rgba.r,y*w.rgba.g+b.rgba.a*b.rgba.g,y*w.rgba.b+b.rgba.a*b.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(b,w,y){if(b.isLighterThan(w))return b;y=y||.5;const M=b.getRelativeLuminance(),r=w.getRelativeLuminance();return y=y*(r-M)/r,b.lighten(y)}static getDarkerColor(b,w,y){if(b.isDarkerThan(w))return b;y=y||.5;const M=b.getRelativeLuminance(),r=w.getRelativeLuminance();return y=y*(M-r)/M,b.darken(y)}static{this.white=new A(new P(255,255,255,1))}static{this.black=new A(new P(0,0,0,1))}static{this.red=new A(new P(255,0,0,1))}static{this.blue=new A(new P(0,0,255,1))}static{this.green=new A(new P(0,255,0,1))}static{this.cyan=new A(new P(0,255,255,1))}static{this.lightgrey=new A(new P(211,211,211,1))}static{this.transparent=new A(new P(0,0,0,0))}}t.$mt=A,function(S){let b;(function(w){let y;(function(M){function r(h){return h.rgba.a===1?`rgb(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b})`:S.Format.CSS.formatRGBA(h)}M.formatRGB=r;function u(h){return`rgba(${h.rgba.r}, ${h.rgba.g}, ${h.rgba.b}, ${+h.rgba.a.toFixed(2)})`}M.formatRGBA=u;function e(h){return h.hsla.a===1?`hsl(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(h)}M.formatHSL=e;function s(h){return`hsla(${h.hsla.h}, ${(h.hsla.s*100).toFixed(2)}%, ${(h.hsla.l*100).toFixed(2)}%, ${h.hsla.a.toFixed(2)})`}M.formatHSLA=s;function m(h){const F=h.toString(16);return F.length!==2?"0"+F:F}function d(h){return`#${m(h.rgba.r)}${m(h.rgba.g)}${m(h.rgba.b)}`}M.formatHex=d;function o(h,F=!1){return F&&h.rgba.a===1?S.Format.CSS.formatHex(h):`#${m(h.rgba.r)}${m(h.rgba.g)}${m(h.rgba.b)}${m(Math.round(h.rgba.a*255))}`}M.formatHexA=o;function $(h){return h.isOpaque()?S.Format.CSS.formatHex(h):S.Format.CSS.formatRGBA(h)}M.format=$;function c(h){const F=h.length;if(F===0||h.charCodeAt(0)!==35)return null;if(F===7){const O=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),B=16*f(h.charCodeAt(5))+f(h.charCodeAt(6));return new S(new P(O,R,B,1))}if(F===9){const O=16*f(h.charCodeAt(1))+f(h.charCodeAt(2)),R=16*f(h.charCodeAt(3))+f(h.charCodeAt(4)),B=16*f(h.charCodeAt(5))+f(h.charCodeAt(6)),v=16*f(h.charCodeAt(7))+f(h.charCodeAt(8));return new S(new P(O,R,B,v/255))}if(F===4){const O=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),B=f(h.charCodeAt(3));return new S(new P(16*O+O,16*R+R,16*B+B))}if(F===5){const O=f(h.charCodeAt(1)),R=f(h.charCodeAt(2)),B=f(h.charCodeAt(3)),v=f(h.charCodeAt(4));return new S(new P(16*O+O,16*R+R,16*B+B,(16*v+v)/255))}return null}M.parseHex=c;function f(h){switch(h){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=w.CSS||(w.CSS={}))})(b=S.Format||(S.Format={}))}(A||(t.$mt=A={}))}),define(be[27],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zh=t.$yh=t.$xh=void 0;function k(A){return(S,b,w)=>{let y=null,M=null;if(typeof w.value=="function"?(y="value",M=w.value):typeof w.get=="function"&&(y="get",M=w.get),!M)throw new Error("not supported");w[y]=A(M,b)}}function P(A,S,b){let w=null,y=null;if(typeof b.value=="function"?(w="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(w="get",y=b.get),!y)throw new Error("not supported");const M=`$memoize$${S}`;b[w]=function(...r){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,r)}),this[M]}}t.$xh=P;function n(A,S,b){return k((w,y)=>{const M=`$debounce$${y}`,r=`$debounce$result$${y}`;return function(...u){this[r]||(this[r]=b?b():void 0),clearTimeout(this[M]),S&&(this[r]=S(this[r],...u),u=[this[r]]),this[M]=setTimeout(()=>{w.apply(this,u),this[r]=b?b():void 0},A)}})}t.$yh=n;function j(A,S,b){return k((w,y)=>{const M=`$throttle$timer$${y}`,r=`$throttle$result$${y}`,u=`$throttle$lastRun$${y}`,e=`$throttle$pending$${y}`;return function(...s){if(this[r]||(this[r]=b?b():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),S&&(this[r]=S(this[r],...s)),this[e])return;const m=this[u]+A;m<=Date.now()?(this[u]=Date.now(),w.apply(this,[this[r]]),this[r]=b?b():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[u]=Date.now(),w.apply(this,[this[r]]),this[r]=b?b():void 0},m-Date.now()))}})}t.$zh=j}),define(be[75],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=void 0;class k{constructor(n,j,A,S){this.originalStart=n,this.originalLength=j,this.modifiedStart=A,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Xs=k}),define(be[6],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class k{constructor(){this.b=[],this.a=function(h){setTimeout(()=>{throw h.stack?$.isErrorNoTelemetry(h)?new $(h.message+`

`+h.stack):new Error(h.message+`

`+h.stack):h},0)}}addListener(h){return this.b.push(h),()=>{this.d(h)}}c(h){this.b.forEach(F=>{F(h)})}d(h){this.b.splice(this.b.indexOf(h),1)}setUnexpectedErrorHandler(h){this.a=h}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(h){this.a(h),this.c(h)}onUnexpectedExternalError(h){this.a(h)}}t.$W=k,t.$X=new k;function P(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=P;function n(f){if(!f||typeof f!="object")return!1;const h=f;return h.code==="EPIPE"&&h.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function j(f){w(f)||t.$X.onUnexpectedError(f)}t.$1=j;function A(f){w(f)||t.$X.onUnexpectedExternalError(f)}t.$2=A;function S(f){if(f instanceof Error){const{name:h,message:F}=f,O=f.stacktrace||f.stack;return{$isError:!0,name:h,message:F,stack:O,noTelemetry:$.isErrorNoTelemetry(f)}}return f}t.$3=S;const b="Canceled";function w(f){return f instanceof y?!0:f instanceof Error&&f.name===b&&f.message===b}t.$4=w;class y extends Error{constructor(){super(b),this.name=this.message}}t.$5=y;function M(){const f=new Error(b);return f.name=f.message,f}t.$6=M;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=r;function u(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=u;class e extends TypeError{constructor(h){super(h?`${h} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=s;class m extends Error{constructor(h){super("NotImplemented"),h&&(this.message=h)}}t.$$=m;class d extends Error{constructor(h){super("NotSupported"),h&&(this.message=h)}}t.$_=d;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=o;class $ extends Error{constructor(h){super(h),this.name="CodeExpectedError"}static fromError(h){if(h instanceof $)return h;const F=new $;return F.message=h.message,F.stack=h.stack,F}static isErrorNoTelemetry(h){return h.name==="CodeExpectedError"}}t.$bb=$;class c extends Error{constructor(h){super(h||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$cb=c}),define(be[12],$e([1,0,6,72]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(K,g=0){return K[K.length-(1+g)]}t.$sb=n;function j(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}t.$tb=j;function A(K,g,D=(p,l)=>p===l){if(K===g)return!0;if(!K||!g||K.length!==g.length)return!1;for(let p=0,l=K.length;p<l;p++)if(!D(K[p],g[p]))return!1;return!0}t.$ub=A;function S(K,g){const D=K.length-1;g<D&&(K[g]=K[D]),K.pop()}t.$vb=S;function b(K,g,D){return w(K.length,p=>D(K[p],g))}t.$wb=b;function w(K,g){let D=0,p=K-1;for(;D<=p;){const l=(D+p)/2|0,i=g(l);if(i<0)D=l+1;else if(i>0)p=l-1;else return l}return-(D+1)}t.$xb=w;function y(K,g,D){if(K=K|0,K>=g.length)throw new TypeError("invalid index");const p=g[Math.floor(g.length*Math.random())],l=[],i=[],a=[];for(const E of g){const I=D(E,p);I<0?l.push(E):I>0?i.push(E):a.push(E)}return K<l.length?y(K,l,D):K<l.length+a.length?a[0]:y(K-(l.length+a.length),i,D)}t.$yb=y;function M(K,g){const D=[];let p;for(const l of K.slice(0).sort(g))!p||g(p[0],l)!==0?(p=[l],D.push(p)):p.push(l);return D}t.$zb=M;function*r(K,g){let D,p;for(const l of K)p!==void 0&&g(p,l)?D.push(l):(D&&(yield D),D=[l]),p=l;D&&(yield D)}t.$Ab=r;function u(K,g){for(let D=0;D<=K.length;D++)g(D===0?void 0:K[D-1],D===K.length?void 0:K[D])}t.$Bb=u;function e(K,g){for(let D=0;D<K.length;D++)g(D===0?void 0:K[D-1],K[D],D+1===K.length?void 0:K[D+1])}t.$Cb=e;function s(K,g,D){const p=[];function l(E,I,N){if(I===0&&N.length===0)return;const H=p[p.length-1];H&&H.start+H.deleteCount===E?(H.deleteCount+=I,H.toInsert.push(...N)):p.push({start:E,deleteCount:I,toInsert:N})}let i=0,a=0;for(;;){if(i===K.length){l(i,0,g.slice(a));break}if(a===g.length){l(i,K.length-i,[]);break}const E=K[i],I=g[a],N=D(E,I);N===0?(i+=1,a+=1):N<0?(l(i,1,[]),i+=1):N>0&&(l(i,0,[I]),a+=1)}return p}t.$Db=s;function m(K,g,D){const p=s(K,g,D),l=[],i=[];for(const a of p)l.push(...K.slice(a.start,a.start+a.deleteCount)),i.push(...a.toInsert);return{removed:l,added:i}}t.$Eb=m;function d(K,g,D){if(D===0)return[];const p=K.slice(0,D).sort(g);return $(K,g,p,D,K.length),p}t.top=d;function o(K,g,D,p,l){return D===0?Promise.resolve([]):new Promise((i,a)=>{(async()=>{const E=K.length,I=K.slice(0,D).sort(g);for(let N=D,H=Math.min(D+p,E);N<E;N=H,H=Math.min(H+p,E)){if(N>D&&await new Promise(_=>setTimeout(_)),l&&l.isCancellationRequested)throw new k.$5;$(K,g,I,N,H)}return I})().then(i,a)})}t.$Gb=o;function $(K,g,D,p,l){for(const i=D.length;p<l;p++){const a=K[p];if(g(a,D[i-1])<0){D.pop();const E=(0,P.$kb)(D,I=>g(a,I)<0);D.splice(E,0,a)}}}function c(K){return K.filter(g=>!!g)}t.$Hb=c;function f(K){let g=0;for(let D=0;D<K.length;D++)K[D]&&(K[g]=K[D],g+=1);K.length=g}t.$Ib=f;function h(K,g,D){K.splice(D,0,K.splice(g,1)[0])}t.$Jb=h;function F(K){return!Array.isArray(K)||K.length===0}t.$Kb=F;function O(K){return Array.isArray(K)&&K.length>0}t.$Lb=O;function R(K,g=D=>D){const D=new Set;return K.filter(p=>{const l=g(p);return D.has(l)?!1:(D.add(l),!0)})}t.$Mb=R;function B(K){const g=new Set;return D=>{const p=K(D);return g.has(p)?!1:(g.add(p),!0)}}t.$Nb=B;function v(K,g){return K.length>0?K[0]:g}t.$Ob=v;function C(K,g){return K.length>0?K[K.length-1]:g}t.$Pb=C;function V(K,g,D=(p,l)=>p===l){let p=0;for(let l=0,i=Math.min(K.length,g.length);l<i&&D(K[l],g[l]);l++)p++;return p}t.$Qb=V;function U(K){return[].concat(...K)}t.$Rb=U;function T(K,g){let D=typeof g=="number"?K:0;typeof g=="number"?D=K:(D=0,g=K);const p=[];if(D<=g)for(let l=D;l<g;l++)p.push(l);else for(let l=D;l>g;l--)p.push(l);return p}t.$Sb=T;function L(K,g,D){return K.reduce((p,l)=>(p[g(l)]=D?D(l):l,p),Object.create(null))}t.$Tb=L;function z(K,g){return K.push(g),()=>X(K,g)}t.$Ub=z;function X(K,g){const D=K.indexOf(g);if(D>-1)return K.splice(D,1),g}t.$Vb=X;function Y(K,g,D){const p=K.slice(0,g),l=K.slice(g);return p.concat(D,l)}t.$Wb=Y;function fe(K,g){let D;if(typeof g=="number"){let p=g;D=()=>{const l=Math.sin(p++)*179426549;return l-Math.floor(l)}}else D=Math.random;for(let p=K.length-1;p>0;p-=1){const l=Math.floor(D()*(p+1)),i=K[p];K[p]=K[l],K[l]=i}}t.$Xb=fe;function le(K,g){const D=K.indexOf(g);D>-1&&(K.splice(D,1),K.unshift(g))}t.$Yb=le;function ee(K,g){const D=K.indexOf(g);D>-1&&(K.splice(D,1),K.push(g))}t.$Zb=ee;function ge(K,g){for(const D of g)K.push(D)}t.$1b=ge;function Le(K,g){return Array.isArray(K)?K.map(g):g(K)}t.$2b=Le;function Ne(K){return Array.isArray(K)?K:[K]}t.$3b=Ne;function Be(K){return K[Math.floor(Math.random()*K.length)]}t.$4b=Be;function ne(K,g,D){const p=se(K,g),l=K.length,i=D.length;K.length=l+i;for(let a=l-1;a>=p;a--)K[a+i]=K[a];for(let a=0;a<i;a++)K[a+p]=D[a]}t.$5b=ne;function J(K,g,D,p){const l=se(K,g);let i=K.splice(l,D);return i===void 0&&(i=[]),ne(K,l,p),i}t.$6b=J;function se(K,g){return g<0?Math.max(g+K.length,0):Math.min(g,K.length)}var oe;(function(K){function g(i){return i<0}K.isLessThan=g;function D(i){return i<=0}K.isLessThanOrEqual=D;function p(i){return i>0}K.isGreaterThan=p;function l(i){return i===0}K.isNeitherLessOrGreaterThan=l,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(oe||(t.CompareResult=oe={}));function W(K,g){return(D,p)=>g(K(D),K(p))}t.$7b=W;function G(...K){return(g,D)=>{for(const p of K){const l=p(g,D);if(!oe.isNeitherLessOrGreaterThan(l))return l}return oe.neitherLessOrGreaterThan}}t.$8b=G;const ue=(K,g)=>K-g;t.$9b=ue;const me=(K,g)=>(0,t.$9b)(K?1:0,g?1:0);t.$0b=me;function Se(K){return(g,D)=>-K(g,D)}t.$$b=Se;class ke{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let D=this.c;for(;D<this.g.length&&g(this.g[D]);)D++;const p=D===this.c?null:this.g.slice(this.c,D);return this.c=D,p}takeFromEndWhile(g){let D=this.d;for(;D>=0&&g(this.g[D]);)D--;const p=D===this.d?null:this.g.slice(D+1,this.d+1);return this.d=D,p}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const D=this.g.slice(this.c,this.c+g);return this.c+=g,D}}t.$_b=ke;class Ce{static{this.empty=new Ce(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(D=>(g(D),!0))}toArray(){const g=[];return this.iterate(D=>(g.push(D),!0)),g}filter(g){return new Ce(D=>this.iterate(p=>g(p)?D(p):!0))}map(g){return new Ce(D=>this.iterate(p=>D(g(p))))}some(g){let D=!1;return this.iterate(p=>(D=g(p),!D)),D}findFirst(g){let D;return this.iterate(p=>g(p)?(D=p,!1):!0),D}findLast(g){let D;return this.iterate(p=>(g(p)&&(D=p),!0)),D}findLastMaxBy(g){let D,p=!0;return this.iterate(l=>((p||oe.isGreaterThan(g(l,D)))&&(p=!1,D=l),!0)),D}}t.$ac=Ce}),define(be[76],$e([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function P(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=P;function n(b,w="Unreachable"){throw new Error(w)}t.$6c=n;function j(b){if(!b)throw new k.$cb("Assertion Failed")}t.$7c=j;function A(b){if(!b()){debugger;b(),(0,k.$1)(new k.$cb("Assertion Failed"))}}t.$8c=A;function S(b,w){let y=0;for(;y<b.length-1;){const M=b[y],r=b[y+1];if(!w(M,r))return!1;y++}return!0}t.$9c=S}),define(be[43],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function k(P,n){const j=this;let A=!1,S;return function(){if(A)return S;if(A=!0,n)try{S=P.apply(j,arguments)}finally{n()}else S=P.apply(j,arguments);return S}}t.$db=k}),define(be[77],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nN=t.$mN=void 0;class k{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$mN=k,t.$nN=new k("id#")}),define(be[28],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(P){function n(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}P.is=n;const j=Object.freeze([]);function A(){return j}P.empty=A;function*S(h){yield h}P.single=S;function b(h){return n(h)?h:S(h)}P.wrap=b;function w(h){return h||j}P.from=w;function*y(h){for(let F=h.length-1;F>=0;F--)yield h[F]}P.reverse=y;function M(h){return!h||h[Symbol.iterator]().next().done===!0}P.isEmpty=M;function r(h){return h[Symbol.iterator]().next().value}P.first=r;function u(h,F){for(const O of h)if(F(O))return!0;return!1}P.some=u;function e(h,F){for(const O of h)if(F(O))return O}P.find=e;function*s(h,F){for(const O of h)F(O)&&(yield O)}P.filter=s;function*m(h,F){let O=0;for(const R of h)yield F(R,O++)}P.map=m;function*d(...h){for(const F of h)yield*F}P.concat=d;function o(h,F,O){let R=O;for(const B of h)R=F(R,B);return R}P.reduce=o;function*$(h,F,O=h.length){for(F<0&&(F+=h.length),O<0?O+=h.length:O>h.length&&(O=h.length);F<O;F++)yield h[F]}P.slice=$;function c(h,F=Number.POSITIVE_INFINITY){const O=[];if(F===0)return[O,h];const R=h[Symbol.iterator]();for(let B=0;B<F;B++){const v=R.next();if(v.done)return[O,P.empty()];O.push(v.value)}return[O,{[Symbol.iterator](){return R}}]}P.consume=c;async function f(h){const F=[];for await(const O of h)F.push(O);return Promise.resolve(F)}P.asyncToArray=f})(k||(t.Iterable=k={}))}),define(be[44],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7q=t.KeyMod=t.KeyCodeUtils=t.$6q=t.$5q=t.$4q=t.$3q=t.$2q=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var P;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(P||(t.ScanCode=P={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,m){this._keyCodeToStr[s]=m,this._strToKeyCode[m.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const j=new n,A=new n,S=new n;t.$2q=new Array(230),t.$3q={};const b=[],w=Object.create(null),y=Object.create(null);t.$4q={lowerCaseToEnum:e=>y[e]||0,toEnum:e=>w[e]||0,toString:e=>b[e]||"None"},t.$5q=[],t.$6q=[];for(let e=0;e<=193;e++)t.$5q[e]=-1;for(let e=0;e<=132;e++)t.$6q[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],m=[],d=[];for(const o of s){const[$,c,f,h,F,O,R,B,v]=o;if(d[c]||(d[c]=!0,b[c]=f,w[f]=c,y[f.toLowerCase()]=c,$&&(t.$5q[c]=h,h!==0&&h!==3&&h!==5&&h!==4&&h!==6&&h!==57&&(t.$6q[h]=c))),!m[h]){if(m[h]=!0,!F)throw new Error(`String representation missing for key code ${h} around scan code ${f}`);j.define(h,F),A.define(h,B||F),S.define(h,v||B||F)}O&&(t.$2q[O]=h),R&&(t.$3q[R]=h)}t.$6q[3]=46})();var M;(function(e){function s(f){return j.keyCodeToStr(f)}e.toString=s;function m(f){return j.strToKeyCode(f)}e.fromString=m;function d(f){return A.keyCodeToStr(f)}e.toUserSettingsUS=d;function o(f){return S.keyCodeToStr(f)}e.toUserSettingsGeneral=o;function $(f){return A.strToKeyCode(f)||S.strToKeyCode(f)}e.fromUserSettings=$;function c(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return j.keyCodeToStr(f)}e.toElectronAccelerator=c})(M||(t.KeyCodeUtils=M={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function u(e,s){const m=(s&65535)<<16>>>0;return(e|m)>>>0}t.$7q=u}),define(be[78],$e([1,0,6]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$br=t.$ar=t.$_q=t.$$q=t.$0q=t.$9q=t.$8q=void 0;var P;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(P||(P={}));function n(M,r){if(typeof M=="number"){if(M===0)return null;const u=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new b([j(u,r),j(e,r)]):new b([j(u,r)])}else{const u=[];for(let e=0;e<M.length;e++)u.push(j(M[e],r));return new b(u)}}t.$8q=n;function j(M,r){const u=!!(M&2048),e=!!(M&256),s=r===2?e:u,m=!!(M&1024),d=!!(M&512),o=r===2?u:e,$=M&255;return new A(s,m,d,o,$)}t.$9q=j;class A{constructor(r,u,e,s,m){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.keyCode=m}equals(r){return r instanceof A&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${r}${u}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$0q=A;class S{constructor(r,u,e,s,m){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.scanCode=m}equals(r){return r instanceof S&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",u=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${r}${u}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$$q=S;class b{constructor(r){if(r.length===0)throw(0,k.$7)("chords");this.chords=r}getHashCode(){let r="";for(let u=0,e=this.chords.length;u<e;u++)u!==0&&(r+=";"),r+=this.chords[u].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let u=0;u<this.chords.length;u++)if(!this.chords[u].equals(r.chords[u]))return!1;return!0}}t.$_q=b;class w{constructor(r,u,e,s,m,d){this.ctrlKey=r,this.shiftKey=u,this.altKey=e,this.metaKey=s,this.keyLabel=m,this.keyAriaLabel=d}}t.$ar=w;class y{}t.$br=y}),define(be[23],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class k{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=k}),define(be[45],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class k{static{this.Undefined=new k(void 0)}constructor(j){this.element=j,this.next=k.Undefined,this.prev=k.Undefined}}class P{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let j=this.a;for(;j!==k.Undefined;){const A=j.next;j.prev=k.Undefined,j.next=k.Undefined,j=A}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,A){const S=new k(j);if(this.a===k.Undefined)this.a=S,this.b=S;else if(A){const w=this.b;this.b=S,S.prev=w,w.next=S}else{const w=this.a;this.a=S,S.next=w,w.prev=S}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(S))}}shift(){if(this.a!==k.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==k.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==k.Undefined&&j.next!==k.Undefined){const A=j.prev;A.next=j.next,j.next.prev=A}else j.prev===k.Undefined&&j.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):j.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):j.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==k.Undefined;)yield j.element,j=j.next}}t.$4c=P}),define(be[32],$e([1,0]),function(ie,t){"use strict";var k,P,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function j($,c,f){let h=$.get(c);return h===void 0&&(h=f,$.set(c,h)),h}t.$xc=j;function A($){const c=[];return $.forEach((f,h)=>{c.push(`${h} => ${f}`)}),`Map(${$.size}) {${c.join(", ")}}`}t.$yc=A;function S($){const c=[];return $.forEach(f=>{c.push(f)}),`Set(${$.size}) {${c.join(", ")}}`}t.$zc=S;class b{constructor(c,f){this.uri=c,this.value=f}}function w($){return Array.isArray($)}class y{static{this.c=c=>c.toString()}constructor(c,f){if(this[k]="ResourceMap",c instanceof y)this.d=new Map(c.d),this.e=f??y.c;else if(w(c)){this.d=new Map,this.e=f??y.c;for(const[h,F]of c)this.set(h,F)}else this.d=new Map,this.e=c??y.c}set(c,f){return this.d.set(this.e(c),new b(c,f)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[h,F]of this.d)c(F.value,F.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}t.$Ac=y;class M{constructor(c,f){this[P]="ResourceSet",!c||typeof c=="function"?this.c=new y(c):(this.c=new y(f),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,f){this.c.forEach((h,F)=>c.call(f,F,F,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=M;var r;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(r||(t.Touch=r={}));class u{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,f=0){const h=this.c.get(c);if(h)return f!==0&&this.l(h,f),h.value}set(c,f,h=0){let F=this.c.get(c);if(F)F.value=f,h!==0&&this.l(F,h);else{switch(F={key:c,value:f,next:void 0,previous:void 0},h){case 0:this.j(F);break;case 1:this.i(F);break;case 2:this.j(F);break;default:this.j(F);break}this.c.set(c,F),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.c.get(c);if(f)return this.c.delete(c),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,f){const h=this.g;let F=this.d;for(;F;){if(f?c.bind(f)(F.value,F.key,this):c(F.value,F.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");F=F.next}}keys(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:h.key,done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return F}values(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:h.value,done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return F}entries(){const c=this,f=this.g;let h=this.d;const F={[Symbol.iterator](){return F},next(){if(c.g!==f)throw new Error("LinkedMap got modified during iteration.");if(h){const O={value:[h.key,h.value],done:!1};return h=h.next,O}else return{value:void 0,done:!0}}};return F}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.d,h=this.size;for(;f&&h>c;)this.c.delete(f.key),f=f.next,h--;this.d=f,this.f=h,f&&(f.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const f=c.next,h=c.previous;if(!f||!h)throw new Error("Invalid list");f.previous=h,h.next=f}c.next=void 0,c.previous=void 0,this.g++}l(c,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.d)return;const h=c.next,F=c.previous;c===this.e?(F.next=void 0,this.e=F):(h.previous=F,F.next=h),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(f===2){if(c===this.e)return;const h=c.next,F=c.previous;c===this.d?(h.previous=void 0,this.d=h):(h.previous=F,F.next=h),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((f,h)=>{c.push([h,f])}),c}fromJSON(c){this.clear();for(const[f,h]of c)this.set(f,h)}}t.$Cc=u;class e extends u{constructor(c,f=1){super(),this.m=c,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let f=this.c.get(c)||0;return f===0?!1:(f--,f===0?this.c.delete(c):this.c.set(c,f),!0)}has(c){return this.c.has(c)}}t.$Ec=s;class m{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[f,h]of c)this.set(f,h)}clear(){this.c.clear(),this.d.clear()}set(c,f){this.c.set(c,f),this.d.set(f,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const f=this.c.get(c);return f===void 0?!1:(this.c.delete(c),this.d.delete(f),!0)}forEach(c,f){this.c.forEach((h,F)=>{c.call(f,h,F,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=m;class d{constructor(){this.c=new Map}add(c,f){let h=this.c.get(c);h||(h=new Set,this.c.set(c,h)),h.add(f)}delete(c,f){const h=this.c.get(c);h&&(h.delete(f),h.size===0&&this.c.delete(c))}forEach(c,f){const h=this.c.get(c);h&&h.forEach(f)}get(c){const f=this.c.get(c);return f||new Set}}t.$Gc=d;function o($,c){if($===c)return!0;if($.size!==c.size)return!1;for(const[f,h]of $)if(!c.has(f)||c.get(f)!==h)return!1;for(const[f]of c)if(!$.has(f))return!1;return!0}t.$Hc=o}),define(be[2],$e([1,0,12,73,32,43,28]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const S=!1;let b=null;class w{constructor(){this.b=new Map}static{this.a=0}c(z){let X=this.b.get(z);return X||(X={parent:null,source:null,isSingleton:!1,value:z,idx:w.a++},this.b.set(z,X)),X}trackDisposable(z){const X=this.c(z);X.source||(X.source=new Error().stack)}setParent(z,X){const Y=this.c(z);Y.parent=X}markAsDisposed(z){this.b.delete(z)}markAsSingleton(z){this.c(z).isSingleton=!0}f(z,X){const Y=X.get(z);if(Y)return Y;const fe=z.parent?this.f(this.c(z.parent),X):z;return X.set(z,fe),fe}getTrackedDisposables(){const z=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,z).isSingleton).flatMap(([Y])=>Y)}computeLeakingDisposables(z=10,X){let Y;if(X)Y=X;else{const Le=new Map,Ne=[...this.b.values()].filter(ne=>ne.source!==null&&!this.f(ne,Le).isSingleton);if(Ne.length===0)return;const Be=new Set(Ne.map(ne=>ne.value));if(Y=Ne.filter(ne=>!(ne.parent&&Be.has(ne.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function fe(Le){function Ne(ne,J){for(;ne.length>0&&J.some(se=>typeof se=="string"?se===ne[0]:ne[0].match(se));)ne.shift()}const Be=Le.source.split(`
`).map(ne=>ne.trim().replace("at ","")).filter(ne=>ne!=="");return Ne(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const le=new n.$Gc;for(const Le of Y){const Ne=fe(Le);for(let Be=0;Be<=Ne.length;Be++)le.add(Ne.slice(0,Be).join(`
`),Le)}Y.sort((0,k.$7b)(Le=>Le.idx,k.$9b));let ee="",ge=0;for(const Le of Y.slice(0,z)){ge++;const Ne=fe(Le),Be=[];for(let ne=0;ne<Ne.length;ne++){let J=Ne[ne];J=`(shared with ${le.get(Ne.slice(0,ne+1).join(`
`)).size}/${Y.length} leaks) at ${J}`;const oe=le.get(Ne.slice(0,ne).join(`
`)),W=(0,P.$K)([...oe].map(G=>fe(G)[ne]),G=>G);delete W[Ne[ne]];for(const[G,ue]of Object.entries(W))Be.unshift(`    - stacktraces of ${ue.length} other leaks continue with ${G}`);Be.unshift(J)}ee+=`


==================== Leaking disposable ${ge}/${Y.length}: ${Le.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return Y.length>z&&(ee+=`


... and ${Y.length-z} more leaking disposables

`),{leaks:Y,details:ee}}}t.$Ic=w;function y(L){b=L}if(t.$Jc=y,S){const L="__is_disposable_tracked__";y(new class{trackDisposable(z){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{z[L]||console.log(X)},3e3)}setParent(z,X){if(z&&z!==h.None)try{z[L]=!0}catch{}}markAsDisposed(z){if(z&&z!==h.None)try{z[L]=!0}catch{}}markAsSingleton(z){}})}function M(L){return b?.trackDisposable(L),L}t.$Kc=M;function r(L){b?.markAsDisposed(L)}t.$Lc=r;function u(L,z){b?.setParent(L,z)}function e(L,z){if(b)for(const X of L)b.setParent(X,z)}function s(L){return b?.markAsSingleton(L),L}t.$Mc=s;function m(L){return typeof L.dispose=="function"&&L.dispose.length===0}t.$Nc=m;function d(L){if(A.Iterable.is(L)){const z=[];for(const X of L)if(X)try{X.dispose()}catch(Y){z.push(Y)}if(z.length===1)throw z[0];if(z.length>1)throw new AggregateError(z,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}t.$Oc=d;function o(L){for(const z of L)m(z)&&z.dispose();return[]}t.$Pc=o;function $(...L){const z=c(()=>d(L));return e(L,z),z}t.$Qc=$;function c(L){const z=M({dispose:(0,j.$db)(()=>{r(z),L()})});return z}t.$Rc=c;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,M(this)}dispose(){this.g||(r(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(z){if(!z)return z;if(z===this)throw new Error("Cannot register a disposable on itself!");return u(z,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(z),z}delete(z){if(z){if(z===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(z),z.dispose()}}deleteAndLeak(z){z&&this.f.has(z)&&(this.f.delete(z),u(z,null))}}t.$Sc=f;class h{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,M(this),u(this.q,this)}dispose(){r(this),this.q.dispose()}B(z){if(z===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(z)}}t.$Tc=h;class F{constructor(){this.b=!1,M(this)}get value(){return this.b?void 0:this.a}set value(z){this.b||z===this.a||(this.a?.dispose(),z&&u(z,this),this.a=z)}clear(){this.value=void 0}dispose(){this.b=!0,r(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const z=this.a;return this.a=void 0,z&&u(z,null),z}}t.$Uc=F;class O{constructor(z){this.a=new F,this.b=!1,this.a.value=z}get value(){return this.a.value}set value(z){this.b||z===this.a.value||(this.a.value=z)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=O;class R{constructor(z){this.b=z,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class B{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(z){let X=z;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,r(this))},this}}t.$Xc=B;class v{constructor(){this.a=new Map}acquire(z,...X){let Y=this.a.get(z);Y||(Y={counter:0,object:this.b(z,...X)},this.a.set(z,Y));const{object:fe}=Y,le=(0,j.$db)(()=>{--Y.counter===0&&(this.c(z,Y.object),this.a.delete(z))});return Y.counter++,{object:fe,dispose:le}}}t.$Yc=v;class C{constructor(z){this.a=z}async acquire(z,...X){const Y=this.a.acquire(z,...X);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(fe){throw Y.dispose(),fe}}}t.$Zc=C;class V{constructor(z){this.object=z}dispose(){}}t.$1c=V;function U(L){const z=new f;try{L(z)}finally{z.dispose()}}t.$2c=U;class T{constructor(){this.a=new Map,this.b=!1,M(this)}dispose(){r(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(z){return this.a.has(z)}get size(){return this.a.size}get(z){return this.a.get(z)}set(z,X,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(z)?.dispose(),this.a.set(z,X)}deleteAndDispose(z){this.a.get(z)?.dispose(),this.a.delete(z)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=T}),function(ie,t){typeof define=="function"&&define.amd?define(be[79],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ie=typeof globalThis<"u"?globalThis:ie||self,t(ie.marked={}))}(this,function(ie){"use strict";function t(g,D){for(var p=0;p<D.length;p++){var l=D[p];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(g,l.key,l)}}function k(g,D,p){return D&&t(g.prototype,D),p&&t(g,p),Object.defineProperty(g,"prototype",{writable:!1}),g}function P(g,D){if(g){if(typeof g=="string")return n(g,D);var p=Object.prototype.toString.call(g).slice(8,-1);if(p==="Object"&&g.constructor&&(p=g.constructor.name),p==="Map"||p==="Set")return Array.from(g);if(p==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(p))return n(g,D)}}function n(g,D){(D==null||D>g.length)&&(D=g.length);for(var p=0,l=new Array(D);p<D;p++)l[p]=g[p];return l}function j(g,D){var p=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(p)return(p=p.call(g)).next.bind(p);if(Array.isArray(g)||(p=P(g))||D&&g&&typeof g.length=="number"){p&&(g=p);var l=0;return function(){return l>=g.length?{done:!0}:{done:!1,value:g[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=A();function S(g){ie.defaults=g}var b=/[&<>"']/,w=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(D){return r[D]};function e(g,D){if(D){if(b.test(g))return g.replace(w,u)}else if(y.test(g))return g.replace(M,u);return g}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(g){return g.replace(s,function(D,p){return p=p.toLowerCase(),p==="colon"?":":p.charAt(0)==="#"?p.charAt(1)==="x"?String.fromCharCode(parseInt(p.substring(2),16)):String.fromCharCode(+p.substring(1)):""})}var d=/(^|[^\[])\^/g;function o(g,D){g=typeof g=="string"?g:g.source,D=D||"";var p={replace:function(i,a){return a=a.source||a,a=a.replace(d,"$1"),g=g.replace(i,a),p},getRegex:function(){return new RegExp(g,D)}};return p}var $=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(g,D,p){if(g){var l;try{l=decodeURIComponent(m(p)).replace($,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}D&&!c.test(p)&&(p=B(D,p));try{p=encodeURI(p).replace(/%25/g,"%")}catch{return null}return p}var h={},F=/^[^:]+:\/*[^/]*$/,O=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function B(g,D){h[" "+g]||(F.test(g)?h[" "+g]=g+"/":h[" "+g]=U(g,"/",!0)),g=h[" "+g];var p=g.indexOf(":")===-1;return D.substring(0,2)==="//"?p?D:g.replace(O,"$1")+D:D.charAt(0)==="/"?p?D:g.replace(R,"$1")+D:g+D}var v={exec:function(){}};function C(g){for(var D=1,p,l;D<arguments.length;D++){p=arguments[D];for(l in p)Object.prototype.hasOwnProperty.call(p,l)&&(g[l]=p[l])}return g}function V(g,D){var p=g.replace(/\|/g,function(a,E,I){for(var N=!1,H=E;--H>=0&&I[H]==="\\";)N=!N;return N?"|":" |"}),l=p.split(/ \|/),i=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>D)l.splice(D);else for(;l.length<D;)l.push("");for(;i<l.length;i++)l[i]=l[i].trim().replace(/\\\|/g,"|");return l}function U(g,D,p){var l=g.length;if(l===0)return"";for(var i=0;i<l;){var a=g.charAt(l-i-1);if(a===D&&!p)i++;else if(a!==D&&p)i++;else break}return g.slice(0,l-i)}function T(g,D){if(g.indexOf(D[1])===-1)return-1;for(var p=g.length,l=0,i=0;i<p;i++)if(g[i]==="\\")i++;else if(g[i]===D[0])l++;else if(g[i]===D[1]&&(l--,l<0))return i;return-1}function L(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function z(g,D){if(D<1)return"";for(var p="";D>1;)D&1&&(p+=g),D>>=1,g+=g;return p+g}function X(g,D,p,l){var i=D.href,a=D.title?e(D.title):null,E=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){l.state.inLink=!0;var I={type:"link",raw:p,href:i,title:a,text:E,tokens:l.inlineTokens(E)};return l.state.inLink=!1,I}return{type:"image",raw:p,href:i,title:a,text:e(E)}}function Y(g,D){var p=g.match(/^(\s+)(?:```)/);if(p===null)return D;var l=p[1];return D.split(`
`).map(function(i){var a=i.match(/^\s+/);if(a===null)return i;var E=a[0];return E.length>=l.length?i.slice(l.length):i}).join(`
`)}var fe=function(){function g(p){this.options=p||ie.defaults}var D=g.prototype;return D.space=function(l){var i=this.rules.block.newline.exec(l);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},D.code=function(l){var i=this.rules.block.code.exec(l);if(i){var a=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?a:U(a,`
`)}}},D.fences=function(l){var i=this.rules.block.fences.exec(l);if(i){var a=i[0],E=Y(a,i[3]||"");return{type:"code",raw:a,lang:i[2]?i[2].trim():i[2],text:E}}},D.heading=function(l){var i=this.rules.block.heading.exec(l);if(i){var a=i[2].trim();if(/#$/.test(a)){var E=U(a,"#");(this.options.pedantic||!E||/ $/.test(E))&&(a=E.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:a,tokens:this.lexer.inline(a)}}},D.hr=function(l){var i=this.rules.block.hr.exec(l);if(i)return{type:"hr",raw:i[0]}},D.blockquote=function(l){var i=this.rules.block.blockquote.exec(l);if(i){var a=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(a,[]),text:a}}},D.list=function(l){var i=this.rules.block.list.exec(l);if(i){var a,E,I,N,H,_,Z,he,pe,ye,we,Ee,ve=i[1].trim(),Pe=ve.length>1,Ie={type:"list",raw:"",ordered:Pe,start:Pe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Pe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Pe?ve:"[*+-]");for(var Me=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ee=!1,!(!(i=Me.exec(l))||this.rules.block.hr.test(l)));){if(a=i[0],l=l.substring(a.length),he=i[2].split(`
`,1)[0],pe=l.split(`
`,1)[0],this.options.pedantic?(N=2,we=he.trimLeft()):(N=i[2].search(/[^ ]/),N=N>4?1:N,we=he.slice(N),N+=i[1].length),_=!1,!he&&/^ *$/.test(pe)&&(a+=pe+`
`,l=l.substring(pe.length+1),Ee=!0),!Ee)for(var Ye=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,N-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Qe=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,N-1)+"}#");l&&(ye=l.split(`
`,1)[0],he=ye,this.options.pedantic&&(he=he.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(he)||x.test(he)||Ye.test(he)||et.test(l)));){if(he.search(/[^ ]/)>=N||!he.trim())we+=`
`+he.slice(N);else if(!_)we+=`
`+he;else break;!_&&!he.trim()&&(_=!0),a+=ye+`
`,l=l.substring(ye.length+1)}Ie.loose||(Z?Ie.loose=!0:/\n *\n *$/.test(a)&&(Z=!0)),this.options.gfm&&(E=/^\[[ xX]\] /.exec(we),E&&(I=E[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:a,task:!!E,checked:I,loose:!1,text:we}),Ie.raw+=a}Ie.items[Ie.items.length-1].raw=a.trimRight(),Ie.items[Ie.items.length-1].text=we.trimRight(),Ie.raw=Ie.raw.trimRight();var re=Ie.items.length;for(H=0;H<re;H++){this.lexer.state.top=!1,Ie.items[H].tokens=this.lexer.blockTokens(Ie.items[H].text,[]);var de=Ie.items[H].tokens.filter(function(Te){return Te.type==="space"}),Ae=de.every(function(Te){for(var je=Te.raw.split(""),Ve=0,_e=j(je),Je;!(Je=_e()).done;){var tt=Je.value;if(tt===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ie.loose&&de.length&&Ae&&(Ie.loose=!0,Ie.items[H].loose=!0)}return Ie}},D.html=function(l){var i=this.rules.block.html.exec(l);if(i){var a={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var E=this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]);a.type="paragraph",a.text=E,a.tokens=this.lexer.inline(E)}return a}},D.def=function(l){var i=this.rules.block.def.exec(l);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var a=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:a,raw:i[0],href:i[2],title:i[3]}}},D.table=function(l){var i=this.rules.block.table.exec(l);if(i){var a={type:"table",header:V(i[1]).map(function(Z){return{text:Z}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(a.header.length===a.align.length){a.raw=i[0];var E=a.align.length,I,N,H,_;for(I=0;I<E;I++)/^ *-+: *$/.test(a.align[I])?a.align[I]="right":/^ *:-+: *$/.test(a.align[I])?a.align[I]="center":/^ *:-+ *$/.test(a.align[I])?a.align[I]="left":a.align[I]=null;for(E=a.rows.length,I=0;I<E;I++)a.rows[I]=V(a.rows[I],a.header.length).map(function(Z){return{text:Z}});for(E=a.header.length,N=0;N<E;N++)a.header[N].tokens=this.lexer.inline(a.header[N].text);for(E=a.rows.length,N=0;N<E;N++)for(_=a.rows[N],H=0;H<_.length;H++)_[H].tokens=this.lexer.inline(_[H].text);return a}}},D.lheading=function(l){var i=this.rules.block.lheading.exec(l);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},D.paragraph=function(l){var i=this.rules.block.paragraph.exec(l);if(i){var a=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:a,tokens:this.lexer.inline(a)}}},D.text=function(l){var i=this.rules.block.text.exec(l);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},D.escape=function(l){var i=this.rules.inline.escape.exec(l);if(i)return{type:"escape",raw:i[0],text:e(i[1])}},D.tag=function(l){var i=this.rules.inline.tag.exec(l);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]):i[0]}},D.link=function(l){var i=this.rules.inline.link.exec(l);if(i){var a=i[2].trim();if(!this.options.pedantic&&/^</.test(a)){if(!/>$/.test(a))return;var E=U(a.slice(0,-1),"\\");if((a.length-E.length)%2===0)return}else{var I=T(i[2],"()");if(I>-1){var N=i[0].indexOf("!")===0?5:4,H=N+i[1].length+I;i[2]=i[2].substring(0,I),i[0]=i[0].substring(0,H).trim(),i[3]=""}}var _=i[2],Z="";if(this.options.pedantic){var he=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(_);he&&(_=he[1],Z=he[3])}else Z=i[3]?i[3].slice(1,-1):"";return _=_.trim(),/^</.test(_)&&(this.options.pedantic&&!/>$/.test(a)?_=_.slice(1):_=_.slice(1,-1)),X(i,{href:_&&_.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},D.reflink=function(l,i){var a;if((a=this.rules.inline.reflink.exec(l))||(a=this.rules.inline.nolink.exec(l))){var E=(a[2]||a[1]).replace(/\s+/g," ");if(E=i[E.toLowerCase()],!E||!E.href){var I=a[0].charAt(0);return{type:"text",raw:I,text:I}}return X(a,E,a[0],this.lexer)}},D.emStrong=function(l,i,a){a===void 0&&(a="");var E=this.rules.inline.emStrong.lDelim.exec(l);if(E&&!(E[3]&&a.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=E[1]||E[2]||"";if(!I||I&&(a===""||this.rules.inline.punctuation.exec(a))){var N=E[0].length-1,H,_,Z=N,he=0,pe=E[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,i=i.slice(-1*l.length+N);(E=pe.exec(i))!=null;)if(H=E[1]||E[2]||E[3]||E[4]||E[5]||E[6],!!H){if(_=H.length,E[3]||E[4]){Z+=_;continue}else if((E[5]||E[6])&&N%3&&!((N+_)%3)){he+=_;continue}if(Z-=_,!(Z>0)){if(_=Math.min(_,_+Z+he),Math.min(N,_)%2){var ye=l.slice(1,N+E.index+_);return{type:"em",raw:l.slice(0,N+E.index+_+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var we=l.slice(2,N+E.index+_-1);return{type:"strong",raw:l.slice(0,N+E.index+_+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},D.codespan=function(l){var i=this.rules.inline.code.exec(l);if(i){var a=i[2].replace(/\n/g," "),E=/[^ ]/.test(a),I=/^ /.test(a)&&/ $/.test(a);return E&&I&&(a=a.substring(1,a.length-1)),a=e(a,!0),{type:"codespan",raw:i[0],text:a}}},D.br=function(l){var i=this.rules.inline.br.exec(l);if(i)return{type:"br",raw:i[0]}},D.del=function(l){var i=this.rules.inline.del.exec(l);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},D.autolink=function(l,i){var a=this.rules.inline.autolink.exec(l);if(a){var E,I;return a[2]==="@"?(E=e(this.options.mangle?i(a[1]):a[1]),I="mailto:"+E):(E=e(a[1]),I=E),{type:"link",raw:a[0],text:E,href:I,tokens:[{type:"text",raw:E,text:E}]}}},D.url=function(l,i){var a;if(a=this.rules.inline.url.exec(l)){var E,I;if(a[2]==="@")E=e(this.options.mangle?i(a[0]):a[0]),I="mailto:"+E;else{var N;do N=a[0],a[0]=this.rules.inline._backpedal.exec(a[0])[0];while(N!==a[0]);E=e(a[0]),a[1]==="www."?I="http://"+E:I=E}return{type:"link",raw:a[0],text:E,href:I,tokens:[{type:"text",raw:E,text:E}]}}},D.inlineText=function(l,i){var a=this.rules.inline.text.exec(l);if(a){var E;return this.lexer.state.inRawBlock?E=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(a[0]):e(a[0]):a[0]:E=e(this.options.smartypants?i(a[0]):a[0]),{type:"text",raw:a[0],text:E}}},g}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:v,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=o(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=o(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=o(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=o(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=o(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=o(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=C({},le),le.gfm=C({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=o(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=o(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=C({},le.normal,{html:o(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:v,paragraph:o(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:v,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:v,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=o(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=o(le._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=o(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=o(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=o(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=o(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=o(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=o(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=o(ee.reflink).replace("label",ee._label).replace("ref",le._label).getRegex(),ee.nolink=o(ee.nolink).replace("ref",le._label).getRegex(),ee.reflinkSearch=o(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=C({},ee),ee.pedantic=C({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:o(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:o(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=C({},ee.normal,{escape:o(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=o(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=C({},ee.gfm,{br:o(ee.br).replace("{2,}","*").getRegex(),text:o(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Le(g){var D="",p,l,i=g.length;for(p=0;p<i;p++)l=g.charCodeAt(p),Math.random()>.5&&(l="x"+l.toString(16)),D+="&#"+l+";";return D}var Ne=function(){function g(p){this.tokens=[],this.tokens.links=Object.create(null),this.options=p||ie.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:le.normal,inline:ee.normal};this.options.pedantic?(l.block=le.pedantic,l.inline=ee.pedantic):this.options.gfm&&(l.block=le.gfm,this.options.breaks?l.inline=ee.breaks:l.inline=ee.gfm),this.tokenizer.rules=l}g.lex=function(l,i){var a=new g(i);return a.lex(l)},g.lexInline=function(l,i){var a=new g(i);return a.inlineTokens(l)};var D=g.prototype;return D.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},D.blockTokens=function(l,i){var a=this;i===void 0&&(i=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(Z,he,pe){return he+"    ".repeat(pe.length)});for(var E,I,N,H;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(E=Z.call({lexer:a},l,i))?(l=l.substring(E.raw.length),i.push(E),!0):!1}))){if(E=this.tokenizer.space(l)){l=l.substring(E.raw.length),E.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(E);continue}if(E=this.tokenizer.code(l)){l=l.substring(E.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+E.raw,I.text+=`
`+E.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(E);continue}if(E=this.tokenizer.fences(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.heading(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.hr(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.blockquote(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.list(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.html(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.def(l)){l=l.substring(E.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+E.raw,I.text+=`
`+E.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[E.tag]||(this.tokens.links[E.tag]={href:E.href,title:E.title});continue}if(E=this.tokenizer.table(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.lheading(l)){l=l.substring(E.raw.length),i.push(E);continue}if(N=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,he=l.slice(1),pe=void 0;a.options.extensions.startBlock.forEach(function(ye){pe=ye.call({lexer:this},he),typeof pe=="number"&&pe>=0&&(Z=Math.min(Z,pe))}),Z<1/0&&Z>=0&&(N=l.substring(0,Z+1))}(),this.state.top&&(E=this.tokenizer.paragraph(N))){I=i[i.length-1],H&&I.type==="paragraph"?(I.raw+=`
`+E.raw,I.text+=`
`+E.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(E),H=N.length!==l.length,l=l.substring(E.raw.length);continue}if(E=this.tokenizer.text(l)){l=l.substring(E.raw.length),I=i[i.length-1],I&&I.type==="text"?(I.raw+=`
`+E.raw,I.text+=`
`+E.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(E);continue}if(l){var _="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return this.state.top=!0,i},D.inline=function(l,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:l,tokens:i}),i},D.inlineTokens=function(l,i){var a=this;i===void 0&&(i=[]);var E,I,N,H=l,_,Z,he;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(_=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)pe.includes(_[0].slice(_[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,_.index)+"["+z("a",_[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(_=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,_.index)+"["+z("a",_[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(_=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,_.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(Z||(he=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(E=we.call({lexer:a},l,i))?(l=l.substring(E.raw.length),i.push(E),!0):!1}))){if(E=this.tokenizer.escape(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.tag(l)){l=l.substring(E.raw.length),I=i[i.length-1],I&&E.type==="text"&&I.type==="text"?(I.raw+=E.raw,I.text+=E.text):i.push(E);continue}if(E=this.tokenizer.link(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(E.raw.length),I=i[i.length-1],I&&E.type==="text"&&I.type==="text"?(I.raw+=E.raw,I.text+=E.text):i.push(E);continue}if(E=this.tokenizer.emStrong(l,H,he)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.codespan(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.br(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.del(l)){l=l.substring(E.raw.length),i.push(E);continue}if(E=this.tokenizer.autolink(l,Le)){l=l.substring(E.raw.length),i.push(E);continue}if(!this.state.inLink&&(E=this.tokenizer.url(l,Le))){l=l.substring(E.raw.length),i.push(E);continue}if(N=l,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ee=l.slice(1),ve=void 0;a.options.extensions.startInline.forEach(function(Pe){ve=Pe.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(we=Math.min(we,ve))}),we<1/0&&we>=0&&(N=l.substring(0,we+1))}(),E=this.tokenizer.inlineText(N,ge)){l=l.substring(E.raw.length),E.raw.slice(-1)!=="_"&&(he=E.raw.slice(-1)),Z=!0,I=i[i.length-1],I&&I.type==="text"?(I.raw+=E.raw,I.text+=E.text):i.push(E);continue}if(l){var ye="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return i},k(g,null,[{key:"rules",get:function(){return{block:le,inline:ee}}}]),g}(),Be=function(){function g(p){this.options=p||ie.defaults}var D=g.prototype;return D.code=function(l,i,a){var E=(i||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(l,E);I!=null&&I!==l&&(a=!0,l=I)}return l=l.replace(/\n$/,"")+`
`,E?'<pre><code class="'+this.options.langPrefix+e(E,!0)+'">'+(a?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(a?l:e(l,!0))+`</code></pre>
`},D.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},D.html=function(l){return l},D.heading=function(l,i,a,E){if(this.options.headerIds){var I=this.options.headerPrefix+E.slug(a);return"<h"+i+' id="'+I+'">'+l+"</h"+i+`>
`}return"<h"+i+">"+l+"</h"+i+`>
`},D.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},D.list=function(l,i,a){var E=i?"ol":"ul",I=i&&a!==1?' start="'+a+'"':"";return"<"+E+I+`>
`+l+"</"+E+`>
`},D.listitem=function(l){return"<li>"+l+`</li>
`},D.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},D.paragraph=function(l){return"<p>"+l+`</p>
`},D.table=function(l,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+i+`</table>
`},D.tablerow=function(l){return`<tr>
`+l+`</tr>
`},D.tablecell=function(l,i){var a=i.header?"th":"td",E=i.align?"<"+a+' align="'+i.align+'">':"<"+a+">";return E+l+("</"+a+`>
`)},D.strong=function(l){return"<strong>"+l+"</strong>"},D.em=function(l){return"<em>"+l+"</em>"},D.codespan=function(l){return"<code>"+l+"</code>"},D.br=function(){return this.options.xhtml?"<br/>":"<br>"},D.del=function(l){return"<del>"+l+"</del>"},D.link=function(l,i,a){if(l=f(this.options.sanitize,this.options.baseUrl,l),l===null)return a;var E='<a href="'+e(l)+'"';return i&&(E+=' title="'+i+'"'),E+=">"+a+"</a>",E},D.image=function(l,i,a){if(l=f(this.options.sanitize,this.options.baseUrl,l),l===null)return a;var E='<img src="'+l+'" alt="'+a+'"';return i&&(E+=' title="'+i+'"'),E+=this.options.xhtml?"/>":">",E},D.text=function(l){return l},g}(),ne=function(){function g(){}var D=g.prototype;return D.strong=function(l){return l},D.em=function(l){return l},D.codespan=function(l){return l},D.del=function(l){return l},D.html=function(l){return l},D.text=function(l){return l},D.link=function(l,i,a){return""+a},D.image=function(l,i,a){return""+a},D.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var D=g.prototype;return D.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},D.getNextSafeSlug=function(l,i){var a=l,E=0;if(this.seen.hasOwnProperty(a)){E=this.seen[l];do E++,a=l+"-"+E;while(this.seen.hasOwnProperty(a))}return i||(this.seen[l]=E,this.seen[a]=0),a},D.slug=function(l,i){i===void 0&&(i={});var a=this.serialize(l);return this.getNextSafeSlug(a,i.dryrun)},g}(),se=function(){function g(p){this.options=p||ie.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new J}g.parse=function(l,i){var a=new g(i);return a.parse(l)},g.parseInline=function(l,i){var a=new g(i);return a.parseInline(l)};var D=g.prototype;return D.parse=function(l,i){i===void 0&&(i=!0);var a="",E,I,N,H,_,Z,he,pe,ye,we,Ee,ve,Pe,Ie,Me,Ye,et,Qe,x,re=l.length;for(E=0;E<re;E++){if(we=l[E],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(x=this.options.extensions.renderers[we.type].call({parser:this},we),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){a+=x||"";continue}switch(we.type){case"space":continue;case"hr":{a+=this.renderer.hr();continue}case"heading":{a+=this.renderer.heading(this.parseInline(we.tokens),we.depth,m(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{a+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(pe="",he="",H=we.header.length,I=0;I<H;I++)he+=this.renderer.tablecell(this.parseInline(we.header[I].tokens),{header:!0,align:we.align[I]});for(pe+=this.renderer.tablerow(he),ye="",H=we.rows.length,I=0;I<H;I++){for(Z=we.rows[I],he="",_=Z.length,N=0;N<_;N++)he+=this.renderer.tablecell(this.parseInline(Z[N].tokens),{header:!1,align:we.align[N]});ye+=this.renderer.tablerow(he)}a+=this.renderer.table(pe,ye);continue}case"blockquote":{ye=this.parse(we.tokens),a+=this.renderer.blockquote(ye);continue}case"list":{for(Ee=we.ordered,ve=we.start,Pe=we.loose,H=we.items.length,ye="",I=0;I<H;I++)Me=we.items[I],Ye=Me.checked,et=Me.task,Ie="",Me.task&&(Qe=this.renderer.checkbox(Ye),Pe?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=Qe+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=Qe+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:Qe}):Ie+=Qe),Ie+=this.parse(Me.tokens,Pe),ye+=this.renderer.listitem(Ie,et,Ye);a+=this.renderer.list(ye,Ee,ve);continue}case"html":{a+=this.renderer.html(we.text);continue}case"paragraph":{a+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ye=we.tokens?this.parseInline(we.tokens):we.text;E+1<re&&l[E+1].type==="text";)we=l[++E],ye+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);a+=i?this.renderer.paragraph(ye):ye;continue}default:{var de='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return a},D.parseInline=function(l,i){i=i||this.renderer;var a="",E,I,N,H=l.length;for(E=0;E<H;E++){if(I=l[E],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(N=this.options.extensions.renderers[I.type].call({parser:this},I),N!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){a+=N||"";continue}switch(I.type){case"escape":{a+=i.text(I.text);break}case"html":{a+=i.html(I.text);break}case"link":{a+=i.link(I.href,I.title,this.parseInline(I.tokens,i));break}case"image":{a+=i.image(I.href,I.title,I.text);break}case"strong":{a+=i.strong(this.parseInline(I.tokens,i));break}case"em":{a+=i.em(this.parseInline(I.tokens,i));break}case"codespan":{a+=i.codespan(I.text);break}case"br":{a+=i.br();break}case"del":{a+=i.del(this.parseInline(I.tokens,i));break}case"text":{a+=i.text(I.text);break}default:{var _='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return a},g}();function oe(g,D,p){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof D=="function"&&(p=D,D=null),D=C({},oe.defaults,D||{}),L(D),p){var l=D.highlight,i;try{i=Ne.lex(g,D)}catch(H){return p(H)}var a=function(_){var Z;if(!_)try{D.walkTokens&&oe.walkTokens(i,D.walkTokens),Z=se.parse(i,D)}catch(he){_=he}return D.highlight=l,_?p(_):p(null,Z)};if(!l||l.length<3||(delete D.highlight,!i.length))return a();var E=0;oe.walkTokens(i,function(H){H.type==="code"&&(E++,setTimeout(function(){l(H.text,H.lang,function(_,Z){if(_)return a(_);Z!=null&&Z!==H.text&&(H.text=Z,H.escaped=!0),E--,E===0&&a()})},0))}),E===0&&a();return}function I(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,D.silent)return"<p>An error occurred:</p><pre>"+e(H.message+"",!0)+"</pre>";throw H}try{var N=Ne.lex(g,D);if(D.walkTokens){if(D.async)return Promise.all(oe.walkTokens(N,D.walkTokens)).then(function(){return se.parse(N,D)}).catch(I);oe.walkTokens(N,D.walkTokens)}return se.parse(N,D)}catch(H){I(H)}}oe.options=oe.setOptions=function(g){return C(oe.defaults,g),S(oe.defaults),oe},oe.getDefaults=A,oe.defaults=ie.defaults,oe.use=function(){for(var g=arguments.length,D=new Array(g),p=0;p<g;p++)D[p]=arguments[p];var l=C.apply(void 0,[{}].concat(D)),i=oe.defaults.extensions||{renderers:{},childTokens:{}},a;D.forEach(function(E){if(E.extensions&&(a=!0,E.extensions.forEach(function(N){if(!N.name)throw new Error("extension name required");if(N.renderer){var H=i.renderers?i.renderers[N.name]:null;H?i.renderers[N.name]=function(){for(var _=arguments.length,Z=new Array(_),he=0;he<_;he++)Z[he]=arguments[he];var pe=N.renderer.apply(this,Z);return pe===!1&&(pe=H.apply(this,Z)),pe}:i.renderers[N.name]=N.renderer}if(N.tokenizer){if(!N.level||N.level!=="block"&&N.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[N.level]?i[N.level].unshift(N.tokenizer):i[N.level]=[N.tokenizer],N.start&&(N.level==="block"?i.startBlock?i.startBlock.push(N.start):i.startBlock=[N.start]:N.level==="inline"&&(i.startInline?i.startInline.push(N.start):i.startInline=[N.start]))}N.childTokens&&(i.childTokens[N.name]=N.childTokens)})),E.renderer&&function(){var N=oe.defaults.renderer||new Be,H=function(he){var pe=N[he];N[he]=function(){for(var ye=arguments.length,we=new Array(ye),Ee=0;Ee<ye;Ee++)we[Ee]=arguments[Ee];var ve=E.renderer[he].apply(N,we);return ve===!1&&(ve=pe.apply(N,we)),ve}};for(var _ in E.renderer)H(_);l.renderer=N}(),E.tokenizer&&function(){var N=oe.defaults.tokenizer||new fe,H=function(he){var pe=N[he];N[he]=function(){for(var ye=arguments.length,we=new Array(ye),Ee=0;Ee<ye;Ee++)we[Ee]=arguments[Ee];var ve=E.tokenizer[he].apply(N,we);return ve===!1&&(ve=pe.apply(N,we)),ve}};for(var _ in E.tokenizer)H(_);l.tokenizer=N}(),E.walkTokens){var I=oe.defaults.walkTokens;l.walkTokens=function(N){var H=[];return H.push(E.walkTokens.call(this,N)),I&&(H=H.concat(I.call(this,N))),H}}a&&(l.extensions=i),oe.setOptions(l)})},oe.walkTokens=function(g,D){for(var p=[],l=function(){var I=a.value;switch(p=p.concat(D.call(oe,I)),I.type){case"table":{for(var N=j(I.header),H;!(H=N()).done;){var _=H.value;p=p.concat(oe.walkTokens(_.tokens,D))}for(var Z=j(I.rows),he;!(he=Z()).done;)for(var pe=he.value,ye=j(pe),we;!(we=ye()).done;){var Ee=we.value;p=p.concat(oe.walkTokens(Ee.tokens,D))}break}case"list":{p=p.concat(oe.walkTokens(I.items,D));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[I.type]?oe.defaults.extensions.childTokens[I.type].forEach(function(ve){p=p.concat(oe.walkTokens(I[ve],D))}):I.tokens&&(p=p.concat(oe.walkTokens(I.tokens,D)))}},i=j(g),a;!(a=i()).done;)l();return p},oe.parseInline=function(g,D){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");D=C({},oe.defaults,D||{}),L(D);try{var p=Ne.lexInline(g,D);return D.walkTokens&&oe.walkTokens(p,D.walkTokens),se.parseInline(p,D)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,D.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},oe.Parser=se,oe.parser=se.parse,oe.Renderer=Be,oe.TextRenderer=ne,oe.Lexer=Ne,oe.lexer=Ne.lex,oe.Tokenizer=fe,oe.Slugger=J,oe.parse=oe;var W=oe.options,G=oe.setOptions,ue=oe.use,me=oe.walkTokens,Se=oe.parseInline,ke=oe,Ce=se.parse,K=Ne.lex;ie.Lexer=Ne,ie.Parser=se,ie.Renderer=Be,ie.Slugger=J,ie.TextRenderer=ne,ie.Tokenizer=fe,ie.getDefaults=A,ie.lexer=K,ie.marked=oe,ie.options=W,ie.parse=ke,ie.parseInline=Se,ie.parser=Ce,ie.setOptions=G,ie.use=ue,ie.walkTokens=me,Object.defineProperty(ie,"__esModule",{value:!0})}),define(be[80],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=void 0;function k(s){const m=j(s);if(m&&m.length>0)return new Uint32Array(m)}t.$Rj=k;let P=0;const n=new Uint32Array(10);function j(s){if(P=0,A(s,M,4352),P>0||(A(s,r,4449),P>0)||(A(s,u,4520),P>0)||(A(s,e,12593),P))return n.subarray(0,P);if(s>=44032&&s<=55203){const m=s-44032,d=m%588,o=Math.floor(m/588),$=Math.floor(d/28),c=d%28-1;if(o<M.length?A(o,M,0):4352+o-12593<e.length&&A(4352+o,e,12593),$<r.length?A($,r,0):4449+$-12593<e.length&&A(4449+$-12593,e,12593),c>=0&&(c<u.length?A(c,u,0):4520+c-12593<e.length&&A(4520+c-12593,e,12593)),P>0)return n.subarray(0,P)}}function A(s,m,d){s>=d&&s<d+m.length&&S(m[s-d])}function S(s){s!==0&&(n[P++]=s&255,s>>8&&(n[P++]=s>>8&255),s>>16&&(n[P++]=s>>16&255))}var b;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var w;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(w||(w={}));var y;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(y||(y={}));const M=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),r=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),u=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_S=void 0;class k{constructor(n,j=0,A=n.length,S=j-1){this.a=n,this.b=j,this.c=A,this.d=S}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$_S=k}),define(be[82],$e([1,0,81]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=t.$aT=void 0;class P{constructor(A=[],S=10){this.h(A),this.b=S,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new k.$_S(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const S of A)this.a.add(S)}get j(){const A=[];return this.a.forEach(S=>A.push(S)),A}}t.$aT=P;class n{get size(){return this.f}constructor(A,S=10){if(this.g=S,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let b=1;b<A.length;b++)this.add(A[b])}add(A){const S={value:A,previous:this.c,next:void 0};for(this.c.next=S,this.c=S,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const S=this.c.value;return this.a.delete(S),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),S}prepend(A){if(this.f===this.g||this.a.has(A))return;const S={value:A,previous:void 0,next:this.b};this.b.previous=S,this.b=S,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let S=this.b;for(;S!==this.c;)S.value===A&&(S===this.b?(this.b=this.b.next,this.b.previous=void 0):(S.previous.next=S.next,S.next.previous=S.previous),this.f--),S=S.next}}t.$bT=n}),define(be[46],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$l=t.$0l=t.$9l=t.rot=t.$7l=void 0;function k(S,b,w){return Math.min(Math.max(S,b),w)}t.$7l=k;function P(S,b){return(b+S%b)%b}t.rot=P;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$9l=n;class j{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$0l=j;class A{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const w=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$$l=A}),define(be[47],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var k;(function(P){function n(b,w){if(b.start>=w.end||w.start>=b.end)return{start:0,end:0};const y=Math.max(b.start,w.start),M=Math.min(b.end,w.end);return M-y<=0?{start:0,end:0}:{start:y,end:M}}P.intersect=n;function j(b){return b.end-b.start<=0}P.isEmpty=j;function A(b,w){return!j(n(b,w))}P.intersects=A;function S(b,w){const y=[],M={start:b.start,end:Math.min(w.start,b.end)},r={start:Math.max(w.end,b.start),end:b.end};return j(M)||y.push(M),j(r)||y.push(r),y}P.relativeComplement=S})(k||(t.Range=k={}))}),define(be[83],$e([1,0,47]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VR=t.$UR=t.$TR=t.$SR=void 0;function P(b,w){const y=[];for(const M of w){if(b.start>=M.range.end)continue;if(b.end<M.range.start)break;const r=k.Range.intersect(b,M.range);k.Range.isEmpty(r)||y.push({range:r,size:M.size})}return y}t.$SR=P;function n({start:b,end:w},y){return{start:b+y,end:w+y}}t.$TR=n;function j(b){const w=[];let y=null;for(const M of b){const r=M.range.start,u=M.range.end,e=M.size;if(y&&e===y.size){y.range.end=u;continue}y={range:{start:r,end:u},size:e},w.push(y)}return w}t.$UR=j;function A(...b){return j(b.reduce((w,y)=>w.concat(y),[]))}class S{get paddingTop(){return this.c}set paddingTop(w){this.b=this.b+w-this.c,this.c=w}constructor(w){this.a=[],this.b=0,this.c=0,this.c=w??0,this.b=this.c}splice(w,y,M=[]){const r=M.length-y,u=P({start:0,end:w},this.a),e=P({start:w+y,end:Number.POSITIVE_INFINITY},this.a).map(m=>({range:n(m.range,r),size:m.size})),s=M.map((m,d)=>({range:{start:w+d,end:w+d+1},size:m.size}));this.a=A(u,s,e),this.b=this.c+this.a.reduce((m,d)=>m+d.size*(d.range.end-d.range.start),0)}get count(){const w=this.a.length;return w?this.a[w-1].range.end:0}get size(){return this.b}indexAt(w){if(w<0)return-1;if(w<this.c)return 0;let y=0,M=this.c;for(const r of this.a){const u=r.range.end-r.range.start,e=M+u*r.size;if(w<e)return y+Math.floor((w-M)/r.size);y+=u,M=e}return y}indexAfter(w){return Math.min(this.indexAt(w)+1,this.count)}positionAt(w){if(w<0)return-1;let y=0,M=0;for(const r of this.a){const u=r.range.end-r.range.start,e=M+u;if(w<e)return this.c+y+(w-M)*r.size;y+=u*r.size,M=e}return-1}}t.$VR=S}),define(be[84],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class P{static create(j){return new P(j)}constructor(j){this.c=k&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Rd=P}),define(be[4],$e([1,0,6,43,2,45,84]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.Event=void 0;const S=!1,b=!1;var w;(function(U){U.None=()=>n.$Tc.None;function T(l){if(b){const{onDidAddListener:i}=l,a=e.create();let E=0;l.onDidAddListener=()=>{++E===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),a.print()),i?.()}}}function L(l,i){return Be(l,()=>{},0,void 0,!0,void 0,i)}U.defer=L;function z(l){return(i,a=null,E)=>{let I=!1,N;return N=l(H=>{if(!I)return N?N.dispose():I=!0,i.call(a,H)},null,E),I&&N.dispose(),N}}U.once=z;function X(l,i,a){return Le((E,I=null,N)=>l(H=>E.call(I,i(H)),null,N),a)}U.map=X;function Y(l,i,a){return Le((E,I=null,N)=>l(H=>{i(H),E.call(I,H)},null,N),a)}U.forEach=Y;function fe(l,i,a){return Le((E,I=null,N)=>l(H=>i(H)&&E.call(I,H),null,N),a)}U.filter=fe;function le(l){return l}U.signal=le;function ee(...l){return(i,a=null,E)=>{const I=(0,n.$Qc)(...l.map(N=>N(H=>i.call(a,H))));return Ne(I,E)}}U.any=ee;function ge(l,i,a,E){let I=a;return X(l,N=>(I=i(I,N),I),E)}U.reduce=ge;function Le(l,i){let a;const E={onWillAddFirstListener(){a=l(I.fire,I)},onDidRemoveLastListener(){a?.dispose()}};i||T(E);const I=new $(E);return i?.add(I),I.event}function Ne(l,i){return i instanceof Array?i.push(l):i&&i.add(l),l}function Be(l,i,a=100,E=!1,I=!1,N,H){let _,Z,he,pe=0,ye;const we={leakWarningThreshold:N,onWillAddFirstListener(){_=l(ve=>{pe++,Z=i(Z,ve),E&&!he&&(Ee.fire(Z),Z=void 0),ye=()=>{const Pe=Z;Z=void 0,he=void 0,(!E||pe>1)&&Ee.fire(Pe),pe=0},typeof a=="number"?(clearTimeout(he),he=setTimeout(ye,a)):he===void 0&&(he=0,queueMicrotask(ye))})},onWillRemoveListener(){I&&pe>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,_.dispose()}};H||T(we);const Ee=new $(we);return H?.add(Ee),Ee.event}U.debounce=Be;function ne(l,i=0,a){return U.debounce(l,(E,I)=>E?(E.push(I),E):[I],i,void 0,!0,void 0,a)}U.accumulate=ne;function J(l,i=(E,I)=>E===I,a){let E=!0,I;return fe(l,N=>{const H=E||!i(N,I);return E=!1,I=N,H},a)}U.latch=J;function se(l,i,a){return[U.filter(l,i,a),U.filter(l,E=>!i(E),a)]}U.split=se;function oe(l,i=!1,a=[],E){let I=a.slice(),N=l(Z=>{I?I.push(Z):_.fire(Z)});E&&E.add(N);const H=()=>{I?.forEach(Z=>_.fire(Z)),I=null},_=new $({onWillAddFirstListener(){N||(N=l(Z=>_.fire(Z)),E&&E.add(N))},onDidAddFirstListener(){I&&(i?setTimeout(H):H())},onDidRemoveLastListener(){N&&N.dispose(),N=null}});return E&&E.add(_),_.event}U.buffer=oe;function W(l,i){return(E,I,N)=>{const H=i(new ue);return l(function(_){const Z=H.evaluate(_);Z!==G&&E.call(I,Z)},void 0,N)}}U.chain=W;const G=Symbol("HaltChainable");class ue{constructor(){this.f=[]}map(i){return this.f.push(i),this}forEach(i){return this.f.push(a=>(i(a),a)),this}filter(i){return this.f.push(a=>i(a)?a:G),this}reduce(i,a){let E=a;return this.f.push(I=>(E=i(E,I),E)),this}latch(i=(a,E)=>a===E){let a=!0,E;return this.f.push(I=>{const N=a||!i(I,E);return a=!1,E=I,N?I:G}),this}evaluate(i){for(const a of this.f)if(i=a(i),i===G)break;return i}}function me(l,i,a=E=>E){const E=(..._)=>H.fire(a(..._)),I=()=>l.on(i,E),N=()=>l.removeListener(i,E),H=new $({onWillAddFirstListener:I,onDidRemoveLastListener:N});return H.event}U.fromNodeEventEmitter=me;function Se(l,i,a=E=>E){const E=(..._)=>H.fire(a(..._)),I=()=>l.addEventListener(i,E),N=()=>l.removeEventListener(i,E),H=new $({onWillAddFirstListener:I,onDidRemoveLastListener:N});return H.event}U.fromDOMEventEmitter=Se;function ke(l){return new Promise(i=>z(l)(i))}U.toPromise=ke;function Ce(l){const i=new $;return l.then(a=>{i.fire(a)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}U.fromPromise=Ce;function K(l,i,a){return i(a),l(E=>i(E))}U.runAndSubscribe=K;class g{constructor(i,a){this._observable=i,this.f=0,this.g=!1;const E={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};a||T(E),this.emitter=new $(E),a&&a.add(this.emitter)}beginUpdate(i){this.f++}handlePossibleChange(i){}handleChange(i,a){this.g=!0}endUpdate(i){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function D(l,i){return new g(l,i).emitter.event}U.fromObservable=D;function p(l){return(i,a,E)=>{let I=0,N=!1;const H={beginUpdate(){I++},endUpdate(){I--,I===0&&(l.reportChanges(),N&&(N=!1,i.call(a)))},handlePossibleChange(){},handleChange(){N=!0}};l.addObserver(H),l.reportChanges();const _={dispose(){l.removeObserver(H)}};return E instanceof n.$Sc?E.add(_):Array.isArray(E)&&E.push(_),_}}U.fromObservableLight=p})(w||(t.Event=w={}));class y{static{this.all=new Set}static{this.f=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${y.f++}`,y.all.add(this)}start(T){this.g=new A.$Rd,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}t.$Td=y;let M=-1;function r(U){const T=M;return M=U,{dispose(){M=T}}}t.$Ud=r;class u{constructor(T,L=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=L,this.g=0}dispose(){this.f?.clear()}check(T,L){const z=this.threshold;if(z<=0||L<z)return;this.f||(this.f=new Map);const X=this.f.get(T.value)||0;if(this.f.set(T.value,X+1),this.g-=1,this.g<=0){this.g=z*.5;let Y,fe=0;for(const[le,ee]of this.f)(!Y||fe<ee)&&(Y=le,fe=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${fe}):`),console.warn(Y)}return()=>{const Y=this.f.get(T.value)||0;this.f.set(T.value,Y-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class m{constructor(T){this.value=T,this.id=s++}}const d=2,o=(U,T)=>{if(U instanceof m)T(U);else for(let L=0;L<U.length;L++){const z=U[L];z&&T(z)}};class ${constructor(T){this.w=0,this.f=T,this.g=M>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??M):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const T=this.t;queueMicrotask(()=>{o(T,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(T,L,z)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;L&&(T=T.bind(L));const X=new m(T);let Y,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=e.create(),Y=this.g.check(X.stack,this.w+1)),S&&(X.stack=fe??e.create()),this.t?this.t instanceof m?(this.u??=new f,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,n.$Rc)(()=>{Y?.(),this.x(X)});return z instanceof n.$Sc?z.add(le):Array.isArray(z)&&z.push(le),le},this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,z=L.indexOf(T);if(z===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[z]=void 0;const X=this.u.current===this;if(this.w*d<=L.length){let Y=0;for(let fe=0;fe<L.length;fe++)L[fe]?L[Y++]=L[fe]:X&&(this.u.end--,Y<this.u.i&&this.u.i--);L.length=Y}}y(T,L){if(!T)return;const z=this.f?.onListenerError||k.$1;if(!z){T.value(L);return}try{T.value(L)}catch(X){z(X)}}z(T){const L=T.current.t;for(;T.i<T.end;)this.y(L[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,T);else{const L=this.u;L.enqueue(this,T,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Vd=$;const c=()=>new f;t.$Wd=c;class f{constructor(){this.i=-1,this.end=0}enqueue(T,L,z){this.i=0,this.end=z,this.current=T,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends ${async fireAsync(T,L,z){if(this.t)for(this.h||(this.h=new j.$4c),o(this.t,X=>this.h.push([X.value,T]));this.h.size>0&&!L.isCancellationRequested;){const[X,Y]=this.h.shift(),fe=[],le={...Y,token:L,waitUntil:ee=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");z&&(ee=z(ee,X)),fe.push(ee)}};try{X(le)}catch(ee){(0,k.$1)(ee);continue}Object.freeze(fe),await Promise.allSettled(fe).then(ee=>{for(const ge of ee)ge.status==="rejected"&&(0,k.$1)(ge.reason)})}}}t.$Xd=h;class F extends ${get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new j.$4c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}t.$Yd=F;class O extends F{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}t.$Zd=O;class R extends ${constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}t.$1d=R;class B{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const L={event:T,listener:null};this.h.push(L),this.g&&this.m(L);const z=()=>{this.g&&this.o(L);const X=this.h.indexOf(L);this.h.splice(X,1)};return(0,n.$Rc)((0,P.$db)(z))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(L=>this.f.fire(L))}o(T){T.listener&&T.listener.dispose(),T.listener=null}dispose(){this.f.dispose()}}t.$2d=B;class v{constructor(T,L,z,X){this.f=new n.$Sc;const Y=this.f.add(new B),fe=this.f.add(new n.$3c);function le(ee){fe.set(ee,Y.add(X(ee)))}for(const ee of T)le(ee);this.f.add(L(ee=>{le(ee)})),this.f.add(z(ee=>{fe.deleteAndDispose(ee)})),this.event=Y.event}dispose(){this.f.dispose()}}t.$3d=v;class C{constructor(){this.f=[]}wrapEvent(T){return(L,z,X)=>T(Y=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>L.call(z,Y)):L.call(z,Y)},void 0,X)}bufferEvents(T){const L=[];this.f.push(L);const z=T();return this.f.pop(),L.forEach(X=>X()),z}}t.$4d=C;class V{constructor(){this.f=!1,this.g=w.None,this.h=n.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$5d=V}),define(be[16],$e([1,0,21,4,2]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=void 0;class j{constructor(){this.a=new Map,this.b=new P.$Vd,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new P.$Vd,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new j}getZoomLevel(f){return this.a.get(this.f(f))??0}setZoomLevel(f,h){if(this.getZoomLevel(h)===f)return;const F=this.f(h);this.a.set(F,f),this.b.fire(F)}getZoomFactor(f){return this.c.get(this.f(f))??1}setZoomFactor(f,h){this.c.set(this.f(h),f)}setFullscreen(f,h){if(this.isFullscreen(h)===f)return;const F=this.f(h);this.e.set(F,f),this.d.fire(F)}isFullscreen(f){return!!this.e.get(this.f(f))}f(f){return f.vscodeWindowId}}class A extends n.$Tc{constructor(){super(),this.a=this.B(new P.$Vd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(f){this.c?.removeEventListener("change",this.b),this.c=k.$window.matchMedia(`(resolution: ${k.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),f&&this.a.fire()}}class S extends n.$Tc{get value(){return this.b}constructor(){super(),this.a=this.B(new P.$Vd),this.onDidChange=this.a.event,this.b=this.c();const f=this.B(new A);this.B(f.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const f=document.createElement("canvas").getContext("2d"),h=k.$window.devicePixelRatio||1,F=f.webkitBackingStorePixelRatio||f.mozBackingStorePixelRatio||f.msBackingStorePixelRatio||f.oBackingStorePixelRatio||f.backingStorePixelRatio||1;return h/F}}class b{constructor(){this.a=null}b(){return this.a||(this.a=(0,n.$Mc)(new S)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function w(c,f,h){typeof f=="string"&&(f=c.matchMedia(f)),f.addEventListener("change",h)}t.$hP=w,t.$iP=new b;function y(c,f){j.INSTANCE.setZoomLevel(c,f)}t.$jP=y;function M(c){return j.INSTANCE.getZoomLevel(c)}t.$kP=M,t.$lP=j.INSTANCE.onDidChangeZoomLevel;function r(c){return j.INSTANCE.getZoomFactor(c)}t.$mP=r;function u(c,f){j.INSTANCE.setZoomFactor(c,f)}t.$nP=u;function e(c,f){j.INSTANCE.setFullscreen(c,f)}t.$oP=e;function s(c){return j.INSTANCE.isFullscreen(c)}t.$pP=s,t.$qP=j.INSTANCE.onDidChangeFullscreen;const m=navigator.userAgent;t.$rP=m.indexOf("Firefox")>=0,t.$sP=m.indexOf("AppleWebKit")>=0,t.$tP=m.indexOf("Chrome")>=0,t.$uP=!t.$tP&&m.indexOf("Safari")>=0,t.$vP=!t.$tP&&!t.$uP&&t.$sP,t.$wP=m.indexOf("Electron/")>=0,t.$xP=m.indexOf("Android")>=0;let d=!1;if(typeof k.$dP.matchMedia=="function"){const c=k.$dP.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),f=k.$dP.matchMedia("(display-mode: fullscreen)");d=c.matches,w(k.$dP,c,({matches:h})=>{d&&f.matches||(d=h)})}function o(){return d}t.$yP=o;function $(){return navigator?.windowControlsOverlay?.visible}t.$zP=$}),define(be[22],$e([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=void 0;class P{get event(){return this.a.event}constructor(j,A,S){const b=w=>this.a.fire(w);this.a=new k.$Vd({onWillAddFirstListener:()=>j.addEventListener(A,b,S),onDidRemoveLastListener:()=>j.removeEventListener(A,b,S)})}dispose(){this.a.dispose()}}t.$NR=P}),define(be[29],$e([1,0,4]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.CancellationToken=void 0;const P=Object.freeze(function(S,b){const w=setTimeout(S.bind(b),0);return{dispose(){clearTimeout(w)}}});var n;(function(S){function b(w){return w===S.None||w===S.Cancelled||w instanceof j?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}S.isCancellationToken=b,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(n||(t.CancellationToken=n={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?P:(this.b||(this.b=new k.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(b){this.f=void 0,this.g=void 0,this.g=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=n.Cancelled}dispose(b=!1){b&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=n.None}}t.$6d=A}),define(be[85],$e([1,0,29]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ge=t.$Fe=t.$Ee=void 0;class P{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new k.$6d,b=this.b(S.token);return this.a={promise:b,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}t.$Ee=P;class n{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const b=JSON.stringify(S);return this.b!==b&&(this.b=b,this.a=this.c(S)),this.a}}t.$Fe=n;class j{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const b=this.b(S);return this.a.set(S,b),b}}t.$Ge=j}),define(be[48],$e([1,0,4,2]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ns=t.$ms=t.$ls=t.$ks=t.ScrollbarVisibility=void 0;var n;(function(u){u[u.Auto=1]="Auto",u[u.Hidden=2]="Hidden",u[u.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class j{constructor(e,s,m,d,o,$,c){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,m=m|0,d=d|0,o=o|0,$=$|0,c=c|0),this.rawScrollLeft=d,this.rawScrollTop=c,s<0&&(s=0),d+s>m&&(d=m-s),d<0&&(d=0),o<0&&(o=0),c+o>$&&(c=$-o),c<0&&(c=0),this.width=s,this.scrollWidth=m,this.scrollLeft=d,this.height=o,this.scrollHeight=$,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new j(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new j(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const m=this.width!==e.width,d=this.scrollWidth!==e.scrollWidth,o=this.scrollLeft!==e.scrollLeft,$=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,f=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:m,scrollWidthChanged:d,scrollLeftChanged:o,heightChanged:$,scrollHeightChanged:c,scrollTopChanged:f}}}t.$ks=j;class A extends P.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new k.$Vd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new j(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const m=this.g.withScrollDimensions(e,s);this.n(m,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const m=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===m.scrollLeft&&this.h.to.scrollTop===m.scrollTop)return;let d;s?d=new y(this.h.from,m,this.h.startTime,this.h.duration):d=this.h.combine(this.g,m,this.c),this.h.dispose(),this.h=d}else{const m=this.g.withScrollPosition(e);this.h=y.start(this.g,m,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const m=this.g;m.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(m,s)))}}t.$ls=A;class S{constructor(e,s,m){this.scrollLeft=e,this.scrollTop=s,this.isDone=m}}t.$ms=S;function b(u,e){const s=e-u;return function(m){return u+s*r(m)}}function w(u,e,s){return function(m){return m<s?u(m/s):e((m-s)/(1-s))}}class y{constructor(e,s,m,d){this.from=e,this.to=s,this.duration=d,this.startTime=m,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,m){if(Math.abs(e-s)>2.5*m){let o,$;return e<s?(o=e+.75*m,$=s-.75*m):(o=e-.75*m,$=s+.75*m),w(b(e,o),b($,s),.33)}return b(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const m=this.c(s),d=this.d(s);return new S(m,d,!1)}return new S(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,m){return y.start(e,s,m)}static start(e,s,m){m=m+10;const d=Date.now()-10;return new y(e,s,d,m)}}t.$ns=y;function M(u){return Math.pow(u,3)}function r(u){return 1-M(1-u)}}),define(be[86],$e([1,0,6,2]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=void 0;function n(c){const f=c;return f?typeof f.read=="function":!1}t.$7d=n;function j(c){const f=c;return f?[f.on,f.pause,f.resume,f.destroy].every(h=>typeof h=="function"):!1}t.$8d=j;function A(c){const f=c;return f?j(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}t.$9d=A;function S(c,f){return new b(c,f)}t.$0d=S;class b{constructor(f,h){this.e=f,this.f=h,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(h=>this.d.push(h))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(h=>h(f))}h(f){this.c.error.length===0?(0,k.$1)(f):this.c.error.slice(0).forEach(h=>h(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,h){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(h),this.resume();break;case"end":this.c.end.push(h),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(h),this.a.flowing&&this.k();break}}removeListener(f,h){if(this.a.destroyed)return;let F;switch(f){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const O=F.indexOf(h);O>=0&&F.splice(O,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const h=[...this.d];this.d.length=0,h.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,f){const h=[];let F;for(;(F=c.read())!==null;)h.push(F);return f(h)}t.$$d=w;function y(c,f,h){const F=[];let O;for(;(O=c.read())!==null&&F.length<h;)F.push(O);return O===null&&F.length>0?f(F):{read:()=>{if(F.length>0)return F.shift();if(typeof O<"u"){const R=O;return O=void 0,R}return c.read()}}}t.$_d=y;function M(c,f){return new Promise((h,F)=>{const O=[];r(c,{onData:R=>{f&&O.push(R)},onError:R=>{f?F(R):h(void 0)},onEnd:()=>{h(f?f(O):void 0)}})})}t.$ae=M;function r(c,f,h){c.on("error",F=>{h?.isCancellationRequested||f.onError(F)}),c.on("end",()=>{h?.isCancellationRequested||f.onEnd()}),c.on("data",F=>{h?.isCancellationRequested||f.onData(F)})}t.$be=r;function u(c,f){return new Promise((h,F)=>{const O=new P.$Sc,R=[],B=V=>{if(R.push(V),R.length>f)return O.dispose(),c.pause(),h({stream:c,buffer:R,ended:!1})},v=V=>(O.dispose(),F(V)),C=()=>(O.dispose(),h({stream:c,buffer:R,ended:!0}));O.add((0,P.$Rc)(()=>c.removeListener("error",v))),c.on("error",v),O.add((0,P.$Rc)(()=>c.removeListener("end",C))),c.on("end",C),O.add((0,P.$Rc)(()=>c.removeListener("data",B))),c.on("data",B)})}t.$ce=u;function e(c,f){const h=S(f);return h.end(c),h}t.$de=e;function s(){const c=S(()=>{throw new Error("not supported")});return c.end(),c}t.$ee=s;function m(c){let f=!1;return{read:()=>f?null:(f=!0,c)}}t.$fe=m;function d(c,f,h){const F=S(h);return r(c,{onData:O=>F.write(f.data(O)),onError:O=>F.error(f.error?f.error(O):O),onEnd:()=>F.end()}),F}t.$ge=d;function o(c,f,h){let F=!1;return{read:()=>{const O=f.read();return F?O:(F=!0,O!==null?h([c,O]):c)}}}t.$he=o;function $(c,f,h){let F=!1;const O=S(h);return r(f,{onData:R=>F?O.write(R):(F=!0,O.write(h([c,R]))),onError:R=>O.error(R),onEnd:()=>{F||(F=!0,O.write(c)),O.end()}}),O}t.$ie=$}),define(be[33],$e([1,0,23,86]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=void 0;const n=typeof Buffer<"u",j=new k.$V(()=>new Uint8Array(256));let A,S;class b{static alloc(L){return n?new b(Buffer.allocUnsafe(L)):new b(new Uint8Array(L))}static wrap(L){return n&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new b(L)}static fromString(L,z){return!(z?.dontUseNodeBuffer||!1)&&n?new b(Buffer.from(L)):(A||(A=new TextEncoder),new b(A.encode(L)))}static fromByteArray(L){const z=b.alloc(L.length);for(let X=0,Y=L.length;X<Y;X++)z.buffer[X]=L[X];return z}static concat(L,z){if(typeof z>"u"){z=0;for(let fe=0,le=L.length;fe<le;fe++)z+=L[fe].byteLength}const X=b.alloc(z);let Y=0;for(let fe=0,le=L.length;fe<le;fe++){const ee=L[fe];X.set(ee,Y),Y+=ee.byteLength}return X}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=b.alloc(this.byteLength);return L.set(this),L}toString(){return n?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(L,z){return new b(this.buffer.subarray(L,z))}set(L,z){if(L instanceof b)this.buffer.set(L.buffer,z);else if(L instanceof Uint8Array)this.buffer.set(L,z);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),z);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),z);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return r(this.buffer,L)}writeUInt32BE(L,z){u(this.buffer,L,z)}readUInt32LE(L){return e(this.buffer,L)}writeUInt32LE(L,z){s(this.buffer,L,z)}readUInt8(L){return m(this.buffer,L)}writeUInt8(L,z){d(this.buffer,L,z)}indexOf(L,z=0){return w(this.buffer,L instanceof b?L.buffer:L,z)}}t.$je=b;function w(T,L,z=0){const X=L.byteLength,Y=T.byteLength;if(X===0)return 0;if(X===1)return T.indexOf(L[0]);if(X>Y-z)return-1;const fe=j.value;fe.fill(L.length);for(let Le=0;Le<L.length;Le++)fe[L[Le]]=L.length-Le-1;let le=z+L.length-1,ee=le,ge=-1;for(;le<Y;)if(T[le]===L[ee]){if(ee===0){ge=le;break}le--,ee--}else le+=Math.max(L.length-ee,fe[T[le]]),ee=L.length-1;return ge}t.$ke=w;function y(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0}t.$le=y;function M(T,L,z){T[z+0]=L&255,L=L>>>8,T[z+1]=L&255}t.$me=M;function r(T,L){return T[L]*2**24+T[L+1]*2**16+T[L+2]*2**8+T[L+3]}t.$ne=r;function u(T,L,z){T[z+3]=L,L=L>>>8,T[z+2]=L,L=L>>>8,T[z+1]=L,L=L>>>8,T[z]=L}t.$oe=u;function e(T,L){return T[L+0]<<0>>>0|T[L+1]<<8>>>0|T[L+2]<<16>>>0|T[L+3]<<24>>>0}t.$pe=e;function s(T,L,z){T[z+0]=L&255,L=L>>>8,T[z+1]=L&255,L=L>>>8,T[z+2]=L&255,L=L>>>8,T[z+3]=L&255}t.$qe=s;function m(T,L){return T[L]}t.$re=m;function d(T,L,z){T[z]=L}t.$se=d;function o(T){return P.$$d(T,L=>b.concat(L))}t.$te=o;function $(T){return P.$fe(T)}t.$ue=$;function c(T){return P.$ae(T,L=>b.concat(L))}t.$ve=c;async function f(T){return T.ended?b.concat(T.buffer):b.concat([...T.buffer,await c(T.stream)])}t.$we=f;function h(T){return P.$de(T,L=>b.concat(L))}t.$xe=h;function F(T){return P.$ge(T,{data:L=>typeof L=="string"?b.fromString(L):b.wrap(L)},L=>b.concat(L))}t.$ye=F;function O(T){return P.$0d(L=>b.concat(L),T)}t.$ze=O;function R(T,L){return P.$he(T,L,z=>b.concat(z))}t.$Ae=R;function B(T,L){return P.$ie(T,L,z=>b.concat(z))}t.$Be=B;function v(T){let L=0,z=0,X=0;const Y=new Uint8Array(Math.floor(T.length/4*3)),fe=ee=>{switch(z){case 3:Y[X++]=L|ee,z=0;break;case 2:Y[X++]=L|ee>>>2,L=ee<<6,z=3;break;case 1:Y[X++]=L|ee>>>4,L=ee<<4,z=2;break;default:L=ee<<2,z=1}};for(let ee=0;ee<T.length;ee++){const ge=T.charCodeAt(ee);if(ge>=65&&ge<=90)fe(ge-65);else if(ge>=97&&ge<=122)fe(ge-97+26);else if(ge>=48&&ge<=57)fe(ge-48+52);else if(ge===43||ge===45)fe(62);else if(ge===47||ge===95)fe(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${T[ee]}`)}}const le=X;for(;z>0;)fe(0);return b.wrap(Y).slice(0,le)}t.$Ce=v;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",V="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:T},L=!0,z=!1){const X=z?V:C;let Y="";const fe=T.byteLength%3;let le=0;for(;le<T.byteLength-fe;le+=3){const ee=T[le+0],ge=T[le+1],Le=T[le+2];Y+=X[ee>>>2],Y+=X[(ee<<4|ge>>>4)&63],Y+=X[(ge<<2|Le>>>6)&63],Y+=X[Le&63]}if(fe===1){const ee=T[le+0];Y+=X[ee>>>2],Y+=X[ee<<4&63],L&&(Y+="==")}else if(fe===2){const ee=T[le+0],ge=T[le+1];Y+=X[ee>>>2],Y+=X[(ee<<4|ge>>>4)&63],Y+=X[ge<<2&63],L&&(Y+="=")}return Y}t.$De=U}),define(be[10],$e([1,0,85,23]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.GraphemeBreakType=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=void 0;function n(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$Je=n;const j=/{(\d+)}/g;function A(x,...re){return re.length===0?x:x.replace(j,function(de,Ae){const Te=parseInt(Ae,10);return isNaN(Te)||Te<0||Te>=re.length?de:re[Te]})}t.$Ke=A;const S=/{([^}]+)}/g;function b(x,re){return Object.keys(re).length===0?x:x.replace(S,(de,Ae)=>re[Ae]??de)}t.$Le=b;function w(x){return x.replace(/[<>"'&]/g,re=>{switch(re){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return re})}t.$Me=w;function y(x){return x.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}t.$Ne=y;function M(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Oe=M;function r(x,re){let de=0;const Ae=re.charCodeAt(0);for(let Te=x.length-1;Te>=0;Te--)x.charCodeAt(Te)===Ae&&de++;return de}t.$Pe=r;function u(x,re,de="\u2026"){return x.length<=re?x:`${x.substr(0,re)}${de}`}t.$Qe=u;function e(x,re,de="\u2026"){if(x.length<=re)return x;const Ae=Math.ceil(re/2)-de.length/2,Te=Math.floor(re/2)-de.length/2;return`${x.substr(0,Ae)}${de}${x.substr(x.length-Te)}`}t.$Re=e;function s(x,re=" "){const de=m(x,re);return d(de,re)}t.$Se=s;function m(x,re){if(!x||!re)return x;const de=re.length;if(de===0||x.length===0)return x;let Ae=0;for(;x.indexOf(re,Ae)===Ae;)Ae=Ae+de;return x.substring(Ae)}t.$Te=m;function d(x,re){if(!x||!re)return x;const de=re.length,Ae=x.length;if(de===0||Ae===0)return x;let Te=Ae,je=-1;for(;je=x.lastIndexOf(re,Te-1),!(je===-1||je+de!==Te);){if(je===0)return"";Te=je}return x.substring(0,Te)}t.$Ue=d;function o(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ve=o;function $(x){return x.replace(/\*/g,"")}t.$We=$;function c(x,re,de={}){if(!x)throw new Error("Cannot create regex from empty string");re||(x=M(x)),de.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ae="";return de.global&&(Ae+="g"),de.matchCase||(Ae+="i"),de.multiline&&(Ae+="m"),de.unicode&&(Ae+="u"),new RegExp(x,Ae)}t.$Xe=c;function f(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$Ye=f;function h(x){return x.split(/\r\n|\r|\n/)}t.$Ze=h;function F(x){for(let re=0,de=x.length;re<de;re++){const Ae=x.charCodeAt(re);if(Ae!==32&&Ae!==9)return re}return-1}t.$1e=F;function O(x,re=0,de=x.length){for(let Ae=re;Ae<de;Ae++){const Te=x.charCodeAt(Ae);if(Te!==32&&Te!==9)return x.substring(re,Ae)}return x.substring(re,de)}t.$2e=O;function R(x,re=x.length-1){for(let de=re;de>=0;de--){const Ae=x.charCodeAt(de);if(Ae!==32&&Ae!==9)return de}return-1}t.$3e=R;function B(x,re,de){const Ae=[];let Te=0;for(const je of x.matchAll(re)){if(Ae.push(x.slice(Te,je.index)),je.index===void 0)throw new Error("match.index should be defined");Te=je.index+je[0].length,Ae.push(de(je[0],...je.slice(1),je.index,x,je.groups))}return Ae.push(x.slice(Te)),Promise.all(Ae).then(je=>je.join(""))}t.$4e=B;function v(x,re){return x<re?-1:x>re?1:0}t.$5e=v;function C(x,re,de=0,Ae=x.length,Te=0,je=re.length){for(;de<Ae&&Te<je;de++,Te++){const Je=x.charCodeAt(de),tt=re.charCodeAt(Te);if(Je<tt)return-1;if(Je>tt)return 1}const Ve=Ae-de,_e=je-Te;return Ve<_e?-1:Ve>_e?1:0}t.$6e=C;function V(x,re){return U(x,re,0,x.length,0,re.length)}t.$7e=V;function U(x,re,de=0,Ae=x.length,Te=0,je=re.length){for(;de<Ae&&Te<je;de++,Te++){let Je=x.charCodeAt(de),tt=re.charCodeAt(Te);if(Je===tt)continue;if(Je>=128||tt>=128)return C(x.toLowerCase(),re.toLowerCase(),de,Ae,Te,je);L(Je)&&(Je-=32),L(tt)&&(tt-=32);const Ze=Je-tt;if(Ze!==0)return Ze}const Ve=Ae-de,_e=je-Te;return Ve<_e?-1:Ve>_e?1:0}t.$8e=U;function T(x){return x>=48&&x<=57}t.$9e=T;function L(x){return x>=97&&x<=122}t.$0e=L;function z(x){return x>=65&&x<=90}t.$$e=z;function X(x,re){return x.length===re.length&&U(x,re)===0}t.$_e=X;function Y(x,re){const de=re.length;return re.length>x.length?!1:U(x,re,0,de)===0}t.$af=Y;function fe(x,re){const de=Math.min(x.length,re.length);let Ae;for(Ae=0;Ae<de;Ae++)if(x.charCodeAt(Ae)!==re.charCodeAt(Ae))return Ae;return de}t.$bf=fe;function le(x,re){const de=Math.min(x.length,re.length);let Ae;const Te=x.length-1,je=re.length-1;for(Ae=0;Ae<de;Ae++)if(x.charCodeAt(Te-Ae)!==re.charCodeAt(je-Ae))return Ae;return de}t.$cf=le;function ee(x){return 55296<=x&&x<=56319}t.$df=ee;function ge(x){return 56320<=x&&x<=57343}t.$ef=ge;function Le(x,re){return(x-55296<<10)+(re-56320)+65536}t.$ff=Le;function Ne(x,re,de){const Ae=x.charCodeAt(de);if(ee(Ae)&&de+1<re){const Te=x.charCodeAt(de+1);if(ge(Te))return Le(Ae,Te)}return Ae}t.$gf=Ne;function Be(x,re){const de=x.charCodeAt(re-1);if(ge(de)&&re>1){const Ae=x.charCodeAt(re-2);if(ee(Ae))return Le(Ae,de)}return de}class ne{get offset(){return this.e}constructor(re,de=0){this.c=re,this.d=re.length,this.e=de}setOffset(re){this.e=re}prevCodePoint(){const re=Be(this.c,this.e);return this.e-=re>=65536?2:1,re}nextCodePoint(){const re=Ne(this.c,this.d,this.e);return this.e+=re>=65536?2:1,re}eol(){return this.e>=this.d}}t.$hf=ne;class J{get offset(){return this.c.offset}constructor(re,de=0){this.c=new ne(re,de)}nextGraphemeLength(){const re=Ee.getInstance(),de=this.c,Ae=de.offset;let Te=re.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const je=de.offset,Ve=re.getGraphemeBreakType(de.nextCodePoint());if(ye(Te,Ve)){de.setOffset(je);break}Te=Ve}return de.offset-Ae}prevGraphemeLength(){const re=Ee.getInstance(),de=this.c,Ae=de.offset;let Te=re.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const je=de.offset,Ve=re.getGraphemeBreakType(de.prevCodePoint());if(ye(Ve,Te)){de.setOffset(je);break}Te=Ve}return Ae-de.offset}eol(){return this.c.eol()}}t.$if=J;function se(x,re){return new J(x,re).nextGraphemeLength()}t.$jf=se;function oe(x,re){return new J(x,re).prevGraphemeLength()}t.$kf=oe;function W(x,re){re>0&&ge(x.charCodeAt(re))&&re--;const de=re+se(x,re);return[de-oe(x,de),de]}t.$lf=W;function G(x){const re=new J(x);let de=0;for(;!re.eol();)de++,re.nextGraphemeLength();return de}t.$mf=G;let ue;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Se(x){return ue||(ue=me()),ue.test(x)}t.$nf=Se;const ke=/^[\t\n\r\x20-\x7E]*$/;function Ce(x){return ke.test(x)}t.$of=Ce,t.$pf=/[\u2028\u2029]/;function K(x){return t.$pf.test(x)}t.$qf=K;function g(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$rf=g;function D(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$sf=D;function p(x,re,de=""){const Ae=x.trimStart();if(Ae.length<re)return Ae;const Te=/\b/g;let je=0;for(;Te.test(Ae)&&!(Ae.length-Te.lastIndex<re);)je=Te.lastIndex,Te.lastIndex+=1;return je===0?Ae:de+Ae.substring(je).trimStart()}t.$tf=p;const l=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,i=/\x1b\].*?\x07/g;function a(x){return x&&(x=x.replace(l,"").replace(i,"")),x}t.$uf=a,t.$vf=String.fromCharCode(65279);function E(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$wf=E;function I(x){return E(x)?x.substr(1):x}t.$xf=I;function N(x,re){if(!x||!re||x.length<re.length)return!1;const de=re.length,Ae=x.toLowerCase();let Te=0,je=-1;for(;Te<de;){const Ve=Ae.indexOf(re[Te],je+1);if(Ve<0)return!1;je=Ve,Te++}return!0}t.$yf=N;function H(x,re=!1){return x?(re&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$zf=H;function _(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$Af=_;function Z(x,re=1){if(re===0)return"";let de=-1;do de=x.indexOf(`
`,de+1),re--;while(re>0&&de>=0);return de===-1?x:(x[de-1]==="\r"&&de--,x.substr(0,de))}t.$Bf=Z;function he(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Cf=he;function pe(x){return Ee.getInstance().getGraphemeBreakType(x)}t.$Df=pe;function ye(x,re){return x===0?re!==5&&re!==7:x===2&&re===3?!1:x===4||x===2||x===3||re===4||re===2||re===3?!0:!(x===8&&(re===8||re===9||re===11||re===12)||(x===11||x===9)&&(re===9||re===10)||(x===12||x===10)&&re===10||re===5||re===13||re===7||x===1||x===13&&re===14||x===6&&re===6)}var we;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(we||(t.GraphemeBreakType=we={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const de=this.d,Ae=de.length/3;let Te=1;for(;Te<=Ae;)if(re<de[3*Te])Te=2*Te;else if(re>de[3*Te+1])Te=2*Te+1;else return de[3*Te+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(x,re){if(x===0)return 0;const de=Ie(x,re);if(de!==void 0)return de;const Ae=new ne(re,x);return Ae.prevCodePoint(),Ae.offset}t.$Ef=Pe;function Ie(x,re){const de=new ne(re,x);let Ae=de.prevCodePoint();for(;Me(Ae)||Ae===65039||Ae===8419;){if(de.offset===0)return;Ae=de.prevCodePoint()}if(!D(Ae))return;let Te=de.offset;return Te>0&&de.prevCodePoint()===8205&&(Te=de.offset),Te}function Me(x){return 127995<=x&&x<=127999}var Ye;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),t.$Ff="\xA0";class et{static{this.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$Fe(re=>{function de(Ze){const nt=new Map;for(let st=0;st<Ze.length;st+=2)nt.set(Ze[st],Ze[st+1]);return nt}function Ae(Ze,nt){const st=new Map(Ze);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Te(Ze,nt){if(!Ze)return nt;const st=new Map;for(const[rt,gt]of Ze)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let Ve=re.filter(Ze=>!Ze.startsWith("_")&&Ze in je);Ve.length===0&&(Ve=["_default"]);let _e;for(const Ze of Ve){const nt=de(je[Ze]);_e=Te(_e,nt)}const Je=de(je._common),tt=Ae(Je,_e);return new et(tt)})}static getInstance(re){return et.d.get(Array.from(re))}static{this.e=new P.$V(()=>Object.keys(et.c.value).filter(re=>!re.startsWith("_")))}static getLocales(){return et.e.value}constructor(re){this.f=re}isAmbiguous(re){return this.f.has(re)}getPrimaryConfusable(re){return this.f.get(re)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Gf=et;class Qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Qe.c())),this.d}static isInvisibleCharacter(re){return Qe.e().has(re)}static get codePoints(){return Qe.e()}}t.$Hf=Qe}),define(be[34],$e([1,0,32,80,10]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9j=t.$8j=t.$7j=t.$6j=t.FuzzyScore=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.or=void 0;function j(...N){return function(H,_){for(let Z=0,he=N.length;Z<he;Z++){const pe=N[Z](H,_);if(pe)return pe}return null}}t.or=j,t.$Tj=A.bind(void 0,!1),t.$Uj=A.bind(void 0,!0);function A(N,H,_){if(!_||_.length<H.length)return null;let Z;return N?Z=n.$af(_,H):Z=_.indexOf(H)===0,Z?H.length>0?[{start:0,end:H.length}]:[]:null}function S(N,H){const _=H.toLowerCase().indexOf(N.toLowerCase());return _===-1?null:[{start:_,end:_+N.length}]}t.$Vj=S;function b(N,H){return w(N.toLowerCase(),H.toLowerCase(),0,0)}t.$Wj=b;function w(N,H,_,Z){if(_===N.length)return[];if(Z===H.length)return null;if(N[_]===H[Z]){let he=null;return(he=w(N,H,_+1,Z+1))?c({start:Z,end:Z+1},he):null}return w(N,H,_,Z+1)}function y(N){return 97<=N&&N<=122}function M(N){return 65<=N&&N<=90}t.$Xj=M;function r(N){return 48<=N&&N<=57}function u(N){return N===32||N===9||N===10||N===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>e.add(N.charCodeAt(0)));function s(N){return u(N)||e.has(N)}function m(N,H){return N===H||s(N)&&s(H)}const d=new Map;function o(N){if(d.has(N))return d.get(N);let H;const _=(0,P.$Rj)(N);return _&&(H=_),d.set(N,H),H}function $(N){return y(N)||M(N)||r(N)}function c(N,H){return H.length===0?H=[N]:N.end===H[0].start?H[0].start=N.start:H.unshift(N),H}function f(N,H){for(let _=H;_<N.length;_++){const Z=N.charCodeAt(_);if(M(Z)||r(Z)||_>0&&!$(N.charCodeAt(_-1)))return _}return N.length}function h(N,H,_,Z){if(_===N.length)return[];if(Z===H.length)return null;if(N[_]!==H[Z].toLowerCase())return null;{let he=null,pe=Z+1;for(he=h(N,H,_+1,Z+1);!he&&(pe=f(H,pe))<H.length;)he=h(N,H,_+1,pe),pe++;return he===null?null:c({start:Z,end:Z+1},he)}}function F(N){let H=0,_=0,Z=0,he=0,pe=0;for(let Pe=0;Pe<N.length;Pe++)pe=N.charCodeAt(Pe),M(pe)&&H++,y(pe)&&_++,$(pe)&&Z++,r(pe)&&he++;const ye=H/N.length,we=_/N.length,Ee=Z/N.length,ve=he/N.length;return{upperPercent:ye,lowerPercent:we,alphaPercent:Ee,numericPercent:ve}}function O(N){const{upperPercent:H,lowerPercent:_}=N;return _===0&&H>.6}function R(N){const{upperPercent:H,lowerPercent:_,alphaPercent:Z,numericPercent:he}=N;return _>.2&&H<.8&&Z>.6&&he<.2}function B(N){let H=0,_=0,Z=0,he=0;for(let pe=0;pe<N.length;pe++)Z=N.charCodeAt(pe),M(Z)&&H++,y(Z)&&_++,u(Z)&&he++;return(H===0||_===0)&&he===0?N.length<=30:H<=5}function v(N,H){if(!H||(H=H.trim(),H.length===0)||!B(N)||H.length>60)return null;const _=F(H);if(!R(_)){if(!O(_))return null;H=H.toLowerCase()}let Z=null,he=0;for(N=N.toLowerCase();he<H.length&&(Z=h(N,H,0,he))===null;)he=f(H,he+1);return Z}t.$Yj=v;function C(N,H,_=!1){if(!H||H.length===0)return null;let Z=null,he=0;for(N=N.toLowerCase(),H=H.toLowerCase();he<H.length&&(Z=V(N,H,0,he,_),Z===null);)he=U(H,he+1);return Z}t.$Zj=C;function V(N,H,_,Z,he){let pe=0;if(_===N.length)return[];if(Z===H.length)return null;if(!m(N.charCodeAt(_),H.charCodeAt(Z))){const Ee=o(N.charCodeAt(_));if(!Ee)return null;for(let ve=0;ve<Ee.length;ve++)if(!m(Ee[ve],H.charCodeAt(Z+ve)))return null;pe+=Ee.length-1}let ye=null,we=Z+pe+1;if(ye=V(N,H,_+1,we,he),!he)for(;!ye&&(we=U(H,we))<H.length;)ye=V(N,H,_+1,we,he),we++;if(!ye)return null;if(N.charCodeAt(_)!==H.charCodeAt(Z)){const Ee=o(N.charCodeAt(_));if(!Ee)return ye;for(let ve=0;ve<Ee.length;ve++)if(Ee[ve]!==H.charCodeAt(Z+ve))return ye}return c({start:Z,end:Z+pe+1},ye)}function U(N,H){for(let _=H;_<N.length;_++)if(s(N.charCodeAt(_))||_>0&&s(N.charCodeAt(_-1)))return _;return N.length}const T=j(t.$Uj,v,S),L=j(t.$Uj,v,b),z=new k.$Dc(1e4);function X(N,H,_=!1){if(typeof N!="string"||typeof H!="string")return null;let Z=z.get(N);Z||(Z=new RegExp(n.$Ve(N),"i"),z.set(N,Z));const he=Z.exec(H);return he?[{start:he.index,end:he.index+he[0].length}]:_?L(N,H):T(N,H)}t.$1j=X;function Y(N,H){const _=D(N,N.toLowerCase(),0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?le(_):null}t.$2j=Y;function fe(N,H,_,Z,he,pe){const ye=Math.min(13,N.length);for(;_<ye;_++){const we=D(N,H,_,Z,he,pe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,pe]}t.$3j=fe;function le(N){if(typeof N>"u")return[];const H=[],_=N[1];for(let Z=N.length-1;Z>1;Z--){const he=N[Z]+_,pe=H[H.length-1];pe&&pe.end===he?pe.end=he+1:H.push({start:he,end:he+1})}return H}t.$4j=le;const ee=128;function ge(){const N=[],H=[];for(let _=0;_<=ee;_++)H[_]=0;for(let _=0;_<=ee;_++)N.push(H.slice(0));return N}function Le(N){const H=[];for(let _=0;_<=N;_++)H[_]=0;return H}const Ne=Le(2*ee),Be=Le(2*ee),ne=ge(),J=ge(),se=ge(),oe=!1;function W(N,H,_,Z,he){function pe(we,Ee,ve=" "){for(;we.length<Ee;)we=ve+we;return we}let ye=` |   |${Z.split("").map(we=>pe(we,3)).join("|")}
`;for(let we=0;we<=_;we++)we===0?ye+=" |":ye+=`${H[we-1]}|`,ye+=N[we].slice(0,he+1).map(Ee=>pe(Ee.toString(),3)).join("|")+`
`;return ye}function G(N,H,_,Z){N=N.substr(H),_=_.substr(Z),console.log(W(J,N,N.length,_,_.length)),console.log(W(se,N,N.length,_,_.length)),console.log(W(ne,N,N.length,_,_.length))}function ue(N,H){if(H<0||H>=N.length)return!1;const _=N.codePointAt(H);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$sf(_)}}function me(N,H){if(H<0||H>=N.length)return!1;switch(N.charCodeAt(H)){case 32:case 9:return!0;default:return!1}}function Se(N,H,_){return H[N]!==_[N]}function ke(N,H,_,Z,he,pe,ye=!1){for(;H<_&&he<pe;)N[H]===Z[he]&&(ye&&(Ne[H]=he),H+=1),he+=1;return H===_}t.$5j=ke;var Ce;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var K;(function(N){N.Default=[-100,0];function H(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}N.isDefault=H})(K||(t.FuzzyScore=K={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(H,_){this.firstMatchCanBeWeak=H,this.boostFullMatch=_}}t.$6j=g;function D(N,H,_,Z,he,pe,ye=g.default){const we=N.length>ee?ee:N.length,Ee=Z.length>ee?ee:Z.length;if(_>=we||pe>=Ee||we-_>Ee-pe||!ke(H,_,we,he,pe,Ee,!0))return;p(we,Ee,_,pe,H,he);let ve=1,Pe=1,Ie=_,Me=pe;const Ye=[!1];for(ve=1,Ie=_;Ie<we;ve++,Ie++){const de=Ne[Ie],Ae=Be[Ie],Te=Ie+1<we?Be[Ie+1]:Ee;for(Pe=de-pe+1,Me=de;Me<Te;Pe++,Me++){let je=Number.MIN_SAFE_INTEGER,Ve=!1;Me<=Ae&&(je=l(N,H,Ie,_,Z,he,Me,Ee,pe,ne[ve-1][Pe-1]===0,Ye));let _e=0;je!==Number.MAX_SAFE_INTEGER&&(Ve=!0,_e=je+J[ve-1][Pe-1]);const Je=Me>de,tt=Je?J[ve][Pe-1]+(ne[ve][Pe-1]>0?-5:0):0,Ze=Me>de+1&&ne[ve][Pe-1]>0,nt=Ze?J[ve][Pe-2]+(ne[ve][Pe-2]>0?-5:0):0;if(Ze&&(!Je||nt>=tt)&&(!Ve||nt>=_e))J[ve][Pe]=nt,se[ve][Pe]=3,ne[ve][Pe]=0;else if(Je&&(!Ve||tt>=_e))J[ve][Pe]=tt,se[ve][Pe]=2,ne[ve][Pe]=0;else if(Ve)J[ve][Pe]=_e,se[ve][Pe]=1,ne[ve][Pe]=ne[ve-1][Pe-1]+1;else throw new Error("not possible")}}if(oe&&G(N,_,Z,pe),!Ye[0]&&!ye.firstMatchCanBeWeak)return;ve--,Pe--;const et=[J[ve][Pe],pe];let Qe=0,x=0;for(;ve>=1;){let de=Pe;do{const Ae=se[ve][de];if(Ae===3)de=de-2;else if(Ae===2)de=de-1;else break}while(de>=1);Qe>1&&H[_+ve-1]===he[pe+Pe-1]&&!Se(de+pe-1,Z,he)&&Qe+1>ne[ve][de]&&(de=Pe),de===Pe?Qe++:Qe=1,x||(x=de),ve--,Pe=de-1,et.push(Pe)}Ee===we&&ye.boostFullMatch&&(et[0]+=2);const re=x-we;return et[0]-=re,et}t.$7j=D;function p(N,H,_,Z,he,pe){let ye=N-1,we=H-1;for(;ye>=_&&we>=Z;)he[ye]===pe[we]&&(Be[ye]=we,ye--),we--}function l(N,H,_,Z,he,pe,ye,we,Ee,ve,Pe){if(H[_]!==pe[ye])return Number.MIN_SAFE_INTEGER;let Ie=1,Me=!1;return ye===_-Z?Ie=N[_]===he[ye]?7:5:Se(ye,he,pe)&&(ye===0||!Se(ye-1,he,pe))?(Ie=N[_]===he[ye]?7:5,Me=!0):ue(pe,ye)&&(ye===0||!ue(pe,ye-1))?Ie=5:(ue(pe,ye-1)||me(pe,ye-1))&&(Ie=5,Me=!0),Ie>1&&_===Z&&(Pe[0]=!0),Me||(Me=Se(ye,he,pe)||ue(pe,ye-1)||me(pe,ye-1)),_===Z?ye>Ee&&(Ie-=Me?3:5):ve?Ie+=Me?2:0:Ie+=Me?0:1,ye+1===we&&(Ie-=Me?3:5),Ie}function i(N,H,_,Z,he,pe,ye){return E(N,H,_,Z,he,pe,!0,ye)}t.$8j=i;function a(N,H,_,Z,he,pe,ye){return E(N,H,_,Z,he,pe,!1,ye)}t.$9j=a;function E(N,H,_,Z,he,pe,ye,we){let Ee=D(N,H,_,Z,he,pe,we);if(Ee&&!ye)return Ee;if(N.length>=3){const ve=Math.min(7,N.length-1);for(let Pe=_+1;Pe<ve;Pe++){const Ie=I(N,Pe);if(Ie){const Me=D(Ie,Ie.toLowerCase(),_,Z,he,pe,we);Me&&(Me[0]-=3,(!Ee||Me[0]>Ee[0])&&(Ee=Me))}}}return Ee}function I(N,H){if(H+1>=N.length)return;const _=N[H],Z=N[H+1];if(_!==Z)return N.slice(0,H)+Z+_+N.slice(H+2)}}),define(be[49],$e([1,0,10]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Vi=t.$Ui=t.$Ti=void 0;function P(d){return n(d,0)}t.$Ti=P;function n(d,o){switch(typeof d){case"object":return d===null?j(349,o):Array.isArray(d)?b(d,o):w(d,o);case"string":return S(d,o);case"boolean":return A(d,o);case"number":return j(d,o);case"undefined":return j(937,o);default:return j(617,o)}}t.$Ui=n;function j(d,o){return(o<<5)-o+d|0}t.$Vi=j;function A(d,o){return j(d?433:863,o)}function S(d,o){o=j(149417,o);for(let $=0,c=d.length;$<c;$++)o=j(d.charCodeAt($),o);return o}t.$Wi=S;function b(d,o){return o=j(104579,o),d.reduce(($,c)=>n(c,$),o)}function w(d,o){return o=j(181387,o),Object.keys(d).sort().reduce(($,c)=>($=S(c,$),n(d[c],$)),o)}class y{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=n(o,this.g),this.g}}t.$Xi=y;var M;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function r(d,o,$=32){const c=$-o,f=~((1<<c)-1);return(d<<o|(f&d)>>>c)>>>0}function u(d,o=0,$=d.byteLength,c=0){for(let f=0;f<$;f++)d[o+f]=c}function e(d,o,$="0"){for(;d.length<o;)d=$+d;return d}function s(d,o=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map($=>$.toString(16).padStart(2,"0")).join(""):e((d>>>0).toString(16),o/4)}t.$Yi=s;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const $=o.length;if($===0)return;const c=this.p;let f=this.r,h=this.u,F,O;for(h!==0?(F=h,O=-1,h=0):(F=o.charCodeAt(0),O=0);;){let R=F;if(k.$df(F))if(O+1<$){const B=o.charCodeAt(O+1);k.$ef(B)?(O++,R=k.$ff(F,B)):R=65533}else{h=F;break}else k.$ef(F)&&(R=65533);if(f=this.w(c,f,R),O++,O<$)F=o.charCodeAt(O);else break}this.r=f,this.u=h}w(o,$,c){return c<128?o[$++]=c:c<2048?(o[$++]=192|(c&1984)>>>6,o[$++]=128|(c&63)>>>0):c<65536?(o[$++]=224|(c&61440)>>>12,o[$++]=128|(c&4032)>>>6,o[$++]=128|(c&63)>>>0):(o[$++]=240|(c&1835008)>>>18,o[$++]=128|(c&258048)>>>12,o[$++]=128|(c&4032)>>>6,o[$++]=128|(c&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=m.g,$=this.q;for(let C=0;C<64;C+=4)o.setUint32(C,$.getUint32(C,!1),!1);for(let C=64;C<320;C+=4)o.setUint32(C,r(o.getUint32(C-12,!1)^o.getUint32(C-32,!1)^o.getUint32(C-56,!1)^o.getUint32(C-64,!1),1),!1);let c=this.h,f=this.l,h=this.m,F=this.n,O=this.o,R,B,v;for(let C=0;C<80;C++)C<20?(R=f&h|~f&F,B=1518500249):C<40?(R=f^h^F,B=1859775393):C<60?(R=f&h|f&F|h&F,B=2400959708):(R=f^h^F,B=3395469782),v=r(c,5)+R+O+B+o.getUint32(C*4,!1)&4294967295,O=F,F=h,h=r(f,30),f=c,c=v;this.h=this.h+c&4294967295,this.l=this.l+f&4294967295,this.m=this.m+h&4294967295,this.n=this.n+F&4294967295,this.o=this.o+O&4294967295}}t.$Zi=m}),define(be[87],$e([1,0,75,49]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1s=t.$Zs=t.$Ys=void 0;class n{constructor(r){this.a=r}getElements(){const r=this.a,u=new Int32Array(r.length);for(let e=0,s=r.length;e<s;e++)u[e]=r.charCodeAt(e);return u}}t.$Ys=n;function j(M,r,u){return new y(new n(M),new n(r)).ComputeDiff(u).changes}t.$Zs=j;class A{static Assert(r,u){if(!r)throw new Error(u)}}class S{static Copy(r,u,e,s,m){for(let d=0;d<m;d++)e[s+d]=r[u+d]}static Copy2(r,u,e,s,m){for(let d=0;d<m;d++)e[s+d]=r[u+d]}}var b;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(b||(b={}));class w{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$Xs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.d++}AddModifiedElement(r,u){this.b=Math.min(this.b,r),this.c=Math.min(this.c,u),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class y{constructor(r,u,e=null){this.a=e,this.b=r,this.c=u;const[s,m,d]=y.o(r),[o,$,c]=y.o(u);this.d=d&&c,this.e=s,this.f=m,this.g=o,this.h=$,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const u=r.getElements();if(y.n(u)){const e=new Int32Array(u.length);for(let s=0,m=u.length;s<m;s++)e[s]=(0,P.$Wi)(u[s],0);return[u,e,!0]}return u instanceof Int32Array?[[],u,!1]:[[],new Int32Array(u),!1]}p(r,u){return this.f[r]!==this.h[u]?!1:this.d?this.e[r]===this.g[u]:!0}q(r,u){if(!this.p(r,u))return!1;const e=y.r(this.b,r),s=y.r(this.c,u);return e===s}static r(r,u){return typeof r.getStrictElement=="function"?r.getStrictElement(u):null}s(r,u){return this.f[r]!==this.f[u]?!1:this.d?this.e[r]===this.e[u]:!0}u(r,u){return this.h[r]!==this.h[u]?!1:this.d?this.g[r]===this.g[u]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,u,e,s,m){const d=[!1];let o=this.w(r,u,e,s,d);return m&&(o=this.z(o)),{quitEarly:d[0],changes:o}}w(r,u,e,s,m){for(m[0]=!1;r<=u&&e<=s&&this.p(r,e);)r++,e++;for(;u>=r&&s>=e&&this.p(u,s);)u--,s--;if(r>u||e>s){let h;return e<=s?(A.Assert(r===u+1,"originalStart should only be one more than originalEnd"),h=[new k.$Xs(r,0,e,s-e+1)]):r<=u?(A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),h=[new k.$Xs(r,u-r+1,e,0)]):(A.Assert(r===u+1,"originalStart should only be one more than originalEnd"),A.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),h=[]),h}const d=[0],o=[0],$=this.y(r,u,e,s,d,o,m),c=d[0],f=o[0];if($!==null)return $;if(!m[0]){const h=this.w(r,c,e,f,m);let F=[];return m[0]?F=[new k.$Xs(c+1,u-(c+1)+1,f+1,s-(f+1)+1)]:F=this.w(c+1,u,f+1,s,m),this.H(h,F)}return[new k.$Xs(r,u-r+1,e,s-e+1)]}x(r,u,e,s,m,d,o,$,c,f,h,F,O,R,B,v,C,V){let U=null,T=null,L=new w,z=u,X=e,Y=O[0]-v[0]-s,fe=-1073741824,le=this.k.length-1;do{const ee=Y+r;ee===z||ee<X&&c[ee-1]<c[ee+1]?(h=c[ee+1],R=h-Y-s,h<fe&&L.MarkNextChange(),fe=h,L.AddModifiedElement(h+1,R),Y=ee+1-r):(h=c[ee-1]+1,R=h-Y-s,h<fe&&L.MarkNextChange(),fe=h-1,L.AddOriginalElement(h,R+1),Y=ee-1-r),le>=0&&(c=this.k[le],r=c[0],z=1,X=c.length-1)}while(--le>=-1);if(U=L.getReverseChanges(),V[0]){let ee=O[0]+1,ge=v[0]+1;if(U!==null&&U.length>0){const Le=U[U.length-1];ee=Math.max(ee,Le.getOriginalEnd()),ge=Math.max(ge,Le.getModifiedEnd())}T=[new k.$Xs(ee,F-ee+1,ge,B-ge+1)]}else{L=new w,z=d,X=o,Y=O[0]-v[0]-$,fe=1073741824,le=C?this.m.length-1:this.m.length-2;do{const ee=Y+m;ee===z||ee<X&&f[ee-1]>=f[ee+1]?(h=f[ee+1]-1,R=h-Y-$,h>fe&&L.MarkNextChange(),fe=h+1,L.AddOriginalElement(h+1,R+1),Y=ee+1-m):(h=f[ee-1],R=h-Y-$,h>fe&&L.MarkNextChange(),fe=h,L.AddModifiedElement(h+1,R+1),Y=ee-1-m),le>=0&&(f=this.m[le],m=f[0],z=1,X=f.length-1)}while(--le>=-1);T=L.getChanges()}return this.H(U,T)}y(r,u,e,s,m,d,o){let $=0,c=0,f=0,h=0,F=0,O=0;r--,e--,m[0]=0,d[0]=0,this.k=[],this.m=[];const R=u-r+(s-e),B=R+1,v=new Int32Array(B),C=new Int32Array(B),V=s-e,U=u-r,T=r-e,L=u-s,X=(U-V)%2===0;v[V]=r,C[U]=u,o[0]=!1;for(let Y=1;Y<=R/2+1;Y++){let fe=0,le=0;f=this.J(V-Y,Y,V,B),h=this.J(V+Y,Y,V,B);for(let ge=f;ge<=h;ge+=2){ge===f||ge<h&&v[ge-1]<v[ge+1]?$=v[ge+1]:$=v[ge-1]+1,c=$-(ge-V)-T;const Le=$;for(;$<u&&c<s&&this.p($+1,c+1);)$++,c++;if(v[ge]=$,$+c>fe+le&&(fe=$,le=c),!X&&Math.abs(ge-U)<=Y-1&&$>=C[ge])return m[0]=$,d[0]=c,Le<=C[ge]&&1447>0&&Y<=1447+1?this.x(V,f,h,T,U,F,O,L,v,C,$,u,m,c,s,d,X,o):null}const ee=(fe-r+(le-e)-Y)/2;if(this.a!==null&&!this.a(fe,ee))return o[0]=!0,m[0]=fe,d[0]=le,ee>0&&1447>0&&Y<=1447+1?this.x(V,f,h,T,U,F,O,L,v,C,$,u,m,c,s,d,X,o):(r++,e++,[new k.$Xs(r,u-r+1,e,s-e+1)]);F=this.J(U-Y,Y,U,B),O=this.J(U+Y,Y,U,B);for(let ge=F;ge<=O;ge+=2){ge===F||ge<O&&C[ge-1]>=C[ge+1]?$=C[ge+1]-1:$=C[ge-1],c=$-(ge-U)-L;const Le=$;for(;$>r&&c>e&&this.p($,c);)$--,c--;if(C[ge]=$,X&&Math.abs(ge-V)<=Y&&$<=v[ge])return m[0]=$,d[0]=c,Le>=v[ge]&&1447>0&&Y<=1447+1?this.x(V,f,h,T,U,F,O,L,v,C,$,u,m,c,s,d,X,o):null}if(Y<=1447){let ge=new Int32Array(h-f+2);ge[0]=V-f+1,S.Copy2(v,f,ge,1,h-f+1),this.k.push(ge),ge=new Int32Array(O-F+2),ge[0]=U-F+1,S.Copy2(C,F,ge,1,O-F+1),this.m.push(ge)}}return this.x(V,f,h,T,U,F,O,L,v,C,$,u,m,c,s,d,X,o)}z(r){for(let u=0;u<r.length;u++){const e=r[u],s=u<r.length-1?r[u+1].originalStart:this.f.length,m=u<r.length-1?r[u+1].modifiedStart:this.h.length,d=e.originalLength>0,o=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<m&&(!d||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!o||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const $=[null];if(u<r.length-1&&this.I(r[u],r[u+1],$)){r[u]=$[0],r.splice(u+1,1),u--;continue}}for(let u=r.length-1;u>=0;u--){const e=r[u];let s=0,m=0;if(u>0){const h=r[u-1];s=h.originalStart+h.originalLength,m=h.modifiedStart+h.modifiedLength}const d=e.originalLength>0,o=e.modifiedLength>0;let $=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let h=1;;h++){const F=e.originalStart-h,O=e.modifiedStart-h;if(F<s||O<m||d&&!this.s(F,F+e.originalLength)||o&&!this.u(O,O+e.modifiedLength))break;const B=(F===s&&O===m?5:0)+this.G(F,e.originalLength,O,e.modifiedLength);B>c&&(c=B,$=h)}e.originalStart-=$,e.modifiedStart-=$;const f=[null];if(u>0&&this.I(r[u-1],r[u],f)){r[u-1]=f[0],r.splice(u,1),u++;continue}}if(this.d)for(let u=1,e=r.length;u<e;u++){const s=r[u-1],m=r[u],d=m.originalStart-s.originalStart-s.originalLength,o=s.originalStart,$=m.originalStart+m.originalLength,c=$-o,f=s.modifiedStart,h=m.modifiedStart+m.modifiedLength,F=h-f;if(d<5&&c<20&&F<20){const O=this.A(o,c,f,F,d);if(O){const[R,B]=O;(R!==s.originalStart+s.originalLength||B!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=R-s.originalStart,s.modifiedLength=B-s.modifiedStart,m.originalStart=R+d,m.modifiedStart=B+d,m.originalLength=$-m.originalStart,m.modifiedLength=h-m.modifiedStart)}}}return r}A(r,u,e,s,m){if(u<m||s<m)return null;const d=r+u-m+1,o=e+s-m+1;let $=0,c=0,f=0;for(let h=r;h<d;h++)for(let F=e;F<o;F++){const O=this.B(h,F,m);O>0&&O>$&&($=O,c=h,f=F)}return $>0?[c,f]:null}B(r,u,e){let s=0;for(let m=0;m<e;m++){if(!this.p(r+m,u+m))return 0;s+=this.e[r+m].length}return s}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,u){if(this.C(r)||this.C(r-1))return!0;if(u>0){const e=r+u;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,u){if(this.E(r)||this.E(r-1))return!0;if(u>0){const e=r+u;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,u,e,s){const m=this.D(r,u)?1:0,d=this.F(e,s)?1:0;return m+d}H(r,u){const e=[];if(r.length===0||u.length===0)return u.length>0?u:r;if(this.I(r[r.length-1],u[0],e)){const s=new Array(r.length+u.length-1);return S.Copy(r,0,s,0,r.length-1),s[r.length-1]=e[0],S.Copy(u,1,s,r.length,u.length-1),s}else{const s=new Array(r.length+u.length);return S.Copy(r,0,s,0,r.length),S.Copy(u,0,s,r.length,u.length),s}}I(r,u,e){if(A.Assert(r.originalStart<=u.originalStart,"Left change is not less than or equal to right change"),A.Assert(r.modifiedStart<=u.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=u.originalStart||r.modifiedStart+r.modifiedLength>=u.modifiedStart){const s=r.originalStart;let m=r.originalLength;const d=r.modifiedStart;let o=r.modifiedLength;return r.originalStart+r.originalLength>=u.originalStart&&(m=u.originalStart+u.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=u.modifiedStart&&(o=u.modifiedStart+u.modifiedLength-r.modifiedStart),e[0]=new k.$Xs(s,m,d,o),!0}else return e[0]=null,!1}J(r,u,e,s){if(r>=0&&r<s)return r;const m=e,d=s-e-1,o=u%2===0;if(r<0){const $=m%2===0;return o===$?0:1}else{const $=d%2===0;return o===$?s-1:s-2}}}t.$1s=y}),define(be[50],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=void 0,t.$Sd=Symbol("MicrotaskDelay")}),define(be[88],$e([1,0,12,10]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.$$h=t.$0h=t.$9h=t.$8h=void 0;class n{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const e=u.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$8h=n;class j{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,P.$6e)(u,this.b,0,u.length,this.c,this.d):(0,P.$8e)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$9h=j;class A{constructor(u=!0,e=!0){this.f=u,this.g=e}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let e=u.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,P.$6e)(u,this.b,0,u.length,this.d,this.e):(0,P.$8e)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$0h=A;var S;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(S||(S={}));class b{constructor(u,e){this.f=u,this.g=e,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,P.$7e)(u,this.c.scheme);if(this.d[this.e]===2)return(0,P.$7e)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,P.$5e)(u,this.c.query);if(this.d[this.e]===5)return(0,P.$5e)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$$h=b;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(y||(y={}));class M{static forUris(u=()=>!1,e=()=>!1){return new M(new b(u,e))}static forPaths(u=!1){return new M(new A(void 0,!u))}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new j)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,e){if(e){const s=e.slice(0);(0,k.$Xb)(s);for(const m of s)this.set(m,u)}else{const s=u.slice(0);(0,k.$Xb)(s);for(const m of s)this.set(m[0],m[1])}}set(u,e){const s=this.b.reset(u);let m;this.c||(this.c=new w,this.c.segment=s.value());const d=[];for(m=this.c;;){const $=s.cmp(m.segment);if($>0)m.left||(m.left=new w,m.left.segment=s.value()),d.push([-1,m]),m=m.left;else if($<0)m.right||(m.right=new w,m.right.segment=s.value()),d.push([1,m]),m=m.right;else if(s.hasNext())s.next(),m.mid||(m.mid=new w,m.mid.segment=s.value()),d.push([0,m]),m=m.mid;else break}const o=m.value;m.value=e,m.key=u;for(let $=d.length-1;$>=0;$--){const c=d[$][1];c.updateHeight();const f=c.balanceFactor();if(f<-1||f>1){const h=d[$][0],F=d[$+1][0];if(h===1&&F===1)d[$][1]=c.rotateLeft();else if(h===-1&&F===-1)d[$][1]=c.rotateRight();else if(h===1&&F===-1)c.right=d[$+1][1]=d[$+1][1].rotateRight(),d[$][1]=c.rotateLeft();else if(h===-1&&F===1)c.left=d[$+1][1]=d[$+1][1].rotateLeft(),d[$][1]=c.rotateRight();else throw new Error;if($>0)switch(d[$-1][0]){case-1:d[$-1][1].left=d[$][1];break;case 1:d[$-1][1].right=d[$][1];break;case 0:d[$-1][1].mid=d[$][1];break}else this.c=d[0][1]}}return o}get(u){return this.d(u)?.value}d(u){const e=this.b.reset(u);let s=this.c;for(;s;){const m=e.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(u){const e=this.d(u);return!(e?.value===void 0&&e?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,e){const s=this.b.reset(u),m=[];let d=this.c;for(;d;){const o=s.cmp(d.segment);if(o>0)m.push([-1,d]),d=d.left;else if(o<0)m.push([1,d]),d=d.right;else if(s.hasNext())s.next(),m.push([0,d]),d=d.mid;else break}if(d){if(e?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const o=this.f(d.right);if(o.key){const{key:$,value:c,segment:f}=o;this.e(o.key,!1),d.key=$,d.value=c,d.segment=f}}else{const o=d.left??d.right;if(m.length>0){const[$,c]=m[m.length-1];switch($){case-1:c.left=o;break;case 0:c.mid=o;break;case 1:c.right=o;break}}else this.c=o}for(let o=m.length-1;o>=0;o--){const $=m[o][1];$.updateHeight();const c=$.balanceFactor();if(c>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),m[o][1]=$.rotateLeft()):c<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),m[o][1]=$.rotateRight()),o>0)switch(m[o-1][0]){case-1:m[o-1][1].left=m[o][1];break;case 1:m[o-1][1].right=m[o][1];break;case 0:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const e=this.b.reset(u);let s=this.c,m;for(;s;){const d=e.cmp(s.segment);if(d>0)s=s.left;else if(d<0)s=s.right;else if(e.hasNext())e.next(),m=s.value||m,s=s.mid;else break}return s&&s.value||m}findSuperstr(u){return this.g(u,!1)}g(u,e){const s=this.b.reset(u);let m=this.c;for(;m;){const d=s.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(s.hasNext())s.next(),m=m.mid;else return m.mid?this.h(m.mid):e?m.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[e,s]of this)u(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const e=[];return this.j(u,e),e[Symbol.iterator]()}j(u,e){u&&(u.left&&this.j(u.left,e),u.value&&e.push([u.key,u.value]),u.mid&&this.j(u.mid,e),u.right&&this.j(u.right,e))}_isBalanced(){const u=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:u(e.left)&&u(e.right)};return u(this.c)}}t.$_h=M}),define(be[7],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=void 0;function k(f){return typeof f=="string"}t.$If=k;function P(f){return Array.isArray(f)&&f.every(h=>k(h))}t.$Jf=P;function n(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Kf=n;function j(f){const h=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof h}t.$Lf=j;function A(f){return typeof f=="number"&&!isNaN(f)}t.$Mf=A;function S(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Nf=S;function b(f){return f===!0||f===!1}t.$Of=b;function w(f){return typeof f>"u"}t.$Pf=w;function y(f){return!M(f)}t.$Qf=y;function M(f){return w(f)||f===null}t.$Rf=M;function r(f,h){if(!f)throw new Error(h?`Unexpected type, expected '${h}'`:"Unexpected type")}t.$Sf=r;function u(f){if(M(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$Tf=u;function e(...f){const h=[];for(let F=0;F<f.length;F++){const O=f[F];if(M(O))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);h.push(O)}return h}t.$Uf=e;const s=Object.prototype.hasOwnProperty;function m(f){if(!n(f))return!1;for(const h in f)if(s.call(f,h))return!1;return!0}t.$Vf=m;function d(f){return typeof f=="function"}t.$Wf=d;function o(...f){return f.length>0&&f.every(d)}t.$Xf=o;function $(f,h){const F=Math.min(f.length,h.length);for(let O=0;O<F;O++)c(f[O],h[O])}t.$Yf=$;function c(f,h){if(k(h)){if(typeof f!==h)throw new Error(`argument does not match constraint: typeof ${h}`)}else if(d(h)){try{if(f instanceof h)return}catch{}if(!M(f)&&f.constructor===h||h.length===1&&h.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Zf=c}),define(be[17],$e([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_j=t.$$j=t.$0j=void 0;const P=Object.create(null);function n(S,b){if((0,k.$If)(b)){const w=P[b];if(w===void 0)throw new Error(`${S} references an unknown codicon: ${b}`);b=w}return P[S]=b,{id:S}}function j(){return P}t.$0j=j;function A(){return Object.values(t.$_j)}t.$$j=A,t.$_j={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[51],$e([1,0,7]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=t.$xn=t.$wn=t.$vn=void 0;function P(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const o=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([$,c])=>{o[$]=c&&typeof c=="object"?P(c):c}),o}t.$vn=P;function n(d){if(!d||typeof d!="object")return d;const o=[d];for(;o.length>0;){const $=o.shift();Object.freeze($);for(const c in $)if(j.call($,c)){const f=$[c];typeof f=="object"&&!Object.isFrozen(f)&&!(0,k.$Lf)(f)&&o.push(f)}}return d}t.$wn=n;const j=Object.prototype.hasOwnProperty;function A(d,o){return S(d,o,new Set)}t.$xn=A;function S(d,o,$){if((0,k.$Rf)(d))return d;const c=o(d);if(typeof c<"u")return c;if(Array.isArray(d)){const f=[];for(const h of d)f.push(S(h,o,$));return f}if((0,k.$Kf)(d)){if($.has(d))throw new Error("Cannot clone recursive data-structure");$.add(d);const f={};for(const h in d)j.call(d,h)&&(f[h]=S(d[h],o,$));return $.delete(d),f}return d}function b(d,o,$=!0){return(0,k.$Kf)(d)?((0,k.$Kf)(o)&&Object.keys(o).forEach(c=>{c in d?$&&((0,k.$Kf)(d[c])&&(0,k.$Kf)(o[c])?b(d[c],o[c],$):d[c]=o[c]):d[c]=o[c]}),d):o}t.$yn=b;function w(d,o){if(d===o)return!0;if(d==null||o===null||o===void 0||typeof d!=typeof o||typeof d!="object"||Array.isArray(d)!==Array.isArray(o))return!1;let $,c;if(Array.isArray(d)){if(d.length!==o.length)return!1;for($=0;$<d.length;$++)if(!w(d[$],o[$]))return!1}else{const f=[];for(c in d)f.push(c);f.sort();const h=[];for(c in o)h.push(c);if(h.sort(),!w(f,h))return!1;for($=0;$<f.length;$++)if(!w(d[f[$]],o[f[$]]))return!1}return!0}t.$zn=w;function y(d){const o=new Set;return JSON.stringify(d,($,c)=>{if((0,k.$Kf)(c)||Array.isArray(c)){if(o.has(c))return"[Circular]";o.add(c)}return c})}t.$An=y;function M(d,o){const $=Object.create(null);return!d||!o||Object.keys(o).forEach(f=>{const h=d[f],F=o[f];w(h,F)||($[f]=F)}),$}t.$Bn=M;function r(d,o){const $=o.toLowerCase(),c=Object.keys(d).find(f=>f.toLowerCase()===$);return c?d[c]:d[o]}t.$Cn=r;function u(d,o){const $=Object.create(null);for(const[c,f]of Object.entries(d))o(c,f)&&($[c]=f);return $}t.$Dn=u;function e(d){let o=[];for(;Object.prototype!==d;)o=o.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return o}t.$En=e;function s(d){const o=[];for(const $ of e(d))typeof d[$]=="function"&&o.push($);return o}t.$Fn=s;function m(d,o){const $=f=>function(){const h=Array.prototype.slice.call(arguments,0);return o(f,h)},c={};for(const f of d)c[f]=$(f);return c}t.$Gn=m}),define(be[18],$e([1,0,17]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$ak=t.ThemeColor=void 0;var P;(function(A){function S(b){return b&&typeof b=="object"&&typeof b.id=="string"}A.isThemeColor=S})(P||(t.ThemeColor=P={}));function n(A){return{id:A}}t.$ak=n;var j;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function b(o){const $=S.exec(o.id);if(!$)return b(k.$_j.error);const[,c,f]=$,h=["codicon","codicon-"+c];return f&&h.push("codicon-modifier-"+f.substring(1)),h}A.asClassNameArray=b;function w(o){return b(o).join(" ")}A.asClassName=w;function y(o){return"."+b(o).join(".")}A.asCSSSelector=y;function M(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color>"u"||P.isThemeColor(o.color))}A.isThemeIcon=M;const r=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function u(o){const $=r.exec(o);if(!$)return;const[,c]=$;return{id:c}}A.fromString=u;function e(o){return{id:o}}A.fromId=e;function s(o,$){let c=o.id;const f=c.lastIndexOf("~");return f!==-1&&(c=c.substring(0,f)),$&&(c=`${c}~${$}`),{id:c}}A.modify=s;function m(o){const $=o.id.lastIndexOf("~");if($!==-1)return o.id.substring($+1)}A.getModifier=m;function d(o,$){return o.id===$.id&&o.color?.id===$.color?.id}A.isEqual=d})(j||(t.ThemeIcon=j={}))}),define(be[35],$e([1,0,34,10,18]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.$bk=void 0;const j="$(",A=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${A.source}`,"g");function b(d){return d.replace(S,(o,$)=>$?o:`\\${o}`)}t.$bk=b;const w=new RegExp(`\\\\${A.source}`,"g");function y(d){return d.replace(w,o=>`\\${o}`)}t.$ck=y;const M=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function r(d){return d.indexOf(j)===-1?d:d.replace(M,(o,$,c,f)=>c?o:$||f||"")}t.$dk=r;function u(d){return d?d.replace(/\$\((.*?)\)/g,(o,$)=>` ${$} `).trim():""}t.$ek=u;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(d){e.lastIndex=0;let o="";const $=[];let c=0;for(;;){const f=e.lastIndex,h=e.exec(d),F=d.substring(f,h?.index);if(F.length>0){o+=F;for(let O=0;O<F.length;O++)$.push(c)}if(!h)break;c+=h[0].length}return{text:o,iconOffsets:$}}t.$fk=s;function m(d,o,$=!1){const{text:c,iconOffsets:f}=o;if(!f||f.length===0)return(0,k.$1j)(d,c,$);const h=(0,P.$Te)(c," "),F=c.length-h.length,O=(0,k.$1j)(d,h,$);if(O)for(const R of O){const B=f[R.start+F]+F;R.start+=B,R.end+=B}return O}t.$gk=m}),define(be[89],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=t.$AU=void 0,t.$AU="vscode:contextmenu",t.$BU="vscode:onCloseContextMenu"}),define(be[90],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IU=void 0;class k{constructor(n,j){this.a=n,this.onMessage=j}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$IU=k}),define(be[30],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const k=globalThis.vscode;t.$O=k.ipcRenderer,t.$P=k.ipcMessagePort,t.$Q=k.webFrame,t.$R=k.process,t.$S=k.context}),define(be[91],$e([1,0,89,30]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EU=void 0;let n=0;function j(S,b,w){const y=[],M=n++,r=`vscode:onContextMenu${M}`,u=(e,s,m)=>{y[s].click?.(m)};P.$O.once(r,u),P.$O.once(k.$BU,(e,s)=>{s===M&&(P.$O.removeListener(r,u),w?.())}),P.$O.send(k.$AU,M,S.map(e=>A(e,y)),r,b)}t.$EU=j;function A(S,b){const w={id:b.length,label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:typeof S.enabled=="boolean"?S.enabled:!0,visible:typeof S.visible=="boolean"?S.visible:!0};return b.push(S),Array.isArray(S.submenu)&&(w.submenu=S.submenu.map(y=>A(y,b))),w}}),define(be[52],$e([8]),{}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([1,0,93,94]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([8]),{}),define(be[102],$e([8]),{}),define(be[103],$e([8]),{}),define(be[104],$e([8]),{}),define(be[105],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],$e([13,11]),function(ie,t){return ie.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],$e([13,11]),function(ie,t){return ie.create("vs/base/common/actions",t)}),define(be[36],$e([1,0,4,2,112]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pi=t.$Oi=t.$Ni=t.$Mi=t.$Li=t.$Ki=void 0;class j extends P.$Tc{constructor(r,u="",e="",s=!0,m){super(),this.h=this.B(new k.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=u,this.u=e,this.w=s,this.C=m}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,u){this.C&&await this.C(r)}}t.$Ki=j;class A extends P.$Tc{constructor(){super(...arguments),this.f=this.B(new k.$Vd),this.onWillRun=this.f.event,this.m=this.B(new k.$Vd),this.onDidRun=this.m.event}async run(r,u){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.u(r,u)}catch(s){e=s}this.m.fire({action:r,error:e})}async u(r,u){await r.run(u)}}t.$Li=A;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let u=[];for(const e of r)e.length&&(u.length?u=[...u,new S,...e]:u=e);return u}static{this.ID="vs.actions.separator"}async run(){}}t.$Mi=S;class b{get actions(){return this.a}constructor(r,u,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=u,this.class=s,this.a=e}async run(){}}t.$Ni=b;class w extends j{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,n.localize(0,null),void 0,!1)}}t.$Oi=w;function y(M){return{id:M.id,label:M.label,class:M.class,enabled:M.enabled??!0,checked:M.checked??!1,run:async(...r)=>M.run(...r),tooltip:M.label}}t.$Pi=y}),define(be[113],$e([13,11]),function(ie,t){return ie.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,113]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let P=!1,n=!1,j=!1,A=!1,S=!1,b=!1,w=!1,y=!1,M=!1,r=!1,u,e=t.$g,s=t.$g,m,d;const o=globalThis;let $;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?$=o.vscode.process:typeof process<"u"&&($=process);const c=typeof $?.versions?.electron=="string",f=c&&$?.type==="renderer";if(typeof $=="object"){P=$.platform==="win32",n=$.platform==="darwin",j=$.platform==="linux",A=j&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,w=c,M=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=t.$g,e=t.$g;const T=$.env.VSCODE_NLS_CONFIG;if(T)try{const L=JSON.parse(T),z=L.availableLanguages["*"];u=L.locale,s=L.osLocale,e=z||t.$g,m=L._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!f?(d=navigator.userAgent,P=d.indexOf("Windows")>=0,n=d.indexOf("Macintosh")>=0,y=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=d.indexOf("Linux")>=0,r=d?.indexOf("Mobi")>=0,b=!0,u=k.getConfiguredDefaultLocale(k.localize(0,null))||t.$g,e=u,s=navigator.language):console.error("Unable to resolve platform.");var h;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(h||(t.Platform=h={}));function F(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=F;let O=0;n?O=1:P?O=3:j&&(O=2),t.$i=P,t.$j=n,t.$k=j,t.$l=A,t.$m=S,t.$n=w,t.$o=b,t.$p=b&&typeof o.importScripts=="function",t.$q=t.$p?o.origin:void 0,t.$r=y,t.$s=r,t.$t=M,t.$u=O,t.$v=d,t.$w=e;var R;(function(T){function L(){return t.$w}T.value=L;function z(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}T.isDefaultVariant=z;function X(){return t.$w==="en"}T.isDefault=X})(R||(t.Language=R={})),t.$x=u,t.$y=s,t.$z=m,t.$A=typeof o.postMessage=="function"&&!o.importScripts,t.$B=(()=>{if(t.$A){const T=[];o.addEventListener("message",z=>{if(z.data&&z.data.vscodeScheduleAsyncWork)for(let X=0,Y=T.length;X<Y;X++){const fe=T[X];if(fe.id===z.data.vscodeScheduleAsyncWork){T.splice(X,1),fe.callback();return}}});let L=0;return z=>{const X=++L;T.push({id:X,callback:z}),o.postMessage({vscodeScheduleAsyncWork:X},"*")}}return T=>setTimeout(T)})();var B;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(B||(t.OperatingSystem=B={})),t.OS=n||y?2:P?1:3;let v=!0,C=!1;function V(){if(!C){C=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,v=new Uint16Array(T.buffer)[0]===(2<<8)+1}return v}t.$D=V,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function U(T){return parseFloat(T)>=20}t.$J=U}),define(be[114],$e([1,0,16,21,5]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AP=t.KeyboardSupport=void 0;var j;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(j||(t.KeyboardSupport=j={})),t.$AP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>n.$m||k.$yP()?0:navigator.keyboard||k.$uP?1:2)(),touch:"ontouchstart"in P.$dP||navigator.maxTouchPoints>0,pointerEvents:P.$dP.PointerEvent&&("ontouchstart"in P.$dP||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,44,78,5]),function(ie,t,k,P,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IP=t.$HP=t.$GP=void 0;function A(e){if(e.charCode){const m=String.fromCharCode(e.charCode).toUpperCase();return P.KeyCodeUtils.fromString(m)}const s=e.keyCode;if(s===3)return 7;if(k.$rP)switch(s){case 59:return 85;case 60:if(j.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(j.$j)return 57;break}else if(k.$sP){if(j.$j&&s===93)return 57;if(!j.$j&&s===92)return 57}return P.$2q[s]||0}const S=j.$j?256:2048,b=512,w=1024,y=j.$j?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$GP=M;function r(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${P.KeyCodeUtils.toString(e.keyCode)}')`}t.$HP=r;class u{constructor(s){this._standardKeyboardEventBrand=!0;const m=s;this.browserEvent=m,this.target=m.target,this.ctrlKey=m.ctrlKey,this.shiftKey=m.shiftKey,this.altKey=m.altKey,this.metaKey=m.metaKey,this.altGraphKey=m.getModifierState("AltGraph"),this.keyCode=A(m),this.code=m.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let m=0;return this.ctrlKey&&(m|=S),this.altKey&&(m|=b),this.shiftKey&&(m|=w),this.metaKey&&(m|=y),m|=s,m}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$0q(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$IP=u}),define(be[19],$e([1,0,16,69,5]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FP=t.$EP=t.$DP=void 0;class j{constructor(w,y){this.timestamp=Date.now(),this.browserEvent=y,this.leftButton=y.button===0,this.middleButton=y.button===1,this.rightButton=y.button===2,this.buttons=y.buttons,this.target=y.target,this.detail=y.detail||1,y.type==="dblclick"&&(this.detail=2),this.ctrlKey=y.ctrlKey,this.shiftKey=y.shiftKey,this.altKey=y.altKey,this.metaKey=y.metaKey,typeof y.pageX=="number"?(this.posx=y.pageX,this.posy=y.pageY):(this.posx=y.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=y.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const M=P.$BP.getPositionOfChildWindowRelativeToAncestorWindow(w,y.view);this.posx-=M.left,this.posy-=M.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$DP=j;class A extends j{constructor(w,y){super(w,y),this.dataTransfer=y.dataTransfer}}t.$EP=A;class S{constructor(w,y=0,M=0){if(this.browserEvent=w||null,this.target=w?w.target||w.targetNode||w.srcElement:null,this.deltaY=M,this.deltaX=y,w){const r=w,u=w,e=w.view?.devicePixelRatio||1;if(typeof r.wheelDeltaY<"u")k.$tP?this.deltaY=r.wheelDeltaY/(120*e):this.deltaY=r.wheelDeltaY/120;else if(typeof u.VERTICAL_AXIS<"u"&&u.axis===u.VERTICAL_AXIS)this.deltaY=-u.detail/3;else if(w.type==="wheel"){const s=w;s.deltaMode===s.DOM_DELTA_LINE?k.$rP&&!n.$j?this.deltaY=-w.deltaY/3:this.deltaY=-w.deltaY:this.deltaY=-w.deltaY/40}if(typeof r.wheelDeltaX<"u")k.$uP&&n.$i?this.deltaX=-(r.wheelDeltaX/120):k.$tP?this.deltaX=r.wheelDeltaX/(120*e):this.deltaX=r.wheelDeltaX/120;else if(typeof u.HORIZONTAL_AXIS<"u"&&u.axis===u.HORIZONTAL_AXIS)this.deltaX=-w.detail/3;else if(w.type==="wheel"){const s=w;s.deltaMode===s.DOM_DELTA_LINE?k.$rP&&!n.$j?this.deltaX=-w.deltaX/3:this.deltaX=-w.deltaX:this.deltaX=-w.deltaX/40}this.deltaY===0&&this.deltaX===0&&w.wheelDelta&&(k.$tP?this.deltaY=w.wheelDelta/(120*e):this.deltaY=w.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$FP=S}),define(be[115],$e([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let P;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const j=n.process;P={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?P={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:P={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=P.cwd,t.env=P.env,t.$dc=P.platform,t.$ec=P.arch}),define(be[24],$e([1,0,115]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const P=65,n=97,j=90,A=122,S=46,b=47,w=92,y=58,M=63;class r extends Error{constructor(F,O,R){let B;typeof O=="string"&&O.indexOf("not ")===0?(B="must not be",O=O.replace(/^not /,"")):B="must be";const v=F.indexOf(".")!==-1?"property":"argument";let C=`The "${F}" ${v} ${B} of type ${O}`;C+=`. Received type ${typeof R}`,super(C),this.code="ERR_INVALID_ARG_TYPE"}}function u(h,F){if(h===null||typeof h!="object")throw new r(F,"Object",h)}function e(h,F){if(typeof h!="string")throw new r(F,"string",h)}const s=k.$dc==="win32";function m(h){return h===b||h===w}function d(h){return h===b}function o(h){return h>=P&&h<=j||h>=n&&h<=A}function $(h,F,O,R){let B="",v=0,C=-1,V=0,U=0;for(let T=0;T<=h.length;++T){if(T<h.length)U=h.charCodeAt(T);else{if(R(U))break;U=b}if(R(U)){if(!(C===T-1||V===1))if(V===2){if(B.length<2||v!==2||B.charCodeAt(B.length-1)!==S||B.charCodeAt(B.length-2)!==S){if(B.length>2){const L=B.lastIndexOf(O);L===-1?(B="",v=0):(B=B.slice(0,L),v=B.length-1-B.lastIndexOf(O)),C=T,V=0;continue}else if(B.length!==0){B="",v=0,C=T,V=0;continue}}F&&(B+=B.length>0?`${O}..`:"..",v=2)}else B.length>0?B+=`${O}${h.slice(C+1,T)}`:B=h.slice(C+1,T),v=T-C-1;C=T,V=0}else U===S&&V!==-1?++V:V=-1}return B}function c(h,F){u(F,"pathObject");const O=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return O?O===F.root?`${O}${R}`:`${O}${h}${R}`:R}t.$fc={resolve(...h){let F="",O="",R=!1;for(let B=h.length-1;B>=-1;B--){let v;if(B>=0){if(v=h[B],e(v,"path"),v.length===0)continue}else F.length===0?v=k.cwd():(v=k.env[`=${F}`]||k.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==F.toLowerCase()&&v.charCodeAt(2)===w)&&(v=`${F}\\`));const C=v.length;let V=0,U="",T=!1;const L=v.charCodeAt(0);if(C===1)m(L)&&(V=1,T=!0);else if(m(L))if(T=!0,m(v.charCodeAt(1))){let z=2,X=z;for(;z<C&&!m(v.charCodeAt(z));)z++;if(z<C&&z!==X){const Y=v.slice(X,z);for(X=z;z<C&&m(v.charCodeAt(z));)z++;if(z<C&&z!==X){for(X=z;z<C&&!m(v.charCodeAt(z));)z++;(z===C||z!==X)&&(U=`\\\\${Y}\\${v.slice(X,z)}`,V=z)}}}else V=1;else o(L)&&v.charCodeAt(1)===y&&(U=v.slice(0,2),V=2,C>2&&m(v.charCodeAt(2))&&(T=!0,V=3));if(U.length>0)if(F.length>0){if(U.toLowerCase()!==F.toLowerCase())continue}else F=U;if(R){if(F.length>0)break}else if(O=`${v.slice(V)}\\${O}`,R=T,T&&F.length>0)break}return O=$(O,!R,"\\",m),R?`${F}\\${O}`:`${F}${O}`||"."},normalize(h){e(h,"path");const F=h.length;if(F===0)return".";let O=0,R,B=!1;const v=h.charCodeAt(0);if(F===1)return d(v)?"\\":h;if(m(v))if(B=!0,m(h.charCodeAt(1))){let V=2,U=V;for(;V<F&&!m(h.charCodeAt(V));)V++;if(V<F&&V!==U){const T=h.slice(U,V);for(U=V;V<F&&m(h.charCodeAt(V));)V++;if(V<F&&V!==U){for(U=V;V<F&&!m(h.charCodeAt(V));)V++;if(V===F)return`\\\\${T}\\${h.slice(U)}\\`;V!==U&&(R=`\\\\${T}\\${h.slice(U,V)}`,O=V)}}}else O=1;else o(v)&&h.charCodeAt(1)===y&&(R=h.slice(0,2),O=2,F>2&&m(h.charCodeAt(2))&&(B=!0,O=3));let C=O<F?$(h.slice(O),!B,"\\",m):"";return C.length===0&&!B&&(C="."),C.length>0&&m(h.charCodeAt(F-1))&&(C+="\\"),R===void 0?B?`\\${C}`:C:B?`${R}\\${C}`:`${R}${C}`},isAbsolute(h){e(h,"path");const F=h.length;if(F===0)return!1;const O=h.charCodeAt(0);return m(O)||F>2&&o(O)&&h.charCodeAt(1)===y&&m(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let F,O;for(let v=0;v<h.length;++v){const C=h[v];e(C,"path"),C.length>0&&(F===void 0?F=O=C:F+=`\\${C}`)}if(F===void 0)return".";let R=!0,B=0;if(typeof O=="string"&&m(O.charCodeAt(0))){++B;const v=O.length;v>1&&m(O.charCodeAt(1))&&(++B,v>2&&(m(O.charCodeAt(2))?++B:R=!1))}if(R){for(;B<F.length&&m(F.charCodeAt(B));)B++;B>=2&&(F=`\\${F.slice(B)}`)}return t.$fc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F)return"";const O=t.$fc.resolve(h),R=t.$fc.resolve(F);if(O===R||(h=O.toLowerCase(),F=R.toLowerCase(),h===F))return"";let B=0;for(;B<h.length&&h.charCodeAt(B)===w;)B++;let v=h.length;for(;v-1>B&&h.charCodeAt(v-1)===w;)v--;const C=v-B;let V=0;for(;V<F.length&&F.charCodeAt(V)===w;)V++;let U=F.length;for(;U-1>V&&F.charCodeAt(U-1)===w;)U--;const T=U-V,L=C<T?C:T;let z=-1,X=0;for(;X<L;X++){const fe=h.charCodeAt(B+X);if(fe!==F.charCodeAt(V+X))break;fe===w&&(z=X)}if(X!==L){if(z===-1)return R}else{if(T>L){if(F.charCodeAt(V+X)===w)return R.slice(V+X+1);if(X===2)return R.slice(V+X)}C>L&&(h.charCodeAt(B+X)===w?z=X:X===2&&(z=3)),z===-1&&(z=0)}let Y="";for(X=B+z+1;X<=v;++X)(X===v||h.charCodeAt(X)===w)&&(Y+=Y.length===0?"..":"\\..");return V+=z,Y.length>0?`${Y}${R.slice(V,U)}`:(R.charCodeAt(V)===w&&++V,R.slice(V,U))},toNamespacedPath(h){if(typeof h!="string"||h.length===0)return h;const F=t.$fc.resolve(h);if(F.length<=2)return h;if(F.charCodeAt(0)===w){if(F.charCodeAt(1)===w){const O=F.charCodeAt(2);if(O!==M&&O!==S)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(o(F.charCodeAt(0))&&F.charCodeAt(1)===y&&F.charCodeAt(2)===w)return`\\\\?\\${F}`;return h},dirname(h){e(h,"path");const F=h.length;if(F===0)return".";let O=-1,R=0;const B=h.charCodeAt(0);if(F===1)return m(B)?h:".";if(m(B)){if(O=R=1,m(h.charCodeAt(1))){let V=2,U=V;for(;V<F&&!m(h.charCodeAt(V));)V++;if(V<F&&V!==U){for(U=V;V<F&&m(h.charCodeAt(V));)V++;if(V<F&&V!==U){for(U=V;V<F&&!m(h.charCodeAt(V));)V++;if(V===F)return h;V!==U&&(O=R=V+1)}}}}else o(B)&&h.charCodeAt(1)===y&&(O=F>2&&m(h.charCodeAt(2))?3:2,R=O);let v=-1,C=!0;for(let V=F-1;V>=R;--V)if(m(h.charCodeAt(V))){if(!C){v=V;break}}else C=!1;if(v===-1){if(O===-1)return".";v=O}return h.slice(0,v)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let O=0,R=-1,B=!0,v;if(h.length>=2&&o(h.charCodeAt(0))&&h.charCodeAt(1)===y&&(O=2),F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let C=F.length-1,V=-1;for(v=h.length-1;v>=O;--v){const U=h.charCodeAt(v);if(m(U)){if(!B){O=v+1;break}}else V===-1&&(B=!1,V=v+1),C>=0&&(U===F.charCodeAt(C)?--C===-1&&(R=v):(C=-1,R=V))}return O===R?R=V:R===-1&&(R=h.length),h.slice(O,R)}for(v=h.length-1;v>=O;--v)if(m(h.charCodeAt(v))){if(!B){O=v+1;break}}else R===-1&&(B=!1,R=v+1);return R===-1?"":h.slice(O,R)},extname(h){e(h,"path");let F=0,O=-1,R=0,B=-1,v=!0,C=0;h.length>=2&&h.charCodeAt(1)===y&&o(h.charCodeAt(0))&&(F=R=2);for(let V=h.length-1;V>=F;--V){const U=h.charCodeAt(V);if(m(U)){if(!v){R=V+1;break}continue}B===-1&&(v=!1,B=V+1),U===S?O===-1?O=V:C!==1&&(C=1):O!==-1&&(C=-1)}return O===-1||B===-1||C===0||C===1&&O===B-1&&O===R+1?"":h.slice(O,B)},format:c.bind(null,"\\"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const O=h.length;let R=0,B=h.charCodeAt(0);if(O===1)return m(B)?(F.root=F.dir=h,F):(F.base=F.name=h,F);if(m(B)){if(R=1,m(h.charCodeAt(1))){let z=2,X=z;for(;z<O&&!m(h.charCodeAt(z));)z++;if(z<O&&z!==X){for(X=z;z<O&&m(h.charCodeAt(z));)z++;if(z<O&&z!==X){for(X=z;z<O&&!m(h.charCodeAt(z));)z++;z===O?R=z:z!==X&&(R=z+1)}}}}else if(o(B)&&h.charCodeAt(1)===y){if(O<=2)return F.root=F.dir=h,F;if(R=2,m(h.charCodeAt(2))){if(O===3)return F.root=F.dir=h,F;R=3}}R>0&&(F.root=h.slice(0,R));let v=-1,C=R,V=-1,U=!0,T=h.length-1,L=0;for(;T>=R;--T){if(B=h.charCodeAt(T),m(B)){if(!U){C=T+1;break}continue}V===-1&&(U=!1,V=T+1),B===S?v===-1?v=T:L!==1&&(L=1):v!==-1&&(L=-1)}return V!==-1&&(v===-1||L===0||L===1&&v===V-1&&v===C+1?F.base=F.name=h.slice(C,V):(F.name=h.slice(C,v),F.base=h.slice(C,V),F.ext=h.slice(v,V))),C>0&&C!==R?F.dir=h.slice(0,C-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(s){const h=/\\/g;return()=>{const F=k.cwd().replace(h,"/");return F.slice(F.indexOf("/"))}}return()=>k.cwd()})();t.$gc={resolve(...h){let F="",O=!1;for(let R=h.length-1;R>=-1&&!O;R--){const B=R>=0?h[R]:f();e(B,"path"),B.length!==0&&(F=`${B}/${F}`,O=B.charCodeAt(0)===b)}return F=$(F,!O,"/",d),O?`/${F}`:F.length>0?F:"."},normalize(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b,O=h.charCodeAt(h.length-1)===b;return h=$(h,!F,"/",d),h.length===0?F?"/":O?"./":".":(O&&(h+="/"),F?`/${h}`:h)},isAbsolute(h){return e(h,"path"),h.length>0&&h.charCodeAt(0)===b},join(...h){if(h.length===0)return".";let F;for(let O=0;O<h.length;++O){const R=h[O];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$gc.normalize(F)},relative(h,F){if(e(h,"from"),e(F,"to"),h===F||(h=t.$gc.resolve(h),F=t.$gc.resolve(F),h===F))return"";const O=1,R=h.length,B=R-O,v=1,C=F.length-v,V=B<C?B:C;let U=-1,T=0;for(;T<V;T++){const z=h.charCodeAt(O+T);if(z!==F.charCodeAt(v+T))break;z===b&&(U=T)}if(T===V)if(C>V){if(F.charCodeAt(v+T)===b)return F.slice(v+T+1);if(T===0)return F.slice(v+T)}else B>V&&(h.charCodeAt(O+T)===b?U=T:T===0&&(U=0));let L="";for(T=O+U+1;T<=R;++T)(T===R||h.charCodeAt(T)===b)&&(L+=L.length===0?"..":"/..");return`${L}${F.slice(v+U)}`},toNamespacedPath(h){return h},dirname(h){if(e(h,"path"),h.length===0)return".";const F=h.charCodeAt(0)===b;let O=-1,R=!0;for(let B=h.length-1;B>=1;--B)if(h.charCodeAt(B)===b){if(!R){O=B;break}}else R=!1;return O===-1?F?"/":".":F&&O===1?"//":h.slice(0,O)},basename(h,F){F!==void 0&&e(F,"ext"),e(h,"path");let O=0,R=-1,B=!0,v;if(F!==void 0&&F.length>0&&F.length<=h.length){if(F===h)return"";let C=F.length-1,V=-1;for(v=h.length-1;v>=0;--v){const U=h.charCodeAt(v);if(U===b){if(!B){O=v+1;break}}else V===-1&&(B=!1,V=v+1),C>=0&&(U===F.charCodeAt(C)?--C===-1&&(R=v):(C=-1,R=V))}return O===R?R=V:R===-1&&(R=h.length),h.slice(O,R)}for(v=h.length-1;v>=0;--v)if(h.charCodeAt(v)===b){if(!B){O=v+1;break}}else R===-1&&(B=!1,R=v+1);return R===-1?"":h.slice(O,R)},extname(h){e(h,"path");let F=-1,O=0,R=-1,B=!0,v=0;for(let C=h.length-1;C>=0;--C){const V=h.charCodeAt(C);if(V===b){if(!B){O=C+1;break}continue}R===-1&&(B=!1,R=C+1),V===S?F===-1?F=C:v!==1&&(v=1):F!==-1&&(v=-1)}return F===-1||R===-1||v===0||v===1&&F===R-1&&F===O+1?"":h.slice(F,R)},format:c.bind(null,"/"),parse(h){e(h,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return F;const O=h.charCodeAt(0)===b;let R;O?(F.root="/",R=1):R=0;let B=-1,v=0,C=-1,V=!0,U=h.length-1,T=0;for(;U>=R;--U){const L=h.charCodeAt(U);if(L===b){if(!V){v=U+1;break}continue}C===-1&&(V=!1,C=U+1),L===S?B===-1?B=U:T!==1&&(T=1):B!==-1&&(T=-1)}if(C!==-1){const L=v===0&&O?1:v;B===-1||T===0||T===1&&B===C-1&&B===v+1?F.base=F.name=h.slice(L,C):(F.name=h.slice(L,B),F.base=h.slice(L,C),F.ext=h.slice(B,C))}return v>0?F.dir=h.slice(0,v-1):O&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],$e([1,0,24,5,10,7]),function(ie,t,k,P,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=void 0;function A(v){return v===47||v===92}t.$1f=A;function S(v){return v.replace(/[\\/]/g,k.$gc.sep)}t.$2f=S;function b(v){return v.indexOf("/")===-1&&(v=S(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}t.$3f=b;function w(v,C=k.$gc.sep){if(!v)return"";const V=v.length,U=v.charCodeAt(0);if(A(U)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let L=3;const z=L;for(;L<V&&!A(v.charCodeAt(L));L++);if(z!==L&&!A(v.charCodeAt(L+1))){for(L+=1;L<V;L++)if(A(v.charCodeAt(L)))return v.slice(0,L+1).replace(/[\\/]/g,C)}}return C}else if(d(U)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+C:v.slice(0,2);let T=v.indexOf("://");if(T!==-1){for(T+=3;T<V;T++)if(A(v.charCodeAt(T)))return v.slice(0,T+1)}return""}t.$4f=w;function y(v){if(!P.$i||!v||v.length<5)return!1;let C=v.charCodeAt(0);if(C!==92||(C=v.charCodeAt(1),C!==92))return!1;let V=2;const U=V;for(;V<v.length&&(C=v.charCodeAt(V),C!==92);V++);return!(U===V||(C=v.charCodeAt(V+1),isNaN(C)||C===92))}t.$5f=y;const M=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(v,C=P.$i){const V=C?M:r;return!(!v||v.length===0||/^\s+$/.test(v)||(V.lastIndex=0,V.test(v))||C&&u.test(v)||v==="."||v===".."||C&&v[v.length-1]==="."||C&&v.length!==v.trim().length||v.length>255)}t.$6f=e;function s(v,C,V){const U=v===C;return!V||U?U:!v||!C?!1:(0,n.$_e)(v,C)}t.$7f=s;function m(v,C,V,U=k.sep){if(v===C)return!0;if(!v||!C||C.length>v.length)return!1;if(V){if(!(0,n.$af)(v,C))return!1;if(C.length===v.length)return!0;let L=C.length;return C.charAt(C.length-1)===U&&L--,v.charAt(L)===U}return C.charAt(C.length-1)!==U&&(C+=U),v.indexOf(C)===0}t.$8f=m;function d(v){return v>=65&&v<=90||v>=97&&v<=122}t.$9f=d;function o(v,C){return P.$i&&v.endsWith(":")&&(v+=k.sep),(0,k.$ic)(v)||(v=(0,k.$jc)(C,v)),v=(0,k.$hc)(v),P.$i?(v=(0,n.$Ue)(v,k.sep),v.endsWith(":")&&(v+=k.sep)):(v=(0,n.$Ue)(v,k.sep),v||(v=k.sep)),v}t.$0f=o;function $(v){const C=(0,k.$hc)(v);return P.$i?v.length>3?!1:c(C)&&(v.length===2||C.charCodeAt(2)===92):C===k.$gc.sep}t.$$f=$;function c(v,C=P.$i){return C?d(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}t.$_f=c;function f(v,C=P.$i){return c(v,C)?v[0]:void 0}t.$ag=f;function h(v,C,V){return C.length>v.length?-1:v===C?0:(V&&(v=v.toLowerCase(),C=C.toLowerCase()),v.indexOf(C))}t.$bg=h;function F(v){const C=v.split(":");let V,U,T;for(const L of C){const z=Number(L);(0,j.$Mf)(z)?U===void 0?U=z:T===void 0&&(T=z):V=V?[V,L].join(":"):L}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:U!==void 0?U:void 0,column:T!==void 0?T:U!==void 0?1:void 0}}t.$cg=F;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function B(v,C,V=8){let U="";for(let L=0;L<V;L++){let z;L===0&&P.$i&&!C&&(V===3||V===4)?z=R:z=O,U+=z.charAt(Math.floor(Math.random()*z.length))}let T;return C?T=`${C}-${U}`:T=U,v?(0,k.$jc)(v,T):T}t.$dg=B}),define(be[117],$e([1,0,24]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$js=t.$is=t.$hs=t.$gs=t.$fs=void 0,t.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(y){const M=(0,k.$oc)(y),r=P[M.toLowerCase()];return r!==void 0?r:A(y)}t.$gs=j;function A(y){const M=(0,k.$oc)(y);return n[M.toLowerCase()]}t.$hs=A;function S(y){for(const M in n)if(n[M]===y)return M}t.$is=S;const b=/^(.+)\/(.+?)(;.+)?$/;function w(y,M){const r=b.exec(y);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:M?void 0:y}t.$js=w}),define(be[15],$e([1,0,24,5]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,j=/^\//,A=/^\/\//;function S(R,B){if(!R.scheme&&B)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!n.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!j.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(R,B){return!R&&!B?"file":R}function w(R,B){switch(R){case"https":case"http":case"file":B?B[0]!==M&&(B=M+B):B=M;break}return B}const y="",M="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(B){return B instanceof u?!0:B?typeof B.authority=="string"&&typeof B.fragment=="string"&&typeof B.path=="string"&&typeof B.query=="string"&&typeof B.scheme=="string"&&typeof B.fsPath=="string"&&typeof B.with=="function"&&typeof B.toString=="function":!1}constructor(B,v,C,V,U,T=!1){typeof B=="object"?(this.scheme=B.scheme||y,this.authority=B.authority||y,this.path=B.path||y,this.query=B.query||y,this.fragment=B.fragment||y):(this.scheme=b(B,T),this.authority=v||y,this.path=w(this.scheme,C||y),this.query=V||y,this.fragment=U||y,S(this,T))}get fsPath(){return c(this,!1)}with(B){if(!B)return this;let{scheme:v,authority:C,path:V,query:U,fragment:T}=B;return v===void 0?v=this.scheme:v===null&&(v=y),C===void 0?C=this.authority:C===null&&(C=y),V===void 0?V=this.path:V===null&&(V=y),U===void 0?U=this.query:U===null&&(U=y),T===void 0?T=this.fragment:T===null&&(T=y),v===this.scheme&&C===this.authority&&V===this.path&&U===this.query&&T===this.fragment?this:new m(v,C,V,U,T)}static parse(B,v=!1){const C=r.exec(B);return C?new m(C[2]||y,O(C[4]||y),O(C[5]||y),O(C[7]||y),O(C[9]||y),v):new m(y,y,y,y,y)}static file(B){let v=y;if(P.$i&&(B=B.replace(/\\/g,M)),B[0]===M&&B[1]===M){const C=B.indexOf(M,2);C===-1?(v=B.substring(2),B=M):(v=B.substring(2,C),B=B.substring(C)||M)}return new m("file",v,B,y,y)}static from(B,v){return new m(B.scheme,B.authority,B.path,B.query,B.fragment,v)}static joinPath(B,...v){if(!B.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return P.$i&&B.scheme==="file"?C=u.file(k.$fc.join(c(B,!0),...v)).path:C=k.$gc.join(B.path,...v),B.with({path:C})}toString(B=!1){return f(this,B)}toJSON(){return this}static revive(B){if(B){if(B instanceof u)return B;{const v=new m(B);return v._formatted=B.external??null,v._fsPath=B._sep===s?B.fsPath??null:null,v}}else return B}}t.URI=u;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const s=P.$i?1:void 0;class m extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(B=!1){return B?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const B={$mid:1};return this._fsPath&&(B.fsPath=this._fsPath,B._sep=s),this._formatted&&(B.external=this._formatted),this.path&&(B.path=this.path),this.scheme&&(B.scheme=this.scheme),this.authority&&(B.authority=this.authority),this.query&&(B.query=this.query),this.fragment&&(B.fragment=this.fragment),B}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(R,B,v){let C,V=-1;for(let U=0;U<R.length;U++){const T=R.charCodeAt(U);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||B&&T===47||v&&T===91||v&&T===93||v&&T===58)V!==-1&&(C+=encodeURIComponent(R.substring(V,U)),V=-1),C!==void 0&&(C+=R.charAt(U));else{C===void 0&&(C=R.substr(0,U));const L=d[T];L!==void 0?(V!==-1&&(C+=encodeURIComponent(R.substring(V,U)),V=-1),C+=L):V===-1&&(V=U)}}return V!==-1&&(C+=encodeURIComponent(R.substring(V))),C!==void 0?C:R}function $(R){let B;for(let v=0;v<R.length;v++){const C=R.charCodeAt(v);C===35||C===63?(B===void 0&&(B=R.substr(0,v)),B+=d[C]):B!==void 0&&(B+=R[v])}return B!==void 0?B:R}function c(R,B){let v;return R.authority&&R.path.length>1&&R.scheme==="file"?v=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?B?v=R.path.substr(1):v=R.path[1].toLowerCase()+R.path.substr(2):v=R.path,P.$i&&(v=v.replace(/\//g,"\\")),v}t.$wc=c;function f(R,B){const v=B?$:o;let C="",{scheme:V,authority:U,path:T,query:L,fragment:z}=R;if(V&&(C+=V,C+=":"),(U||V==="file")&&(C+=M,C+=M),U){let X=U.indexOf("@");if(X!==-1){const Y=U.substr(0,X);U=U.substr(X+1),X=Y.lastIndexOf(":"),X===-1?C+=v(Y,!1,!1):(C+=v(Y.substr(0,X),!1,!1),C+=":",C+=v(Y.substr(X+1),!1,!0)),C+="@"}U=U.toLowerCase(),X=U.lastIndexOf(":"),X===-1?C+=v(U,!1,!0):(C+=v(U.substr(0,X),!1,!0),C+=U.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}C+=v(T,!0,!1)}return L&&(C+="?",C+=v(L,!1,!1)),z&&(C+="#",C+=B?z:o(z,!1,!1)),C}function h(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+h(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function O(R){return R.match(F)?R.replace(F,B=>h(B)):R}}),define(be[53],$e([1,0,33,15]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ch=t.$Bh=t.$Ah=void 0;function n(b){return JSON.stringify(b,A)}t.$Ah=n;function j(b){let w=JSON.parse(b);return w=S(w),w}t.$Bh=j;function A(b,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function S(b,w=0){if(!b||w>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof k.$je||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=S(b[y],w+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=S(b[y],w+1))}return b}t.$Ch=S}),define(be[31],$e([1,0,6,5,10,15]),function(ie,t,k,P,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.$eg=t.Schemas=void 0;var A;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(A||(t.Schemas=A={}));function S(r,u){return j.URI.isUri(r)?(0,n.$_e)(r.scheme,u):(0,n.$af)(r,u+":")}t.$eg=S;function b(r,...u){return u.some(e=>S(r,e))}t.$fg=b,t.$gg="vscode-tkn",t.$hg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u){this.f=`${u}/${A.vscodeRemoteResource}`}set(u,e,s){this.a[u]=e,this.b[u]=s}setConnectionToken(u,e){this.c[u]=e}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch($){return k.$1($),u}const e=u.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const m=this.b[e],d=this.c[e];let o=`path=${encodeURIComponent(u.path)}`;return typeof d=="string"&&(o+=`&${t.$hg}=${encodeURIComponent(d)}`),j.URI.from({scheme:P.$o?this.d:A.vscodeRemoteResource,authority:`${s}:${m}`,path:this.f,query:o})}}t.$ig=new w,t.$jg="vs/../../extensions",t.$kg="vs/../../node_modules",t.$lg="vs/../../node_modules.asar",t.$mg="vs/../../node_modules.asar.unpacked",t.$ng="vscode-app";class y{static{this.a=t.$ng}asBrowserUri(u){const e=this.b(u,ie);return this.uriToBrowserUri(e)}uriToBrowserUri(u){return u.scheme===A.vscodeRemote?t.$ig.rewrite(u):u.scheme===A.file&&(P.$m||P.$q===`${A.vscodeFileResource}://${y.a}`)?u.with({scheme:A.vscodeFileResource,authority:u.authority||y.a,query:null,fragment:null}):u}asFileUri(u){const e=this.b(u,ie);return this.uriToFileUri(e)}uriToFileUri(u){return u.scheme===A.vscodeFileResource?u.with({scheme:A.file,authority:u.authority!==y.a?u.authority:null,query:null,fragment:null}):u}b(u,e){return j.URI.isUri(u)?u:j.URI.parse(e.toUrl(u))}}t.$og=new y;var M;(function(r){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(u.get("3"));const e="vscode-coi";function s(d){let o;typeof d=="string"?o=new URL(d).searchParams:d instanceof URL?o=d.searchParams:j.URI.isUri(d)&&(o=new URL(d.toString(!0)).searchParams);const $=o?.get(e);if($)return u.get($)}r.getHeadersFromQuery=s;function m(d,o,$){if(!globalThis.crossOriginIsolated)return;const c=o&&$?"3":$?"2":"1";d instanceof URLSearchParams?d.set(e,c):d[e]=c}r.addSearchParam=m})(M||(t.COI=M={}))}),define(be[37],$e([1,0,116,31,24,5,10,15]),function(ie,t,k,P,n,j,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rg=t.DataUri=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=void 0;function b(u){return(0,S.$wc)(u,!0)}t.$vg=b;class w{constructor(e){this.a=e}compare(e,s,m=!1){return e===s?0:(0,A.$5e)(this.getComparisonKey(e,m),this.getComparisonKey(s,m))}isEqual(e,s,m=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,m)===this.getComparisonKey(s,m)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,m=!1){if(e.scheme===s.scheme){if(e.scheme===P.Schemas.file)return k.$8f(b(e),b(s),this.a(e))&&e.query===s.query&&(m||e.fragment===s.fragment);if((0,t.$Mg)(e.authority,s.authority))return k.$8f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(m||e.fragment===s.fragment)}return!1}joinPath(e,...s){return S.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Eg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===P.Schemas.file?s=S.URI.file(n.$mc(b(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===P.Schemas.file?s=S.URI.file(n.$hc(b(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Mg)(e.authority,s.authority))return;if(e.scheme===P.Schemas.file){const o=n.$lc(b(e),b(s));return j.$i?k.$2f(o):o}let m=e.path||"/";const d=s.path||"/";if(this.a(e)){let o=0;for(const $=Math.min(m.length,d.length);o<$&&!(m.charCodeAt(o)!==d.charCodeAt(o)&&m.charAt(o).toLowerCase()!==d.charAt(o).toLowerCase());o++);m=d.substr(0,o)+m.substr(o)}return n.$gc.relative(m,d)}resolvePath(e,s){if(e.scheme===P.Schemas.file){const m=S.URI.file(n.$kc(b(e),s));return e.with({authority:m.authority,path:m.path})}return s=k.$3f(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,A.$_e)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===P.Schemas.file){const m=b(e);return m.length>k.$4f(m).length&&m[m.length-1]===s}else{const m=e.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Ng)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let m=!1;if(e.scheme===P.Schemas.file){const d=b(e);m=d!==void 0&&d.length===k.$4f(d).length&&d[d.length-1]===s}else{s="/";const d=e.path;m=d.length===1&&d.charCodeAt(d.length-1)===47}return!m&&!(0,t.$Ng)(e,s)?e.with({path:e.path+"/"}):e}}t.$wg=w,t.$xg=new w(()=>!1),t.$yg=new w(u=>u.scheme===P.Schemas.file?!j.$k:!0),t.$zg=new w(u=>!0),t.$Ag=t.$xg.isEqual.bind(t.$xg),t.$Bg=t.$xg.isEqualOrParent.bind(t.$xg),t.$Cg=t.$xg.getComparisonKey.bind(t.$xg),t.$Dg=t.$xg.basenameOrAuthority.bind(t.$xg),t.$Eg=t.$xg.basename.bind(t.$xg),t.$Fg=t.$xg.extname.bind(t.$xg),t.$Gg=t.$xg.dirname.bind(t.$xg),t.$Hg=t.$xg.joinPath.bind(t.$xg),t.$Ig=t.$xg.normalizePath.bind(t.$xg),t.$Jg=t.$xg.relativePath.bind(t.$xg),t.$Kg=t.$xg.resolvePath.bind(t.$xg),t.$Lg=t.$xg.isAbsolutePath.bind(t.$xg),t.$Mg=t.$xg.isEqualAuthority.bind(t.$xg),t.$Ng=t.$xg.hasTrailingPathSeparator.bind(t.$xg),t.$Og=t.$xg.removeTrailingPathSeparator.bind(t.$xg),t.$Pg=t.$xg.addTrailingPathSeparator.bind(t.$xg);function y(u,e){const s=[];for(let m=0;m<u.length;m++){const d=e(u[m]);u.some((o,$)=>$===m?!1:(0,t.$Bg)(d,e(o)))||s.push(u[m])}return s}t.$Qg=y;var M;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function e(s){const m=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach($=>{const[c,f]=$.split(":");c&&f&&m.set(c,f)});const o=s.path.substring(0,s.path.indexOf(";"));return o&&m.set(u.META_DATA_MIME,o),m}u.parseMetaData=e})(M||(t.DataUri=M={}));function r(u,e,s){if(e){let m=u.path;return m&&m[0]!==n.$gc.sep&&(m=n.$gc.sep+m),u.with({scheme:s,authority:e,path:m})}return u.with({scheme:s})}t.$Rg=r}),define(be[9],$e([1,0,29,6,4,2,37,5,50,23]),function(ie,t,k,P,n,j,A,S,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.Promises=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=void 0;function y(D){return!!D&&typeof D.then=="function"}t.$Sg=y;function M(D){const p=new k.$6d,l=D(p.token),i=new Promise((a,E)=>{const I=p.token.onCancellationRequested(()=>{I.dispose(),E(new P.$5)});Promise.resolve(l).then(N=>{I.dispose(),p.dispose(),a(N)},N=>{I.dispose(),p.dispose(),E(N)})});return new class{cancel(){p.cancel(),p.dispose()}then(a,E){return i.then(a,E)}catch(a){return this.then(void 0,a)}finally(a){return i.finally(a)}}}t.$Tg=M;function r(D,p,l){return new Promise((i,a)=>{const E=p.onCancellationRequested(()=>{E.dispose(),i(l)});D.then(i,a).finally(()=>E.dispose())})}t.$Ug=r;function u(D,p){return new Promise((l,i)=>{const a=p.onCancellationRequested(()=>{a.dispose(),i(new P.$5)});D.then(l,i).finally(()=>a.dispose())})}t.$Vg=u;async function e(D){let p=-1;const l=D.map((i,a)=>i.then(E=>(p=a,E)));try{return await Promise.race(l)}finally{D.forEach((i,a)=>{a!==p&&i.cancel()})}}t.$Wg=e;function s(D,p,l){let i;const a=setTimeout(()=>{i?.(void 0),l?.()},p);return Promise.race([D.finally(()=>clearTimeout(a)),new Promise(E=>i=E)])}t.$Xg=s;function m(D){return new Promise((p,l)=>{const i=D();y(i)?i.then(p,l):p(i)})}t.$Yg=m;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const l=()=>{if(this.b=null,this.f)return;const i=this.queue(this.d);return this.d=null,i};this.b=new Promise(i=>{this.a.then(l,l).then(i)})}return new Promise((l,i)=>{this.b.then(l,i)})}return this.a=p(),new Promise((l,i)=>{this.a.then(a=>{this.a=null,l(a)},a=>{this.a=null,i(a)})})}dispose(){this.f=!0}}t.$Zg=d;class o{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$1g=o;class ${constructor(){this.a=new Map}queue(p,l){const a=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(l).finally(()=>{this.a.get(p)===a&&this.a.delete(p)});return this.a.set(p,a),a}}t.$2g=$;const c=(D,p)=>{let l=!0;const i=setTimeout(()=>{l=!1,p()},D);return{isTriggered:()=>l,dispose:()=>{clearTimeout(i),l=!1}}},f=D=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,D())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class h{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,l=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((a,E)=>{this.d=a,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const a=this.g;return this.g=null,a()}}));const i=()=>{this.a=null,this.d?.(null)};return this.a=l===b.$Sd?f(i):c(l,i),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$3g=h;class F{constructor(p){this.a=new h(p),this.b=new d}trigger(p,l){return this.a.trigger(()=>this.b.queue(p),l)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$4g=F;class O{constructor(){this.a=!1,this.b=new Promise((p,l)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$5g=O;class R extends O{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$6g=R;function B(D,p){return p?new Promise((l,i)=>{const a=setTimeout(()=>{E.dispose(),l()},D),E=p.onCancellationRequested(()=>{clearTimeout(a),E.dispose(),i(new P.$5)})}):M(l=>B(D,l))}t.$7g=B;function v(D,p=0,l){const i=setTimeout(()=>{D(),l&&a.dispose()},p),a=(0,j.$Rc)(()=>{clearTimeout(i),l?.deleteAndLeak(a)});return l?.add(a),a}t.$8g=v;function C(D){const p=[];let l=0;const i=D.length;function a(){return l<i?D[l++]():null}function E(I){I!=null&&p.push(I);const N=a();return N?N.then(E):Promise.resolve(p)}return Promise.resolve(null).then(E)}t.$9g=C;function V(D,p=i=>!!i,l=null){let i=0;const a=D.length,E=()=>{if(i>=a)return Promise.resolve(l);const I=D[i++];return Promise.resolve(I()).then(H=>p(H)?Promise.resolve(H):E())};return E()}t.$0g=V;function U(D,p=i=>!!i,l=null){if(D.length===0)return Promise.resolve(l);let i=D.length;const a=()=>{i=-1;for(const E of D)E.cancel?.()};return new Promise((E,I)=>{for(const N of D)N.then(H=>{--i>=0&&p(H)?(a(),E(H)):i===0&&E(l)}).catch(H=>{--i>=0&&(a(),I(H))})})}t.$$g=U;class T{constructor(p){this.a=0,this.b=!1,this.f=p,this.g=[],this.d=0,this.h=new n.$Vd}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(p){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((l,i)=>{this.g.push({factory:p,c:l,e:i}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const p=this.g.shift();this.d++;const l=p.factory();l.then(p.c,p.e),l.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$_g=T;class L extends T{constructor(){super(1)}}t.$ah=L;class z{constructor(){this.a=new J,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$bh=z;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new W;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueSize(p,l=A.$xg){const i=l.getComparisonKey(p);return this.a.get(i)?.size??0}queueFor(p,l,i=A.$xg){const a=i.getComparisonKey(p);let E=this.a.get(a);if(!E){E=new L;const I=this.f++,N=n.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(a),this.h(),this.d?.deleteAndDispose(I),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set(I,N),this.a.set(a,E)}return E.queue(l)}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$ch=X;class Y{constructor(p,l){this.a=-1,typeof p=="function"&&typeof l=="number"&&this.setIfNotSet(p,l)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,l){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},l)}setIfNotSet(p,l){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},l))}}t.$dh=Y;class fe{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(p,l,i=globalThis){this.cancel();const a=i.setInterval(()=>{p()},l);this.d=(0,j.$Rc)(()=>{i.clearInterval(a),this.d=void 0})}dispose(){this.cancel()}}t.$eh=fe;class le{constructor(p,l){this.b=-1,this.a=p,this.d=l,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$fh=le;class ee{constructor(p,l){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.a=p,this.b=l,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$gh=ee;class ge extends le{constructor(p,l){super(p,l),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$hh=ge;class Le extends j.$Tc{constructor(p,l){super(),this.g=p,this.h=l,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const l of p)this.a.push(l);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$ih=Le,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$kh=(D,p)=>{(0,S.$B)(()=>{if(l)return;const i=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,i-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:t.$kh=(D,p,l)=>{const i=D.requestIdleCallback(p,typeof l=="number"?{timeout:l}:void 0);let a=!1;return{dispose(){a||(a=!0,D.cancelIdleCallback(i))}}},t.$jh=D=>(0,t.$kh)(globalThis,D)}();class Ne{constructor(p,l){this.g=!1,this.d=()=>{try{this.j=l()}catch(i){this.l=i}finally{this.g=!0}},this.f=(0,t.$kh)(p,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$lh=Ne;class Be extends Ne{constructor(p){super(globalThis,p)}}t.$mh=Be;async function ne(D,p,l){let i;for(let a=0;a<l;a++)try{return await D()}catch(E){i=E,await B(p)}throw i}t.$nh=ne;class J{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,l,i){return this.a={taskId:p,cancel:()=>i?.(),promise:l},l.then(()=>this.d(p),()=>this.d(p)),l}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let l,i;const a=new Promise((E,I)=>{l=E,i=I});this.b={run:p,promise:a,promiseResolve:l,promiseReject:i}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$oh=J;class se{constructor(p,l=()=>Date.now()){this.d=p,this.f=l,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$ph=se;var oe;(function(D){D[D.Resolved=0]="Resolved",D[D.Rejected=1]="Rejected"})(oe||(oe={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,l)=>{this.a=p,this.b=l})}complete(p){return new Promise(l=>{this.a(p),this.d={outcome:0,value:p},l()})}error(p){return new Promise(l=>{this.b(p),this.d={outcome:1,value:p},l()})}cancel(){return this.error(new P.$5)}}t.$qh=W;var G;(function(D){async function p(i){let a;const E=await Promise.all(i.map(I=>I.then(N=>N,N=>{a||(a=N)})));if(typeof a<"u")throw a;return E}D.settled=p;function l(i){return new Promise(async(a,E)=>{try{await i(a,E)}catch(I){E(I)}})}D.withAsyncBody=l})(G||(t.Promises=G={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(p){this.a=void 0,this.b=void 0,this.d=!1,this.promise=p.then(l=>(this.a=l,this.d=!0,l),l=>{throw this.b=l,this.d=!0,l})}requireValue(){if(!this.d)throw new P.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$rh=ue;class me{constructor(p){this.b=p,this.a=new w.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$sh=me;var Se;(function(D){D[D.Initial=0]="Initial",D[D.DoneOK=1]="DoneOK",D[D.DoneError=2]="DoneError"})(Se||(Se={}));class ke{static fromArray(p){return new ke(l=>{l.emitMany(p)})}static fromPromise(p){return new ke(async l=>{l.emitMany(await p)})}static fromPromises(p){return new ke(async l=>{await Promise.all(p.map(async i=>l.emitOne(await i)))})}static merge(p){return new ke(async l=>{await Promise.all(p.map(async i=>{for await(const a of i)l.emitOne(a)}))})}static{this.EMPTY=ke.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new n.$Vd,queueMicrotask(async()=>{const l={emitOne:i=>this.g(i),emitMany:i=>this.h(i),reject:i=>this.k(i)};try{await Promise.resolve(p(l)),this.j()}catch(i){this.k(i)}finally{l.emitOne=void 0,l.emitMany=void 0,l.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(p,l){return new ke(async i=>{for await(const a of p)i.emitOne(l(a))})}map(p){return ke.map(this,p)}static filter(p,l){return new ke(async i=>{for await(const a of p)l(a)&&i.emitOne(a)})}filter(p){return ke.filter(this,p)}static coalesce(p){return ke.filter(p,l=>!!l)}coalesce(){return ke.coalesce(this)}static async toPromise(p){const l=[];for await(const i of p)l.push(i);return l}toPromise(){return ke.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$th=ke;class Ce extends ke{constructor(p,l){super(l),this.l=p}cancel(){this.l.cancel()}}t.$uh=Ce;function K(D){const p=new k.$6d,l=D(p.token);return new Ce(p,async i=>{const a=p.token.onCancellationRequested(()=>{a.dispose(),p.dispose(),i.reject(new P.$5)});try{for await(const E of l){if(p.token.isCancellationRequested)return;i.emitOne(E)}a.dispose(),p.dispose()}catch(E){a.dispose(),p.dispose(),i.reject(E)}})}t.$vh=K;class g{constructor(){this.a=new W,this.b=new ke(i=>{if(p){i.reject(p);return}return l&&i.emitMany(l),this.d=a=>i.reject(a),this.f=a=>i.emitOne(a),this.a.p});let p,l;this.f=i=>{l||(l=[]),l.push(i)},this.d=i=>{p||(p=i)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$wh=g}),define(be[3],$e([1,0,16,114,14,19,9,6,4,118,2,31,5,15,49,21]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s){"use strict";var m;Object.defineProperty(t,"__esModule",{value:!0}),t.$fR=t.$eR=t.h=t.$cR=t.$bR=t.$aR=t.$_Q=t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.DetectedFullscreenMode=t.$7Q=t.$6Q=t.$5Q=t.$4Q=t.$3Q=t.$2Q=t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$=t.Namespace=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,m=function(){const q=new Map;(0,s.$cP)(s.$dP,1),q.set(s.$dP.vscodeWindowId,{window:s.$dP,disposables:new y.$Sc});const Q=new b.$Vd,te=new b.$Vd,ce=new b.$Vd;return{onDidRegisterWindow:Q.event,onWillUnregisterWindow:ce.event,onDidUnregisterWindow:te.event,registerWindow(De){if(q.has(De.vscodeWindowId))return y.$Tc.None;const Oe=new y.$Sc,He={window:De,disposables:Oe.add(new y.$Sc)};return q.set(De.vscodeWindowId,He),Oe.add((0,y.$Rc)(()=>{q.delete(De.vscodeWindowId),te.fire(De)})),Oe.add($(De,t.$FQ.BEFORE_UNLOAD,()=>{ce.fire(De)})),Q.fire(He),Oe},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(De){return De.vscodeWindowId},hasWindow(De){return q.has(De)},getWindowById(De){return q.get(De)},getWindow(De){const Oe=De;if(Oe?.ownerDocument?.defaultView)return Oe.ownerDocument.defaultView.window;const He=De;return He?.view?He.view.window:s.$dP},getDocument(De){const Oe=De;return(0,t.getWindow)(Oe).document}}}(),t.registerWindow=m.registerWindow,t.getWindow=m.getWindow,t.getDocument=m.getDocument,t.getWindows=m.getWindows,t.getWindowsCount=m.getWindowsCount,t.getWindowId=m.getWindowId,t.getWindowById=m.getWindowById,t.hasWindow=m.hasWindow,t.onDidRegisterWindow=m.onDidRegisterWindow,t.onWillUnregisterWindow=m.onWillUnregisterWindow,t.onDidUnregisterWindow=m.onDidUnregisterWindow;function d(q){for(;q.firstChild;)q.firstChild.remove()}t.$KP=d;class o{constructor(Q,te,ce,De){this.f=Q,this.g=te,this.d=ce,this.j=De||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function $(q,Q,te,ce){return new o(q,Q,te,ce)}t.$LP=$;function c(q,Q){return function(te){return Q(new j.$DP(q,te))}}function f(q){return function(Q){return q(new n.$IP(Q))}}const h=function(Q,te,ce,De){let Oe=ce;return te==="click"||te==="mousedown"?Oe=c((0,t.getWindow)(Q),ce):(te==="keydown"||te==="keypress"||te==="keyup")&&(Oe=f(ce)),$(Q,te,Oe,De)};t.$MP=h;const F=function(Q,te,ce){const De=c((0,t.getWindow)(Q),te);return R(Q,De,ce)};t.$NP=F;const O=function(Q,te,ce){const De=c((0,t.getWindow)(Q),te);return v(Q,De,ce)};t.$OP=O;function R(q,Q,te){return $(q,r.$r&&P.$AP.pointerEvents?t.$FQ.POINTER_DOWN:t.$FQ.MOUSE_DOWN,Q,te)}t.$PP=R;function B(q,Q,te){return $(q,r.$r&&P.$AP.pointerEvents?t.$FQ.POINTER_MOVE:t.$FQ.MOUSE_MOVE,Q,te)}t.$QP=B;function v(q,Q,te){return $(q,r.$r&&P.$AP.pointerEvents?t.$FQ.POINTER_UP:t.$FQ.MOUSE_UP,Q,te)}t.$RP=v;function C(q,Q,te){return(0,A.$kh)(q,Q,te)}t.$SP=C;class V extends A.$lh{constructor(Q,te){super(Q,te)}}t.$TP=V;function U(q,Q,te,ce){let De=0;const Oe=q.setInterval(()=>{De++,(typeof ce=="number"&&De>=ce||Q()===!0)&&He.dispose()},te),He=(0,y.$Rc)(()=>{q.clearInterval(Oe)});return He}t.$WP=U;class T extends A.$eh{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,te,ce){return super.cancelAndSet(Q,te,ce??this.f)}}t.$XP=T;class L{constructor(Q,te=0){this.d=Q,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,S.$1)(Q)}}static sort(Q,te){return te.priority-Q.priority}}(function(){const q=new Map,Q=new Map,te=new Map,ce=new Map,De=Oe=>{te.set(Oe,!1);const He=q.get(Oe)??[];for(Q.set(Oe,He),q.set(Oe,[]),ce.set(Oe,!0);He.length>0;)He.sort(L.sort),He.shift().execute();ce.set(Oe,!1)};t.$VP=(Oe,He,xe=0)=>{const Ge=(0,t.getWindowId)(Oe),qe=new L(He,xe);let at=q.get(Ge);return at||(at=[],q.set(Ge,at)),at.push(qe),te.get(Ge)||(te.set(Ge,!0),Oe.requestAnimationFrame(()=>De(Ge))),qe},t.$UP=(Oe,He,xe)=>{const Ge=(0,t.getWindowId)(Oe);if(ce.get(Ge)){const qe=new L(He,xe);let at=Q.get(Ge);return at||(at=[],Q.set(Ge,at)),at.push(qe),qe}else return(0,t.$VP)(Oe,He,xe)}})();function z(q,Q){return(0,t.$VP)(q,Q,1e4)}t.$YP=z;function X(q,Q){return(0,t.$VP)(q,Q,-1e4)}t.$ZP=X;const Y=8,fe=function(q,Q){return Q};class le extends y.$Tc{constructor(Q,te,ce,De=fe,Oe=Y){super();let He=null,xe=0;const Ge=this.B(new A.$dh),qe=()=>{xe=new Date().getTime(),ce(He),He=null};this.B($(Q,te,at=>{He=De(He,at);const Nt=new Date().getTime()-xe;Nt>=Oe?(Ge.cancel(),qe()):Ge.setIfNotSet(qe,Oe-Nt)}))}}function ee(q,Q,te,ce,De){return new le(q,Q,te,ce,De)}t.$1P=ee;function ge(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}t.$2P=ge;function Le(q,Q){const te=(0,t.getWindow)(q),ce=te.document;if(q!==ce.body)return new Be(q.clientWidth,q.clientHeight);if(r.$r&&te?.visualViewport)return new Be(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Be(te.innerWidth,te.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(Q)return Le(Q);throw new Error("Unable to figure out browser width and height")}t.$3P=Le;class Ne{static d(Q,te){return parseFloat(te)||0}static f(Q,te,ce){const De=ge(Q),Oe=De?De.getPropertyValue(te):"0";return Ne.d(Q,Oe)}static getBorderLeftWidth(Q){return Ne.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Ne.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Ne.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Ne.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Ne.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Ne.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Ne.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Ne.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Ne.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Ne.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Ne.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Ne.f(Q,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(Q,te){this.width=Q,this.height=te}with(Q=this.width,te=this.height){return Q!==this.width||te!==this.height?new Be(Q,te):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Be?Q:new Be(Q.width,Q.height)}static equals(Q,te){return Q===te?!0:!Q||!te?!1:Q.width===te.width&&Q.height===te.height}}t.$4P=Be;function ne(q){let Q=q.offsetParent,te=q.offsetTop,ce=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){te-=q.scrollTop;const De=I(q)?null:ge(q);De&&(ce-=De.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(ce+=Ne.getBorderLeftWidth(q),te+=Ne.getBorderTopWidth(q),te+=q.offsetTop,ce+=q.offsetLeft,Q=q.offsetParent)}return{left:ce,top:te}}t.$5P=ne;function J(q,Q,te){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof te=="number"&&(q.style.height=`${te}px`)}t.$6P=J;function se(q,Q,te,ce,De,Oe="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof te=="number"&&(q.style.right=`${te}px`),typeof ce=="number"&&(q.style.bottom=`${ce}px`),typeof De=="number"&&(q.style.left=`${De}px`),q.style.position=Oe}t.$7P=se;function oe(q){const Q=q.getBoundingClientRect(),te=(0,t.getWindow)(q);return{left:Q.left+te.scrollX,top:Q.top+te.scrollY,width:Q.width,height:Q.height}}t.$8P=oe;function W(q){let Q=q,te=1;do{const ce=ge(Q).zoom;ce!=null&&ce!=="1"&&(te*=ce),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return te}t.$9P=W;function G(q){const Q=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.offsetWidth+Q}t.$0P=G;function ue(q){const Q=Ne.getBorderLeftWidth(q)+Ne.getBorderRightWidth(q),te=Ne.getPaddingLeft(q)+Ne.getPaddingRight(q);return q.offsetWidth-Q-te}t.$$P=ue;function me(q){const Q=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.scrollWidth+Q}t.$_P=me;function Se(q){const Q=Ne.getBorderTopWidth(q)+Ne.getBorderBottomWidth(q),te=Ne.getPaddingTop(q)+Ne.getPaddingBottom(q);return q.offsetHeight-Q-te}t.$aQ=Se;function ke(q){const Q=Ne.getMarginTop(q)+Ne.getMarginBottom(q);return q.offsetHeight+Q}t.$bQ=ke;function Ce(q,Q){if(q===null)return 0;const te=ne(q),ce=ne(Q);return te.left-ce.left}function K(q,Q){const te=Q.map(De=>Math.max(me(De),G(De))+Ce(De,q)||0);return Math.max(...te)}t.$cQ=K;function g(q,Q){return!!Q?.contains(q)}t.$dQ=g;const D="parentFlowToElementId";function p(q,Q){q.dataset[D]=Q.id}t.$eQ=p;function l(q){const Q=q.dataset[D];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function i(q,Q){let te=q;for(;te;){if(te===Q)return!0;if(te instanceof HTMLElement){const ce=l(te);if(ce){te=ce;continue}}te=te.parentNode}return!1}t.$fQ=i;function a(q,Q,te){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(te){if(typeof te=="string"){if(q.classList.contains(te))return null}else if(q===te)return null}q=q.parentNode}return null}t.$gQ=a;function E(q,Q,te){return!!a(q,Q,te)}t.$hQ=E;function I(q){return q&&!!q.host&&!!q.mode}t.$iQ=I;function N(q){return!!H(q)}t.$jQ=N;function H(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return I(q)?q:null}t.$kQ=H;function _(){let q=ye().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}t.$lQ=_;function Z(q){return _()===q}t.$mQ=Z;function he(q){return g(_(),q)}t.$nQ=he;function pe(q){return q.ownerDocument===ye()}t.$oQ=pe;function ye(){return(0,t.getWindowsCount)()<=1?s.$dP.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??s.$dP.document}t.$pQ=ye;function we(){return ye().defaultView?.window??s.$dP}t.$qQ=we;function Ee(q){const Q=(0,t.getWindow)(q);Q.document.hasFocus()||Q.focus()}t.$rQ=Ee;const ve=new Map;function Pe(q){return ve.has(q)}t.$sQ=Pe;function Ie(){return new Me}t.$tQ=Ie;class Me{constructor(){this.d="",this.f=void 0}setStyle(Q){Q===this.d&&(this.d=Q,this.f?this.f.innerText=Q:this.f=Ye(s.$dP.document.head,te=>te.innerText=Q))}dispose(){this.f&&(d(this.f),this.f=void 0)}}function Ye(q=s.$dP.document.head,Q,te){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",Q?.(ce),q.appendChild(ce),te&&te.add((0,y.$Rc)(()=>q.removeChild(ce))),q===s.$dP.document.head){const De=new Set;ve.set(ce,De);for(const{window:Oe,disposables:He}of(0,t.getWindows)()){if(Oe===s.$dP)continue;const xe=He.add(Qe(ce,De,Oe));te?.add(xe)}}return ce}t.$uQ=Ye;function et(q){const Q=new y.$Sc;for(const[te,ce]of ve)Q.add(Qe(te,ce,q));return Q}t.$vQ=et;function Qe(q,Q,te){const ce=new y.$Sc,De=q.cloneNode(!0);te.document.head.appendChild(De),ce.add((0,y.$Rc)(()=>te.document.head.removeChild(De)));for(const Oe of je(q))De.sheet?.insertRule(Oe.cssText,De.sheet?.cssRules.length);return ce.add(t.$wQ.observe(q,ce,{childList:!0})(()=>{De.textContent=q.textContent})),Q.add(De),ce.add((0,y.$Rc)(()=>Q.delete(De))),ce}t.$wQ=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,te){let ce=this.mutationObservers.get(q);ce||(ce=new Map,this.mutationObservers.set(q,ce));const De=(0,e.$Ti)(te);let Oe=ce.get(De);if(Oe)Oe.users+=1;else{const He=new b.$Vd,xe=new MutationObserver(qe=>He.fire(qe));xe.observe(q,te);const Ge=Oe={users:1,observer:xe,onDidMutate:He.event};Q.add((0,y.$Rc)(()=>{Ge.users-=1,Ge.users===0&&(He.dispose(),xe.disconnect(),ce?.delete(De),ce?.size===0&&this.mutationObservers.delete(q))})),ce.set(De,Oe)}return Oe.onDidMutate}};function x(q=s.$dP.document.head){return de("meta",q)}t.$xQ=x;function re(q=s.$dP.document.head){return de("link",q)}t.$yQ=re;function de(q,Q=s.$dP.document.head){const te=document.createElement(q);return Q.appendChild(te),te}let Ae=null;function Te(){return Ae||(Ae=Ye()),Ae}function je(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function Ve(q,Q,te=Te()){if(!(!te||!Q)){te.sheet?.insertRule(`${q} {${Q}}`,0);for(const ce of ve.get(te)??[])Ve(q,Q,ce)}}t.$zQ=Ve;function _e(q,Q=Te()){if(!Q)return;const te=je(Q),ce=[];for(let De=0;De<te.length;De++){const Oe=te[De];Je(Oe)&&Oe.selectorText.indexOf(q)!==-1&&ce.push(De)}for(let De=ce.length-1;De>=0;De--)Q.sheet?.deleteRule(ce[De]);for(const De of ve.get(Q)??[])_e(q,De)}t.$AQ=_e;function Je(q){return typeof q.selectorText=="string"}function tt(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}t.$BQ=tt;function Ze(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}t.$CQ=Ze;function nt(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}t.$DQ=nt;function st(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$EQ=st,t.$FQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:k.$sP?"webkitAnimationStart":"animationstart",ANIMATION_END:k.$sP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:k.$sP?"webkitAnimationIteration":"animationiteration"};function rt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$GQ=rt,t.$HQ={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function gt(q){const Q=[];for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)Q[te]=q.scrollTop,q=q.parentNode;return Q}t.$IQ=gt;function St(q,Q){for(let te=0;q&&q.nodeType===q.ELEMENT_NODE;te++)q.scrollTop!==Q[te]&&(q.scrollTop=Q[te]),q=q.parentNode}t.$JQ=St;class mt extends y.$Tc{static m(Q){if(Q instanceof HTMLElement){const te=H(Q),ce=te?te.activeElement:Q.ownerDocument.activeElement;return g(ce,Q)}else{const te=Q;return g(te.document.activeElement,te.document)}}constructor(Q){super(),this.f=this.B(new b.$Vd),this.onDidFocus=this.f.event,this.g=this.B(new b.$Vd),this.onDidBlur=this.g.event;let te=mt.m(Q),ce=!1;const De=()=>{ce=!1,te||(te=!0,this.f.fire())},Oe=()=>{te&&(ce=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{ce&&(ce=!1,te=!1,this.g.fire())},0))};this.j=()=>{mt.m(Q)!==te&&(te?Oe():De())},this.B($(Q,t.$FQ.FOCUS,De,!0)),this.B($(Q,t.$FQ.BLUR,Oe,!0)),Q instanceof HTMLElement&&(this.B($(Q,t.$FQ.FOCUS_IN,()=>this.j())),this.B($(Q,t.$FQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Ft(q){return new mt(q)}t.$KQ=Ft;function Ot(q,Q){return q.after(Q),Q}t.$LQ=Ot;function ze(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$MQ=ze;function ae(q,Q){return q.insertBefore(Q,q.firstChild),Q}t.$NQ=ae;function Fe(q,...Q){q.innerText="",ze(q,...Q)}t.$OQ=Fe;const Re=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var We;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(We||(t.Namespace=We={}));function it(q,Q,te,...ce){const De=Re.exec(Q);if(!De)throw new Error("Bad use of emmet");const Oe=De[1]||"div";let He;return q!==We.HTML?He=document.createElementNS(q,Oe):He=document.createElement(Oe),De[3]&&(He.id=De[3]),De[4]&&(He.className=De[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?He[xe]=Ge:xe==="selected"?Ge&&He.setAttribute(xe,"true"):He.setAttribute(xe,Ge))}),He.append(...ce),He}function lt(q,Q,...te){return it(We.HTML,q,Q,...te)}t.$=lt,lt.SVG=function(q,Q,...te){return it(We.SVG,q,Q,...te)};function Ke(q,Q){const te=[];return q.forEach((ce,De)=>{De>0&&(Q instanceof Node?te.push(Q.cloneNode()):te.push(document.createTextNode(Q))),te.push(ce)}),te}t.$QQ=Ke;function ct(q,...Q){q?$t(...Q):Dt(...Q)}t.$RQ=ct;function $t(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$SQ=$t;function Dt(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$TQ=Dt;function Gt(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Ai(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Gt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}t.$UQ=Ai;function ki(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}t.$VQ=ki;function Si(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const ce=()=>{q.window.removeEventListener("DOMContentLoaded",ce,!1),Q()};q.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$WQ=Si;function Fi(q,Q){const te=q.devicePixelRatio*Q;return Math.max(1,Math.floor(te))/q.devicePixelRatio}t.$XQ=Fi;function Ni(q){s.$dP.open(q,"_blank","noopener")}t.$YQ=Ni;const Xt=780,Yt=640;function Ti(q){const Q=Math.floor(s.$dP.screenLeft+s.$dP.innerWidth/2-Xt/2),te=Math.floor(s.$dP.screenTop+s.$dP.innerHeight/2-Yt/2);s.$dP.open(q,"_blank",`width=${Xt},height=${Yt},top=${te},left=${Q}`)}t.$ZQ=Ti;function Ci(q,Q=!0){const te=s.$dP.open();return te?(Q&&(te.opener=null),te.location.href=q,!0):!1}t.$1Q=Ci;function Pi(q,Q){const te=()=>{Q(),ce=(0,t.$VP)(q,te)};let ce=(0,t.$VP)(q,te);return(0,y.$Rc)(()=>ce.dispose())}t.$2Q=Pi,M.$ig.setPreferredWebSchema(/^https:/.test(s.$dP.location.href)?"https":"http");function Ri(q){return q?`url('${M.$og.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$3Q=Ri;function Li(q){return`'${q.replace(/'/g,"%27")}'`}t.$4Q=Li;function Zt(q,Q){if(q!==void 0){const te=q.match(/^\s*var\((.+)\)$/);if(te){const ce=te[1].split(",",2);return ce.length===2&&(Q=Zt(ce[1].trim(),Q)),`var(${ce[0]}, ${Q})`}return q}return Q}t.$5Q=Zt;function Ii(q,Q){let te;if(u.URI.isUri(q))te=q.toString(!0);else{const Oe=new Blob([q]);te=URL.createObjectURL(Oe),setTimeout(()=>URL.revokeObjectURL(te))}const ce=we(),De=document.createElement("a");ce.document.body.appendChild(De),De.download=Q,De.href=te,De.click(),setTimeout(()=>ce.document.body.removeChild(De))}t.$6Q=Ii;function Mi(){return new Promise(q=>{const Q=we(),te=document.createElement("input");Q.document.body.appendChild(te),te.type="file",te.multiple=!0,b.Event.once(b.Event.fromDOMEventEmitter(te,"input"))(()=>{q(te.files??void 0)}),te.click(),setTimeout(()=>Q.document.body.removeChild(te))})}t.$7Q=Mi;var yt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Oi(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:yt.BROWSER,guess:!1}:(r.$j||r.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:yt.BROWSER,guess:!0}:null}t.$8Q=Oi;function Jt(q,Q=!1){const te=document.createElement("a");return w.addHook("afterSanitizeAttributes",ce=>{for(const De of["href","src"])if(ce.hasAttribute(De)){const Oe=ce.getAttribute(De);if(De==="href"&&Oe.startsWith("#"))continue;if(te.href=Oe,!q.includes(te.protocol.replace(/:$/,""))){if(Q&&De==="src"&&te.href.startsWith("data:"))continue;ce.removeAttribute(De)}}}),(0,y.$Rc)(()=>{w.removeHook("afterSanitizeAttributes")})}t.$9Q=Jt;const Bi=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.$0Q=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function ji(q,Q){const te=Jt(Bi);try{const ce=w.sanitize(Q,zi);q.innerHTML=ce}finally{te.dispose()}}t.$$Q=ji;function Hi(q){const Q=new Uint16Array(q.length);for(let De=0;De<Q.length;De++)Q[De]=q.charCodeAt(De);let te="";const ce=new Uint8Array(Q.buffer);for(let De=0;De<ce.length;De++)te+=String.fromCharCode(ce[De]);return te}function Ui(q){return btoa(Hi(q))}t.$_Q=Ui;class pt extends b.$Vd{constructor(){super(),this.o=new y.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(b.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:te})=>this.C(Q,te),{window:s.$dP,disposables:this.o}))}C(Q,te){te.add($(Q,"keydown",ce=>{if(ce.defaultPrevented)return;const De=new n.$IP(ce);if(!(De.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(De.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),te.add($(Q,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),te.add($(Q.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add($(Q.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add($(Q.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add($(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$aR=pt;function Wi(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$bR=Wi;class Vi extends y.$Tc{constructor(Q,te){super(),this.j=Q,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B($(this.j,t.$FQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B($(this.j,t.$FQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B($(this.j,t.$FQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B($(this.j,t.$FQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B($(this.j,t.$FQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B($(this.j,t.$FQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B($(this.j,t.$FQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$cR=Vi;const qi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function _i(q,...Q){let te,ce;Array.isArray(Q[0])?(te={},ce=Q[0]):(te=Q[0]||{},ce=Q[1]);const De=qi.exec(q);if(!De||!De.groups)throw new Error("Bad use of h");const Oe=De.groups.tag||"div",He=document.createElement(Oe);De.groups.id&&(He.id=De.groups.id);const xe=[];if(De.groups.class)for(const qe of De.groups.class.split("."))qe!==""&&xe.push(qe);if(te.className!==void 0)for(const qe of te.className.split("."))qe!==""&&xe.push(qe);xe.length>0&&(He.className=xe.join(" "));const Ge={};if(De.groups.name&&(Ge[De.groups.name]=He),ce)for(const qe of ce)qe instanceof HTMLElement?He.appendChild(qe):typeof qe=="string"?He.append(qe):"root"in qe&&(Object.assign(Ge,qe),He.appendChild(qe.root));for(const[qe,at]of Object.entries(te))if(qe!=="className")if(qe==="style")for(const[Nt,Bt]of Object.entries(at))He.style.setProperty(ei(Nt),typeof Bt=="number"?Bt+"px":""+Bt);else qe==="tabIndex"?He.tabIndex=at:He.setAttribute(ei(qe),at.toString());return Ge.root=He,Ge}t.h=_i;function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q){for(const{name:te,value:ce}of q.attributes)Q.setAttribute(te,ce)}t.$eR=ti;function Qi(q,Q,te){const ce=q.getAttribute(te);ce?Q.setAttribute(te,ce):Q.removeAttribute(te)}function Ki(q,Q,te){ti(q,Q);const ce=new y.$Sc;return ce.add(t.$wQ.observe(q,ce,{attributes:!0,attributeFilter:te})(De=>{for(const Oe of De)Oe.type==="attributes"&&Oe.attributeName&&Qi(q,Q,Oe.attributeName)})),ce}t.$fR=Ki}),define(be[54],$e([1,0,3,2,117]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=t.$gR=void 0;class j extends P.$Tc{constructor(b,w){super(),this.B((0,k.$LP)(b,"dragover",y=>{y.preventDefault(),this.a||(this.a=setTimeout(()=>{w(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(y=>{this.B((0,k.$LP)(b,y,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$gR=j,t.$hR={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$fs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(S,b,w,y,M){const r=document.createElement("div");if(r.className=w,r.textContent=b,M&&(r.style.color=M),y&&(r.style.background=y),S.dataTransfer){const u=(0,k.getWindow)(S).document;u.body.appendChild(r),S.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>u.body.removeChild(r),0)}}t.$iR=A}),define(be[55],$e([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MR=t.$LR=t.$KR=void 0;function P(r,u={}){const e=j(u);return e.textContent=r,e}t.$KR=P;function n(r,u={}){const e=j(u);return b(e,w(r,!!u.renderCodeSegments),u.actionHandler,u.renderCodeSegments),e}t.$LR=n;function j(r){const u=r.inline?"span":"div",e=document.createElement(u);return r.className&&(e.className=r.className),e}t.$MR=j;class A{constructor(u){this.b=u,this.c=0}eos(){return this.c>=this.b.length}next(){const u=this.peek();return this.advance(),u}peek(){return this.b[this.c]}advance(){this.c++}}var S;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(S||(S={}));function b(r,u,e,s){let m;if(u.type===2)m=document.createTextNode(u.content||"");else if(u.type===3)m=document.createElement("b");else if(u.type===4)m=document.createElement("i");else if(u.type===7&&s)m=document.createElement("code");else if(u.type===5&&e){const d=document.createElement("a");e.disposables.add(k.$MP(d,"click",o=>{e.callback(String(u.index),o)})),m=d}else u.type===8?m=document.createElement("br"):u.type===1&&(m=r);m&&r!==m&&r.appendChild(m),m&&Array.isArray(u.children)&&u.children.forEach(d=>{b(m,d,e,s)})}function w(r,u){const e={type:1,children:[]};let s=0,m=e;const d=[],o=new A(r);for(;!o.eos();){let $=o.next();const c=$==="\\"&&M(o.peek(),u)!==0;if(c&&($=o.next()),!c&&y($,u)&&$===o.peek()){o.advance(),m.type===2&&(m=d.pop());const f=M($,u);if(m.type===f||m.type===5&&f===6)m=d.pop();else{const h={type:f,children:[]};f===5&&(h.index=s,s++),m.children.push(h),d.push(m),m=h}}else if($===`
`)m.type===2&&(m=d.pop()),m.children.push({type:8});else if(m.type!==2){const f={type:2,content:$};m.children.push(f),d.push(m),m=f}else m.content+=$}return m.type===2&&(m=d.pop()),d.length,e}function y(r,u){return M(r,u)!==0}function M(r,u){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return u?7:0;default:return 0}}}),define(be[56],$e([1,0,3,2]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mR=void 0;class n{constructor(){this.a=new P.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,S){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const b=this.c;this.c=null,A&&b&&b(S)}isMonitoring(){return!!this.b}startMonitoring(A,S,b,w,y){this.isMonitoring()&&this.stopMonitoring(!1),this.b=w,this.c=y;let M=A;try{A.setPointerCapture(S),this.a.add((0,P.$Rc)(()=>{try{A.releasePointerCapture(S)}catch{}}))}catch{M=k.getWindow(A)}this.a.add(k.$LP(M,k.$FQ.POINTER_MOVE,r=>{if(r.buttons!==b){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(k.$LP(M,k.$FQ.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$mR=n});var Xe=this&&this.__decorate||function(ie,t,k,P){var n=arguments.length,j=n<3?t:P===null?P=Object.getOwnPropertyDescriptor(t,k):P,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ie,t,k,P);else for(var S=ie.length-1;S>=0;S--)(A=ie[S])&&(j=(n<3?A(j):n>3?A(t,k,j):A(t,k))||j);return n>3&&j&&Object.defineProperty(t,k,j),j};define(be[25],$e([1,0,3,21,12,27,4,2,45]),function(ie,t,k,P,n,j,A,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jR=t.EventType=void 0;var w;(function(M){M.Tap="-monaco-gesturetap",M.Change="-monaco-gesturechange",M.Start="-monaco-gesturestart",M.End="-monaco-gesturesend",M.Contextmenu="-monaco-gesturecontextmenu"})(w||(t.EventType=w={}));class y extends S.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new b.$4c,this.h=new b.$4c,this.m={},this.j=null,this.n=0,this.B(A.Event.runAndSubscribe(k.onDidRegisterWindow,({window:r,disposables:u})=>{u.add(k.$LP(r.document,"touchstart",e=>this.s(e),{passive:!1})),u.add(k.$LP(r.document,"touchend",e=>this.u(r,e))),u.add(k.$LP(r.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:P.$dP,disposables:this.q}))}static addTarget(r){if(!y.isTouchDevice())return S.$Tc.None;y.b||(y.b=(0,S.$Mc)(new y));const u=y.b.g.push(r);return(0,S.$Rc)(u)}static ignoreTarget(r){if(!y.isTouchDevice())return S.$Tc.None;y.b||(y.b=(0,S.$Mc)(new y));const u=y.b.h.push(r);return(0,S.$Rc)(u)}static isTouchDevice(){return"ontouchstart"in P.$dP||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(r){const u=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=r.targetTouches.length;e<s;e++){const m=r.targetTouches.item(e);this.m[m.identifier]={id:m.identifier,initialTarget:m.target,initialTimeStamp:u,initialPageX:m.pageX,initialPageY:m.pageY,rollingTimestamps:[u],rollingPageX:[m.pageX],rollingPageY:[m.pageY]};const d=this.w(w.Start,m.target);d.pageX=m.pageX,d.pageY=m.pageY,this.z(d)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}u(r,u){const e=Date.now(),s=Object.keys(this.m).length;for(let m=0,d=u.changedTouches.length;m<d;m++){const o=u.changedTouches.item(m);if(!this.m.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const $=this.m[o.identifier],c=Date.now()-$.initialTimeStamp;if(c<y.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const f=this.w(w.Tap,$.initialTarget);f.pageX=n.$sb($.rollingPageX),f.pageY=n.$sb($.rollingPageY),this.z(f)}else if(c>=y.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const f=this.w(w.Contextmenu,$.initialTarget);f.pageX=n.$sb($.rollingPageX),f.pageY=n.$sb($.rollingPageY),this.z(f)}else if(s===1){const f=n.$sb($.rollingPageX),h=n.$sb($.rollingPageY),F=n.$sb($.rollingTimestamps)-$.rollingTimestamps[0],O=f-$.rollingPageX[0],R=h-$.rollingPageY[0],B=[...this.g].filter(v=>$.initialTarget instanceof Node&&v.contains($.initialTarget));this.C(r,B,e,Math.abs(O)/F,O>0?1:-1,f,Math.abs(R)/F,R>0?1:-1,h)}this.z(this.w(w.End,$.initialTarget)),delete this.m[o.identifier]}this.f&&(u.preventDefault(),u.stopPropagation(),this.f=!1)}w(r,u){const e=document.createEvent("CustomEvent");return e.initEvent(r,!1,!0),e.initialTarget=u,e.tapCount=0,e}z(r){if(r.type===w.Tap){const u=new Date().getTime();let e=0;u-this.n>y.r?e=1:e=2,this.n=u,r.tapCount=e}else(r.type===w.Change||r.type===w.Contextmenu)&&(this.n=0);if(r.initialTarget instanceof Node){for(const u of this.h)if(u.contains(r.initialTarget))return;for(const u of this.g)u.contains(r.initialTarget)&&(u.dispatchEvent(r),this.f=!0)}}C(r,u,e,s,m,d,o,$,c){this.j=k.$VP(r,()=>{const f=Date.now(),h=f-e;let F=0,O=0,R=!0;s+=y.a*h,o+=y.a*h,s>0&&(R=!1,F=m*s*h),o>0&&(R=!1,O=$*o*h);const B=this.w(w.Change);B.translationX=F,B.translationY=O,u.forEach(v=>v.dispatchEvent(B)),R||this.C(r,u,f,s,m,d+F,o,$,c+O)})}D(r){const u=Date.now();for(let e=0,s=r.changedTouches.length;e<s;e++){const m=r.changedTouches.item(e);if(!this.m.hasOwnProperty(String(m.identifier))){console.warn("end of an UNKNOWN touch",m);continue}const d=this.m[m.identifier],o=this.w(w.Change,d.initialTarget);o.translationX=m.pageX-n.$sb(d.rollingPageX),o.translationY=m.pageY-n.$sb(d.rollingPageY),o.pageX=m.pageX,o.pageY=m.pageY,this.z(o),d.rollingPageX.length>3&&(d.rollingPageX.shift(),d.rollingPageY.shift(),d.rollingTimestamps.shift()),d.rollingPageX.push(m.pageX),d.rollingPageY.push(m.pageY),d.rollingTimestamps.push(u)}this.f&&(r.preventDefault(),r.stopPropagation(),this.f=!1)}}t.$jR=y,Xe([j.$xh],y,"isTouchDevice",null)}),define(be[57],$e([1,0,3,92]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=t.$PR=t.$OR=void 0;const P=2e4;let n,j,A,S,b;function w(u){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const m=document.createElement("div");return m.className="monaco-alert",m.setAttribute("role","alert"),m.setAttribute("aria-atomic","true"),n.appendChild(m),m};j=e(),A=e();const s=()=>{const m=document.createElement("div");return m.className="monaco-status",m.setAttribute("aria-live","polite"),m.setAttribute("aria-atomic","true"),n.appendChild(m),m};S=s(),b=s(),u.appendChild(n)}t.$OR=w;function y(u){n&&(j.textContent!==u?(k.$KP(A),r(j,u)):(k.$KP(j),r(A,u)))}t.$PR=y;function M(u){n&&(S.textContent!==u?(k.$KP(b),r(S,u)):(k.$KP(S),r(b,u)))}t.$QR=M;function r(u,e){k.$KP(u),e.length>P&&(e=e.substr(0,P)),u.textContent=e,u.style.visibility="hidden",u.style.visibility="visible"}}),define(be[119],$e([1,0,3,18]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iS=t.$hS=void 0;const n=new RegExp(`(\\\\)?\\$\\((${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?)\\)`,"g");function j(S){const b=new Array;let w,y=0,M=0;for(;(w=n.exec(S))!==null;){M=w.index||0,y<M&&b.push(S.substring(y,M)),y=(w.index||0)+w[0].length;const[,r,u]=w;b.push(r?`$(${u})`:A({id:u}))}return y<S.length&&b.push(S.substring(y)),b}t.$hS=j;function A(S){const b=k.$("span");return b.classList.add(...P.ThemeIcon.asClassNameArray(S)),b}t.$iS=A}),define(be[120],$e([1,0,3]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WR=void 0;function P(j){try{j.parentElement?.removeChild(j)}catch{}}class n{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let S=this.h(A).pop(),b=!1;if(S)b=this.b.has(S.domNode),b&&this.b.delete(S.domNode);else{const w=(0,k.$)(".monaco-list-row"),M=this.i(A).renderTemplate(w);S={domNode:w,templateId:A,templateData:M}}return{row:S,isReusingConnectedDomNode:b}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const S of this.b)this.g(S);this.b.clear(),this.c=!1}}f(A){const{domNode:S,templateId:b}=A;S&&(this.c?this.b.add(S):this.g(S)),this.h(b).push(A)}g(A){A.classList.remove("scrolling"),P(A)}h(A){let S=this.a.get(A);return S||(S=[],this.a.set(A,S)),S}dispose(){this.a.forEach((A,S)=>{for(const b of A)this.i(S).disposeTemplate(b.templateData),b.templateData=null}),this.a.clear(),this.b.clear()}i(A){const S=this.d.get(A);if(!S)throw new Error(`No renderer found for ${A}`);return S}}t.$WR=n}),define(be[121],$e([1,0,9,2]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=void 0;class n extends P.$Tc{constructor(A,S,b){super(),this.a=A,this.b=S,this.c=b,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new k.$dh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$rR=n}),define(be[122],$e([1,0,3,25,12,4,2,5]),function(ie,t,k,P,n,j,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pS=void 0;class b extends A.$Tc{constructor(y,M,r,u){super(),this.f=0,this.b=u||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new j.$Vd),this.h=r,this.j(),this.setOptions(y,M)}j(){this.B(P.$jR.addTarget(this.a)),[P.EventType.Tap].forEach(y=>{this.B(k.$LP(this.a,y,M=>{this.a.focus()}))}),this.B(k.$MP(this.a,"click",y=>{k.$HQ.stop(y,!0)})),this.B(k.$MP(this.a,"change",y=>{this.a.title=y.target.value,this.g.fire({index:y.target.selectedIndex,selected:y.target.value})})),this.B(k.$MP(this.a,"keydown",y=>{let M=!1;S.$j?(y.keyCode===18||y.keyCode===16||y.keyCode===10)&&(M=!0):(y.keyCode===18&&y.altKey||y.keyCode===10||y.keyCode===3)&&(M=!0),M&&y.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(y,M){(!this.c||!n.$ub(this.c,y))&&(this.c=y,this.a.options.length=0,this.c.forEach((r,u)=>{this.a.add(this.m(r.text,u,r.isDisabled))})),M!==void 0&&this.select(M)}select(y){this.c.length===0?this.f=0:y>=0&&y<this.c.length?this.f=y:y>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(y){this.b.ariaLabel=y,this.a.setAttribute("aria-label",y)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(y){this.a.tabIndex=y?0:-1}render(y){y.classList.add("select-container"),y.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(y){this.h=y,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(y,M,r){const u=document.createElement("option");return u.value=y,u.text=y,u.disabled=!!r,u}}t.$pS=b}),define(be[58],$e([1,0,26,12,9,50,87,4,28]),function(ie,t,k,P,n,j,A,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XT=t.$WT=t.$VT=void 0;function w(u){return typeof u=="object"&&"visibility"in u&&"data"in u}t.$VT=w;function y(u){switch(u){case!0:return 1;case!1:return 0;default:return u}}t.$WT=y;function M(u){return typeof u.collapsible=="boolean"}class r{constructor(e,s,m,d={}){this.o=e,this.p=s,this.rootRef=[],this.d=new S.$4d,this.f=new S.$Vd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new S.$Vd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new S.$Vd,this.onDidSplice=this.l.event,this.m=new n.$3g(j.$Sd),this.h=typeof d.collapseByDefault>"u"?!1:d.collapseByDefault,this.j=d.filter,this.k=typeof d.autoExpandSingleChildren>"u"?!1:d.autoExpandSingleChildren,this.c={parent:void 0,element:m,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,m=b.Iterable.empty(),d={}){if(e.length===0)throw new k.$TT(this.o,"Invalid tree location");d.diffIdentityProvider?this.q(d.diffIdentityProvider,e,s,m,d):this.s(e,s,m,d)}q(e,s,m,d=b.Iterable.empty(),o,$=o.diffDepth??0){const{parentNode:c}=this.G(s);if(!c.lastDiffIds)return this.s(s,m,d,o);const f=[...d],h=s[s.length-1],F=new A.$1s({getElements:()=>c.lastDiffIds},{getElements:()=>[...c.children.slice(0,h),...f,...c.children.slice(h+m)].map(C=>e.getId(C.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return c.lastDiffIds=void 0,this.s(s,m,f,o);const O=s.slice(0,-1),R=(C,V,U)=>{if($>0)for(let T=0;T<U;T++)C--,V--,this.q(e,[...O,C,0],Number.MAX_SAFE_INTEGER,f[V].children,o,$-1)};let B=Math.min(c.children.length,h+m),v=f.length;for(const C of F.changes.sort((V,U)=>U.originalStart-V.originalStart))R(B,v,B-(C.originalStart+C.originalLength)),B=C.originalStart,v=C.modifiedStart-h,this.s([...O,B],C.originalLength,b.Iterable.slice(f,v,v+C.modifiedLength),o);R(B,v,B)}s(e,s,m=b.Iterable.empty(),{onDidCreateNode:d,onDidDeleteNode:o,diffIdentityProvider:$}){const{parentNode:c,listIndex:f,revealed:h,visible:F}=this.G(e),O=[],R=b.Iterable.map(m,X=>this.w(X,c,c.visible?1:0,h,O,d)),B=e[e.length-1];let v=0;for(let X=B;X>=0&&X<c.children.length;X--){const Y=c.children[X];if(Y.visible){v=Y.visibleChildIndex;break}}const C=[];let V=0,U=0;for(const X of R)C.push(X),U+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=v+V++);const T=(0,P.$6b)(c.children,B,s,C);$?c.lastDiffIds?(0,P.$6b)(c.lastDiffIds,B,s,C.map(X=>$.getId(X.element).toString())):c.lastDiffIds=c.children.map(X=>$.getId(X.element).toString()):c.lastDiffIds=void 0;let L=0;for(const X of T)X.visible&&L++;if(L!==0)for(let X=B+C.length;X<c.children.length;X++){const Y=c.children[X];Y.visible&&(Y.visibleChildIndex-=L)}if(c.visibleChildrenCount+=V-L,h&&F){const X=T.reduce((Y,fe)=>Y+(fe.visible?fe.renderNodeCount:0),0);this.B(c,U-X),this.p.splice(f,X,O)}if(T.length>0&&o){const X=Y=>{o(Y),Y.children.forEach(X)};T.forEach(X)}this.l.fire({insertedNodes:C,deletedNodes:T});let z=c;for(;z;){if(z.visibility===2){this.m.trigger(()=>this.refilter());break}z=z.parent}}rerender(e){if(e.length===0)throw new k.$TT(this.o,"Invalid tree location");const{node:s,listIndex:m,revealed:d}=this.F(e);s.visible&&d&&this.p.splice(m,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new k.$TT(this.o,"Invalid tree location");const{listIndex:m}=this.F(e);this.p.updateElementHeight(m,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:m,revealed:d}=this.F(e);return m&&d?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const m=this.E(e);typeof s>"u"&&(s=!m.collapsible);const d={collapsible:s};return this.d.bufferEvents(()=>this.t(e,d))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,m){const d=this.E(e);typeof s>"u"&&(s=!d.collapsed);const o={collapsed:s,recursive:m||!1};return this.d.bufferEvents(()=>this.t(e,o))}t(e,s){const{node:m,listIndex:d,revealed:o}=this.F(e),$=this.u(m,d,o,s);if(m!==this.c&&this.k&&$&&!M(s)&&m.collapsible&&!m.collapsed&&!s.recursive){let c=-1;for(let f=0;f<m.children.length;f++)if(m.children[f].visible)if(c>-1){c=-1;break}else c=f;c>-1&&this.t([...e,c],s)}return $}u(e,s,m,d){const o=this.v(e,d,!1);if(!m||!e.visible||!o)return o;const $=e.renderNodeCount,c=this.x(e),f=$-(s===-1?0:1);return this.p.splice(s+1,f,c.slice(1)),o}v(e,s,m){let d;if(e===this.c?d=!1:(M(s)?(d=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(d=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):d=!1,d&&this.f.fire({node:e,deep:m})),!M(s)&&s.recursive)for(const o of e.children)d=this.v(o,s,!0)||d;return d}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,m,d,o,$){const c={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},f=this.C(c,m);c.visibility=f,d&&o.push(c);const h=e.children||b.Iterable.empty(),F=d&&f!==0&&!c.collapsed;let O=0,R=1;for(const B of h){const v=this.w(B,c,f,F,o,$);c.children.push(v),R+=v.renderNodeCount,v.visible&&(v.visibleChildIndex=O++)}return c.collapsible=c.collapsible||c.children.length>0,c.visibleChildrenCount=O,c.visible=f===2?O>0:f===1,c.visible?c.collapsed||(c.renderNodeCount=R):(c.renderNodeCount=0,d&&o.pop()),$?.(c),c}x(e){const s=e.renderNodeCount,m=[];return this.y(e,m),this.B(e.parent,m.length-s),m}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const m of e.children)e.renderNodeCount+=this.y(m,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,m=[];return this.A(e,e.visible?1:0,m),this.B(e.parent,m.length-s),m}A(e,s,m,d=!0){let o;if(e!==this.c){if(o=this.C(e,s),o===0)return e.visible=!1,e.renderNodeCount=0,!1;d&&m.push(e)}const $=m.length;e.renderNodeCount=e===this.c?0:1;let c=!1;if(!e.collapsed||o!==0){let f=0;for(const h of e.children)c=this.A(h,o,m,d&&!e.collapsed)||c,h.visible&&(h.visibleChildIndex=f++);e.visibleChildrenCount=f}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=o===2?c:o===1,e.visibility=o),e.visible?e.collapsed||(e.renderNodeCount+=m.length-$):(e.renderNodeCount=0,d&&m.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const m=this.j?this.j.filter(e.element,s):1;return typeof m=="boolean"?(e.filterData=void 0,m?1:0):w(m)?(e.filterData=m.data,y(m.visibility)):(e.filterData=void 0,y(m))}D(e,s=this.c){if(!e||e.length===0)return!0;const[m,...d]=e;return m<0||m>s.children.length?!1:this.D(d,s.children[m])}E(e,s=this.c){if(!e||e.length===0)return s;const[m,...d]=e;if(m<0||m>s.children.length)throw new k.$TT(this.o,"Invalid tree location");return this.E(d,s.children[m])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:m,revealed:d,visible:o}=this.G(e),$=e[e.length-1];if($<0||$>s.children.length)throw new k.$TT(this.o,"Invalid tree location");const c=s.children[$];return{node:c,listIndex:m,revealed:d,visible:o&&c.visible}}G(e,s=this.c,m=0,d=!0,o=!0){const[$,...c]=e;if($<0||$>s.children.length)throw new k.$TT(this.o,"Invalid tree location");for(let f=0;f<$;f++)m+=s.children[f].renderNodeCount;return d=d&&!s.collapsed,o=o&&s.visible,c.length===0?{parentNode:s,listIndex:m,revealed:d,visible:o}:this.G(c,s.children[$],m+1,d,o)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let m=e;for(;m.parent;)s.push(m.parent.children.indexOf(m)),m=m.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,P.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$XT=r}),define(be[123],$e([1,0,58,26,28]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=void 0;class j{get size(){return this.d.size}constructor(S,b,w={}){this.k=S,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new k.$XT(S,b,null,w),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,w.sorter&&(this.j={compare(y,M){return w.sorter.compare(y.element,M.element)}}),this.h=w.identityProvider}setChildren(S,b=n.Iterable.empty(),w={}){const y=this.o(S);this.l(y,this.m(b),w)}l(S,b=n.Iterable.empty(),w){const y=new Set,M=new Set,r=e=>{if(e.element===null)return;const s=e;if(y.add(s.element),this.d.set(s.element,s),this.h){const m=this.h.getId(s.element).toString();M.add(m),this.f.set(m,s)}w.onDidCreateNode?.(s)},u=e=>{if(e.element===null)return;const s=e;if(y.has(s.element)||this.d.delete(s.element),this.h){const m=this.h.getId(s.element).toString();M.has(m)||this.f.delete(m)}w.onDidDeleteNode?.(s)};this.c.splice([...S,0],Number.MAX_VALUE,b,{...w,onDidCreateNode:r,onDidDeleteNode:u})}m(S=n.Iterable.empty()){return this.j&&(S=[...S].sort(this.j.compare.bind(this.j))),n.Iterable.map(S,b=>{let w=this.d.get(b.element);if(!w&&this.h){const r=this.h.getId(b.element).toString();w=this.f.get(r)}if(!w){let r;return typeof b.collapsed>"u"?r=void 0:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!b.collapsed,{...b,children:this.m(b.children),collapsed:r}}const y=typeof b.collapsible=="boolean"?b.collapsible:w.collapsible;let M;return typeof b.collapsed>"u"||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrCollapsed||b.collapsed===P.ObjectTreeElementCollapseState.PreserveOrExpanded?M=w.collapsed:b.collapsed===P.ObjectTreeElementCollapseState.Collapsed?M=!0:b.collapsed===P.ObjectTreeElementCollapseState.Expanded?M=!1:M=!!b.collapsed,{...b,collapsible:y,collapsed:M,children:this.m(b.children)}})}rerender(S){const b=this.o(S);this.c.rerender(b)}updateElementHeight(S,b){const w=this.o(S);this.c.updateElementHeight(w,b)}resort(S=null,b=!0){if(!this.j)return;const w=this.o(S),y=this.c.getNode(w);this.l(w,this.n(y,b),{})}n(S,b,w=!0){let y=[...S.children];return(b||w)&&(y=y.sort(this.j.compare.bind(this.j))),n.Iterable.map(y,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,b,!1)}))}getFirstElementChild(S=null){const b=this.o(S);return this.c.getFirstElementChild(b)}getLastElementAncestor(S=null){const b=this.o(S);return this.c.getLastElementAncestor(b)}has(S){return this.d.has(S)}getListIndex(S){const b=this.o(S);return this.c.getListIndex(b)}getListRenderCount(S){const b=this.o(S);return this.c.getListRenderCount(b)}isCollapsible(S){const b=this.o(S);return this.c.isCollapsible(b)}setCollapsible(S,b){const w=this.o(S);return this.c.setCollapsible(w,b)}isCollapsed(S){const b=this.o(S);return this.c.isCollapsed(b)}setCollapsed(S,b,w){const y=this.o(S);return this.c.setCollapsed(y,b,w)}expandTo(S){const b=this.o(S);this.c.expandTo(b)}refilter(){this.c.refilter()}getNode(S=null){if(S===null)return this.c.getNode(this.c.rootRef);const b=this.d.get(S);if(!b)throw new P.$TT(this.k,`Tree element not found: ${S}`);return b}getNodeLocation(S){return S.element}getParentNodeLocation(S){if(S===null)throw new P.$TT(this.k,"Invalid getParentNodeLocation call");const b=this.d.get(S);if(!b)throw new P.$TT(this.k,`Tree element not found: ${S}`);const w=this.c.getNodeLocation(b),y=this.c.getParentNodeLocation(w);return this.c.getNode(y).element}o(S){if(S===null)return[];const b=this.d.get(S);if(!b)throw new P.$TT(this.k,`Tree element not found: ${S}`);return this.c.getNodeLocation(b)}}t.$5T=j}),define(be[20],$e([1,0,3,14,19,25,2]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=void 0;class S extends A.$Tc{f(w,y){this.B(k.$LP(w,k.$FQ.CLICK,M=>y(new n.$DP(k.getWindow(w),M))))}j(w,y){this.B(k.$LP(w,k.$FQ.MOUSE_DOWN,M=>y(new n.$DP(k.getWindow(w),M))))}m(w,y){this.B(k.$LP(w,k.$FQ.MOUSE_OVER,M=>y(new n.$DP(k.getWindow(w),M))))}u(w,y){this.B(k.$LP(w,k.$FQ.MOUSE_LEAVE,M=>y(new n.$DP(k.getWindow(w),M))))}z(w,y){this.B(k.$LP(w,k.$FQ.KEY_DOWN,M=>y(new P.$IP(M))))}C(w,y){this.B(k.$LP(w,k.$FQ.KEY_UP,M=>y(new P.$IP(M))))}D(w,y){this.B(k.$LP(w,k.$FQ.INPUT,y))}F(w,y){this.B(k.$LP(w,k.$FQ.BLUR,y))}G(w,y){this.B(k.$LP(w,k.$FQ.FOCUS,y))}H(w,y){this.B(k.$LP(w,k.$FQ.CHANGE,y))}I(w){return j.$jR.ignoreTarget(w)}}t.$nR=S}),define(be[38],$e([1,0,56,20,9,18,3]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=t.$oR=void 0,t.$oR=11;class S extends P.$nR{constructor(w){super(),this.a=w.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=w.bgWidth+"px",this.bgDomNode.style.height=w.bgHeight+"px",typeof w.top<"u"&&(this.bgDomNode.style.top="0px"),typeof w.left<"u"&&(this.bgDomNode.style.left="0px"),typeof w.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof w.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=w.className,this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(w.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$oR+"px",this.domNode.style.height=t.$oR+"px",typeof w.top<"u"&&(this.domNode.style.top=w.top+"px"),typeof w.left<"u"&&(this.domNode.style.left=w.left+"px"),typeof w.bottom<"u"&&(this.domNode.style.bottom=w.bottom+"px"),typeof w.right<"u"&&(this.domNode.style.right=w.right+"px"),this.g=this.B(new k.$mR),this.B(A.$MP(this.bgDomNode,A.$FQ.POINTER_DOWN,y=>this.h(y))),this.B(A.$MP(this.domNode,A.$FQ.POINTER_DOWN,y=>this.h(y))),this.b=this.B(new A.$XP),this.c=this.B(new n.$dh)}h(w){if(!w.target||!(w.target instanceof Element))return;const y=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(w))};this.a(),this.b.cancel(),this.c.cancelAndSet(y,200),this.g.startMonitoring(w.target,w.pointerId,w.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),w.preventDefault()}}t.$pR=S}),define(be[59],$e([1,0,3,41,56,38,121,20,5]),function(ie,t,k,P,n,j,A,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sR=void 0;const w=140;class y extends S.$nR{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.n=this.B(new A.$rR(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$mR),this.s=!0,this.domNode=(0,P.$lR)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(k.$LP(this.domNode.domNode,k.$FQ.POINTER_DOWN,u=>this.M(u)))}t(r){const u=this.B(new j.$pR(r));this.domNode.domNode.appendChild(u.bgDomNode),this.domNode.domNode.appendChild(u.domNode)}w(r,u,e,s){this.slider=(0,P.$lR)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(u),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(k.$LP(this.slider.domNode,k.$FQ.POINTER_DOWN,m=>{m.button===0&&(m.preventDefault(),this.O(m))})),this.f(this.slider.domNode,m=>{m.leftButton&&m.stopPropagation()})}y(r){return this.h.setVisibleSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(r){return this.h.setScrollSize(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(r){return this.h.setScrollPosition(r)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(r){r.target===this.domNode.domNode&&this.N(r)}delegatePointerDown(r){const u=this.domNode.domNode.getClientRects()[0].top,e=u+this.h.getSliderPosition(),s=u+this.h.getSliderPosition()+this.h.getSliderSize(),m=this.U(r);e<=m&&m<=s?r.button===0&&(r.preventDefault(),this.O(r)):this.N(r)}N(r){let u,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")u=r.offsetX,e=r.offsetY;else{const m=k.$8P(this.domNode.domNode);u=r.pageX-m.left,e=r.pageY-m.top}const s=this.S(u,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),r.button===0&&(r.preventDefault(),this.O(r))}O(r){if(!r.target||!(r.target instanceof Element))return;const u=this.U(r),e=this.W(r),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(r.target,r.pointerId,r.buttons,m=>{const d=this.W(m),o=Math.abs(d-e);if(b.$i&&o>w){this.P(s.getScrollPosition());return}const c=this.U(m)-u;this.P(s.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(r){const u={};this.writeScrollPosition(u,r),this.b.setScrollPositionNow(u)}updateScrollbarSize(r){this.X(r),this.h.setScrollbarSize(r),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$sR=y}),define(be[124],$e([1,0,19,59,38,42,17]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=void 0;class S extends P.$sR{constructor(w,y,M){const r=w.getScrollDimensions(),u=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:M,scrollbarState:new j.$qR(y.horizontalHasArrows?y.arrowSize:0,y.horizontal===2?0:y.horizontalScrollbarSize,y.vertical===2?0:y.verticalScrollbarSize,r.width,r.scrollWidth,u.scrollLeft),visibility:y.horizontal,extraScrollbarClassName:"horizontal",scrollable:w,scrollByPage:y.scrollByPage}),y.horizontalHasArrows){const e=(y.arrowSize-n.$oR)/2,s=(y.horizontalScrollbarSize-n.$oR)/2;this.t({className:"scra",icon:A.$_j.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$FP(null,1,0))}),this.t({className:"scra",icon:A.$_j.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:y.arrowSize,bgHeight:y.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new k.$FP(null,-1,0))})}this.w(Math.floor((y.horizontalScrollbarSize-y.horizontalSliderSize)/2),0,void 0,y.horizontalSliderSize)}R(w,y){this.slider.setWidth(w),this.slider.setLeft(y)}Q(w,y){this.domNode.setWidth(w),this.domNode.setHeight(y),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(w){return this.s=this.J(w.scrollWidth)||this.s,this.s=this.L(w.scrollLeft)||this.s,this.s=this.y(w.width)||this.s,this.s}S(w,y){return w}U(w){return w.pageX}W(w){return w.pageY}X(w){this.slider.setHeight(w)}writeScrollPosition(w,y){w.scrollLeft=y}updateOptions(w){this.updateScrollbarSize(w.horizontal===2?0:w.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.n.setVisibility(w.horizontal),this.c=w.scrollByPage}}t.$tR=S}),define(be[125],$e([1,0,19,59,38,42,17]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uR=void 0;class S extends P.$sR{constructor(w,y,M){const r=w.getScrollDimensions(),u=w.getCurrentScrollPosition();if(super({lazyRender:y.lazyRender,host:M,scrollbarState:new j.$qR(y.verticalHasArrows?y.arrowSize:0,y.vertical===2?0:y.verticalScrollbarSize,0,r.height,r.scrollHeight,u.scrollTop),visibility:y.vertical,extraScrollbarClassName:"vertical",scrollable:w,scrollByPage:y.scrollByPage}),y.verticalHasArrows){const e=(y.arrowSize-n.$oR)/2,s=(y.verticalScrollbarSize-n.$oR)/2;this.t({className:"scra",icon:A.$_j.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$FP(null,0,1))}),this.t({className:"scra",icon:A.$_j.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:y.verticalScrollbarSize,bgHeight:y.arrowSize,onActivate:()=>this.a.onMouseWheel(new k.$FP(null,0,-1))})}this.w(0,Math.floor((y.verticalScrollbarSize-y.verticalSliderSize)/2),y.verticalSliderSize,void 0)}R(w,y){this.slider.setHeight(w),this.slider.setTop(y)}Q(w,y){this.domNode.setWidth(y),this.domNode.setHeight(w),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(w){return this.s=this.J(w.scrollHeight)||this.s,this.s=this.L(w.scrollTop)||this.s,this.s=this.y(w.height)||this.s,this.s}S(w,y){return y}U(w){return w.pageY}W(w){return w.pageX}X(w){this.slider.setWidth(w)}writeScrollPosition(w,y){w.scrollTop=y}updateOptions(w){this.updateScrollbarSize(w.vertical===2?0:w.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(w.vertical),this.c=w.scrollByPage}}t.$uR=S}),define(be[60],$e([1,0,16,3,41,19,124,125,20,9,4,2,5,48,99]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=t.$yR=t.$xR=t.$wR=t.$vR=void 0;const e=500,s=50,m=!0;class d{constructor(R,B,v){this.timestamp=R,this.deltaX=B,this.deltaY=v,this.score=0}}class o{static{this.INSTANCE=new o}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,B=0,v=1,C=this.d;do{const V=C===this.c?R:Math.pow(2,-v);if(R-=V,B+=this.b[C].score*V,C===this.c)break;C=(this.a+C-1)%this.a,v++}while(!0);return B<=.5}acceptStandardWheelEvent(R){const B=P.getWindow(R.browserEvent),v=B.devicePixelRatio/(0,k.$mP)(B);r.$i||r.$k?this.accept(Date.now(),R.deltaX/v,R.deltaY/v):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,B,v){const C=new d(R,B,v);C.score=this.f(C),this.c===-1&&this.d===-1?(this.b[0]=C,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=C)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let B=.5;const v=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(B+=.25),Math.min(Math.max(B,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$vR=o;class $ extends b.$nR{get options(){return this.a}constructor(R,B,v){super(),this.O=this.B(new y.$Vd),this.onScroll=this.O.event,this.P=this.B(new y.$Vd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(B),this.b=v,this.B(this.b.onScroll(V=>{this.P.fire(V),this.S(V),this.O.fire(V)}));const C={onMouseWheel:V=>this.R(V),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new S.$uR(this.b,this.a,C)),this.g=this.B(new A.$tR(this.b,this.a,C)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$lR)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$lR)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$lR)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,V=>this.Z(V)),this.u(this.t,V=>this.Y(V)),this.L=this.B(new w.$dh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,M.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new j.$FP(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,M.$Oc)(this.w),R)){const v=C=>{this.R(new j.$FP(C))};this.w.push(P.$LP(this.t,P.$FQ.MOUSE_WHEEL,v,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const B=o.INSTANCE;m&&B.acceptStandardWheelEvent(R);let v=!1;if(R.deltaY||R.deltaX){let V=R.deltaY*this.a.mouseWheelScrollSensitivity,U=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&U+V===0?U=V=0:Math.abs(V)>=Math.abs(U)?U=0:V=0),this.a.flipAxes&&([V,U]=[U,V]);const T=!r.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||T)&&!U&&(U=V,V=0),R.browserEvent&&R.browserEvent.altKey&&(U=U*this.a.fastScrollSensitivity,V=V*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let z={};if(V){const X=s*V,Y=L.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(z,Y)}if(U){const X=s*U,Y=L.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(z,Y)}z=this.b.validateScrollPosition(z),(L.scrollLeft!==z.scrollLeft||L.scrollTop!==z.scrollTop)&&(m&&this.a.mouseWheelSmoothScroll&&B.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(z):this.b.setScrollPositionNow(z),v=!0)}let C=v;!C&&this.a.alwaysConsumeMouseWheel&&(C=!0),!C&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(C=!0),C&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),B=R.scrollTop>0,v=R.scrollLeft>0,C=v?" left":"",V=B?" top":"",U=v||B?" top-left-corner":"";this.n.setClassName(`shadow${C}`),this.r.setClassName(`shadow${V}`),this.s.setClassName(`shadow${U}${V}${C}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$wR=$;class c extends ${constructor(R,B){B=B||{},B.mouseWheelSmoothScroll=!1;const v=new u.$ls({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>P.$VP(P.getWindow(R),C)});super(R,B,v),this.B(v)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$xR=c;class f extends ${constructor(R,B,v){super(R,B,v)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$yR=f;class h extends ${constructor(R,B){B=B||{},B.mouseWheelSmoothScroll=!1;const v=new u.$ls({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:C=>P.$VP(P.getWindow(R),C)});super(R,B,v),this.B(v),this.cb=R,this.B(this.onScroll(C=>{C.scrollTopChanged&&(this.cb.scrollTop=C.scrollTop),C.scrollLeftChanged&&(this.cb.scrollLeft=C.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$zR=h;function F(O){const R={lazyRender:typeof O.lazyRender<"u"?O.lazyRender:!1,className:typeof O.className<"u"?O.className:"",useShadows:typeof O.useShadows<"u"?O.useShadows:!0,handleMouseWheel:typeof O.handleMouseWheel<"u"?O.handleMouseWheel:!0,flipAxes:typeof O.flipAxes<"u"?O.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof O.consumeMouseWheelIfScrollbarIsNeeded<"u"?O.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof O.alwaysConsumeMouseWheel<"u"?O.alwaysConsumeMouseWheel:!1,scrollYToX:typeof O.scrollYToX<"u"?O.scrollYToX:!1,mouseWheelScrollSensitivity:typeof O.mouseWheelScrollSensitivity<"u"?O.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof O.fastScrollSensitivity<"u"?O.fastScrollSensitivity:5,scrollPredominantAxis:typeof O.scrollPredominantAxis<"u"?O.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof O.mouseWheelSmoothScroll<"u"?O.mouseWheelSmoothScroll:!0,arrowSize:typeof O.arrowSize<"u"?O.arrowSize:11,listenOnDomNode:typeof O.listenOnDomNode<"u"?O.listenOnDomNode:null,horizontal:typeof O.horizontal<"u"?O.horizontal:1,horizontalScrollbarSize:typeof O.horizontalScrollbarSize<"u"?O.horizontalScrollbarSize:10,horizontalSliderSize:typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:0,horizontalHasArrows:typeof O.horizontalHasArrows<"u"?O.horizontalHasArrows:!1,vertical:typeof O.vertical<"u"?O.vertical:1,verticalScrollbarSize:typeof O.verticalScrollbarSize<"u"?O.verticalScrollbarSize:10,verticalHasArrows:typeof O.verticalHasArrows<"u"?O.verticalHasArrows:!1,verticalSliderSize:typeof O.verticalSliderSize<"u"?O.verticalSliderSize:0,scrollByPage:typeof O.scrollByPage<"u"?O.scrollByPage:!1};return R.horizontalSliderSize=typeof O.horizontalSliderSize<"u"?O.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof O.verticalSliderSize<"u"?O.verticalSliderSize:R.verticalScrollbarSize,r.$j&&(R.className+=" mac"),R}}),define(be[61],$e([1,0,54,3,22,25,60,12,9,27,4,2,47,48,83,120,6]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1R=t.$ZR=t.$YR=t.$XR=t.ListViewTargetSector=void 0;const d={CurrentDragAndDropData:void 0};var o;(function(B){B[B.TOP=0]="TOP",B[B.CENTER_TOP=1]="CENTER_TOP",B[B.CENTER_BOTTOM=2]="CENTER_BOTTOM",B[B.BOTTOM=3]="BOTTOM"})(o||(t.ListViewTargetSector=o={}));const $={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(B){return[B]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class c{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$XR=c;class f{constructor(v){this.elements=v}update(){}getData(){return this.elements}}t.$YR=f;class h{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let C=0;C<v.files.length;C++){const V=v.files.item(C);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$ZR=h;function F(B,v){return Array.isArray(B)&&Array.isArray(v)?(0,S.$ub)(B,v):B===v}class O{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(C,V,U)=>U,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(C,V)=>V+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=C=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=C=>{}}}class R{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const C of this.d)this.Z(C);this.W(),this.q.setScrollDimensions({width:(0,P.$$P)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,C,V,U=$){if(this.R=C,this.domId=`list_id_${++R.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new b.$3g(50),this.v=!1,this.x=M.$Tc.None,this.y=0,this.G=!1,this.K=M.$Tc.None,this.L=M.$Tc.None,this.M=new M.$Sc,this.N=new y.$Vd,this.O=new y.$Vd,this.onDidChangeContentHeight=y.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=y.Event.latch(this.O.event,void 0,this.M),this.P=!1,U.horizontalScrolling&&U.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$VR(U.paddingTop??0);for(const L of V)this.j.set(L.templateId,L);this.h=this.M.add(new s.$WR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof U.mouseSupport=="boolean"?U.mouseSupport:!0),this.P=U.horizontalScrolling??$.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof U.paddingBottom>"u"?0:U.paddingBottom,this.D=new O(U.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(U.transformOptimization??$.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(j.$jR.addTarget(this.o)),this.p=this.M.add(new u.$ls({forceIntegerValues:!0,smoothScrollDuration:U.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,P.$VP)((0,P.getWindow)(this.domNode),L)})),this.q=this.M.add(new A.$yR(this.o,{alwaysConsumeMouseWheel:U.alwaysConsumeMouseWheel??$.alwaysConsumeMouseWheel,horizontal:1,vertical:U.verticalScrollMode??$.verticalScrollMode,useShadows:U.useShadows??$.useShadows,mouseWheelScrollSensitivity:U.mouseWheelScrollSensitivity,fastScrollSensitivity:U.fastScrollSensitivity,scrollByPage:U.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.hb,this,this.M),this.M.add((0,P.$LP)(this.o,j.EventType.Change,L=>this.ib(L))),this.M.add((0,P.$LP)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,P.$LP)(this.domNode,"dragover",L=>this.kb(this.gb(L)))),this.M.add((0,P.$LP)(this.domNode,"drop",L=>this.mb(this.gb(L)))),this.M.add((0,P.$LP)(this.domNode,"dragleave",L=>this.lb(this.gb(L)))),this.M.add((0,P.$LP)(this.domNode,"dragend",L=>this.nb(L))),this.z=U.setRowLineHeight??$.setRowLineHeight,this.A=U.setRowHeight??$.setRowHeight,this.B=U.supportDynamicHeights??$.supportDynamicHeights,this.F=U.dnd??this.M.add($.dnd),this.layout(U.initialSize?.height,U.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let C;if(v.scrollByPage!==void 0&&(C={...C??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(C={...C??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(C={...C??{},fastScrollSensitivity:v.fastScrollSensitivity}),C&&this.q.updateOptions(C),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const V=this.ub(this.k,this.m),U=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.X(V,Math.max(0,this.k+U),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,C,V){if(v<0||v>=this.d.length)return;const U=this.d[v].size;if(typeof C>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,C=U+this.wb(v)}if(U===C)return;const T=this.ub(this.k,this.m);let L=0;v<T.start||V!==null&&V>v&&V<T.end?L=C-U:L=0,this.g.splice(v,1,[{size:C}]),this.d[v].size=C,this.X(T,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.U(),this.B&&this.vb(this.k,this.m)}splice(v,C,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.S(v,C,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}S(v,C,V=[]){const U=this.ub(this.k,this.m),T={start:v,end:v+C},L=r.Range.intersect(U,T),z=new Map;for(let G=L.end-1;G>=L.start;G--){const ue=this.d[G];if(ue.dragStartDisposable.dispose(),ue.checkedDisposable.dispose(),ue.row){let me=z.get(ue.templateId);me||(me=[],z.set(ue.templateId,me));const Se=this.j.get(ue.templateId);Se&&Se.disposeElement&&Se.disposeElement(ue.element,G,ue.row.templateData,ue.size),me.push(ue.row)}ue.row=null}const X={start:v+C,end:this.d.length},Y=r.Range.intersect(X,U),fe=r.Range.relativeComplement(X,U),le=V.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.$Tc.None,checkedDisposable:M.$Tc.None}));let ee;v===0&&C>=this.d.length?(this.g=new e.$VR(this.g.paddingTop),this.g.splice(0,0,le),ee=this.d,this.d=le):(this.g.splice(v,C,le),ee=this.d.splice(v,C,...le));const ge=V.length-C,Le=this.ub(this.k,this.m),Ne=(0,e.$TR)(Y,ge),Be=r.Range.intersect(Le,Ne);for(let G=Be.start;G<Be.end;G++)this.ab(this.d[G],G);const ne=r.Range.relativeComplement(Ne,Le);for(const G of ne)for(let ue=G.start;ue<G.end;ue++)this.bb(ue);const J=fe.map(G=>(0,e.$TR)(G,ge)),oe=[{start:v,end:v+V.length},...J].map(G=>r.Range.intersect(Le,G)),W=this.xb(oe);for(const G of oe)for(let ue=G.start;ue<G.end;ue++){const me=this.d[ue],ke=z.get(me.templateId)?.pop();this.Y(ue,W,ke)}for(const G of z.values())for(const ue of G)this.h.release(ue);return this.U(),this.B&&this.vb(this.scrollTop,this.renderHeight),ee.map(G=>G.element)}U(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,P.$VP)((0,P.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.W(),this.t=null}))}V(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.W())}W(){if(!this.Q)return;let v=0;for(const C of this.d)typeof C.width<"u"&&(v=Math.max(v,C.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const C=this.d[v];this.Z(C),typeof C.width<"u"&&C.width>this.E&&(this.E=C.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.vb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.ub(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,C=this.g.positionAt(v),V=this.g.positionAt(v+1);return V!==-1&&(V-C)/2+C<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.ub(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(C=>C.element===v)}domElement(v){const C=this.d[v].row;return C&&C.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,C){const V={height:typeof v=="number"?v:(0,P.$aQ)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof C<"u"&&(this.n=C,this.B&&this.vb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,P.$$P)(this.domNode)})}X(v,C,V,U,T,L=!1){const z=this.ub(C,V),X=r.Range.relativeComplement(z,v),Y=r.Range.relativeComplement(v,z),fe=this.xb(X);if(L){const le=r.Range.intersect(v,z);for(let ee=le.start;ee<le.end;ee++)this.ab(this.d[ee],ee)}this.h.transact(()=>{for(const le of Y)for(let ee=le.start;ee<le.end;ee++)this.bb(ee);for(const le of X)for(let ee=le.start;ee<le.end;ee++)this.Y(ee,fe)}),U!==void 0&&(this.o.style.left=`-${U}px`),this.o.style.top=`-${C}px`,this.Q&&T!==void 0&&(this.o.style.width=`${Math.max(T,this.n)}px`),this.k=C,this.m=V}Y(v,C,V){const U=this.d[v];let T=!1;if(!U.row)if(V)U.row=V;else{const fe=this.h.alloc(U.templateId);U.row=fe.row,T=fe.isReusingConnectedDomNode}const L=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",L);const z=this.D.isChecked(U.element);if(typeof z=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!z));else if(z){const fe=le=>U.row.domNode.setAttribute("aria-checked",String(!!le));fe(z.value),U.checkedDisposable=z.onDidChange(fe)}(T||!U.row.domNode.parentElement)&&(C?this.o.insertBefore(U.row.domNode,C):this.o.appendChild(U.row.domNode)),this.ab(U,v);const X=this.j.get(U.templateId);if(!X)throw new Error(`No renderer found for template id ${U.templateId}`);X?.renderElement(U.element,v,U.row.templateData,U.size);const Y=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!Y,Y&&(U.dragStartDisposable=(0,P.$LP)(U.row.domNode,"dragstart",fe=>this.jb(U.element,Y,fe))),this.Q&&(this.Z(U),this.V())}Z(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,P.$$P)(v.row.domNode);const C=(0,P.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);C.paddingLeft&&(v.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(v.width+=parseFloat(C.paddingRight)),v.row.domNode.style.width=""}ab(v,C){v.row.domNode.style.top=`${this.elementTop(C)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${C}`),v.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,C,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,C))),v.row.domNode.setAttribute("id",this.getElementDomId(C)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}bb(v){const C=this.d[v];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const V=this.j.get(C.templateId);V&&V.disposeElement&&V.disposeElement(C.element,v,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.Q&&this.V()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"click")).event,v=>this.db(v),this.M)}get onMouseDblClick(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"dblclick")).event,v=>this.db(v),this.M)}get onMouseMiddleClick(){return y.Event.filter(y.Event.map(this.M.add(new n.$NR(this.domNode,"auxclick")).event,v=>this.db(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"mouseup")).event,v=>this.db(v),this.M)}get onMouseDown(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"mousedown")).event,v=>this.db(v),this.M)}get onMouseOver(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"mouseover")).event,v=>this.db(v),this.M)}get onMouseMove(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"mousemove")).event,v=>this.db(v),this.M)}get onMouseOut(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"mouseout")).event,v=>this.db(v),this.M)}get onContextMenu(){return y.Event.any(y.Event.map(this.M.add(new n.$NR(this.domNode,"contextmenu")).event,v=>this.db(v),this.M),y.Event.map(this.M.add(new n.$NR(this.domNode,j.EventType.Contextmenu)).event,v=>this.fb(v),this.M))}get onTouchStart(){return y.Event.map(this.M.add(new n.$NR(this.domNode,"touchstart")).event,v=>this.eb(v),this.M)}get onTap(){return y.Event.map(this.M.add(new n.$NR(this.o,j.EventType.Tap)).event,v=>this.fb(v),this.M)}db(v){const C=this.tb(v.target||null),V=typeof C>"u"?void 0:this.d[C],U=V&&V.element;return{browserEvent:v,index:C,element:U}}eb(v){const C=this.tb(v.target||null),V=typeof C>"u"?void 0:this.d[C],U=V&&V.element;return{browserEvent:v,index:C,element:U}}fb(v){const C=this.tb(v.initialTarget||null),V=typeof C>"u"?void 0:this.d[C],U=V&&V.element;return{browserEvent:v,index:C,element:U}}gb(v){const C=this.tb(v.target||null),V=typeof C>"u"?void 0:this.d[C],U=V&&V.element,T=this.sb(v,C);return{browserEvent:v,index:C,element:U,sector:T}}hb(v){try{const C=this.ub(this.k,this.m);this.X(C,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.vb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",v),C}}ib(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}jb(v,C,V){if(!V.dataTransfer)return;const U=this.F.getDragElements(v);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(k.$hR.TEXT,C),V.dataTransfer.setDragImage){let T;this.F.getDragLabel&&(T=this.F.getDragLabel(U,V)),typeof T>"u"&&(T=String(U.length));const L=(0,P.$)(".monaco-drag-image");L.textContent=T;const X=(Y=>{for(;Y&&!Y.classList.contains("monaco-workbench");)Y=Y.parentElement;return Y||this.domNode.ownerDocument})(this.domNode);X.appendChild(L),V.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>X.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new c(U),d.CurrentDragAndDropData=new f(U),this.F.onDragStart?.(this.H,V)}kb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),d.CurrentDragAndDropData&&d.CurrentDragAndDropData.getData()==="vscode-ui"||(this.pb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if(d.CurrentDragAndDropData)this.H=d.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new h}const C=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof C=="boolean"?C:C.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect?.type===0?"copy":"move";let V;typeof C!="boolean"&&C.feedback?V=C.feedback:typeof v.index>"u"?V=[-1]:V=[v.index],V=(0,S.$Mb)(V).filter(T=>T>=-1&&T<this.length).sort((T,L)=>T-L),V=V[0]===-1?[-1]:V;const U=typeof C!="boolean"&&C.effect&&C.effect.position?C.effect.position:"drop-target";if(F(this.I,V)&&this.J===U)return!0;if(this.I=V,this.J=U,this.K.dispose(),V[0]===-1)this.domNode.classList.add(U),this.o.classList.add(U),this.K=(0,M.$Rc)(()=>{this.domNode.classList.remove(U),this.o.classList.remove(U)});else{if(V.length>1&&U!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");for(const T of V){const L=this.d[T];L.dropTarget=!0,L.row?.domNode.classList.add(U)}this.K=(0,M.$Rc)(()=>{for(const T of V){const L=this.d[T];L.dropTarget=!1,L.row?.domNode.classList.remove(U)}})}return!0}lb(v){this.L.dispose(),this.L=(0,b.$8g)(()=>this.ob(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}mb(v){if(!this.G)return;const C=this.H;this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,d.CurrentDragAndDropData=void 0,!(!C||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),C.update(v.browserEvent.dataTransfer),this.F.drop(C,v.element,v.index,v.sector,v.browserEvent))}nb(v){this.G=!1,this.rb(),this.ob(),this.domNode.classList.remove("dragging"),this.H=void 0,d.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}ob(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=M.$Tc.None}pb(v){if(!this.w){const C=(0,P.$5P)(this.domNode).top;this.w=(0,P.$2Q)((0,P.getWindow)(this.domNode),this.qb.bind(this,C))}this.x.dispose(),this.x=(0,b.$8g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}qb(v){if(this.y===void 0)return;const C=this.y-v,V=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-V))))}rb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}sb(v,C){if(C===void 0)return;const V=v.offsetY/this.d[C].size;return Math.floor(V/.25)}tb(v){const C=this.q.getDomNode();let V=v;for(;V instanceof HTMLElement&&V!==this.o&&C.contains(V);){const U=V.getAttribute("data-index");if(U){const T=Number(U);if(!isNaN(T))return T}V=V.parentElement}}ub(v,C){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+C-1)}}vb(v,C,V){const U=this.ub(v,C);let T,L;v===this.elementTop(U.start)?(T=U.start,L=0):U.end-U.start>1&&(T=U.start+1,L=this.elementTop(T)-v);let z=0;for(;;){const X=this.ub(v,C);let Y=!1;for(let fe=X.start;fe<X.end;fe++){const le=this.wb(fe);le!==0&&this.g.splice(fe,1,[this.d[fe]]),z+=le,Y=Y||le!==0}if(!Y){z!==0&&this.U();const fe=r.Range.relativeComplement(U,X);for(const ee of fe)for(let ge=ee.start;ge<ee.end;ge++)this.d[ge].row&&this.bb(ge);const le=r.Range.relativeComplement(X,U);for(const ee of le)for(let ge=ee.start;ge<ee.end;ge++){const Le=ge+1,Ne=Le<this.d.length?this.d[Le].row:null,Be=Ne?Ne.domNode:null;this.Y(ge,Be)}for(let ee=X.start;ee<X.end;ee++)this.d[ee].row&&this.ab(this.d[ee],ee);if(typeof T=="number"){const ee=this.p.getFutureScrollPosition().scrollTop-v,ge=this.elementTop(T)-L+ee;this.setScrollTop(ge,V)}this.N.fire(this.contentHeight);return}}}wb(v){const C=this.d[v];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(C.element);if(L!==null){const z=C.size;return C.size=L,C.lastDynamicHeightWidth=this.n,L-z}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(C.element))return 0;const V=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.lastDynamicHeightWidth=this.n,C.size-V;const{row:U}=this.h.alloc(C.templateId);U.domNode.style.height="",this.o.appendChild(U.domNode);const T=this.j.get(C.templateId);if(!T)throw new m.$cb("Missing renderer for templateId: "+C.templateId);return T.renderElement(C.element,v,U.templateData,void 0),C.size=U.domNode.offsetHeight,T.disposeElement?.(C.element,v,U.templateData,void 0),this.R.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,this.o.removeChild(U.domNode),this.h.release(U),C.size-V}xb(v){const C=v[v.length-1];if(!C)return null;const V=this.d[C.end];return!V||!V.row?null:V.row.domNode}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const C=this.j.get(v.row.templateId);C&&(C.disposeElement?.(v.element,-1,v.row.templateData,void 0),C.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$1R=R,Xe([w.$xh],R.prototype,"onMouseClick",null),Xe([w.$xh],R.prototype,"onMouseDblClick",null),Xe([w.$xh],R.prototype,"onMouseMiddleClick",null),Xe([w.$xh],R.prototype,"onMouseUp",null),Xe([w.$xh],R.prototype,"onMouseDown",null),Xe([w.$xh],R.prototype,"onMouseOver",null),Xe([w.$xh],R.prototype,"onMouseMove",null),Xe([w.$xh],R.prototype,"onMouseOut",null),Xe([w.$xh],R.prototype,"onContextMenu",null),Xe([w.$xh],R.prototype,"onTouchStart",null),Xe([w.$xh],R.prototype,"onTap",null)}),define(be[39],$e([1,0,3,22,14,25,57,71,12,9,74,27,4,34,2,46,5,7,70,61,19,98]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s,m,d,o,$,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=t.$fS=t.$eS=t.$dS=t.$cS=t.$bS=t.$aS=t.TypeNavigationMode=t.$_R=t.$$R=t.$0R=t.$9R=t.$8R=t.$7R=t.$6R=t.$5R=void 0;class f{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,D,p){const l=this.c.findIndex(i=>i.templateData===p);if(l>=0){const i=this.c[l];this.d.unrender(p),i.index=D}else{const i={index:D,templateData:p};this.c.push(i)}this.d.renderIndex(D,p)}splice(g,D,p){const l=[];for(const i of this.c)i.index<g?l.push(i):i.index>=g+D&&l.push({index:i.index+p-D,templateData:i.templateData});this.c=l}renderIndexes(g){for(const{index:D,templateData:p}of this.c)g.indexOf(D)>-1&&this.d.renderIndex(D,p)}disposeTemplate(g){const D=this.c.findIndex(p=>p.templateData===g);D<0||this.c.splice(D,1)}}class h{get name(){return this.g}get renderer(){return new f(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new r.$Vd,this.onChange=this.f.event}splice(g,D,p){const l=p.length-D,i=g+D,a=[];let E=0;for(;E<this.d.length&&this.d[E]<g;)a.push(this.d[E++]);for(let I=0;I<p.length;I++)p[I]&&a.push(I+g);for(;E<this.d.length&&this.d[E]>=i;)a.push(this.d[E++]+l);this.renderer.splice(g,D,p.length),this.h(a,a)}renderIndex(g,D){D.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,D){return this.h(g,[...g].sort(ue),D)}h(g,D,p){const l=this.c,i=this.d;this.c=g,this.d=D;const a=W(i,g);return this.renderer.renderIndexes(a),this.f.fire({indexes:g,browserEvent:p}),l}get(){return this.c}contains(g){return(0,b.$wb)(this.d,g,ue)>=0}dispose(){(0,e.$Oc)(this.f)}}Xe([M.$xh],h.prototype,"renderer",null);class F extends h{constructor(g){super("selected"),this.k=g}renderIndex(g,D){super.renderIndex(g,D),this.k&&(this.contains(g)?D.setAttribute("aria-selected","true"):D.setAttribute("aria-selected","false"))}}class O{constructor(g,D,p){this.c=g,this.d=D,this.f=p}splice(g,D,p){if(!this.f)return this.c.splice(g,D,new Array(p.length).fill(!1));const l=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(l.length===0)return this.c.splice(g,D,new Array(p.length).fill(!1));const i=new Set(l),a=p.map(E=>i.has(this.f.getId(E).toString()));this.c.splice(g,D,a)}}function R(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}t.$5R=R;function B(K,g){return K.classList.contains(g)?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:B(K.parentElement,g)}function v(K){return B(K,"monaco-editor")}t.$6R=v;function C(K){return B(K,"monaco-custom-toggle")}t.$7R=C;function V(K){return B(K,"action-item")}t.$8R=V;function U(K){return B(K,"monaco-tl-twistie")}t.$9R=U;function T(K){return B(K,"monaco-tree-sticky-row")}t.$0R=T;function L(K){return K.classList.contains("monaco-tree-sticky-container")}t.$$R=L;function z(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:z(K.parentElement)}t.$_R=z;class X{get g(){return r.Event.chain(this.c.add(new P.$NR(this.k.domNode,"keydown")).event,g=>g.filter(D=>!R(D.target)).map(D=>new n.$IP(D)))}constructor(g,D,p){this.h=g,this.k=D,this.c=new e.$Sc,this.d=new e.$Sc,this.f=p.multipleSelectionSupport,this.c.add(this.g(l=>{switch(l.keyCode){case 3:return this.l(l);case 16:return this.o(l);case 18:return this.p(l);case 11:return this.q(l);case 12:return this.s(l);case 9:return this.u(l);case 31:this.f&&(m.$j?l.metaKey:l.ctrlKey)&&this.t(l)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const D=this.h.getFocus()[0];this.h.setAnchor(D),this.h.reveal(D),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,b.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([M.$xh],X.prototype,"g",null);var Y;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(Y||(t.TypeNavigationMode=Y={}));var fe;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(fe||(fe={})),t.$aS=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class le{constructor(g,D,p,l,i){this.o=g,this.p=D,this.q=p,this.s=l,this.t=i,this.c=!1,this.d=fe.Idle,this.f=Y.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??Y.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const D=r.Event.chain(this.k.add(new P.$NR(this.p.domNode,"keydown")).event,i=>i.filter(a=>!R(a.target)).filter(()=>this.f===Y.Automatic||this.g).map(a=>new n.$IP(a)).filter(a=>g||this.s(a)).filter(a=>this.t.mightProducePrintableCharacter(a)).forEach(a=>k.$HQ.stop(a,!0)).map(a=>a.browserEvent.key)),p=r.Event.debounce(D,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(D,p),(i,a)=>a===null?null:(i||"")+a,void 0,this.k)(this.x,this,this.k),p(this.w,this,this.k),D(()=>g=!0,void 0,this.k),p(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const D=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));D&&(0,A.$PR)(D)}this.h=-1}x(g){if(!g){this.d=fe.Idle,this.g=!1;return}const D=this.o.getFocus(),p=D.length>0?D[0]:0,l=this.d===fe.Idle?1:0;this.d=fe.Typing;for(let i=0;i<this.o.length;i++){const a=(p+i+l)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(a)),I=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof I<"u"){if((0,u.$Uj)(g,I)){this.h=p,this.o.setFocus([a]),this.o.reveal(a);return}const N=(0,u.$2j)(g,I);if(N&&N[0].end-N[0].start>1&&N.length===1){this.h=p,this.o.setFocus([a]),this.o.reveal(a);return}}}else if(typeof I>"u"||(0,u.$Uj)(g,I)){this.h=p,this.o.setFocus([a]),this.o.reveal(a);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ee{constructor(g,D){this.d=g,this.f=D,this.c=new e.$Sc;const p=r.Event.chain(this.c.add(new P.$NR(D.domNode,"keydown")).event,i=>i.filter(a=>!R(a.target)).map(a=>new n.$IP(a)));r.Event.chain(p,i=>i.filter(a=>a.keyCode===2&&!a.ctrlKey&&!a.metaKey&&!a.shiftKey&&!a.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const D=this.d.getFocus();if(D.length===0)return;const p=this.f.domElement(D[0]);if(!p)return;const l=p.querySelector("[tabIndex]");if(!l||!(l instanceof HTMLElement)||l.tabIndex===-1)return;const i=(0,k.getWindow)(l).getComputedStyle(l);i.visibility==="hidden"||i.display==="none"||(g.preventDefault(),g.stopPropagation(),l.focus())}dispose(){this.c.dispose()}}function ge(K){return m.$j?K.browserEvent.metaKey:K.browserEvent.ctrlKey}t.$bS=ge;function Le(K){return K.browserEvent.shiftKey}t.$cS=Le;function Ne(K){return(0,k.$BQ)(K)&&K.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Le};class ne{constructor(g){this.k=g,this.f=new e.$Sc,this.g=new r.$Vd,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(j.$jR.addTarget(g.getHTMLElement()))),r.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){v(g.browserEvent.target)||(0,k.$lQ)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(R(g.browserEvent.target)||v(g.browserEvent.target))return;const D=typeof g.index>"u"?[]:[g.index];this.k.setFocus(D,g.browserEvent)}u(g){if(!this.d||R(g.browserEvent.target)||v(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const D=g.index;if(typeof D>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([D],g.browserEvent),this.k.setAnchor(D),Ne(g.browserEvent)||this.k.setSelection([D],g.browserEvent),this.g.fire(g)}v(g){if(R(g.browserEvent.target)||v(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const D=this.k.getFocus();this.k.setSelection(D,g.browserEvent)}w(g){const D=g.index;let p=this.k.getAnchor();if(this.p(g)){typeof p>"u"&&(p=this.k.getFocus()[0]??D,this.k.setAnchor(p));const l=Math.min(p,D),i=Math.max(p,D),a=(0,b.$Sb)(l,i+1),E=this.k.getSelection(),I=oe(W(E,[p]),p);if(I.length===0)return;const N=W(a,G(E,I));this.k.setSelection(N,g.browserEvent),this.k.setFocus([D],g.browserEvent)}else if(this.o(g)){const l=this.k.getSelection(),i=l.filter(a=>a!==D);this.k.setFocus([D]),this.k.setAnchor(D),l.length===i.length?this.k.setSelection([...i,D],g.browserEvent):this.k.setSelection(i,g.browserEvent)}}dispose(){this.f.dispose()}}t.$dS=ne;class J{constructor(g,D){this.c=g,this.d=D}style(g){const D=this.d&&`.${this.d}`,p=[];g.listBackground&&p.push(`.monaco-list${D} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(p.push(`.monaco-list${D}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),p.push(`.monaco-list${D}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&p.push(`.monaco-list${D}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(p.push(`.monaco-list${D}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),p.push(`.monaco-list${D}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&p.push(`.monaco-list${D}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&p.push(`.monaco-list${D}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&p.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&p.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(p.push(`.monaco-list${D} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),p.push(`.monaco-list${D} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&p.push(`.monaco-list${D} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(p.push(`.monaco-list${D} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),p.push(`.monaco-list${D} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(p.push(`.monaco-list${D} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),p.push(`.monaco-list${D} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&p.push(`.monaco-list${D} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&p.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&p.push(`.monaco-list${D}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const l=(0,k.$5Q)(g.listFocusAndSelectionOutline,(0,k.$5Q)(g.listSelectionOutline,g.listFocusOutline??""));l&&p.push(`.monaco-list${D}:focus .monaco-list-row.focused.selected { outline: 1px solid ${l}; outline-offset: -1px;}`),g.listFocusOutline&&p.push(`
				.monaco-drag-image,
				.monaco-list${D}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${D}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,k.$5Q)(g.listSelectionOutline,g.listInactiveFocusOutline??"");i&&p.push(`.monaco-list${D} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),g.listSelectionOutline&&p.push(`.monaco-list${D} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&p.push(`.monaco-list${D} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&p.push(`.monaco-list${D} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&p.push(`
				.monaco-list${D}.drop-target,
				.monaco-list${D} .monaco-list-rows.drop-target,
				.monaco-list${D} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(p.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${D} .monaco-list-row.drop-target-after + .monaco-list-row::before,
			.monaco-list${D} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),p.push(`
			.monaco-list${D} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${D} .monaco-list-row:last-child.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&p.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&p.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=p.join(`
`)}}t.$eS=J,t.$fS={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:y.$mt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:y.$mt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:y.$mt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const se={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function oe(K,g){const D=K.indexOf(g);if(D===-1)return[];const p=[];let l=D-1;for(;l>=0&&K[l]===g-(D-l);)p.push(K[l--]);for(p.reverse(),l=D;l<K.length&&K[l]===g+(l-D);)p.push(K[l++]);return p}function W(K,g){const D=[];let p=0,l=0;for(;p<K.length||l<g.length;)if(p>=K.length)D.push(g[l++]);else if(l>=g.length)D.push(K[p++]);else if(K[p]===g[l]){D.push(K[p]),p++,l++;continue}else K[p]<g[l]?D.push(K[p++]):D.push(g[l++]);return D}function G(K,g){const D=[];let p=0,l=0;for(;p<K.length||l<g.length;)if(p>=K.length)D.push(g[l++]);else if(l>=g.length)D.push(K[p++]);else if(K[p]===g[l]){p++,l++;continue}else K[p]<g[l]?D.push(K[p++]):l++;return D}const ue=(K,g)=>K-g;class me{constructor(g,D){this.c=g,this.d=D}get templateId(){return this.c}renderTemplate(g){return this.d.map(D=>D.renderTemplate(g))}renderElement(g,D,p,l){let i=0;for(const a of this.d)a.renderElement(g,D,p[i++],l)}disposeElement(g,D,p,l){let i=0;for(const a of this.d)a.disposeElement?.(g,D,p[i],l),i+=1}disposeTemplate(g){let D=0;for(const p of this.d)p.disposeTemplate(g[D++])}}class Se{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,D,p){const l=this.c.getAriaLabel(g);l?p.setAttribute("aria-label",l):p.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof i=="number"?p.setAttribute("aria-level",`${i}`):p.removeAttribute("aria-level")}disposeTemplate(g){}}class ke{constructor(g,D){this.c=g,this.d=D}getDragElements(g){const D=this.c.getSelectedElements();return D.indexOf(g)>-1?D:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,D){if(this.d.getDragLabel)return this.d.getDragLabel(g,D)}onDragStart(g,D){this.d.onDragStart?.(g,D)}onDragOver(g,D,p,l,i){return this.d.onDragOver(g,D,p,l,i)}onDragLeave(g,D,p,l){this.d.onDragLeave?.(g,D,p,l)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,D,p,l,i){this.d.drop(g,D,p,l,i)}dispose(){this.d.dispose()}}class Ce{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const D=r.Event.chain(this.y.add(new P.$NR(this.k.domNode,"keydown")).event,i=>i.map(a=>new n.$IP(a)).filter(a=>g=a.keyCode===58||a.shiftKey&&a.keyCode===68).map(a=>k.$HQ.stop(a,!0)).filter(()=>!1)),p=r.Event.chain(this.y.add(new P.$NR(this.k.domNode,"keyup")).event,i=>i.forEach(()=>g=!1).map(a=>new n.$IP(a)).filter(a=>a.keyCode===58||a.shiftKey&&a.keyCode===68).map(a=>k.$HQ.stop(a,!0)).map(({browserEvent:a})=>{const E=this.getFocus(),I=E.length?E[0]:void 0,N=typeof I<"u"?this.k.element(I):void 0,H=typeof I<"u"?this.k.domElement(I):this.k.domNode;return{index:I,element:N,anchor:H,browserEvent:a}})),l=r.Event.chain(this.k.onContextMenu,i=>i.filter(a=>!g).map(({element:a,index:E,browserEvent:I})=>({element:a,index:E,anchor:new c.$DP((0,k.getWindow)(this.k.domNode),I),browserEvent:I})));return r.Event.any(D,p,l)}get onKeyDown(){return this.y.add(new P.$NR(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new P.$NR(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new P.$NR(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new P.$NR(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new P.$NR(this.k.domNode,"blur",!0)).event)}constructor(g,D,p,l,i=se){this.A=g,this.B=i,this.c=new h("focused"),this.f=new h("anchor"),this.g=new r.$4d,this.x="",this.y=new e.$Sc,this.z=new r.$Vd,this.onDidDispose=this.z.event;const a=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(a!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(E.push(new Se(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),l=l.map(N=>new me(N.templateId,[...E,N]));const I={...i,dnd:i.dnd&&new ke(this,i.dnd)};if(this.k=this.C(D,p,l,I),this.k.domNode.setAttribute("role",a),i.styleController)this.q=i.styleController(this.k.domId);else{const N=(0,k.$uQ)(this.k.domNode);this.q=new J(N,this.k.domId)}if(this.o=new S.$RR([new O(this.c,this.k,i.identityProvider),new O(this.d,this.k,i.identityProvider),new O(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ee(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new X(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const N=i.keyboardNavigationDelegate||t.$aS;this.t=new le(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),N),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,D,p,l){return new $.$1R(g,D,p,l)}D(g){return new ne(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,D,p=[]){if(g<0||g>this.k.length)throw new o.$3R(this.A,`Invalid start index: ${g}`);if(D<0)throw new o.$3R(this.A,`Invalid delete count: ${D}`);D===0&&p.length===0||this.g.bufferEvents(()=>this.o.splice(g,D,p))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,D){this.k.updateElementHeight(g,D,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}indexAt(g){return this.k.indexAt(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,D){this.k.layout(g,D)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,D){for(const p of g)if(p<0||p>=this.length)throw new o.$3R(this.A,`Invalid index ${p}`);this.d.set(g,D)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new o.$3R(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,b.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,D){for(const p of g)if(p<0||p>=this.length)throw new o.$3R(this.A,`Invalid index ${p}`);this.c.set(g,D)}focusNext(g=1,D=!1,p,l){if(this.length===0)return;const i=this.c.get(),a=this.E(i.length>0?i[0]+g:0,D,l);a>-1&&this.setFocus([a],p)}focusPrevious(g=1,D=!1,p,l){if(this.length===0)return;const i=this.c.get(),a=this.F(i.length>0?i[0]-g:0,D,l);a>-1&&this.setFocus([a],p)}async focusNextPage(g,D){let p=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);p=p===0?0:p-1;const l=this.getFocus()[0];if(l!==p&&(l===void 0||p>l)){const i=this.F(p,!1,D);i>-1&&l!==i?this.setFocus([i],g):this.setFocus([p],g)}else{const i=this.k.getScrollTop();let a=i+this.k.renderHeight;p>l&&(a-=this.k.elementHeight(p)),this.k.setScrollTop(a),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,w.$7g)(0),await this.focusNextPage(g,D))}}async focusPreviousPage(g,D,p=()=>0){let l;const i=p(),a=this.k.getScrollTop()+i;a===0?l=this.k.indexAt(a):l=this.k.indexAfter(a-1);const E=this.getFocus()[0];if(E!==l&&(E===void 0||E>=l)){const I=this.E(l,!1,D);I>-1&&E!==I?this.setFocus([I],g):this.setFocus([l],g)}else{const I=a;this.k.setScrollTop(a-this.k.renderHeight-i),this.k.getScrollTop()+p()!==I&&(this.setFocus([]),await(0,w.$7g)(0),await this.focusPreviousPage(g,D,p))}}focusLast(g,D){if(this.length===0)return;const p=this.F(this.length-1,!1,D);p>-1&&this.setFocus([p],g)}focusFirst(g,D){this.focusNth(0,g,D)}focusNth(g,D,p){if(this.length===0)return;const l=this.E(g,!1,p);l>-1&&this.setFocus([l],D)}E(g,D=!1,p){for(let l=0;l<this.length;l++){if(g>=this.length&&!D)return-1;if(g=g%this.length,!p||p(this.element(g)))return g;g++}return-1}F(g,D=!1,p){for(let l=0;l<this.length;l++){if(g<0&&!D)return-1;if(g=(this.length+g%this.length)%this.length,!p||p(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,D,p=0){if(g<0||g>=this.length)throw new o.$3R(this.A,`Invalid index ${g}`);const l=this.k.getScrollTop(),i=this.k.elementTop(g),a=this.k.elementHeight(g);if((0,d.$Mf)(D)){const E=a-this.k.renderHeight+p;this.k.setScrollTop(E*(0,s.$7l)(D,0,1)+i-p)}else{const E=i+a,I=l+this.k.renderHeight;i<l+p&&E>=I||(i<l+p||E>=I&&a>=this.k.renderHeight?this.k.setScrollTop(i-p):E>=I&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(g,D=0){if(g<0||g>=this.length)throw new o.$3R(this.A,`Invalid index ${g}`);const p=this.k.getScrollTop(),l=this.k.elementTop(g),i=this.k.elementHeight(g);if(l<p+D||l+i>p+this.k.renderHeight)return null;const a=i-this.k.renderHeight+D;return Math.abs((p+D-l)/a)}isDOMFocused(){return(0,k.$mQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:D}){return{indexes:g,elements:g.map(p=>this.k.element(p)),browserEvent:D}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let D;this.u?.getActiveDescendantId&&(D=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",D||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$gS=Ce,Xe([M.$xh],Ce.prototype,"onDidChangeFocus",null),Xe([M.$xh],Ce.prototype,"onDidChangeSelection",null),Xe([M.$xh],Ce.prototype,"onContextMenu",null),Xe([M.$xh],Ce.prototype,"onKeyDown",null),Xe([M.$xh],Ce.prototype,"onKeyUp",null),Xe([M.$xh],Ce.prototype,"onKeyPress",null),Xe([M.$xh],Ce.prototype,"onDidFocus",null),Xe([M.$xh],Ce.prototype,"onDidBlur",null)}),define(be[62],$e([1,0,6,35,37,10,15]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.MarkdownStringTextNewlineStyle=void 0;var S;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(S||(t.MarkdownStringTextNewlineStyle=S={}));class b{constructor(o="",$=!1){if(this.value=o,typeof this.value!="string")throw(0,k.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(o,$=0){return this.value+=r(this.supportThemeIcons?(0,P.$bk)(o):o).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,$){return this.value+=`
${u($,o)}
`,this}appendLink(o,$,c){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(o),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(o,$){const c=new RegExp((0,j.$Oe)($),"g");return o.replace(c,(f,h)=>o.charAt(h-1)!=="\\"?`\\${f}`:f)}}t.$hk=b;function w(d){return y(d)?!d.value:Array.isArray(d)?d.every(w):!0}t.$ik=w;function y(d){return d instanceof b?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}t.$jk=y;function M(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,n.$Ag)(A.URI.from(d.baseUri),A.URI.from(o.baseUri)))}t.$kk=M;function r(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$lk=r;function u(d,o){const $=d.match(/^`+/gm)?.reduce((f,h)=>f.length>h.length?f:h).length??0,c=$>=3?$+1:3;return[`${"`".repeat(c)}${o}`,d,`${"`".repeat(c)}`].join(`
`)}t.$mk=u;function e(d){return d.replace(/"/g,"&quot;")}t.$nk=e;function s(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$ok=s;function m(d){const o=[],$=d.split("|").map(f=>f.trim());d=$[0];const c=$[1];if(c){const f=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),F=f?f[1]:"",O=h?h[1]:"",R=isFinite(parseInt(O)),B=isFinite(parseInt(F));R&&o.push(`width="${O}"`),B&&o.push(`height="${F}"`)}return{href:d,dimensions:o}}t.$pk=m}),define(be[126],$e([1,0,3,118,22,55,14,19,119,6,4,62,35,77,23,2,79,53,31,51,37,10,15]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s,m,d,o,$,c,f,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nS=t.$mS=t.$lS=t.$kS=t.$jS=void 0;const F=Object.freeze({image:(W,G,ue)=>{let me=[],Se=[];return W&&({href:W,dimensions:me}=(0,M.$pk)(W),Se.push(`src="${(0,M.$nk)(W)}"`)),ue&&Se.push(`alt="${(0,M.$nk)(ue)}"`),G&&Se.push(`title="${(0,M.$nk)(G)}"`),me.length&&(Se=Se.concat(me)),"<img "+Se.join(" ")+">"},paragraph:W=>`<p>${W}</p>`,link:(W,G,ue)=>typeof W!="string"?"":(W===ue&&(ue=(0,M.$ok)(ue)),G=typeof G=="string"?(0,M.$nk)((0,M.$ok)(G)):"",W=(0,M.$ok)(W),W=W.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${W}" title="${G||W}" draggable="false">${ue}</a>`)});function O(W,G={},ue={}){const me=new s.$Sc;let Se=!1;const ke=(0,j.$MR)(G),Ce=function(I){let N;try{N=(0,d.$Bh)(decodeURIComponent(I))}catch{}return N?(N=(0,$.$xn)(N,H=>{if(W.uris&&W.uris[H])return h.URI.revive(W.uris[H])}),encodeURIComponent(JSON.stringify(N))):I},K=function(I,N){const H=W.uris&&W.uris[I];let _=h.URI.revive(H);return N?I.startsWith(o.Schemas.data+":")?I:(_||(_=h.URI.parse(I)),o.$og.uriToBrowserUri(_).toString(!0)):!_||h.URI.parse(I).toString()===_.toString()?I:(_.query&&(_=_.with({query:Ce(_.query)})),_.toString())},g=new m.marked.Renderer;g.image=F.image,g.link=F.link,g.paragraph=F.paragraph;const D=[],p=[];if(G.codeBlockRendererSync?g.code=(I,N)=>{const H=u.$nN.nextId(),_=G.codeBlockRendererSync(R(N),I);return p.push([H,_]),`<div class="code" data-code="${H}">${(0,f.$Ne)(I)}</div>`}:G.codeBlockRenderer&&(g.code=(I,N)=>{const H=u.$nN.nextId(),_=G.codeBlockRenderer(R(N),I);return D.push(_.then(Z=>[H,Z])),`<div class="code" data-code="${H}">${(0,f.$Ne)(I)}</div>`}),G.actionHandler){const I=function(_){let Z=_.target;if(!(Z.tagName!=="A"&&(Z=Z.parentElement,!Z||Z.tagName!=="A")))try{let he=Z.dataset.href;he&&(W.baseUri&&(he=B(h.URI.from(W.baseUri),he)),G.actionHandler.callback(he,_))}catch(he){(0,w.$1)(he)}finally{_.preventDefault()}},N=G.actionHandler.disposables.add(new n.$NR(ke,"click")),H=G.actionHandler.disposables.add(new n.$NR(ke,"auxclick"));G.actionHandler.disposables.add(y.Event.any(N.event,H.event)(_=>{const Z=new S.$DP(k.getWindow(ke),_);!Z.leftButton&&!Z.middleButton||I(Z)})),G.actionHandler.disposables.add(k.$LP(ke,"keydown",_=>{const Z=new A.$IP(_);!Z.equals(10)&&!Z.equals(3)||I(Z)}))}W.supportHtml||(ue.sanitizer=I=>(W.isTrusted?I.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?I:"",ue.sanitize=!0,ue.silent=!0),ue.renderer=g;let l=W.value??"";l.length>1e5&&(l=`${l.substr(0,1e5)}\u2026`),W.supportThemeIcons&&(l=(0,r.$ck)(l));let i;if(G.fillInIncompleteTokens){const I={...m.marked.defaults,...ue},N=m.marked.lexer(l,I),H=Y(N);i=m.marked.parser(H,I)}else i=m.marked.parse(l,ue);W.supportThemeIcons&&(i=(0,b.$hS)(i).map(N=>typeof N=="string"?N:N.outerHTML).join(""));const E=new DOMParser().parseFromString(v(W,i),"text/html");if(E.body.querySelectorAll("img").forEach(I=>{const N=I.getAttribute("src");if(N){let H=N;try{W.baseUri&&(H=B(h.URI.from(W.baseUri),H))}catch{}I.src=K(H,!0)}}),E.body.querySelectorAll("a").forEach(I=>{const N=I.getAttribute("href");if(I.setAttribute("href",""),!N||/^data:|javascript:/i.test(N)||/^command:/i.test(N)&&!W.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(N))I.replaceWith(...I.childNodes);else{let H=K(N,!1);W.baseUri&&(H=B(h.URI.from(W.baseUri),N)),I.dataset.href=H}}),ke.innerHTML=v(W,E.body.innerHTML),D.length>0)Promise.all(D).then(I=>{if(Se)return;const N=new Map(I),H=ke.querySelectorAll("div[data-code]");for(const _ of H){const Z=N.get(_.dataset.code??"");Z&&k.$OQ(_,Z)}G.asyncRenderCallback?.()});else if(p.length>0){const I=new Map(p),N=ke.querySelectorAll("div[data-code]");for(const H of N){const _=I.get(H.dataset.code??"");_&&k.$OQ(H,_)}}if(G.asyncRenderCallback)for(const I of ke.getElementsByTagName("img")){const N=me.add(k.$LP(I,"load",()=>{N.dispose(),G.asyncRenderCallback()}))}return{element:ke,dispose:()=>{Se=!0,me.dispose()}}}t.$jS=O;function R(W){if(!W)return"";const G=W.split(/[\s+|:|,|\{|\?]/,1);return G.length?G[0]:W}function B(W,G){return/^\w[\w\d+.-]*:/.test(G)?G:W.path.endsWith("/")?(0,c.$Kg)(W,G).toString():(0,c.$Kg)((0,c.$Gg)(W),G).toString()}function v(W,G){const{config:ue,allowedSchemes:me}=C(W);P.addHook("uponSanitizeAttribute",(ke,Ce)=>{if(Ce.attrName==="style"||Ce.attrName==="class"){if(ke.tagName==="SPAN"){if(Ce.attrName==="style"){Ce.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ce.attrValue);return}else if(Ce.attrName==="class"){Ce.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ce.attrValue);return}}Ce.keepAttr=!1;return}else if(ke.tagName==="INPUT"&&ke.attributes.getNamedItem("type")?.value==="checkbox"){if(Ce.attrName==="type"&&Ce.attrValue==="checkbox"||Ce.attrName==="disabled"||Ce.attrName==="checked"){Ce.keepAttr=!0;return}Ce.keepAttr=!1}}),P.addHook("uponSanitizeElement",(ke,Ce)=>{Ce.tagName==="input"&&(ke.attributes.getNamedItem("type")?.value==="checkbox"?ke.setAttribute("disabled",""):ke.parentElement?.removeChild(ke))});const Se=k.$9Q(me);try{return P.sanitize(G,{...ue,RETURN_TRUSTED_TYPE:!0})}finally{P.removeHook("uponSanitizeAttribute"),Se.dispose()}}t.$kS=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function C(W){const G=[o.Schemas.http,o.Schemas.https,o.Schemas.mailto,o.Schemas.data,o.Schemas.file,o.Schemas.vscodeFileResource,o.Schemas.vscodeRemote,o.Schemas.vscodeRemoteResource];return W.isTrusted&&G.push(o.Schemas.command),{config:{ALLOWED_TAGS:[...k.$0Q],ALLOWED_ATTR:t.$kS,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:G}}function V(W){return typeof W=="string"?W:U(W)}t.$lS=V;function U(W){let G=W.value??"";G.length>1e5&&(G=`${G.substr(0,1e5)}\u2026`);const ue=m.marked.parse(G,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,me=>T.get(me)??me);return v({isTrusted:!1},ue).toString()}t.$mS=U;const T=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new e.$V(()=>{const W=new m.marked.Renderer;return W.code=G=>G,W.blockquote=G=>G,W.html=G=>"",W.heading=(G,ue,me)=>G+`
`,W.hr=()=>"",W.list=(G,ue)=>G,W.listitem=G=>G+`
`,W.paragraph=G=>G+`
`,W.table=(G,ue)=>G+ue+`
`,W.tablerow=G=>G,W.tablecell=(G,ue)=>G+" ",W.strong=G=>G,W.em=G=>G,W.codespan=G=>G,W.br=()=>`
`,W.del=G=>G,W.image=(G,ue,me)=>"",W.text=G=>G,W.link=(G,ue,me)=>me,W});function z(W){let G="";return W.forEach(ue=>{G+=ue.raw}),G}function X(W){for(let G=0;G<W.tokens.length;G++){const ue=W.tokens[G];if(ue.type==="text"){const me=ue.raw.split(`
`),Se=me[me.length-1];if(Se.includes("`"))return le(W);if(Se.includes("**"))return ne(W);if(Se.match(/\*\w/))return ee(W);if(Se.match(/(^|\s)__\w/))return J(W);if(Se.match(/(^|\s)_\w/))return ge(W);if(Se.match(/(^|\s)\[.*\]\(\w*/)){const ke=W.tokens.slice(G+1);return ke[0]?.type==="link"&&ke[1]?.type==="text"&&ke[1].raw.match(/^ *"[^"]*$/)?Ne(W):Le(W)}else if(Se.match(/(^|\s)\[\w/))return Be(W)}}}function Y(W){let G,ue;for(G=0;G<W.length;G++){const me=W[G];if(me.type==="paragraph"&&me.raw.match(/(\n|^)```/)){ue=fe(W.slice(G));break}if(me.type==="paragraph"&&me.raw.match(/(\n|^)\|/)){ue=oe(W.slice(G));break}if(G===W.length-1&&me.type==="paragraph"){const Se=X(me);if(Se){ue=[Se];break}}}if(ue){const me=[...W.slice(0,G),...ue];return me.links=W.links,me}return W}t.$nS=Y;function fe(W){const G=z(W);return m.marked.lexer(G+"\n```")}function le(W){return se(W,"`")}function ee(W){return se(W,"*")}function ge(W){return se(W,"_")}function Le(W){return se(W,")")}function Ne(W){return se(W,'")')}function Be(W){return se(W,"](about:blank)")}function ne(W){return se(W,"**")}function J(W){return se(W,"__")}function se(W,G){const ue=z(Array.isArray(W)?W:[W]);return m.marked.lexer(ue+G)[0]}function oe(W){const G=z(W),ue=G.split(`
`);let me,Se=!1;for(let ke=0;ke<ue.length;ke++){const Ce=ue[ke].trim();if(typeof me>"u"&&Ce.match(/^\s*\|/)){const K=Ce.match(/(\|[^\|]+)(?=\||$)/g);K&&(me=K.length)}else if(typeof me=="number")if(Ce.match(/^\s*\|/)){if(ke!==ue.length-1)return;Se=!0}else return}if(typeof me=="number"&&me>0){const ke=Se?ue.slice(0,-1).join(`
`):G,Ce=!!ke.match(/\|\s*$/),K=ke+(Ce?"":"|")+`
|${" --- |".repeat(me)}`;return m.marked.lexer(K)}}}),define(be[127],$e([1,0,3,9,29,62,35,2,7,108]),function(ie,t,k,P,n,j,A,S,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=t.$DR=void 0;function y(u,e){(0,b.$If)(e)?u.title=(0,A.$dk)(e):e?.markdownNotSupportedFallback?u.title=e.markdownNotSupportedFallback:u.removeAttribute("title")}t.$DR=y;class M{constructor(e,s,m){this.c=e,this.d=s,this.f=m}async update(e,s,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let d;if(e===void 0||(0,b.$If)(e)||e instanceof HTMLElement)d=e;else if(!(0,b.$Wf)(e.markdown))d=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,w.localize)(0,null),s),this.b=new n.$6d;const o=this.b.token;if(d=await e.markdown(o),d===void 0&&(d=e.markdownNotSupportedFallback),this.isDisposed||o.isCancellationRequested)return}this.g(d,s,m)}g(e,s,m){const d=this.a;if(this.h(e)){const o={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!d},position:{hoverPosition:2},...m};this.a=this.c.showHover(o,s)}d?.dispose()}h(e){return e?(0,j.$jk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(u,e,s,m){let d,o;const $=(U,T)=>{const L=o!==void 0;U&&(o?.dispose(),o=void 0),T&&(d?.dispose(),d=void 0),L&&u.onDidHideHover?.()},c=(U,T,L)=>new P.$dh(async()=>{(!o||o.isDisposed)&&(o=new M(u,L||e,U>0),await o.update(s,T,m))},U);let f=!1;const h=k.$LP(e,k.$FQ.MOUSE_DOWN,()=>{f=!0,$(!0,!0)},!0),F=k.$LP(e,k.$FQ.MOUSE_UP,()=>{f=!1},!0),O=k.$LP(e,k.$FQ.MOUSE_LEAVE,U=>{f=!1,$(!1,U.fromElement===e)},!0),R=()=>{if(d)return;const U=new S.$Sc,T={targetElements:[e],dispose:()=>{}};if(u.placement===void 0||u.placement==="mouse"){const L=z=>{T.x=z.x+10,z.target instanceof HTMLElement&&z.target.classList.contains("action-label")&&$(!0,!0)};U.add(k.$LP(e,k.$FQ.MOUSE_MOVE,L,!0))}U.add(c(u.delay,!1,T)),d=U},B=k.$LP(e,k.$FQ.MOUSE_OVER,R,!0),v=()=>{if(f||d)return;const U={targetElements:[e],dispose:()=>{}},T=new S.$Sc,L=()=>$(!0,!0);T.add(k.$LP(e,k.$FQ.BLUR,L,!0)),T.add(c(u.delay,!1,U)),d=T},C=k.$LP(e,k.$FQ.FOCUS,v,!0);return{show:U=>{$(!1,!0),c(0,U)},hide:()=>{$(!0,!0)},update:async(U,T)=>{s=U,await o?.update(s,void 0,T)},dispose:()=>{B.dispose(),O.dispose(),h.dispose(),F.dispose(),C.dispose(),$(!0,!0)}}}t.$ER=r}),define(be[128],$e([1,0,3,22,14,126,39,12,4,44,2,5,110,101]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=void 0;const u=k.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(o){const $=Object.create(null);return $.root=o,$.text=k.$MQ(o,u(".option-text")),$.detail=k.$MQ(o,u(".option-detail")),$.decoratorRight=k.$MQ(o,u(".option-decorator-right")),$}renderElement(o,$,c){const f=c,h=o.text,F=o.detail,O=o.decoratorRight,R=o.isDisabled;f.text.textContent=h,f.detail.textContent=F||"",f.decoratorRight.innerText=O||"",R?f.root.classList.add("option-disabled"):f.root.classList.remove("option-disabled")}disposeTemplate(o){}}class m extends y.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(o,$,c,f,h){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=f,this.g=h||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=m.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new b.$Vd,this.B(this.r),this.O(),this.N(c),this.n=$||0,o&&this.setOptions(o,$),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(o){this.u=o,this.w=k.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=k.$MQ(this.w,u(".select-box-details-pane"));const $=k.$MQ(this.w,u(".select-box-dropdown-container-width-control")),c=k.$MQ($,u(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",k.$MQ(c,this.D),this.G=0,this.y=k.$uQ(this.w),this.w.setAttribute("draggable","true"),this.B(k.$LP(this.w,k.$FQ.DRAG_START,f=>{k.$HQ.stop(f,!0)}))}O(){this.B(k.$MP(this.h,"change",$=>{this.n=$.target.selectedIndex,this.r.fire({index:$.target.selectedIndex,selected:$.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(k.$LP(this.h,k.$FQ.CLICK,$=>{k.$HQ.stop($),this.f?this.X(!0):this.W()})),this.B(k.$LP(this.h,k.$FQ.MOUSE_DOWN,$=>{k.$HQ.stop($)}));let o;this.B(k.$LP(this.h,"touchstart",$=>{o=this.f})),this.B(k.$LP(this.h,"touchend",$=>{k.$HQ.stop($),o?this.X(!0):this.W()})),this.B(k.$LP(this.h,k.$FQ.KEY_DOWN,$=>{const c=new n.$IP($);let f=!1;M.$j?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(f=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(f=!0),f&&(this.W(),k.$HQ.stop($,!0))}))}get onDidSelect(){return this.r.event}setOptions(o,$){S.$ub(this.m,o)||(this.m=o,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((c,f)=>{this.h.add(this.U(c.text,f,c.isDisabled)),typeof c.description=="string"&&(this.H=!0)})),$!==void 0&&(this.select($),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(o){o>=0&&o<this.m.length?this.n=o:o>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(o){this.g.ariaLabel=o,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(o){this.h.tabIndex=o?0:-1}render(o){this.j=o,o.classList.add("select-container"),o.appendChild(this.h),this.R()}Q(){const o=[];this.s.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=o.join(`
`)}R(){const o=this.s.selectBackground??"",$=this.s.selectForeground??"",c=this.s.selectBorder??"";this.h.style.backgroundColor=o,this.h.style.color=$,this.h.style.borderColor=c}S(){const o=this.s.selectBackground??"",$=k.$5Q(this.s.selectListBackground,o);this.C.style.backgroundColor=$,this.I.style.backgroundColor=$;const c=this.s.focusBorder??"";this.w.style.outlineColor=c,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(o,$,c){const f=document.createElement("option");return f.value=o,f.text=o,f.disabled=!!c,f}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:o=>this.Y(o),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(o){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),o&&this.h.focus(),this.u.hideContextView())}Y(o,$){return o.appendChild(this.w),this.ab($),{dispose:()=>{try{o.removeChild(this.w)}catch{}}}}Z(){let o=0;return this.m.forEach(($,c)=>{this.hb(c),this.I.offsetHeight>o&&(o=this.I.offsetHeight)}),o}ab(o){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const $=k.getWindow(this.h),c=k.$8P(this.h),f=k.getWindow(this.h).getComputedStyle(this.h),h=parseFloat(f.getPropertyValue("--dropdown-padding-top"))+parseFloat(f.getPropertyValue("--dropdown-padding-bottom")),F=$.innerHeight-c.top-c.height-(this.g.minBottomMargin||0),O=c.top-m.b,R=this.h.offsetWidth,B=this.bb(this.D),v=Math.max(B,Math.round(R)).toString()+"px";this.w.style.width=v,this.z.getHTMLElement().style.height="",this.z.layout();let C=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const V=this.H?this.L:0,U=C+h+V,T=Math.floor((F-h-V)/this.getHeight()),L=Math.floor((O-h-V)/this.getHeight());if(o)return c.top+c.height>$.innerHeight-22||c.top<m.b||T<1&&L<1?!1:(T<m.c&&L>T&&this.m.length>T?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(c.top+c.height>$.innerHeight-22||c.top<m.b||this.G===0&&T<1||this.G===1&&L<1)return this.X(!0),!1;if(this.G===0){if(this.f&&T+L<1)return this.X(!0),!1;U>F&&(C=T*this.getHeight())}else U>O&&(C=L*this.getHeight());return this.z.layout(C),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=C+h+"px",this.w.style.height=""):this.w.style.height=C+h+"px",this.hb(this.n),this.w.style.width=v,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(o){let $=0;if(o){let c=0,f=0;this.m.forEach((h,F)=>{const O=h.detail?h.detail.length:0,R=h.decoratorRight?h.decoratorRight.length:0,B=h.text.length+O+R;B>f&&(c=F,f=B)}),o.textContent=this.m[c].text+(this.m[c].decoratorRight?this.m[c].decoratorRight+" ":""),$=k.$0P(o)}return $}cb(o){if(this.z)return;this.C=k.$MQ(o,u(".select-box-dropdown-list-container")),this.t=new s,this.z=new A.$gS("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:f=>{let h=f.text;return f.detail&&(h+=`. ${f.detail}`),f.decoratorRight&&(h+=`. ${f.decoratorRight}`),f.description&&(h+=`. ${f.description}`),h},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>M.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const $=this.B(new P.$NR(this.C,"keydown")),c=b.Event.chain($.event,f=>f.filter(()=>this.z.length>0).map(h=>new n.$IP(h)));this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===3))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===2))(this.jb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===9))(this.ib,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===16))(this.lb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===18))(this.kb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===12))(this.nb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===11))(this.mb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===14))(this.ob,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode===13))(this.pb,this)),this.B(b.Event.chain(c,f=>f.filter(h=>h.keyCode>=21&&h.keyCode<=56||h.keyCode>=85&&h.keyCode<=113))(this.qb,this)),this.B(k.$LP(this.z.getHTMLElement(),k.$FQ.POINTER_UP,f=>this.db(f))),this.B(this.z.onMouseOver(f=>typeof f.index<"u"&&this.z.setFocus([f.index]))),this.B(this.z.onDidChangeFocus(f=>this.gb(f))),this.B(k.$LP(this.w,k.$FQ.FOCUS_OUT,f=>{!this.f||k.$dQ(f.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(o){if(!this.z.length)return;k.$HQ.stop(o);const $=o.target;if(!$||$.classList.contains("slider"))return;const c=$.closest(".monaco-list-row");if(!c)return;const f=Number(c.getAttribute("data-index")),h=c.classList.contains("option-disabled");f>=0&&f<this.m.length&&!h&&(this.n=f,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(o,$){const c=h=>{for(let F=0;F<h.childNodes.length;F++){const O=h.childNodes.item(F);(O.tagName&&O.tagName.toLowerCase())==="img"?h.removeChild(O):c(O)}},f=(0,j.$jS)({value:o,supportThemeIcons:!0},{actionHandler:$});return f.element.classList.add("select-box-description-markdown"),c(f.element),f.element}gb(o){!this.f||!this.H||this.hb(o.indexes[0])}hb(o){this.I.innerText="";const $=this.m[o],c=$?.description??"",f=$?.descriptionIsMarkdown??!1;if(c){if(f){const h=$.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(c,h))}else this.I.innerText=c;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(o){k.$HQ.stop(o),this.select(this.F),this.X(!0)}jb(o){k.$HQ.stop(o),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(o){if(this.n<this.m.length-1){k.$HQ.stop(o,!0);const $=this.m[this.n+1].isDisabled;if($&&this.m.length>this.n+2)this.n+=2;else{if($)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(o){this.n>0&&(k.$HQ.stop(o,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(o){k.$HQ.stop(o),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(o){k.$HQ.stop(o),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(o){k.$HQ.stop(o),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(o){k.$HQ.stop(o),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(o){const $=w.KeyCodeUtils.toString(o.keyCode);let c=-1;for(let f=0;f<this.m.length-1;f++)if(c=(f+this.n+1)%this.m.length,this.m[c].text.charAt(0).toUpperCase()===$&&!this.m[c].isDisabled){this.select(c),this.z.setFocus([c]),this.z.reveal(this.z.getFocus()[0]),k.$HQ.stop(o);break}}dispose(){this.X(!1),super.dispose()}}t.$oS=m}),define(be[129],$e([1,0,39,128,122,20,5,100]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rS=t.$qS=void 0,t.$qS={...k.$fS,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class S extends j.$nR{constructor(w,y,M,r,u){super(),A.$j&&!u?.useCustomDrawn?this.a=new n.$pS(w,y,r,u):this.a=new P.$oS(w,y,M,r,u),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(w,y){this.a.setOptions(w,y)}select(w){this.a.select(w)}setAriaLabel(w){this.a.setAriaLabel(w)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(w){this.a.setFocusable(w)}render(w){this.a.render(w)}}t.$rS=S}),define(be[63],$e([1,0,16,54,3,25,127,129,36,2,5,7,105,52]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zS=t.$yS=t.$xS=void 0;class u extends w.$Tc{get action(){return this._action}constructor(d,o,$={}){super(),this.m=$,this._context=d||this,this._action=o,o instanceof b.$Ki&&this.B(o.onDidChange(c=>{this.element&&this.t(c)}))}t(d){d.enabled!==void 0&&this.u(),d.checked!==void 0&&this.H(),d.class!==void 0&&this.G(),d.label!==void 0&&(this.w(),this.D()),d.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new b.$Li)),this.j}set actionRunner(d){this.j=d}isEnabled(){return this._action.enabled}setActionContext(d){this._context=d}render(d){const o=this.element=d;this.B(j.$jR.addTarget(d));const $=this.m&&this.m.draggable;$&&(d.draggable=!0,k.$rP&&this.B((0,n.$LP)(d,n.$FQ.DRAG_START,c=>c.dataTransfer?.setData(P.$hR.TEXT,this._action.label)))),this.B((0,n.$LP)(o,j.EventType.Tap,c=>this.onClick(c,!0))),this.B((0,n.$LP)(o,n.$FQ.MOUSE_DOWN,c=>{$||n.$HQ.stop(c,!0),this._action.enabled&&c.button===0&&o.classList.add("active")})),y.$j&&this.B((0,n.$LP)(o,n.$FQ.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this.B((0,n.$LP)(o,n.$FQ.CLICK,c=>{n.$HQ.stop(c,!0),this.m&&this.m.isMenu||this.onClick(c)})),this.B((0,n.$LP)(o,n.$FQ.DBLCLICK,c=>{n.$HQ.stop(c,!0)})),[n.$FQ.MOUSE_UP,n.$FQ.MOUSE_OUT].forEach(c=>{this.B((0,n.$LP)(o,c,f=>{n.$HQ.stop(f),o.classList.remove("active")}))})}onClick(d,o=!1){n.$HQ.stop(d,!0);const $=M.$Rf(this._context)?this.m?.useEventAsContext?d:{preserveFocus:o}:this._context;this.actionRunner.run(this._action,$)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(d){this.element&&(this.element.tabIndex=d?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const d=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(d):(this.f=(0,A.$ER)(this.m.hoverDelegate,this.element,d),this.q.add(this.f))):this.element.title=d}F(){if(this.element){const d=this.C()??"";this.element.setAttribute("aria-label",d)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$xS=u;class e extends u{constructor(d,o,$){super(d,o,$),this.m=$,this.m.icon=$.icon!==void 0?$.icon:!1,this.m.label=$.label!==void 0?$.label:!0,this.L=""}render(d){super.render(d),M.$Sf(this.element);const o=document.createElement("a");if(o.classList.add("action-label"),o.setAttribute("role",this.M()),this.I=o,this.element.appendChild(o),this.m.label&&this.m.keybinding){const $=document.createElement("span");$.classList.add("keybinding"),$.textContent=this.m.keybinding,this.element.appendChild($)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===b.$Mi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(d){this.I&&(this.I.tabIndex=d?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let d=null;return this.action.tooltip?d=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(d=this.action.label,this.m.keybinding&&(d=r.localize(0,null,d,this.m.keybinding))),d??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const d=this.C()??"";this.I.setAttribute("aria-label",d)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$yS=e;class s extends u{constructor(d,o,$,c,f,h,F){super(d,o),this.b=new S.$rS($,c,f,h,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(d,o){this.b.setOptions(d,o)}select(d){this.b.select(d)}g(){this.B(this.b.onDidSelect(d=>this.n(d.selected,d.index)))}n(d,o){this.actionRunner.run(this._action,this.r(d,o))}r(d,o){return d}setFocusable(d){this.b.setFocusable(d)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(d){this.b.render(d)}}t.$zS=s}),define(be[64],$e([1,0,3,14,63,36,4,2,7,52]),function(ie,t,k,P,n,j,A,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=t.$FR=t.ActionsOrientation=void 0;var w;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class y extends S.$Tc{constructor(u,e={}){super(),this.g=this.B(new S.$Sc),this.r=this.B(new S.$3c),this.w=!1,this.y=!0,this.C=this.B(new A.$Vd),this.onDidBlur=this.C.event,this.D=this.B(new A.$Vd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new A.$Vd),this.onDidRun=this.G.event,this.H=this.B(new A.$Vd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new j.$Li,this.g.add(this.f)),this.g.add(this.f.onDidRun(d=>this.G.fire(d))),this.g.add(this.f.onWillRun(d=>this.H.fire(d))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,m;switch(this.m){case 0:s=[15],m=[17];break;case 1:s=[16],m=[18],this.domNode.className+=" vertical";break}this.B(k.$LP(this.domNode,k.$FQ.KEY_DOWN,d=>{const o=new P.$IP(d);let $=!0;const c=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(o.equals(s[0])||o.equals(s[1]))?$=this.P():m&&(o.equals(m[0])||o.equals(m[1]))?$=this.O():o.equals(9)&&this.F?this.D.fire():o.equals(14)?$=this.M():o.equals(13)?$=this.N():o.equals(2)&&c instanceof n.$xS&&c.trapsArrowNavigation?$=this.O():this.J(o)?this.n.keyDown?this.R(o):this.w=!0:$=!1,$&&(o.preventDefault(),o.stopPropagation())})),this.B(k.$LP(this.domNode,k.$FQ.KEY_UP,d=>{const o=new P.$IP(d);this.J(o)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(o)),o.preventDefault(),o.stopPropagation()):(o.equals(2)||o.equals(1026)||o.equals(16)||o.equals(18)||o.equals(15)||o.equals(17))&&this.L()})),this.u=this.B(k.$KQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(k.$lQ()===this.domNode||!k.$dQ(k.$lQ(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),u.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(u){u?this.z.setAttribute("aria-label",u):this.z.removeAttribute("aria-label")}setFocusable(u){if(this.y=u,this.y){const e=this.viewItems.find(s=>s instanceof n.$xS&&s.isEnabled());e instanceof n.$xS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$xS&&e.setFocusable(!1)})}J(u){let e=!1;return this.n.keys.forEach(s=>{e=e||u.equals(s)}),e}L(){for(let u=0;u<this.z.children.length;u++){const e=this.z.children[u];if(k.$dQ(k.$lQ(),e)){this.t=u,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(u){this.j=u,this.viewItems.forEach(e=>e.setActionContext(u))}get actionRunner(){return this.f}set actionRunner(u){this.f=u,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=u)}getContainer(){return this.domNode}hasAction(u){return this.viewItems.findIndex(e=>e.action.id===u.id)!==-1}getAction(u){if(typeof u=="number")return this.viewItems[u]?.action;if(u instanceof HTMLElement){for(;u.parentElement!==this.z;){if(!u.parentElement)return;u=u.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===u)return this.viewItems[e].action}}push(u,e={}){const s=Array.isArray(u)?u:[u];let m=b.$Mf(e.index)?e.index:null;s.forEach(d=>{const o=document.createElement("li");o.className="action-item",o.setAttribute("role","presentation");let $;const c={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&($=this.b.actionViewItemProvider(d,c)),$||($=new n.$yS(this.context,d,c)),this.b.allowContextMenu||this.r.set($,k.$LP(o,k.$FQ.CONTEXT_MENU,f=>{k.$HQ.stop(f,!0)})),$.actionRunner=this.f,$.setActionContext(this.context),$.render(o),this.y&&$ instanceof n.$xS&&this.viewItems.length===0&&$.setFocusable(!0),m===null||m<0||m>=this.z.children.length?(this.z.appendChild(o),this.viewItems.push($)):(this.z.insertBefore(o,this.z.children[m]),this.viewItems.splice(m,0,$),m++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(u){if(u>=0&&u<this.z.children.length){const e=this.z.children.item(u);if(e)return e.clientWidth}return 0}getHeight(u){if(u>=0&&u<this.z.children.length){const e=this.z.children.item(u);if(e)return e.clientHeight}return 0}pull(u){u>=0&&u<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[u]),this.r.deleteAndDispose(this.viewItems[u]),(0,S.$Oc)(this.viewItems.splice(u,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,S.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),k.$KP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(u){let e=!1,s;if(u===void 0?e=!0:typeof u=="number"?s=u:typeof u=="boolean"&&(e=u),e&&typeof this.t>"u"){const m=this.viewItems.findIndex(d=>d.isEnabled());this.t=m===-1?void 0:m,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(u){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!u&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===j.$Mi.ID));return this.Q(),!0}P(u){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!u&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===j.$Mi.ID));return this.Q(!0),!0}Q(u,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const m=this.t!==void 0?this.viewItems[this.t]:void 0;if(m){let d=!0;b.$Wf(m.focus)||(d=!1),this.b.focusOnlyEnabledItems&&b.$Wf(m.isEnabled)&&!m.isEnabled()&&(d=!1),m.action.id===j.$Mi.ID&&(d=!1),d?(s||this.s!==this.t)&&(m.focus(u),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),d&&m.showHover?.()}}R(u){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$xS){const s=e._context===null||e._context===void 0?u:e._context;this.run(e._action,s)}}async run(u,e){await this.f.run(u,e)}dispose(){this.j=void 0,this.viewItems=(0,S.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$FR=y;function M(r){if(!r.length)return r;let u=-1;for(let s=0;s<r.length;s++)if(r[s].id!==j.$Mi.ID){u=s;break}if(u===-1)return[];r=r.slice(u);for(let s=r.length-1;s>=0&&r[s].id===j.$Mi.ID;s--)r.splice(s,1);let e=!1;for(let s=r.length-1;s>=0;s--){const m=r[s].id===j.$Mi.ID;m&&!e?r.splice(s,1):m?m&&(e=!1):e=!0}return r}t.$GR=M}),define(be[65],$e([1,0,3,22,55,64,57,60,20,4,82,51,109,97]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=t.$dT=t.$cT=t.MessageType=void 0;const u=k.$;var e;(function(d){d[d.INFO=1]="INFO",d[d.WARNING=2]="WARNING",d[d.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$cT={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends b.$nR{constructor(o,$,c){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new w.$Vd),this.onDidChange=this.O.event,this.P=this.B(new w.$Vd),this.onDidHeightChange=this.P.event,this.a=$,this.g=c,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=k.$MQ(o,u(".monaco-inputbox.idle"));const f=this.g.flexibleHeight?"textarea":"input",h=k.$MQ(this.element,u(".ibwrapper"));if(this.b=k.$MQ(h,u(f+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=k.$MQ(h,u("div.mirror")),this.y.innerText="\xA0",this.N=new S.$xR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),k.$MQ(o,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new P.$NR(o.ownerDocument,"selectionchange")),O=w.Event.filter(F.event,()=>o.ownerDocument.getSelection()?.anchorNode===h);this.B(O(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new j.$FR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(o){this.n=o,this.b.setAttribute("placeholder",o)}setTooltip(o){this.r=o,this.b.title=o}setAriaLabel(o){this.s=o,o?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(o){this.b.value!==o&&(this.b.value=o,this.Y())}get step(){return this.b.step}set step(o){this.b.step=o}get height(){return typeof this.J=="number"?this.J:k.$bQ(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return k.$mQ(this.b)}select(o=null){this.b.select(),o&&(this.b.setSelectionRange(o.start,o.end),o.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(o){o?this.enable():this.disable()}get width(){return k.$0P(this.b)}set width(o){if(this.g.flexibleHeight&&this.g.flexibleWidth){let $=0;if(this.y){const c=parseFloat(this.y.style.paddingLeft||"")||0,f=parseFloat(this.y.style.paddingRight||"")||0;$=c+f}this.b.style.width=o-$+"px"}else this.b.style.width=o+"px";this.y&&(this.y.style.width=o+"px")}set paddingRight(o){this.b.style.width=`calc(100% - ${o}px)`,this.y&&(this.y.style.paddingRight=o+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const o=this.L,$=this.J,c=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:o,height:$}),this.N.setScrollPosition({scrollTop:c})}showMessage(o,$){if(this.w==="open"&&(0,M.$zn)(this.h,o))return;this.h=o,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(o.type));const c=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${k.$5Q(c.border,"transparent")}`,this.h.content&&(this.hasFocus()||$)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let o=null;return this.t&&(o=this.t(this.value),o?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(o)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),o?.type}stylesForType(o){const $=this.g.inputBoxStyles;switch(o){case 1:return{border:$.inputValidationInfoBorder,background:$.inputValidationInfoBackground,foreground:$.inputValidationInfoForeground};case 2:return{border:$.inputValidationWarningBorder,background:$.inputValidationWarningBackground,foreground:$.inputValidationWarningForeground};default:return{border:$.inputValidationErrorBorder,background:$.inputValidationErrorBackground,foreground:$.inputValidationErrorForeground}}}U(o){switch(o){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let o;const $=()=>o.style.width=k.$0P(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:f=>{if(!this.h)return null;o=k.$MQ(f,u(".monaco-inputbox-container")),$();const h={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,n.$LR)(this.h.content,h):(0,n.$KR)(this.h.content,h);F.classList.add(this.U(this.h.type));const O=this.stylesForType(this.h.type);return F.style.backgroundColor=O.background??"",F.style.color=O.foreground??"",F.style.border=O.border?`1px solid ${O.border}`:"",k.$MQ(o,F),null},onHide:()=>{this.w="closed"},layout:$});let c;this.h.type===3?c=r.localize(0,null,this.h.content):this.h.type===2?c=r.localize(1,null,this.h.content):c=r.localize(2,null,this.h.content),A.$PR(c),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const o=this.value,c=o.charCodeAt(o.length-1)===10?" ":"";(o+c).replace(/\u000c/g,"")?this.y.textContent=o+c:this.y.innerText="\xA0",this.layout()}ab(){const o=this.g.inputBoxStyles,$=o.inputBackground??"",c=o.inputForeground??"",f=o.inputBorder??"";this.element.style.backgroundColor=$,this.element.style.color=c,this.b.style.backgroundColor="inherit",this.b.style.color=c,this.element.style.border=`1px solid ${k.$5Q(f,"transparent")}`}layout(){if(!this.y)return;const o=this.L;this.L=k.$bQ(this.y),o!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(o){const $=this.inputElement,c=$.selectionStart,f=$.selectionEnd,h=$.value;c!==null&&f!==null&&(this.value=h.substr(0,c)+o+h.substr(f),$.setSelectionRange(c+1,c+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$dT=s;class m extends s{constructor(o,$,c){const f=r.localize(3,null,"\u21C5"),h=r.localize(4,null,"\u21C5");super(o,$,c),this.db=this.B(new w.$Vd),this.onDidFocus=this.db.event,this.eb=this.B(new w.$Vd),this.onDidBlur=this.eb.event,this.bb=new y.$aT(c.history,100);const F=()=>{if(c.showHistoryHint&&c.showHistoryHint()&&!this.n.endsWith(f)&&!this.n.endsWith(h)&&this.bb.getHistory().length){const O=this.n.endsWith(")")?f:h,R=this.n+O;c.showPlaceholderOnFocus&&!k.$mQ(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((O,R)=>{O.forEach(B=>{B.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const O=R=>{if(this.n.endsWith(R)){const B=this.n.slice(0,this.n.length-R.length);return c.showPlaceholderOnFocus?this.n=B:this.setPlaceHolder(B),!0}else return!1};O(h)||O(f)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(o){this.value&&(o||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(o){const $=this.getHistory();this.clearHistory(),o.forEach(c=>{this.bb.add(c)}),$.forEach(c=>{this.bb.add(c)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let o=this.jb();o&&(o=o===this.value?this.jb():o),this.value=o??"",A.$QR(this.value?this.value:r.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let o=this.ib();o&&(o=o===this.value?this.ib():o),o&&(this.value=o,A.$QR(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(o){super.setPlaceHolder(o),this.setTooltip(o)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let o=this.bb.current();return o||(o=this.bb.last(),this.bb.next()),o}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$eT=m}),define(be[66],$e([1,0,63,20,17,18,4,3,102]),function(ie,t,k,P,n,j,A,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wS=t.$vS=t.$uS=t.$tS=t.$sS=void 0,t.$sS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class b extends k.$xS{constructor(u,e,s){super(u,e,s),this.a=this.B(new w({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(u){this.element=u,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(u){this.a.domNode.tabIndex=u?0:-1}}t.$tS=b;class w extends P.$nR{constructor(u){super(),this.a=this.B(new A.$Vd),this.onChange=this.a.event,this.b=this.B(new A.$Vd),this.onKeyDown=this.b.event,this.c=u,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...j.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(u){this.s=u,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(u){this.g&&this.domNode.classList.remove(...j.ThemeIcon.asClassNameArray(this.g)),this.g=u,this.g&&this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(u){this.domNode.title=u,this.domNode.setAttribute("aria-label",u)}}t.$uS=w;class y extends P.$nR{constructor(u,e,s){super(),this.g=u,this.h=e,this.a=this.B(new A.$Vd),this.onChange=this.a.event,this.b=new w({title:this.g,isChecked:this.h,icon:n.$_j.check,actionClassName:"monaco-checkbox",...t.$sS}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(m=>{this.n(),this.a.fire(m)}))}get checked(){return this.b.checked}set checked(u){this.b.checked=u,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,S.$mQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$vS=y;class M extends k.$xS{constructor(u,e,s){super(u,e,s),this.a=this.B(new y(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(u){if(this.element=u,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,S.$)("span.checkbox-label",void 0,this._action.label));this.B((0,S.$LP)(e,S.$FQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(u){this.a.domNode.tabIndex=u?0:-1}}t.$wS=M}),define(be[130],$e([1,0,66,17,107]),function(ie,t,k,P,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=t.$qT=t.$pT=void 0;const j=n.localize(0,null),A=n.localize(1,null),S=n.localize(2,null);class b extends k.$uS{constructor(r){super({icon:P.$_j.caseSensitive,title:j+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$pT=b;class w extends k.$uS{constructor(r){super({icon:P.$_j.wholeWord,title:A+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$qT=w;class y extends k.$uS{constructor(r){super({icon:P.$_j.regex,title:S+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$rT=y}),define(be[131],$e([1,0,3,130,65,20,4,106,2,96]),function(ie,t,k,P,n,j,A,S,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=void 0;const w=S.localize(0,null);class y extends j.$nR{static{this.OPTION_CHANGE="optionChange"}constructor(r,u,e){super(),this.n=!0,this.s=!1,this.w=this.B(new b.$Uc),this.N=[],this.O=this.B(new A.$Vd),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$Vd),this.onKeyDown=this.P.event,this.Q=this.B(new A.$Vd),this.onMouseDown=this.Q.event,this.R=this.B(new A.$Vd),this.onInput=this.R.event,this.S=this.B(new A.$Vd),this.onKeyUp=this.S.event,this.U=this.B(new A.$Vd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$Vd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||w,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",m=e.appendWholeWordsLabel||"",d=e.appendRegexLabel||"",o=e.history||[],$=!!e.flexibleHeight,c=!!e.flexibleWidth,f=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$eT(this.domNode,u,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:o,showHistoryHint:e.showHistoryHint,flexibleHeight:$,flexibleWidth:c,flexibleMaxHeight:f,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new P.$rT({appendTitle:d,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new P.$qT({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new P.$pT({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const h=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const O=h.indexOf(this.domNode.ownerDocument.activeElement);if(O>=0){let R=-1;F.equals(17)?R=(O+1)%h.length:F.equals(15)&&(O===0?R=h.length-1:R=O-1),F.equals(9)?(h[O].blur(),this.inputBox.focus()):R>=0&&h[R].focus(),k.$HQ.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),r?.appendChild(this.domNode),this.B(k.$LP(this.inputBox.inputElement,"compositionstart",h=>{this.s=!0})),this.B(k.$LP(this.inputBox.inputElement,"compositionend",h=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,h=>this.P.fire(h)),this.C(this.inputBox.inputElement,h=>this.S.fire(h)),this.D(this.inputBox.inputElement,h=>this.R.fire()),this.j(this.inputBox.inputElement,h=>this.Q.fire(h))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.X(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const r of this.N)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const r of this.N)r.disable()}setFocusInputOnOptionClick(r){this.n=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const u of this.N)u.domNode.remove();this.N=[],this.w.value=new b.$Sc;for(const u of r??[])this.w.value.add(u),this.y.appendChild(u.domNode),this.w.value.add(u.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(u);this.N.length>0&&(this.y.style.display=""),this.X()}X(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((u,e)=>u+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(r){this.M&&(this.M.checked=r)}getWholeWords(){return this.L?.checked??!1}setWholeWords(r){this.L&&(this.L.checked=r)}getRegex(){return this.J?.checked??!1}setRegex(r){this.J&&(this.J.checked=r,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$sT=y}),define(be[132],$e([1,0,3,22,14,64,131,65,61,39,66,58,26,36,12,9,17,18,32,4,34,2,46,7,111,103]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s,m,d,o,$,c,f,h,F,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4T=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$3T=t.$2T=t.$1T=t.RenderIndentGuides=t.$ZT=t.$YT=void 0;class R extends b.$XR{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(a=>a.element)),this.c=i}}function B(l){return l instanceof b.$XR?new R(l):l}class v{constructor(i,a){this.d=i,this.f=a,this.b=f.$Tc.None,this.c=new f.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,a){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(E=>E.element),a)}onDragStart(i,a){this.f.onDragStart?.(B(i),a)}onDragOver(i,a,E,I,N,H=!0){const _=this.f.onDragOver(B(i),a&&a.element,E,I,N),Z=this.a!==a;if(Z&&(this.b.dispose(),this.a=a),typeof a>"u")return _;if(Z&&typeof _!="boolean"&&_.autoExpand&&(this.b=(0,s.$8g)(()=>{const Ee=this.d(),ve=Ee.getNodeLocation(a);Ee.isCollapsed(ve)&&Ee.setCollapsed(ve,!1),this.a=void 0},500,this.c)),typeof _=="boolean"||!_.accept||typeof _.bubble>"u"||_.feedback){if(!H){const Ee=typeof _=="boolean"?_:_.accept,ve=typeof _=="boolean"?void 0:_.effect;return{accept:Ee,effect:ve,feedback:[E]}}return _}if(_.bubble===1){const Ee=this.d(),ve=Ee.getNodeLocation(a),Pe=Ee.getParentNodeLocation(ve),Ie=Ee.getNode(Pe),Me=Pe&&Ee.getListIndex(Pe);return this.onDragOver(i,Ie,Me,I,N,!1)}const he=this.d(),pe=he.getNodeLocation(a),ye=he.getListIndex(pe),we=he.getListRenderCount(pe);return{..._,feedback:(0,e.$Sb)(ye,ye+we)}}drop(i,a,E,I,N){this.b.dispose(),this.a=void 0,this.f.drop(B(i),a&&a.element,E,I,N)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function C(l,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(a){return i.identityProvider.getId(a.element)}},dnd:i.dnd&&new v(l,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(a){return i.multipleSelectionController.isSelectionSingleChangeEvent({...a,element:a.element})},isSelectionRangeChangeEvent(a){return i.multipleSelectionController.isSelectionRangeChangeEvent({...a,element:a.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(a){const E=l(),I=E.getNodeLocation(a),N=E.getParentNodeLocation(I);return E.getNode(N).visibleChildrenCount},getPosInSet(a){return a.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?a=>i.accessibilityProvider.isChecked(a.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?a=>i.accessibilityProvider.getRole(a.element):()=>"treeitem",getAriaLabel(a){return i.accessibilityProvider.getAriaLabel(a.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?a=>i.accessibilityProvider.getAriaLevel(a.element):a=>a.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(a=>i.accessibilityProvider.getActiveDescendantId(a.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(a){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(a.element)}}}}class V{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,a){this.a.setDynamicHeight?.(i.element,a)}}t.$YT=V;class U{static lift(i){return i instanceof U?i:new U(i)}static empty(i=0){return new U({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const a of i.expanded)this.expanded[a]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$ZT=U;var T;(function(l){l.None="none",l.OnHover="onHover",l.Always="always"})(T||(t.RenderIndentGuides=T={}));class L{get elements(){return this.b}constructor(i,a=[]){this.b=a,this.a=new f.$Sc,this.onDidChange=$.Event.forEach(i,E=>this.b=E,this.a)}dispose(){this.a.dispose()}}class z{static{this.a=8}constructor(i,a,E,I,N,H={}){this.o=i,this.p=a,this.q=I,this.s=N,this.b=new Map,this.c=new Map,this.d=z.a,this.f=!1,this.g=!1,this.j=new Set,this.k=f.$Tc.None,this.m=new f.$Sc,this.templateId=i.templateId,this.updateOptions(H),$.Event.map(E,_=>_.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const a=(0,h.$7l)(i.indent,0,40);if(a!==this.d){this.d=a;for(const[E,I]of this.c)this.v(E,I)}}if(typeof i.renderIndentGuides<"u"){const a=i.renderIndentGuides!==T.None;if(a!==this.g){this.g=a;for(const[E,I]of this.c)this.w(E,I);if(this.k.dispose(),a){const E=new f.$Sc;this.q.onDidChange(this.x,this,E),this.k=E,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const a=(0,k.$MQ)(i,(0,k.$)(".monaco-tl-row")),E=(0,k.$MQ)(a,(0,k.$)(".monaco-tl-indent")),I=(0,k.$MQ)(a,(0,k.$)(".monaco-tl-twistie")),N=(0,k.$MQ)(a,(0,k.$)(".monaco-tl-contents")),H=this.o.renderTemplate(N);return{container:i,indent:E,twistie:I,indentGuidesDisposable:f.$Tc.None,templateData:H}}renderElement(i,a,E,I){this.c.set(i,E),this.b.set(i.element,i),this.v(i,E),this.o.renderElement(i,a,E.templateData,I)}disposeElement(i,a,E,I){E.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,a,E.templateData,I),typeof I=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const a=this.b.get(i);a&&this.u(a)}u(i){const a=this.c.get(i);a&&(this.x(this.q.elements),this.v(i,a))}v(i,a){const E=z.a+(i.depth-1)*this.d;a.twistie.style.paddingLeft=`${E}px`,a.indent.style.width=`${E+this.d-16}px`,i.collapsible?a.container.setAttribute("aria-expanded",String(!i.collapsed)):a.container.removeAttribute("aria-expanded"),a.twistie.classList.remove(...d.ThemeIcon.asClassNameArray(m.$_j.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(i.element,a.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(I||a.twistie.classList.add(...d.ThemeIcon.asClassNameArray(m.$_j.treeItemExpanded)),a.twistie.classList.add("collapsible"),a.twistie.classList.toggle("collapsed",i.collapsed)):a.twistie.classList.remove("collapsible","collapsed"),this.w(i,a)}w(i,a){if((0,k.$KP)(a.indent),a.indentGuidesDisposable.dispose(),!this.g)return;const E=new f.$Sc,I=this.p();for(;;){const N=I.getNodeLocation(i),H=I.getParentNodeLocation(N);if(!H)break;const _=I.getNode(H),Z=(0,k.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&Z.classList.add("active"),a.indent.childElementCount===0?a.indent.appendChild(Z):a.indent.insertBefore(Z,a.indent.firstElementChild),this.s.add(_,Z),E.add((0,f.$Rc)(()=>this.s.delete(_,Z))),i=_}a.indentGuidesDisposable=E}x(i){if(!this.g)return;const a=new Set,E=this.p();i.forEach(I=>{const N=E.getNodeLocation(I);try{const H=E.getParentNodeLocation(N);I.collapsible&&I.children.length>0&&!I.collapsed?a.add(I):H&&a.add(E.getNode(H))}catch{}}),this.j.forEach(I=>{a.has(I)||this.s.forEach(I,N=>N.classList.remove("active"))}),a.forEach(I=>{this.j.has(I)||this.s.forEach(I,N=>N.classList.add("active"))}),this.j=a}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,f.$Oc)(this.m)}}t.$1T=z;class X{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,a,E){this.g=i,this.j=a,this.k=E,this.a=0,this.b=0,this.c="",this.d="",this.f=new f.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,a){let E=1;if(this.k){const H=this.k.filter(i,a);if(typeof H=="boolean"?E=H?1:0:(0,M.$VT)(H)?E=(0,M.$WT)(H.visibility):E=H,E===0)return!1}if(this.a++,!this.c)return this.b++,{data:c.FuzzyScore.Default,visibility:E};const I=this.j.getKeyboardNavigationLabel(i),N=Array.isArray(I)?I:[I];for(const H of N){const _=H&&H.toString();if(typeof _>"u")return{data:c.FuzzyScore.Default,visibility:E};let Z;if(this.g.findMatchType===ge.Contiguous){const he=_.toLowerCase().indexOf(this.d);if(he>-1){Z=[Number.MAX_SAFE_INTEGER,0];for(let pe=this.d.length;pe>0;pe--)Z.push(he+pe-1)}}else Z=(0,c.$7j)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return this.b++,N.length===1?{data:Z,visibility:E}:{data:{label:_,score:Z},visibility:E}}return this.g.findMode===ee.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:c.FuzzyScore.Default,visibility:E}}m(){this.a=0,this.b=0}dispose(){(0,f.$Oc)(this.f)}}class Y extends y.$uS{constructor(i){super({icon:m.$_j.listFilter,title:(0,O.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$2T=Y;class fe extends y.$uS{constructor(i){super({icon:m.$_j.searchFuzzy,title:(0,O.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$3T=fe;const le={inputBoxStyles:S.$cT,toggleStyles:y.$sS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ee;(function(l){l[l.Highlight=0]="Highlight",l[l.Filter=1]="Filter"})(ee||(t.TreeFindMode=ee={}));var ge;(function(l){l[l.Fuzzy=0]="Fuzzy",l[l.Contiguous=1]="Contiguous"})(ge||(t.TreeFindMatchType=ge={}));class Le extends f.$Tc{set mode(i){this.b.checked=i===ee.Filter,this.f.inputBox.setPlaceHolder(i===ee.Filter?(0,O.localize)(2,null):(0,O.localize)(3,null))}set matchType(i){this.c.checked=i===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,a,E,I,N,H){super(),this.t=a,this.a=(0,k.h)(".monaco-tree-type-filter",[(0,k.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,k.h)(".monaco-tree-type-filter-input@findInput"),(0,k.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$Vd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,f.$Rc)(()=>i.removeChild(this.a.root)));const _=H?.styles??le;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new Y({..._.toggleStyles,isChecked:I===ee.Filter})),this.c=this.B(new fe({..._.toggleStyles,isChecked:N===ge.Fuzzy})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?ee.Filter:ee.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new A.$sT(this.a.findInput,E,{label:(0,O.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:H?.history})),this.g=this.B(new j.$FR(this.a.actionbar)),this.mode=I;const Z=this.B(new P.$NR(this.f.inputBox.inputElement,"keydown")),he=$.Event.chain(Z.event,Ee=>Ee.map(ve=>new n.$IP(ve)));this.B(he(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const pe=this.B(new u.$Ki("close",(0,O.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(pe,{icon:!0,label:!1});const ye=this.B(new P.$NR(this.a.grab,"mousedown"));this.B(ye.event(Ee=>{const ve=new f.$Sc,Pe=ve.add(new P.$NR((0,k.getWindow)(Ee),"mousemove")),Ie=ve.add(new P.$NR((0,k.getWindow)(Ee),"mouseup")),Me=this.m,Ye=Ee.pageX,et=this.s,Qe=Ee.pageY;this.a.grab.classList.add("grabbing");const x=this.a.root.style.transition;this.a.root.style.transition="unset";const re=de=>{const Ae=de.pageX-Ye;this.m=Me-Ae;const Te=de.pageY-Qe;this.s=et+Te,this.layout()};ve.add(Pe.event(re)),ve.add(Ie.event(de=>{re(de),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=x,ve.dispose()}))}));const we=$.Event.chain(this.B(new P.$NR(this.a.grab,"keydown")).event,Ee=>Ee.map(ve=>new n.$IP(ve)));this.B(we(Ee=>{let ve,Pe;if(Ee.keyCode===15?ve=Number.POSITIVE_INFINITY:Ee.keyCode===17?ve=0:Ee.keyCode===10&&(ve=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Pe=0:Ee.keyCode===18&&(Pe=Number.POSITIVE_INFINITY),ve!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=ve,this.layout()),Pe!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Pe;const Ie=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ie},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,h.$7l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,h.$7l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$7g)(300),super.dispose()}}class Ne{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,a,E,I,N,H={}){this.t=i,this.u=E,this.v=I,this.w=N,this.x=H,this.b="",this.c="",this.j=0,this.k=new $.$Vd,this.onDidChangeMode=this.k.event,this.m=new $.$Vd,this.onDidChangeMatchType=this.m.event,this.o=new $.$Vd,this.onDidChangePattern=this.o.event,this.p=new $.$Vd,this.onDidChangeOpenState=this.p.event,this.q=new f.$Sc,this.s=new f.$Sc,this.d=i.options.defaultFindMode??ee.Highlight,this.f=i.options.defaultFindMatchType??ge.Fuzzy,a.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Le(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,E=>!c.FuzzyScore.isDefault(E.filterData));const a=this.t.getFocus();if(a.length>0){const E=a[0];this.t.getRelativeTop(E)===null&&this.t.reveal(E,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,O.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!c.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(l,i){return l.position===i.position&&ne(l,i)}function ne(l,i){return l.node.element===i.node.element&&l.startIndex===i.startIndex&&l.height===i.height&&l.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const a=this.stickyNodes[this.count-2];return a.position+a.height!==i.position}animationStateChanged(i){if(!(0,e.$ub)(this.stickyNodes,i.stickyNodes,ne)||this.count===0)return!1;const a=this.stickyNodes[this.count-1],E=i.stickyNodes[i.count-1];return a.position!==E.position}}class se{constrainStickyScrollNodes(i,a,E){for(let I=0;I<i.length;I++){const N=i[I];if(N.position+N.height>E||I>=a)return i.slice(0,I)}return i}}class oe extends f.$Tc{constructor(i,a,E,I,N,H={}){super(),this.g=i,this.j=a,this.m=E,this.s=N,this.c=.4;const _=this.validateStickySettings(H);this.b=_.stickyScrollMaxItemCount,this.a=H.stickyScrollDelegate??new se,this.f=this.B(new W(E.getScrollableElement(),E,i,I,N,H.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(E.onDidScroll(()=>this.u())),this.B(E.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let a;if(i===0?a=this.m.firstVisibleIndex:a=this.m.indexAt(i+this.m.scrollTop),!(a<0||a>=this.m.length))return this.m.element(a)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const a=this.w(i);this.f.setState(a)}w(i){const a=[];let E=i,I=0,N=this.z(E,void 0,I);for(;N&&(a.push(N),I+=N.height,!(a.length<=this.b&&(E=this.y(N),!E)));)N=this.z(E,N.node,I);const H=this.H(a);return H.length?new J(H):void 0}y(i){return this.t(i.position+i.height)}z(i,a,E){const I=this.F(i,a);if(I&&!(I===i&&(!this.J(i)||this.C(i,E))))return this.D(I,E)}C(i,a){const E=this.L(i),I=this.m.getElementTop(E),N=a;return this.m.scrollTop===I-N}D(i,a){const E=this.s.getHeight(i),{startIndex:I,endIndex:N}=this.M(i),H=this.G(N,a,E);return{node:i,position:H,height:E,startIndex:I,endIndex:N}}F(i,a=void 0){let E=i,I=this.I(E);for(;I;){if(I===a)return E;E=I,I=this.I(E)}if(a===void 0)return E}G(i,a,E){let I=this.m.getRelativeTop(i);if(I===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const he=this.s.getHeight(this.m.element(i)),pe=this.m.getRelativeTop(i+1);I=pe?pe-he/this.m.renderHeight:null}if(I===null)return a;const N=this.m.element(i),H=this.s.getHeight(N),Z=I*this.m.renderHeight+H;return a+E>Z&&a<=Z?Z-E:a}H(i){if(i.length===0)return[];const a=this.m.renderHeight*this.c,E=i[i.length-1];if(i.length<=this.b&&E.position+E.height<=a)return i;const I=this.a.constrainStickyScrollNodes(i,this.b,a);if(!I.length)return[];const N=I[I.length-1];if(I.length>this.b||N.position+N.height>a)throw new Error("stickyScrollDelegate violates constraints");return I}I(i){const a=this.j.getNodeLocation(i),E=this.j.getParentNodeLocation(a);return E?this.j.getNode(E):void 0}J(i){const a=this.j.getNodeLocation(i);return this.j.getListRenderCount(a)>1}L(i){const a=this.j.getNodeLocation(i);return this.j.getListIndex(a)}M(i){const a=this.j.getNodeLocation(i),E=this.j.getListIndex(a);if(E<0)throw new Error("Node not found in tree");const I=this.j.getListRenderCount(a),N=E+I-1;return{startIndex:E,endIndex:N}}nodePositionTopBelowWidget(i){const a=[];let E=this.I(i);for(;E;)a.push(E),E=this.I(E);let I=0;for(let N=0;N<a.length&&N<this.b;N++)I+=this.s.getHeight(a[N]);return I}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const a=this.validateStickySettings(i);this.b!==a.stickyScrollMaxItemCount&&(this.b=a.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let a=7;return typeof i.stickyScrollMaxItemCount=="number"&&(a=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:a}}}class W{constructor(i,a,E,I,N,H){this.g=a,this.j=E,this.k=I,this.m=N,this.o=H,this.c=[],this.d=new f.$Sc,this.a=(0,k.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const _=(0,k.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(_),this.f=new G(this.a,a),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(a=>a.node===i)}setState(i){const a=!!this.b&&this.b.count>0,E=!!i&&i.count>0;if(!a&&!E||a&&E&&this.b.equal(i))return;if(a!==E&&this.s(E),!E){this.b=void 0,this.c=[],this.d.clear();return}const I=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${I.position}px`;else{this.d.clear();const N=Array(i.count);for(let H=i.count-1;H>=0;H--){const _=i.stickyNodes[H],{element:Z,disposable:he}=this.p(_,H,i.count);N[H]=Z,this.a.appendChild(Z),this.d.add(he)}this.f.updateElements(N,i),this.c=N}this.b=i,this.a.style.height=`${I.position+I.height}px`}p(i,a,E){const I=i.startIndex,N=document.createElement("div");N.style.top=`${i.position}px`,N.style.height=`${i.height}px`,N.style.lineHeight=`${i.height}px`,N.classList.add("monaco-tree-sticky-row"),N.classList.add("monaco-list-row"),N.setAttribute("data-index",`${I}`),N.setAttribute("data-parity",I%2===0?"even":"odd"),N.setAttribute("id",this.g.getElementID(I)),this.q(N,i.node.element,a,E);const H=this.m.getTemplateId(i.node),_=this.k.find(ye=>ye.templateId===H);if(!_)throw new Error(`No renderer found for template id ${H}`);let Z=i.node;Z===this.j.getNode(this.j.getNodeLocation(i.node))&&(Z=new Proxy(i.node,{}));const he=_.renderTemplate(N);_.renderElement(Z,i.startIndex,he,i.height);const pe=(0,f.$Rc)(()=>{_.disposeElement(Z,i.startIndex,he,i.height),_.disposeTemplate(he),N.remove()});return{element:N,disposable:pe}}q(i,a,E,I){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(a,E,I))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(a,E))),this.o.getRole&&i.setAttribute("role",this.o.getRole(a)??"treeitem");const N=this.o.getAriaLabel(a);N&&i.setAttribute("aria-label",N);const H=this.o.getAriaLevel&&this.o.getAriaLevel(a);typeof H=="number"&&i.setAttribute("aria-level",`${H}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class G extends f.$Tc{get m(){return this.j}set m(i){this.j=i,this.f.fire(i)}constructor(i,a){super(),this.s=i,this.t=a,this.a=-1,this.b=[],this.f=new $.$Vd,this.onDidChangeHasFocus=this.f.event,this.g=new $.$Vd,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(E=>this.w(E))),this.B(this.t.onMouseDown(E=>this.y(E))),this.B(this.t.onContextMenu(E=>this.u(E)))}u(i){const a=i.browserEvent.target;if(!(0,w.$$R)(a)&&!(0,w.$0R)(a)){this.focusedLast()&&this.t.domFocus();return}if(!(0,k.$CQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const H=this.c.stickyNodes.findIndex(_=>_.node.element===i.element?.element);if(H===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(H);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const I=this.c.stickyNodes[this.a].node.element,N=this.b[this.a];this.g.fire({element:I,anchor:N,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const a=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([a]),this.C(a,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const a=i.browserEvent.target;!(0,w.$$R)(a)&&!(0,w.$0R)(a)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,a){if(a&&a.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(a&&a.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const E=this.a;if(this.D(),this.b=i,this.c=a,a){const I=(0,h.$7l)(E,0,a.count-1);this.F(I)}else this.m&&this.t.domFocus();this.s.tabIndex=a?0:-1}z(i){const a=this.c;if(!a)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<a.count-1)&&a.lastNodePartiallyVisible()){const E=a.stickyNodes[i];this.C(E.endIndex+1,a)}}C(i,a){const E=a.stickyNodes[a.count-1],I=a.count>1?a.stickyNodes[a.count-2]:void 0,N=this.t.getElementTop(i),H=I?I.position+I.height+E.height:E.height;this.t.scrollTop=N-H}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const a=this.a;a>=0&&this.G(this.b[a],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,a){i.classList.toggle("focused",a)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ue(l){let i=r.TreeMouseEventTarget.Unknown;return(0,k.$hQ)(l.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=r.TreeMouseEventTarget.Twistie:(0,k.$hQ)(l.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=r.TreeMouseEventTarget.Element:(0,k.$hQ)(l.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=r.TreeMouseEventTarget.Filter),{browserEvent:l.browserEvent,element:l.element?l.element.element:null,target:i}}function me(l){const i=(0,w.$$R)(l.browserEvent.target);return{element:l.element?l.element.element:null,browserEvent:l.browserEvent,anchor:l.anchor,isStickyScroll:i}}function Se(l,i){i(l),l.children.forEach(a=>Se(a,i))}class ke{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,a){this.g=i,this.j=a,this.a=[],this.c=new $.$Vd,this.onDidChange=this.c.event}set(i,a){!a?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,a)}k(i,a,E){if(this.a=[...i],this.b=void 0,this.d=void 0,!a){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:E})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:a}){if(!this.j){const Z=this.m(),he=pe=>Z.delete(pe);a.forEach(pe=>Se(pe,he)),this.set([...Z.values()]);return}const E=new Set,I=Z=>E.add(this.j.getId(Z.element).toString());a.forEach(Z=>Se(Z,I));const N=new Map,H=Z=>N.set(this.j.getId(Z.element).toString(),Z);i.forEach(Z=>Se(Z,H));const _=[];for(const Z of this.a){const he=this.j.getId(Z.element).toString();if(!E.has(he))_.push(Z);else{const ye=N.get(he);ye&&ye.visible&&_.push(ye)}}if(this.a.length>0&&_.length===0){const Z=this.g();Z&&_.push(Z)}this.k(_,!0)}m(){const i=new Set;for(const a of this.a)i.add(a);return i}}class Ce extends w.$dS{constructor(i,a,E){super(i),this.x=a,this.y=E}u(i){if((0,w.$_R)(i.browserEvent.target)||(0,w.$5R)(i.browserEvent.target)||(0,w.$6R)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const a=i.element;if(!a)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const E=i.browserEvent.target,I=E.classList.contains("monaco-tl-twistie")||E.classList.contains("monaco-icon-label")&&E.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,N=(0,w.$0R)(i.browserEvent.target);let H=!1;if(N?H=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?H=this.x.expandOnlyOnTwistieClick(a.element):H=!!this.x.expandOnlyOnTwistieClick,N)this.A(i,a);else{if(H&&!I&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(a.collapsible&&(!N||I)){const _=this.x.getNodeLocation(a),Z=i.browserEvent.altKey;if(this.x.setFocus([_]),this.x.toggleCollapsed(_,Z),H&&I){i.browserEvent.isHandledByList=!0;return}}N||super.u(i)}A(i,a){if((0,w.$7R)(i.browserEvent.target)||(0,w.$8R)(i.browserEvent.target))return;const E=this.y();if(!E)throw new Error("Sticky scroll controller not found");const I=this.k.indexOf(a),N=this.k.getElementTop(I),H=E.nodePositionTopBelowWidget(a);this.x.scrollTop=N-H,this.k.domFocus(),this.k.setFocus([I]),this.k.setSelection([I])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const a=i.browserEvent.target;if(!(0,w.$$R)(a)&&!(0,w.$0R)(a)){super.s(i);return}}t(i){const a=i.browserEvent.target;if(!(0,w.$$R)(a)&&!(0,w.$0R)(a)){super.t(i);return}}}class K extends w.$gS{constructor(i,a,E,I,N,H,_,Z){super(i,a,E,I,Z),this.p=N,this.s=H,this.K=_}D(i){return new Ce(this,i.tree,i.stickyScrollProvider)}splice(i,a,E=[]){if(super.splice(i,a,E),E.length===0)return;const I=[],N=[];let H;E.forEach((_,Z)=>{this.p.has(_)&&I.push(i+Z),this.s.has(_)&&N.push(i+Z),this.K.has(_)&&(H=i+Z)}),I.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...I])),N.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...N])),typeof H=="number"&&super.setAnchor(H)}setFocus(i,a,E=!1){super.setFocus(i,a),E||this.p.set(i.map(I=>this.element(I)),a)}setSelection(i,a,E=!1){super.setSelection(i,a),E||this.s.set(i.map(I=>this.element(I)),a)}setAnchor(i,a=!1){super.setAnchor(i),a||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var g;(function(l){l[l.Tree=0]="Tree",l[l.StickyScroll=1]="StickyScroll"})(g||(t.AbstractTreePart=g={}));class D{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,ue)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,ue),i=>i.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,me),i=>!i.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,ue)}get onPointer(){return $.Event.map(this.j.onPointer,ue)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ee.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??ge.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,a,E,I,N={}){this.G=i,this.H=N,this.y=new $.$4d,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new f.$Sc,this.E=new $.$Vd,this.onWillRefilter=this.E.event,this.F=new $.$Vd,this.onDidUpdateOptions=this.F.event,this.p=new V(E);const H=new $.$5d,_=new $.$5d,Z=this.D.add(new L(_.event)),he=new o.$Gc;this.k=I.map(ve=>new z(ve,()=>this.o,H.event,Z,he,N));for(const ve of this.k)this.D.add(ve);let pe;N.keyboardNavigationLabelProvider&&(pe=new X(this,N.keyboardNavigationLabelProvider,N.filter),N={...N,filter:pe},this.D.add(pe)),this.q=new ke(()=>this.j.getFocusedElements()[0],N.identityProvider),this.w=new ke(()=>this.j.getSelectedElements()[0],N.identityProvider),this.x=new ke(()=>this.j.getAnchorElement(),N.identityProvider),this.j=new K(i,a,this.p,this.k,this.q,this.w,this.x,{...C(()=>this.o,N),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,N),H.input=this.o.onDidChangeCollapseState;const ye=$.Event.forEach(this.o.onDidSplice,ve=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ve),this.w.onDidModelSplice(ve)})},this.D);ye(()=>null,null,this.D);const we=this.D.add(new $.$Vd),Ee=this.D.add(new s.$3g(0));if(this.D.add($.Event.any(ye,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const ve=new Set;for(const Pe of this.q.getNodes())ve.add(Pe);for(const Pe of this.w.getNodes())ve.add(Pe);we.fire([...ve.values()])})})),_.input=we.event,N.keyboardSupport!==!1){const ve=$.Event.chain(this.j.onKeyDown,Pe=>Pe.filter(Ie=>!(0,w.$5R)(Ie.target)).map(Ie=>new n.$IP(Ie)));$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===15))(this.J,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===17))(this.K,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===10))(this.L,this,this.D)}if((N.findWidgetEnabled??!0)&&N.keyboardNavigationLabelProvider&&N.contextViewProvider){const ve=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ne(this,this.o,this.j,pe,N.contextViewProvider,ve),this.A=Pe=>this.z.shouldAllowFocus(Pe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;N.enableStickyScroll&&(this.B=new oe(this,this.o,this.j,this.k,this.p,N),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,k.$uQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const a of this.k)a.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===T.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new oe(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const a=this.o.getListIndex(i);a!==-1&&this.j.updateWidth(a)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,k.$mQ)(this.getHTMLElement())}layout(i,a){this.j.layout(i,a),(0,F.$Mf)(a)&&this.z?.layout(a)}style(i){const a=`.${this.j.domId}`,E=[];i.treeIndentGuidesStroke&&(E.push(`.monaco-list${a}:hover .monaco-tl-indent > .indent-guide, .monaco-list${a}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),E.push(`.monaco-list${a} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(E.push(`.monaco-list${a} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),E.push(`.monaco-list${a} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(E.push(`.monaco-list${a}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),E.push(`.monaco-list${a}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const I=(0,k.$5Q)(i.listFocusAndSelectionOutline,(0,k.$5Q)(i.listSelectionOutline,i.listFocusOutline??""));I&&(E.push(`.monaco-list${a}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),E.push(`.monaco-list${a}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(E.push(`.monaco-list${a}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),E.push(`.monaco-list${a}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),E.push(`.monaco-workbench.context-menu-visible .monaco-list${a}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),E.push(`.monaco-workbench.context-menu-visible .monaco-list${a}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=E.join(`
`),this.j.style(i)}getParentElement(i){const a=this.o.getParentNodeLocation(i);return this.o.getNode(a).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,a=!1){return this.o.setCollapsed(i,!0,a)}expand(i,a=!1){return this.o.setCollapsed(i,!1,a)}toggleCollapsed(i,a=!1){return this.o.setCollapsed(i,void 0,a)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,a){return this.o.setCollapsible(i,a)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const a=this.o.getNode(i);this.x.set([a]);const E=this.o.getListIndex(i);E>-1&&this.j.setAnchor(E,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,a){this.y.bufferEvents(()=>{const E=i.map(N=>this.o.getNode(N));this.w.set(E,a);const I=i.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setSelection(I,a,!0)})}getSelection(){return this.w.get()}setFocus(i,a){this.y.bufferEvents(()=>{const E=i.map(N=>this.o.getNode(N));this.q.set(E,a);const I=i.map(N=>this.o.getListIndex(N)).filter(N=>N>-1);this.j.setFocus(I,a,!0)})}focusNext(i=1,a=!1,E,I=(0,k.$CQ)(E)&&E.altKey?void 0:this.A){this.j.focusNext(i,a,E,I)}focusPrevious(i=1,a=!1,E,I=(0,k.$CQ)(E)&&E.altKey?void 0:this.A){this.j.focusPrevious(i,a,E,I)}focusNextPage(i,a=(0,k.$CQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,a)}focusPreviousPage(i,a=(0,k.$CQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,a,()=>this.B?.height??0)}focusLast(i,a=(0,k.$CQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,a)}focusFirst(i,a=(0,k.$CQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,a)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,a){this.o.expandTo(i);const E=this.o.getListIndex(i);if(E!==-1)if(!this.B)this.j.reveal(E,a);else{const I=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(E,a,I)}}getRelativeTop(i){const a=this.o.getListIndex(i);if(a===-1)return null;const E=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(a,E?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new r.$TT(this.G,"Can't get tree view state without an identity provider");const a=H=>i.getId(H).toString(),E=U.empty(this.scrollTop);for(const H of this.getFocus())E.focus.add(a(H));for(const H of this.getSelection())E.selection.add(a(H));const I=this.o.getNode(),N=[I];for(;N.length>0;){const H=N.shift();H!==I&&H.collapsible&&(E.expanded[a(H.element)]=H.collapsed?0:1),N.push(...H.children)}return E}J(i){i.preventDefault(),i.stopPropagation();const a=this.j.getFocusedElements();if(a.length===0)return;const E=a[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!0)){const H=this.o.getParentNodeLocation(I);if(!H)return;const _=this.o.getListIndex(H);this.j.reveal(_),this.j.setFocus([_])}}K(i){i.preventDefault(),i.stopPropagation();const a=this.j.getFocusedElements();if(a.length===0)return;const E=a[0],I=this.o.getNodeLocation(E);if(!this.o.setCollapsed(I,!1)){if(!E.children.some(Z=>Z.visible))return;const[H]=this.j.getFocus(),_=H+1;this.j.reveal(_),this.j.setFocus([_])}}L(i){i.preventDefault(),i.stopPropagation();const a=this.j.getFocusedElements();if(a.length===0)return;const E=a[0],I=this.o.getNodeLocation(E),N=i.browserEvent.altKey;this.o.setCollapsed(I,void 0,N)}navigate(i){return new p(this.j,this.o,i)}dispose(){(0,f.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$4T=D;class p{constructor(i,a,E){this.b=i,this.c=a,E?this.a=this.c.getListIndex(E):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],$e([1,0,132,123,26,28]),function(ie,t,k,P,n,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=void 0;class A extends k.$4T{constructor(b,w,y,M,r,u={}){super(b,w,y,M,u),this.f=b,this.g=r,this.d=new Map,this.c=u.identityProvider}getInput(){return this.b}setInput(b,w){if(w&&!this.c)throw new n.$TT(this.f,"Can't restore tree view state without an identity provider");if(this.b=b,!b){this.d.clear(),this.o.setChildren(null,j.Iterable.empty());return}if(!w){this.m(b);return}const y=[],M=[],r=e=>{const s=this.c.getId(e).toString();return!w.expanded[s]},u=e=>{const s=this.c.getId(e.element).toString();w.focus.has(s)&&y.push(e.element),w.selection.has(s)&&M.push(e.element)};this.m(b,r,u),this.setFocus(y),this.setSelection(M),w&&typeof w.scrollTop=="number"&&(this.scrollTop=w.scrollTop)}updateChildren(b=this.b){if(typeof this.b>"u")throw new n.$TT(this.f,"Tree input not set");let w;this.c&&(w=y=>{const M=this.c.getId(y).toString(),r=this.d.get(M);if(r)return r.collapsed}),this.m(b,w)}resort(b=this.b,w=!0){this.o.resort(b===this.b?null:b,w)}refresh(b){if(b===void 0){this.j.rerender();return}this.o.rerender(b)}m(b,w,y){let M;if(this.c){const r=new Set,u=y;y=e=>{const s=this.c.getId(e.element).toString();r.add(s),this.d.set(s,e),u?.(e)},M=e=>{const s=this.c.getId(e.element).toString();r.has(s)||this.d.delete(s)}}this.o.setChildren(b===this.b?null:b,this.s(b,w).elements,{onDidCreateNode:y,onDidDeleteNode:M})}s(b,w){const y=[...this.g.getChildren(b)];return{elements:j.Iterable.map(y,r=>{const{elements:u,size:e}=this.s(r,w),s=this.g.hasChildren?this.g.hasChildren(r):void 0,m=e===0?void 0:w&&w(r);return{element:r,children:u,collapsible:s,collapsed:m}}),size:y.length}}M(b,w,y){return new P.$5T(b,w,y)}}t.$cU=A}),define(be[67],$e([1,0,12,9,33,29,27,6,4,2,53,10,7]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oh=t.ProxyChannel=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.RequestInitiator=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=void 0;var u;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(u||(u={}));function e(ne){switch(ne){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(s||(s={}));function m(ne){switch(ne){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(d||(d={}));function o(ne){let J=0;for(let se=0;;se+=7){const oe=ne.read(1);if(J|=(oe.buffer[0]&127)<<se,!(oe.buffer[0]&128))return J}}const $=O(0);function c(ne,J){if(J===0){ne.write($);return}let se=0;for(let W=J;W!==0;W=W>>>7)se++;const oe=n.$je.alloc(se);for(let W=0;J!==0;W++)oe.buffer[W]=J&127,J=J>>>7,J>0&&(oe.buffer[W]|=128);ne.write(oe)}class f{constructor(J){this.b=J,this.a=0}read(J){const se=this.b.slice(this.a,this.a+J);return this.a+=se.byteLength,se}}t.$Dh=f;class h{constructor(){this.a=[]}get buffer(){return n.$je.concat(this.a)}write(J){this.a.push(J)}}t.$Eh=h;var F;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object",ne[ne.Int=6]="Int"})(F||(F={}));function O(ne){const J=n.$je.alloc(1);return J.writeUInt8(ne,0),J}const R={Undefined:O(F.Undefined),String:O(F.String),Buffer:O(F.Buffer),VSBuffer:O(F.VSBuffer),Array:O(F.Array),Object:O(F.Object),Uint:O(F.Int)},B=typeof Buffer<"u";function v(ne,J){if(typeof J>"u")ne.write(R.Undefined);else if(typeof J=="string"){const se=n.$je.fromString(J);ne.write(R.String),c(ne,se.byteLength),ne.write(se)}else if(B&&Buffer.isBuffer(J)){const se=n.$je.wrap(J);ne.write(R.Buffer),c(ne,se.byteLength),ne.write(se)}else if(J instanceof n.$je)ne.write(R.VSBuffer),c(ne,J.byteLength),ne.write(J);else if(Array.isArray(J)){ne.write(R.Array),c(ne,J.length);for(const se of J)v(ne,se)}else if(typeof J=="number"&&(J|0)===J)ne.write(R.Uint),c(ne,J);else{const se=n.$je.fromString(JSON.stringify(J));ne.write(R.Object),c(ne,se.byteLength),ne.write(se)}}t.$Fh=v;function C(ne){switch(ne.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return ne.read(o(ne)).toString();case F.Buffer:return ne.read(o(ne)).buffer;case F.VSBuffer:return ne.read(o(ne));case F.Array:{const se=o(ne),oe=[];for(let W=0;W<se;W++)oe.push(C(ne));return oe}case F.Object:return JSON.parse(ne.read(o(ne)).toString());case F.Int:return o(ne)}}t.$Gh=C;class V{constructor(J,se,oe=null,W=1e3){this.h=J,this.j=se,this.k=oe,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(J,se){this.b.set(J,se),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const se=this.o([J.type]);this.k?.logOutgoing(se,0,1,m(J.type));return}case 201:case 202:case 204:case 203:{const se=this.o([J.type,J.id],J.data);this.k?.logOutgoing(se,J.id,1,m(J.type),J.data);return}}}o(J,se=void 0){const oe=new h;return v(oe,J),v(oe,se),this.p(oe.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const se=new f(J),oe=C(se),W=C(se),G=oe[0];switch(G){case 100:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,W),this.s({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:W});case 102:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}: ${oe[2]}.${oe[3]}`,W),this.t({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:W});case 101:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]});case 103:return this.k?.logIncoming(J.byteLength,oe[1],1,`${e(G)}`),this.u({type:G,id:oe[1]})}}s(J){const se=this.b.get(J.channelName);if(!se){this.v(J);return}const oe=new j.$6d;let W;try{W=se.call(this.j,J.name,J.arg,oe.token)}catch(me){W=Promise.reject(me)}const G=J.id;W.then(me=>{this.m({id:G,data:me,type:201})},me=>{me instanceof Error?this.m({id:G,data:{message:me.message,name:me.name,stack:me.stack?me.stack.split?me.stack.split(`
`):me.stack:void 0},type:202}):this.m({id:G,data:me,type:203})}).finally(()=>{ue.dispose(),this.d.delete(J.id)});const ue=(0,w.$Rc)(()=>oe.cancel());this.d.set(J.id,ue)}t(J){const se=this.b.get(J.channelName);if(!se){this.v(J);return}const oe=J.id,G=se.listen(this.j,J.name,J.arg)(ue=>this.m({id:oe,data:ue,type:204}));this.d.set(J.id,G)}u(J){const se=this.d.get(J.id);se&&(se.dispose(),this.d.delete(J.id))}v(J){let se=this.g.get(J.channelName);se||(se=[],this.g.set(J.channelName,se));const oe=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);se.push({request:J,timeoutTimer:oe})}w(J){const se=this.g.get(J);if(se){for(const oe of se)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Hh=V;var U;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(U||(t.RequestInitiator=U={}));class T{constructor(J,se=null){this.l=J,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=se}getChannel(J){const se=this;return{call(oe,W,G){return se.a?Promise.reject(new S.$5):se.m(J,oe,W,G)},listen(oe,W){return se.a?b.Event.None:se.o(J,oe,W)}}}m(J,se,oe,W=j.CancellationToken.None){const G=this.g++,me={id:G,type:100,channelName:J,name:se,arg:oe};if(W.isCancellationRequested)return Promise.reject(new S.$5);let Se;return new Promise((Ce,K)=>{if(W.isCancellationRequested)return K(new S.$5);const g=()=>{const i=a=>{switch(a.type){case 201:this.f.delete(G),Ce(a.data);break;case 202:{this.f.delete(G);const E=new Error(a.data.message);E.stack=Array.isArray(a.data.stack)?a.data.stack.join(`
`):a.data.stack,E.name=a.data.name,K(E);break}case 203:this.f.delete(G),K(a.data);break}};this.f.set(G,i),this.p(me)};let D=null;this.b===d.Idle?g():(D=(0,P.$Tg)(i=>this.u()),D.then(()=>{D=null,g()}));const p=()=>{D?(D.cancel(),D=null):this.p({id:G,type:101}),K(new S.$5)},l=W.onCancellationRequested(p);Se=(0,w.$Qc)((0,w.$Rc)(p),l),this.d.add(Se)}).finally(()=>{Se.dispose(),this.d.delete(Se)})}o(J,se,oe){const W=this.g++,ue={id:W,type:102,channelName:J,name:se,arg:oe};let me=null;const Se=new b.$Vd({onWillAddFirstListener:()=>{me=(0,P.$Tg)(Ce=>this.u()),me.then(()=>{me=null,this.d.add(Se),this.p(ue)})},onDidRemoveLastListener:()=>{me?(me.cancel(),me=null):(this.d.delete(Se),this.p({id:W,type:103}))}}),ke=Ce=>Se.fire(Ce.data);return this.f.set(W,ke),Se.event}p(J){switch(J.type){case 100:case 102:{const se=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(se,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const se=this.q([J.type,J.id]);this.j?.logOutgoing(se,J.id,0,e(J.type));return}}}q(J,se=void 0){const oe=new h;return v(oe,J),v(oe,se),this.r(oe.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const se=new f(J),oe=C(se),W=C(se),G=oe[0];switch(G){case 200:return this.j?.logIncoming(J.byteLength,0,0,m(G)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,oe[1],0,m(G),W),this.t({type:oe[0],id:oe[1],data:W})}}t(J){if(J.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Oc)(this.d.values()),this.d.clear()}}t.$Ih=T,Xe([A.$xh],T.prototype,"onDidInitializePromise",null);class L{get connections(){const J=[];return this.f.forEach(se=>J.push(se)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new b.$Vd,this.onDidAddConnection=this.g.event,this.h=new b.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new w.$Sc,this.j.add(J(({protocol:se,onDidClientDisconnect:oe})=>{const W=b.Event.once(se.onMessage);this.j.add(W(G=>{const ue=new f(G),me=C(ue),Se=new V(se,me),ke=new T(se);this.a.forEach((K,g)=>Se.registerChannel(g,K));const Ce={channelServer:Se,channelClient:ke,ctx:me};this.f.add(Ce),this.g.fire(Ce),this.j.add(oe(()=>{Se.dispose(),ke.dispose(),this.f.delete(Ce),this.h.fire(Ce)}))}))}))}getChannel(J,se){const oe=this;return{call(W,G,ue){let me;if((0,r.$Wf)(se)){const ke=(0,k.$4b)(oe.connections.filter(se));me=ke?Promise.resolve(ke):b.Event.toPromise(b.Event.filter(oe.onDidAddConnection,se))}else me=se.routeCall(oe,W,G);const Se=me.then(ke=>ke.channelClient.getChannel(J));return X(Se).call(W,G,ue)},listen(W,G){if((0,r.$Wf)(se))return oe.k(J,se,W,G);const ue=se.routeEvent(oe,W,G).then(me=>me.channelClient.getChannel(J));return X(ue).listen(W,G)}}}k(J,se,oe,W){const G=this;let ue;const me=new b.$Vd({onWillAddFirstListener:()=>{ue=new w.$Sc;const Se=new b.$2d,ke=new Map,Ce=g=>{const p=g.channelClient.getChannel(J).listen(oe,W),l=Se.add(p);ke.set(g,l)},K=g=>{const D=ke.get(g);D&&(D.dispose(),ke.delete(g))};G.connections.filter(se).forEach(Ce),b.Event.filter(G.onDidAddConnection,se)(Ce,void 0,ue),G.onDidRemoveConnection(K,void 0,ue),Se.event(me.fire,me,ue),ue.add(Se)},onDidRemoveLastListener:()=>{ue?.dispose(),ue=void 0}});return me.event}registerChannel(J,se){this.a.set(J,se);for(const oe of this.f)oe.channelServer.registerChannel(J,se)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Jh=L;class z{constructor(J,se,oe=null){const W=new h;v(W,se),J.send(W.buffer),this.a=new T(J,oe),this.d=new V(J,se,oe)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,se){this.d.registerChannel(J,se)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Kh=z;function X(ne){return{call(J,se,oe){return ne.then(W=>W.call(J,se,oe))},listen(J,se){const oe=new b.$5d;return ne.then(W=>oe.input=W.listen(J,se)),oe.event}}}t.$Lh=X;function Y(ne){let J=!1;return{call(se,oe,W){return J?ne.call(se,oe,W):(0,P.$7g)(0).then(()=>J=!0).then(()=>ne.call(se,oe,W))},listen(se,oe){if(J)return ne.listen(se,oe);const W=new b.$5d;return(0,P.$7g)(0).then(()=>J=!0).then(()=>W.input=ne.listen(se,oe)),W.event}}}t.$Mh=Y;class fe{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const se of J.connections)if(await Promise.resolve(this.a(se.ctx)))return Promise.resolve(se);return await b.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Nh=fe;var le;(function(ne){function J(G,ue,me){const Se=G,ke=me&&me.disableMarshalling,Ce=new Map;for(const K in Se)oe(K)&&Ce.set(K,b.Event.buffer(Se[K],!0,void 0,ue));return new class{listen(K,g,D){const p=Ce.get(g);if(p)return p;if(W(g)){const l=Se[g];if(typeof l=="function")return l.call(Se,D)}throw new S.$bb(`Event not found: ${g}`)}call(K,g,D){const p=Se[g];if(typeof p=="function"){if(!ke&&Array.isArray(D))for(let i=0;i<D.length;i++)D[i]=(0,y.$Ch)(D[i]);let l=p.apply(Se,D);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new S.$bb(`Method not found: ${g}`)}}}ne.fromService=J;function se(G,ue){const me=ue&&ue.disableMarshalling;return new Proxy({},{get(Se,ke){if(typeof ke=="string")return ue?.properties?.has(ke)?ue.properties.get(ke):W(ke)?function(Ce){return G.listen(ke,Ce)}:oe(ke)?G.listen(ke):async function(...Ce){let K;ue&&!(0,r.$Rf)(ue.context)?K=[ue.context,...Ce]:K=Ce;const g=await G.call(ke,K);return me?g:(0,y.$Ch)(g)};throw new S.$bb(`Property not found: ${String(ke)}`)}})}ne.toService=se;function oe(G){return G[0]==="o"&&G[1]==="n"&&M.$$e(G.charCodeAt(2))}function W(G){return/^onDynamic/.test(G)&&M.$$e(G.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const J=ne.toString();if(J!=="[object Object]")return J}return ne}function Le(ne){return Array.isArray(ne)?ne.map(ge):ge(ne)}function Ne(ne,J,se,oe,W,G,ue){ue=Le(ue);const me=ee[W],Se=me[oe%me.length];let ke=[`%c[${ne}]%c[${String(J).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(G)?(ke=ke.concat(ue),ke.push(")")):ke.push(ue),console.log.apply(console,ke)}class Be{constructor(J,se){this.d=J,this.f=se,this.a=0,this.b=0}logOutgoing(J,se,oe,W,G){this.b+=J,Ne(this.d,this.b,J,se,oe,W,G)}logIncoming(J,se,oe,W,G){this.a+=J,Ne(this.f,this.a,J,se,oe,W,G)}}t.$Oh=Be}),define(be[134],$e([1,0,33,4,67,90,30]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MU=void 0;class S extends n.$Kh{static f(){const w=P.Event.fromNodeEventEmitter(A.$O,"vscode:message",(y,M)=>k.$je.wrap(M));return A.$O.send("vscode:hello"),new j.$IU(A.$O,w)}constructor(w){const y=S.f();super(y,w),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}t.$MU=S}),define(be[135],$e([13,11]),function(ie,t){return ie.create("vs/platform/files/common/files",t)}),define(be[136],$e([13,11]),function(ie,t){return ie.create("vs/platform/theme/common/iconRegistry",t)}),define(be[40],$e([1,0]),function(ie,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7h=t.$6h=t.$5h=t._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function S(b){return b[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=S})(k||(t._util=k={})),t.$5h=n("instantiationService");function P(A,S,b){S[k.DI_TARGET]===S?S[k.DI_DEPENDENCIES].push({id:A,index:b}):(S[k.DI_DEPENDENCIES]=[{id:A,index:b}],S[k.DI_TARGET]=S)}function n(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const S=function(b,w,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(S,b,y)};return S.toString=()=>A,k.serviceIds.set(A,S),S}t.$6h=n;function j(A){return A}t.$7h=j}),define(be[137],$e([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Km=t.$Jm=t.$Im=t.ID=void 0,t.ID="diagnosticsService",t.$Im=(0,k.$6h)(t.ID);function P(j){return!!j.hostName&&!!j.errorMessage}t.$Jm=P;class n{async getPerformanceInfo(A,S){return{}}async getSystemInfo(A,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,S){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$Km=n}),define(be[138],$e([1,0,88,24,10,7,15,135,40,5,31,23]),function(ie,t,k,P,n,j,A,S,b,w,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zk=t.$Yk=t.$Xk=t.$Wk=t.$Vk=t.FileKind=t.$Uk=t.$Tk=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.FileOperationResult=t.$Nk=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.FileChangeType=t.$Ik=t.FileOperation=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.FileSystemProviderErrorCode=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.$uk=t.$tk=t.FileSystemProviderCapabilities=t.$sk=t.FilePermission=t.FileType=t.$rk=t.$qk=void 0,t.$qk=(0,b.$6h)("fileService");function r(W){return W.create===!0}t.$rk=r;var u;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(u||(t.FileType=u={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(W){const G=W;return!!G&&typeof G.onDidChange=="function"}t.$sk=s;var m;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(m||(t.FileSystemProviderCapabilities=m={}));function d(W){return!!(W.capabilities&2)}t.$tk=d;function o(W){return!!(W.capabilities&8)}t.$uk=o;function $(W){return!!(W.capabilities&131072)}t.$vk=$;function c(W){return!!(W.capabilities&4)}t.$wk=c;function f(W){return!!(W.capabilities&16)}t.$xk=f;function h(W){return d(W)?!!(W.capabilities&16384):!1}t.$yk=h;function F(W){return d(W)?!!(W.capabilities&32768):!1}t.$zk=F;function O(W){return!!(W.capabilities&65536)}t.$Ak=O;function R(W){return!!(W.capabilities&2048)}t.$Bk=R;var B;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(B||(t.FileSystemProviderErrorCode=B={}));class v extends Error{static create(G,ue){const me=new v(G.toString(),ue);return U(me,ue),me}constructor(G,ue){super(G),this.code=ue}}t.$Ck=v;function C(W,G){return v.create(W,G)}t.$Dk=C;function V(W){return W||C((0,S.localize)(0,null),B.Unknown)}t.$Ek=V;function U(W,G){return W.name=G?`${G} (FileSystemError)`:"FileSystemError",W}t.$Fk=U;function T(W){if(!W)return B.Unknown;if(W instanceof v)return W.code;const G=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!G)return B.Unknown;switch(G[1]){case B.FileExists:return B.FileExists;case B.FileIsADirectory:return B.FileIsADirectory;case B.FileNotADirectory:return B.FileNotADirectory;case B.FileNotFound:return B.FileNotFound;case B.FileTooLarge:return B.FileTooLarge;case B.FileWriteLocked:return B.FileWriteLocked;case B.NoPermissions:return B.NoPermissions;case B.Unavailable:return B.Unavailable}return B.Unknown}t.$Gk=T;function L(W){if(W instanceof ee)return W.fileOperationResult;switch(T(W)){case B.FileNotFound:return 1;case B.FileIsADirectory:return 0;case B.FileNotADirectory:return 9;case B.FileWriteLocked:return 5;case B.NoPermissions:return 6;case B.FileExists:return 4;case B.FileTooLarge:return 7;default:return 10}}t.$Hk=L;var z;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(z||(t.FileOperation=z={}));class X{constructor(G,ue,me){this.resource=G,this.operation=ue,this.target=me}isOperation(G){return this.operation===G}}t.$Ik=X;var Y;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(Y||(t.FileChangeType=Y={}));class fe{static{this.a=null}constructor(G,ue){this.c=ue,this.b=void 0,this.d=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawAdded.map(Se=>[Se,!0])),me}),this.f=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawUpdated.map(Se=>[Se,!0])),me}),this.g=new M.$V(()=>{const me=k.$_h.forUris(()=>this.c);return me.fill(this.rawDeleted.map(Se=>[Se,!0])),me}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const me of G){switch(me.type){case 1:this.rawAdded.push(me.resource);break;case 0:this.rawUpdated.push(me.resource);break;case 2:this.rawDeleted.push(me.resource);break}this.b!==fe.a&&(typeof me.cId=="number"?this.b===void 0?this.b=me.cId:this.b!==me.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(G,...ue){return this.h(G,{includeChildren:!1},...ue)}affects(G,...ue){return this.h(G,{includeChildren:!0},...ue)}h(G,ue,...me){if(!G)return!1;const Se=me.length>0;return!!((!Se||me.includes(1))&&(this.d.value.get(G)||ue.includeChildren&&this.d.value.findSuperstr(G))||(!Se||me.includes(0))&&(this.f.value.get(G)||ue.includeChildren&&this.f.value.findSuperstr(G))||(!Se||me.includes(2))&&(this.g.value.findSubstr(G)||ue.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}t.$Jk=fe;function le(W,G,ue){return!W||!G||W===G||G.length>W.length?!1:(G.charAt(G.length-1)!==P.sep&&(G+=P.sep),ue?(0,n.$af)(W,G):W.indexOf(G)===0)}t.$Kk=le;class ee extends Error{constructor(G,ue,me){super(G),this.fileOperationResult=ue,this.options=me}}t.$Lk=ee;class ge extends ee{constructor(G,ue,me,Se){super(G,ue,Se),this.fileOperationResult=ue,this.size=me}}t.$Mk=ge;class Le extends ee{constructor(G,ue,me){super(G,2,me),this.stat=ue}}t.$Nk=Le;var Ne;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Qk="files.associations",t.$Rk="files.exclude",t.$Sk="files.readonlyInclude",t.$Tk="files.readonlyExclude",t.$Uk="files.readonlyFromPermissions";var Be;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(t.FileKind=Be={})),t.$Vk="";function ne(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Wk=ne;async function J(W,G){if(!G.hasProvider(A.URI.from({scheme:W.scheme})))return new Promise(ue=>{const me=G.onDidChangeFileSystemProviderRegistrations(Se=>{Se.scheme===W.scheme&&Se.added&&(me.dispose(),ue())})})}t.$Xk=J;class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(G){return(0,j.$Mf)(G)||(G=0),G<se.KB?(0,S.localize)(1,null,G.toFixed(0)):G<se.MB?(0,S.localize)(2,null,(G/se.KB).toFixed(2)):G<se.GB?(0,S.localize)(3,null,(G/se.MB).toFixed(2)):G<se.TB?(0,S.localize)(4,null,(G/se.GB).toFixed(2)):(0,S.localize)(5,null,(G/se.TB).toFixed(2))}}t.$Yk=se;function oe(W){const G=typeof W=="string"||W?.scheme===y.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===y.Schemas.file?1024*se.MB:G?10*se.MB:w.$o?50*se.MB:1024*se.MB}t.$Zk=oe}),define(be[139],$e([1,0,40]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$P_b=t.$O_b=void 0,t.$O_b=(0,k.$6h)("mainProcessService");class P{constructor(j,A){this.a=j,this.b=A}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,A){this.a.registerChannel(j,A)}}t.$P_b=P}),define(be[140],$e([1,0,2,134]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q_b=void 0;class n extends k.$Tc{constructor(A){super(),this.a=this.B(new P.$MU(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,S){this.a.registerChannel(A,S)}}t.$Q_b=n});var Ei=this&&this.__param||function(ie,t){return function(k,P){t(k,P,ie)}};define(be[141],$e([1,0,67,139]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U_b=void 0;let n=class{constructor(A,S){return this.windowId=A,k.ProxyChannel.toService(S.getChannel("nativeHost"),{context:A,properties:(()=>{const b=new Map;return b.set("windowId",A),b})()})}};t.$U_b=n,t.$U_b=n=Xe([Ei(1,P.$O_b)],n)}),define(be[68],$e([1,0,76,7]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hn=void 0;class n{constructor(){this.a=new Map}add(A,S){k.ok(P.$If(A)),k.ok(P.$Kf(S)),k.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,S)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$Hn=new n}),define(be[142],$e([1,0,4,68]),function(ie,t,k,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$In=void 0,t.$In={JSONContribution:"base.contributions.json"};function n(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class j{constructor(){this.b=new k.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,w){this.a[n(b)]=w,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;P.$Hn.add(t.$In.JSONContribution,A)}),define(be[143],$e([1,0,9,17,18,4,7,15,136,142,68]),function(ie,t,k,P,n,j,A,S,b,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ew=t.$Dw=t.$Cw=t.$Bw=t.$Aw=t.$zw=t.$yw=t.$xw=t.IconFontDefinition=t.IconContribution=t.$ww=void 0,t.$ww={IconContribution:"base.contributions.icons"};var M;(function(c){function f(h,F){let O=h.defaults;for(;n.ThemeIcon.isThemeIcon(O);){const R=e.getIcon(O.id);if(!R)return;O=R.defaults}return O}c.getDefinition=f})(M||(t.IconContribution=M={}));var r;(function(c){function f(F){return{weight:F.weight,style:F.style,src:F.src.map(O=>({format:O.format,location:O.location.toString()}))}}c.toJSONObject=f;function h(F){const O=R=>(0,A.$If)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,A.$If)(R.format)&&(0,A.$If)(R.location)))return{weight:O(F.weight),style:O(F.style),src:F.src.map(R=>({format:R.format,location:S.URI.parse(R.location)}))}}c.fromJSONObject=h})(r||(t.IconFontDefinition=r={}));class u{constructor(){this.a=new j.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(f,h,F,O){const R=this.b[f];if(R){if(F&&!R.description){R.description=F,this.d.properties[f].markdownDescription=`${F} $(${f})`;const C=this.e.enum.indexOf(f);C!==-1&&(this.e.enumDescriptions[C]=F),this.a.fire()}return R}const B={id:f,description:F,defaults:h,deprecationMessage:O};this.b[f]=B;const v={$ref:"#/definitions/icons"};return O&&(v.deprecationMessage=O),F&&(v.markdownDescription=`${F}: $(${f})`),this.d.properties[f]=v,this.e.enum.push(f),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:f}}deregisterIcon(f){delete this.b[f],delete this.d.properties[f];const h=this.e.enum.indexOf(f);h!==-1&&(this.e.enum.splice(h,1),this.e.enumDescriptions.splice(h,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(f=>this.b[f])}getIcon(f){return this.b[f]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(f,h){const F=this.f[f];return F||(this.f[f]=h,this.a.fire(),h)}deregisterIconFont(f){delete this.f[f]}getIconFont(f){return this.f[f]}toString(){const f=(R,B)=>R.id.localeCompare(B.id),h=R=>{for(;n.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const O=Object.keys(this.b).map(R=>this.b[R]);for(const R of O.filter(B=>!!B.description).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|${n.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of O.filter(B=>!n.ThemeIcon.isThemeIcon(B.defaults)).sort(f))F.push(`|<i class="${h(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new u;y.$Hn.add(t.$ww.IconContribution,e);function s(c,f,h,F){return e.registerIcon(c,f,h,F)}t.$xw=s;function m(){return e}t.$yw=m;function d(){const c=(0,P.$0j)();for(const f in c){const h="\\"+c[f].toString(16);e.registerIcon(f,{fontCharacter:h})}}d(),t.$zw="vscode://schemas/icons";const o=y.$Hn.as(w.$In.JSONContribution);o.registerSchema(t.$zw,e.getIconSchema());const $=new k.$fh(()=>o.notifySchemaChanged(t.$zw),200);e.onDidChange(()=>{$.isScheduled()||$.schedule()}),t.$Aw=s("widget-close",P.$_j.close,(0,b.localize)(2,null)),t.$Bw=s("goto-previous-location",P.$_j.arrowUp,(0,b.localize)(3,null)),t.$Cw=s("goto-next-location",P.$_j.arrowDown,(0,b.localize)(4,null)),t.$Dw=n.ThemeIcon.modify(P.$_j.sync,"spin"),t.$Ew=n.ThemeIcon.modify(P.$_j.loading,"spin")}),define(be[144],$e([1,0,3,4,2,18,143]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yFb=t.$xFb=void 0;function S(w){const y=new n.$Sc,M=y.add(new P.$Vd),r=(0,A.$yw)();return y.add(r.onDidChange(()=>M.fire())),w&&y.add(w.onDidProductIconThemeChange(()=>M.fire())),{dispose:()=>y.dispose(),onDidChange:M.event,getCSS(){const u=w?w.getProductIconTheme():new b,e={},s=d=>{const o=u.getIcon(d);if(!o)return;const $=o.font;return $?(e[$.id]=$.definition,`.codicon-${d.id}:before { content: '${o.fontCharacter}'; font-family: ${(0,k.$4Q)($.id)}; }`):`.codicon-${d.id}:before { content: '${o.fontCharacter}'; }`},m=[];for(const d of r.getIcons()){const o=s(d);o&&m.push(o)}for(const d in e){const o=e[d],$=o.weight?`font-weight: ${o.weight};`:"",c=o.style?`font-style: ${o.style};`:"",f=o.src.map(h=>`${(0,k.$3Q)(h.location)} format('${h.format}')`).join(", ");m.push(`@font-face { src: ${f}; font-family: ${(0,k.$4Q)(d)};${$}${c} font-display: block; }`)}return m.join(`
`)}}}t.$xFb=S;class b{getIcon(y){const M=(0,A.$yw)();let r=y.defaults;for(;j.ThemeIcon.isThemeIcon(r);){const u=M.getIcon(r.id);if(!u)return;r=u.defaults}return r}}t.$yFb=b}),define(be[145],$e([1,0,5]),function(ie,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YC=t.$XC=t.$WC=t.$VC=t.$UC=t.$TC=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$SC=t.$RC=t.$QC=t.$PC=t.$OC=t.$NC=void 0,t.$NC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function P(d){return typeof d.parentId=="number"}t.$OC=P;function n(d){return!!d.workspaceUri}t.$PC=n;function j(d){return!!d.folderUri}t.$QC=j;function A(d){return!!d.fileUri}t.$RC=A;function S(d){const o=r(d),$=d.getValue("window.menuBarVisibility");return $==="default"||o&&$==="compact"||k.$j&&k.$m?"classic":$}t.$SC=S;var b;(function(d){d.TITLE_BAR_STYLE="window.titleBarStyle",d.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(b||(t.TitleBarSetting=b={}));var w;(function(d){d.NATIVE="native",d.CUSTOM="custom"})(w||(t.TitlebarStyle=w={}));var y;(function(d){d.AUTO="auto",d.WINDOWED="windowed",d.NEVER="never"})(y||(t.CustomTitleBarVisibility=y={}));function M(d,o){return!0}t.$TC=M;function r(d,o){return o||(o=u(d)),o==="native"}t.$UC=r;function u(d){if(k.$o)return"custom";const o=d.getValue("window");if(o){if(k.$j&&o.nativeTabs===!0||k.$j&&o.nativeFullScreen===!1)return"native";const f=o.titleBarStyle;if(f==="native"||f==="custom")return f}return k.$k?"native":"custom"}t.$VC=u;function e(d){return!(!k.$i||k.$o||r(d))}t.$WC=e;function s(d){const o=d.getValue("window");return!o||typeof o.nativeFullScreen!="boolean"||o.nativeTabs?!0:o.nativeFullScreen!==!1}t.$XC=s;function m(d=0){return Math.pow(1.2,d)}t.$YC=m}),define(be[146],$e([1,0,16,3,21,30,145]),function(ie,t,k,P,n,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1_b=t.$Z_b=t.$Y_b=t.$X_b=t.$W_b=t.ApplyZoomTarget=void 0;var S;(function(r){r[r.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",r[r.ALL_WINDOWS=2]="ALL_WINDOWS"})(S||(t.ApplyZoomTarget=S={})),t.$W_b=8,t.$X_b=-8;function b(r,u){r=Math.min(Math.max(r,t.$X_b),t.$W_b);const e=[];u===S.ACTIVE_WINDOW?e.push((0,P.$qQ)()):u===S.ALL_WINDOWS?e.push(...Array.from((0,P.getWindows)()).map(({window:s})=>s)):e.push(u);for(const s of e)w(s)?.webFrame?.setZoomLevel(r),(0,k.$nP)((0,A.$YC)(r),s),(0,k.$jP)(r,s)}t.$Y_b=b;function w(r){if(r===n.$dP)return{ipcRenderer:j.$O,webFrame:j.$Q};{const u=r;if(u?.vscode?.ipcRenderer&&u?.vscode?.webFrame)return u.vscode}}function y(r){b((0,k.$kP)(typeof r=="number"?(0,P.$qQ)():r)+1,r)}t.$Z_b=y;function M(r){b((0,k.$kP)(typeof r=="number"?(0,P.$qQ)():r)-1,r)}t.$1_b=M}),define(be[147],$e([1,0,11,3,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ie,t,k,P,n,j,A,S,b,w,y,M,r,u,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const m=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,d=/\s--inspect-port=(?<port>\d+)/;class o{getHeight(T){return 22}getTemplateId(T){return B(T)?"process":O(T)?"machine":(0,b.$Jm)(T)?"error":R(T)?"header":""}}class ${hasChildren(T){return(0,b.$Jm)(T)?!1:B(T)?!!T.children?.length:!0}getChildren(T){return B(T)?T.children?T.children:[]:(0,b.$Jm)(T)?[]:R(T)?T.processRoots.length>1?T.processRoots:[T.processRoots[0].rootProcess]:O(T)?[T.rootProcess]:[T.processes]}}class c{constructor(){this.templateId="header"}renderTemplate(T){const L=(0,P.$MQ)(T,(0,P.$)(".row")),z=(0,P.$MQ)(L,(0,P.$)(".nameLabel")),X=(0,P.$MQ)(L,(0,P.$)(".cpu")),Y=(0,P.$MQ)(L,(0,P.$)(".memory")),fe=(0,P.$MQ)(L,(0,P.$)(".pid"));return{name:z,CPU:X,memory:Y,PID:fe}}renderElement(T,L,z,X){z.name.textContent=(0,k.localize)(0,null),z.CPU.textContent=(0,k.localize)(1,null),z.PID.textContent=(0,k.localize)(2,null),z.memory.textContent=(0,k.localize)(3,null)}disposeTemplate(T){}}class f{constructor(){this.templateId="machine"}renderTemplate(T){const L=Object.create(null),z=(0,P.$MQ)(T,(0,P.$)(".row"));return L.name=(0,P.$MQ)(z,(0,P.$)(".nameLabel")),L}renderElement(T,L,z,X){z.name.textContent=T.element.name}disposeTemplate(T){}}class h{constructor(){this.templateId="error"}renderTemplate(T){const L=Object.create(null),z=(0,P.$MQ)(T,(0,P.$)(".row"));return L.name=(0,P.$MQ)(z,(0,P.$)(".nameLabel")),L}renderElement(T,L,z,X){z.name.textContent=T.element.errorMessage}disposeTemplate(T){}}class F{constructor(T,L,z){this.a=T,this.b=L,this.c=z,this.templateId="process"}renderTemplate(T){const L=(0,P.$MQ)(T,(0,P.$)(".row")),z=(0,P.$MQ)(L,(0,P.$)(".nameLabel")),X=(0,P.$MQ)(L,(0,P.$)(".cpu")),Y=(0,P.$MQ)(L,(0,P.$)(".memory")),fe=(0,P.$MQ)(L,(0,P.$)(".pid"));return{name:z,CPU:X,PID:fe,memory:Y}}renderElement(T,L,z,X){const{element:Y}=T,fe=Y.pid.toFixed(0);let le=Y.name;this.c.has(Y.pid)&&(le=this.c.get(Y.pid)),z.name.textContent=le,z.name.title=Y.cmd,z.CPU.textContent=Y.load.toFixed(0),z.PID.textContent=fe,z.PID.parentElement.id=`pid-${fe}`;const ee=this.a==="win32"?Y.mem:this.b*(Y.mem/100);z.memory.textContent=(ee/w.$Yk.MB).toFixed(0)}disposeTemplate(T){}}function O(U){return!!U.name&&!!U.rootProcess}function R(U){return!!U.processRoots}function B(U){return!!U.pid}class v{constructor(T,L){this.f=L,this.b=new Map;const z=new y.$Q_b(T);this.c=new M.$U_b(T,z),this.k(L.styles),this.g(L),S.$O.on("vscode:pidToNameResponse",(X,Y)=>{this.b.clear();for(const[fe,le]of Y)this.b.set(fe,le)}),S.$O.on("vscode:listProcessesResponse",async(X,Y)=>{Y.forEach((fe,le)=>{B(fe.rootProcess)&&(fe.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Y}}),this.d.layout(s.$dP.innerHeight,s.$dP.innerWidth)):await this.h(Y),this.m(0)}),this.a=Date.now(),S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")}g(T){s.$dP.document.onkeydown=L=>{const z=T.platform==="darwin"?L.metaKey:L.ctrlKey;z&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),S.$O.send("vscode:closeProcessExplorer")),z&&L.keyCode===187&&(0,u.$Z_b)(s.$dP),z&&L.keyCode===189&&(0,u.$1_b)(s.$dP)}}async h(T){const L=s.$dP.document.getElementById("process-list");if(!L)return;const{totalmem:z}=await this.c.getOSStatistics(),X=[new F(this.f.platform,z,this.b),new c,new f,new h];this.d=new n.$cU("processExplorer",L,new o,X,new $,{identityProvider:{getId:Y=>B(Y)?Y.pid.toString():(0,b.$Jm)(Y)?Y.hostName:R(Y)?"processes":O(Y)?Y.name:"header"}}),this.d.setInput({processes:{processRoots:T}}),this.d.layout(s.$dP.innerHeight,s.$dP.innerWidth),this.d.onKeyDown(Y=>{const fe=new e.$IP(Y);if(fe.keyCode===35&&fe.altKey){const le=this.n();Promise.all(le.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Y=>{B(Y.element)&&this.l(Y.element,!0)}),L.style.height=`${s.$dP.innerHeight}px`,s.$dP.addEventListener("resize",()=>{L.style.height=`${s.$dP.innerHeight}px`,this.d?.layout(s.$dP.innerHeight,s.$dP.innerWidth)})}i(T){const L=m.exec(T);return L&&L.groups.port!=="0"||T.indexOf("node ")>=0||T.indexOf("node.exe")>=0}j(T){const L={type:"node",request:"attach",name:`process ${T.pid}`};let z=m.exec(T.cmd);z?L.port=Number(z.groups.port):L.processId=String(T.pid),z=d.exec(T.cmd),z&&(L.port=Number(z.groups.port)),S.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(T){const L=(0,P.$uQ)(),z=[];T.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${T.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${T.listFocusBackground}; }`)),T.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${T.listFocusForeground}; }`),T.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${T.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${T.listActiveSelectionBackground}; }`)),T.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${T.listActiveSelectionForeground}; }`),T.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${T.listHoverBackground}; }`),T.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${T.listHoverForeground}; }`),T.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${T.listFocusOutline}; outline-offset: -1px; }`),T.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${T.listHoverOutline}; outline-offset: -1px; }`),T.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${T.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${T.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),T.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${T.scrollbarSliderBackgroundColor};
				}
			`),T.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${T.scrollbarSliderHoverBackgroundColor};
				}
			`),T.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${T.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=z.join(`
`),T.color&&(s.$dP.document.body.style.color=T.color)}l(T,L){const z=[],X=Number(T.pid);L&&(z.push({accelerator:"Alt+E",label:(0,k.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),z.push({label:(0,k.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,k.localize)(6,null),click:()=>{const Y=this.n();Y?.includes(X)||(Y.length=0,Y.push(X));const fe=Y?.map(le=>s.$dP.document.getElementById(`pid-${le}`)).filter(le=>!!le);if(fe){const le=fe.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(le.join(`
`))}}}),z.push({label:(0,k.localize)(7,null),click:()=>{const Y=s.$dP.document.getElementById("process-list");Y&&this.c.writeClipboardText(Y.innerText)}}),T&&L&&this.i(T.cmd)&&(z.push({type:"separator"}),z.push({label:(0,k.localize)(8,null),click:()=>{this.j(T)}})),(0,A.$EU)(z)}m(T){setTimeout(()=>{const L=Date.now(),z=T+L-this.a;this.a=L,z>1e3?(S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(T=>{if(!(!T||!("pid"in T)))return T.pid}).filter(T=>!!T)}}function C(){const U=(0,P.$uQ)();U.id="codiconStyles";const T=(0,r.$xFb)(void 0);function L(){U.textContent=T.getCSS()}const z=new j.$fh(L,0);T.onDidChange(()=>z.schedule()),z.schedule()}function V(U){const T=U.data.platform==="win32"?"windows":U.data.platform==="linux"?"linux":"mac";s.$dP.document.body.classList.add(T),C(),(0,u.$Y_b)(U.data.zoomLevel,s.$dP),new v(U.windowId,U.data)}t.startup=V})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e244acbb172c428cb219717a07bf55d2737492ca/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
